/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],be=function(ne){for(var e=[],d=0,M=ne.length;d<M;d++)e[d]=we[ne[d]];return e};define(we[42],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(M,b){if(!M)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=d}),define(we[51],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function M(t){const E=[];for(let n in t)d.call(t,n)&&E.push(t[n]);return E}e.values=M;function b(t,E){for(let n in t)if(d.call(t,n)&&E({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=b;function R(t,E){const n=Object.create(null);for(const u of t){const l=E(u);let a=n[l];a||(a=n[l]=[]),a.push(u)}return n}e.groupBy=R;function F(t){const E=Object.create(null);return t&&t.forEach((n,u)=>{E[u]=n}),E}e.fromMap=F;function C(t,E){const n=[],u=[];for(let l of t)E.has(l)||n.push(l);for(let l of E)t.has(l)||u.push(l);return{removed:n,added:u}}e.diffSets=C;function _(t,E){const n=[],u=[];for(let[l,a]of t)E.has(l)||n.push(a);for(let[l,a]of E)t.has(l)||u.push(a);return{removed:n,added:u}}e.diffMaps=_;class T{constructor(){this.map=new Map}add(E,n){let u=this.map.get(E);u||(u=new Set,this.map.set(E,u)),u.add(n)}delete(E,n){const u=this.map.get(E);!u||(u.delete(n),u.size===0&&this.map.delete(E))}forEach(E,n){const u=this.map.get(E);!u||u.forEach(n)}}e.SetMap=T}),define(we[52],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(F){return(C,_,T)=>{let t=null,E=null;if(typeof T.value=="function"?(t="value",E=T.value):typeof T.get=="function"&&(t="get",E=T.get),!E)throw new Error("not supported");T[t]=F(E,_)}}e.createDecorator=d;function M(F,C,_){let T=null,t=null;if(typeof _.value=="function"?(T="value",t=_.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(T="get",t=_.get),!t)throw new Error("not supported");const E=`$memoize$${C}`;_[T]=function(...n){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[E]}}e.memoize=M;function b(F,C,_){return d((T,t)=>{const E=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...u){this[n]||(this[n]=_?_():void 0),clearTimeout(this[E]),C&&(this[n]=C(this[n],...u),u=[this[n]]),this[E]=setTimeout(()=>{T.apply(this,u),this[n]=_?_():void 0},F)}})}e.debounce=b;function R(F,C,_){return d((T,t)=>{const E=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,u=`$throttle$lastRun$${t}`,l=`$throttle$pending$${t}`;return function(...a){if(this[n]||(this[n]=_?_():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),C&&(this[n]=C(this[n],...a)),this[l])return;const w=this[u]+F;w<=Date.now()?(this[u]=Date.now(),T.apply(this,[this[n]]),this[n]=_?_():void 0):(this[l]=!0,this[E]=setTimeout(()=>{this[l]=!1,this[u]=Date.now(),T.apply(this,[this[n]]),this[n]=_?_():void 0},w-Date.now()))}})}e.throttle=R}),define(we[13],be([0,1,16]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(j,ue=0){return j[j.length-(1+ue)]}e.tail=M;function b(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=b;function R(j,ue,oe=(ve,Fe)=>ve===Fe){if(j===ue)return!0;if(!j||!ue||j.length!==ue.length)return!1;for(let ve=0,Fe=j.length;ve<Fe;ve++)if(!oe(j[ve],ue[ve]))return!1;return!0}e.equals=R;function F(j,ue,oe){let ve=0,Fe=j.length-1;for(;ve<=Fe;){const Me=(ve+Fe)/2|0,Oe=oe(j[Me],ue);if(Oe<0)ve=Me+1;else if(Oe>0)Fe=Me-1;else return Me}return-(ve+1)}e.binarySearch=F;function C(j,ue){let oe=0,ve=j.length;if(ve===0)return 0;for(;oe<ve;){const Fe=Math.floor((oe+ve)/2);ue(j[Fe])?ve=Fe:oe=Fe+1}return oe}e.findFirstInSorted=C;function _(j,ue,oe){if(j=j|0,j>=ue.length)throw new TypeError("invalid index");let ve=ue[Math.floor(ue.length*Math.random())],Fe=[],Me=[],Oe=[];for(let Ye of ue){const ze=oe(Ye,ve);ze<0?Fe.push(Ye):ze>0?Me.push(Ye):Oe.push(Ye)}return j<Fe.length?_(j,Fe,oe):j<Fe.length+Oe.length?Oe[0]:_(j-(Fe.length+Oe.length),Me,oe)}e.quickSelect=_;function T(j,ue){const oe=[];let ve;for(const Fe of j.slice(0).sort(ue))!ve||ue(ve[0],Fe)!==0?(ve=[Fe],oe.push(ve)):ve.push(Fe);return oe}e.groupBy=T;function t(j,ue,oe){const ve=[];function Fe(Ye,ze,je){if(ze===0&&je.length===0)return;const x=ve[ve.length-1];x&&x.start+x.deleteCount===Ye?(x.deleteCount+=ze,x.toInsert.push(...je)):ve.push({start:Ye,deleteCount:ze,toInsert:je})}let Me=0,Oe=0;for(;;){if(Me===j.length){Fe(Me,0,ue.slice(Oe));break}if(Oe===ue.length){Fe(Me,j.length-Me,[]);break}const Ye=j[Me],ze=ue[Oe],je=oe(Ye,ze);je===0?(Me+=1,Oe+=1):je<0?(Fe(Me,1,[]),Me+=1):je>0&&(Fe(Me,0,[ze]),Oe+=1)}return ve}e.sortedDiff=t;function E(j,ue,oe){const ve=t(j,ue,oe),Fe=[],Me=[];for(const Oe of ve)Fe.push(...j.slice(Oe.start,Oe.start+Oe.deleteCount)),Me.push(...Oe.toInsert);return{removed:Fe,added:Me}}e.delta=E;function n(j,ue,oe){if(oe===0)return[];const ve=j.slice(0,oe).sort(ue);return l(j,ue,ve,oe,j.length),ve}e.top=n;function u(j,ue,oe,ve,Fe){return oe===0?Promise.resolve([]):new Promise((Me,Oe)=>{(async()=>{const Ye=j.length,ze=j.slice(0,oe).sort(ue);for(let je=oe,x=Math.min(oe+ve,Ye);je<Ye;je=x,x=Math.min(x+ve,Ye)){if(je>oe&&await new Promise(Q=>setTimeout(Q)),Fe&&Fe.isCancellationRequested)throw(0,d.canceled)();l(j,ue,ze,je,x)}return ze})().then(Me,Oe)})}e.topAsync=u;function l(j,ue,oe,ve,Fe){for(const Me=oe.length;ve<Fe;ve++){const Oe=j[ve];if(ue(Oe,oe[Me-1])<0){oe.pop();const Ye=C(oe,ze=>ue(Oe,ze)<0);oe.splice(Ye,0,Oe)}}}function a(j){return j.filter(ue=>!!ue)}e.coalesce=a;function w(j){let ue=0;for(let oe=0;oe<j.length;oe++)j[oe]&&(j[ue]=j[oe],ue+=1);j.length=ue}e.coalesceInPlace=w;function I(j,ue,oe){j.splice(oe,0,j.splice(ue,1)[0])}e.move=I;function S(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=S;function o(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=o;function m(j,ue){if(!ue)return j.filter((ve,Fe)=>j.indexOf(ve)===Fe);const oe=Object.create(null);return j.filter(ve=>{const Fe=ue(ve);return oe[Fe]?!1:(oe[Fe]=!0,!0)})}e.distinct=m;function y(j){const ue=new Set;return j.filter(oe=>ue.has(oe)?!1:(ue.add(oe),!0))}e.distinctES6=y;function i(j){const ue=Object.create(null);return oe=>{const ve=j(oe);return ue[ve]?!1:(ue[ve]=!0,!0)}}e.uniqueFilter=i;function v(j,ue){for(let oe=j.length-1;oe>=0;oe--){const ve=j[oe];if(ue(ve))return oe}return-1}e.lastIndex=v;function r(j,ue){return j.length>0?j[0]:ue}e.firstOrDefault=r;function s(j,ue,oe=(ve,Fe)=>ve===Fe){let ve=0;for(let Fe=0,Me=Math.min(j.length,ue.length);Fe<Me&&oe(j[Fe],ue[Fe]);Fe++)ve++;return ve}e.commonPrefixLength=s;function c(j){return[].concat(...j)}e.flatten=c;function h(j,ue){let oe=typeof ue=="number"?j:0;typeof ue=="number"?oe=j:(oe=0,ue=j);const ve=[];if(oe<=ue)for(let Fe=oe;Fe<ue;Fe++)ve.push(Fe);else for(let Fe=oe;Fe>ue;Fe--)ve.push(Fe);return ve}e.range=h;function g(j,ue,oe){return j.reduce((ve,Fe)=>(ve[ue(Fe)]=oe?oe(Fe):Fe,ve),Object.create(null))}e.index=g;function k(j,ue){return j.push(ue),()=>P(j,ue)}e.insert=k;function P(j,ue){const oe=j.indexOf(ue);if(oe>-1)return j.splice(oe,1),ue}e.remove=P;function p(j,ue,oe){const ve=j.slice(0,ue),Fe=j.slice(ue);return ve.concat(oe,Fe)}e.arrayInsert=p;function D(j,ue){let oe;if(typeof ue=="number"){let ve=ue;oe=()=>{const Fe=Math.sin(ve++)*179426549;return Fe-Math.floor(Fe)}}else oe=Math.random;for(let ve=j.length-1;ve>0;ve-=1){const Fe=Math.floor(oe()*(ve+1)),Me=j[ve];j[ve]=j[Fe],j[Fe]=Me}}e.shuffle=D;function f(j,ue){const oe=j.indexOf(ue);oe>-1&&(j.splice(oe,1),j.unshift(ue))}e.pushToStart=f;function A(j,ue){const oe=j.indexOf(ue);oe>-1&&(j.splice(oe,1),j.push(ue))}e.pushToEnd=A;function L(j,ue){return Array.isArray(j)?j.map(ue):ue(j)}e.mapArrayOrNot=L;function V(j){return Array.isArray(j)?j:[j]}e.asArray=V;function G(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=G;function $(j,ue){for(const oe of j){const ve=ue(oe);if(ve!==void 0)return ve}}e.mapFind=$;function K(j,ue,oe){const ve=U(j,ue),Fe=j.length,Me=oe.length;j.length=Fe+Me;for(let Oe=Fe-1;Oe>=ve;Oe--)j[Oe+Me]=j[Oe];for(let Oe=0;Oe<Me;Oe++)j[Oe+ve]=oe[Oe]}e.insertInto=K;function W(j,ue,oe,ve){const Fe=U(j,ue),Me=j.splice(Fe,oe);return K(j,Fe,ve),Me}e.splice=W;function U(j,ue){return ue<0?Math.max(ue+j.length,0):Math.min(ue,j.length)}function z(j,ue){let oe=Number.MAX_SAFE_INTEGER,ve=0;return j.forEach((Fe,Me)=>{const Oe=ue(Fe);Oe<oe&&(oe=Oe,ve=Me)}),ve}e.minIndex=z;function Y(j,ue){let oe=Number.MIN_SAFE_INTEGER,ve=0;return j.forEach((Fe,Me)=>{const Oe=ue(Fe);Oe>oe&&(oe=Oe,ve=Me)}),ve}e.maxIndex=Y;class re{constructor(ue){this.items=ue,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ue){let oe=this.firstIdx;for(;oe<this.items.length&&ue(this.items[oe]);)oe++;const ve=oe===this.firstIdx?null:this.items.slice(this.firstIdx,oe);return this.firstIdx=oe,ve}takeFromEndWhile(ue){let oe=this.lastIdx;for(;oe>=0&&ue(this.items[oe]);)oe--;const ve=oe===this.lastIdx?null:this.items.slice(oe+1,this.lastIdx+1);return this.lastIdx=oe,ve}}e.ArrayQueue=re}),define(we[53],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(we[102],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function F(i,v=!1){let r=0,s=i.length,c="",h=0,g=16,k=0;function P(G){let $=0,K=0;for(;$<G;){const W=i.charCodeAt(r);if(W>=48&&W<=57)K=K*16+W-48;else if(W>=65&&W<=70)K=K*16+W-65+10;else if(W>=97&&W<=102)K=K*16+W-97+10;else break;r++,$++}return $<G&&(K=-1),K}function p(G){r=G,c="",h=0,g=16,k=0}function D(){const G=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&T(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&T(i.charCodeAt(r)))for(r++;r<i.length&&T(i.charCodeAt(r));)r++;else return k=3,i.substring(G,r);let $=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&T(i.charCodeAt(r))){for(r++;r<i.length&&T(i.charCodeAt(r));)r++;$=r}else k=3;return i.substring(G,$)}function f(){let G="",$=r;for(;;){if(r>=s){G+=i.substring($,r),k=2;break}const K=i.charCodeAt(r);if(K===34){G+=i.substring($,r),r++;break}if(K===92){if(G+=i.substring($,r),r++,r>=s){k=2;break}switch(i.charCodeAt(r++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const U=P(4);U>=0?G+=String.fromCharCode(U):k=4;break;default:k=5}$=r;continue}if(K>=0&&K<=31)if(_(K)){G+=i.substring($,r),k=2;break}else k=6;r++}return G}function A(){if(c="",k=0,h=r,r>=s)return h=s,g=17;let G=i.charCodeAt(r);if(C(G)){do r++,c+=String.fromCharCode(G),G=i.charCodeAt(r);while(C(G));return g=15}if(_(G))return r++,c+=String.fromCharCode(G),G===13&&i.charCodeAt(r)===10&&(r++,c+=`
`),g=14;switch(G){case 123:return r++,g=1;case 125:return r++,g=2;case 91:return r++,g=3;case 93:return r++,g=4;case 58:return r++,g=6;case 44:return r++,g=5;case 34:return r++,c=f(),g=10;case 47:const $=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<s&&!_(i.charCodeAt(r));)r++;return c=i.substring($,r),g=12}if(i.charCodeAt(r+1)===42){r+=2;const K=s-1;let W=!1;for(;r<K;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,W=!0;break}r++}return W||(r++,k=1),c=i.substring($,r),g=13}return c+=String.fromCharCode(G),r++,g=16;case 45:if(c+=String.fromCharCode(G),r++,r===s||!T(i.charCodeAt(r)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=D(),g=11;default:for(;r<s&&L(G);)r++,G=i.charCodeAt(r);if(h!==r){switch(c=i.substring(h,r),c){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return c+=String.fromCharCode(G),r++,g=16}}function L(G){if(C(G)||_(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let G;do G=A();while(G>=12&&G<=15);return G}return{setPosition:p,getPosition:()=>r,scan:v?V:A,getToken:()=>g,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>r-h,getTokenError:()=>k}}e.createScanner=F;function C(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function _(i){return i===10||i===13||i===8232||i===8233}function T(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function E(i,v){const r=[],s=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function k(P,p,D,f){h.value=P,h.offset=p,h.length=D,h.type=f,h.colonOffset=void 0,c=h}try{o(i,{onObjectBegin:(P,p)=>{if(v<=P)throw s;c=void 0,g=v>P,r.push("")},onObjectProperty:(P,p,D)=>{if(v<p||(k(P,p,D,"property"),r[r.length-1]=P,v<=p+D))throw s},onObjectEnd:(P,p)=>{if(v<=P)throw s;c=void 0,r.pop()},onArrayBegin:(P,p)=>{if(v<=P)throw s;c=void 0,r.push(0)},onArrayEnd:(P,p)=>{if(v<=P)throw s;c=void 0,r.pop()},onLiteralValue:(P,p,D)=>{if(v<p||(k(P,p,D,y(P)),v<=p+D))throw s},onSeparator:(P,p,D)=>{if(v<=p)throw s;if(P===":"&&c&&c.type==="property")c.colonOffset=p,g=!1,c=void 0;else if(P===","){const f=r[r.length-1];typeof f=="number"?r[r.length-1]=f+1:(g=!0,r[r.length-1]=""),c=void 0}}})}catch(P){if(P!==s)throw P}return{path:r,previousNode:c,isAtPropertyKey:g,matches:P=>{let p=0;for(let D=0;p<P.length&&D<r.length;D++)if(P[p]===r[D]||P[p]==="*")p++;else if(P[p]!=="**")return!1;return p===P.length}}}e.getLocation=E;function n(i,v=[],r=R.DEFAULT){let s=null,c=[];const h=[];function g(P){Array.isArray(c)?c.push(P):s!==null&&(c[s]=P)}return o(i,{onObjectBegin:()=>{const P={};g(P),h.push(c),c=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const P=[];g(P),h.push(c),c=P,s=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:g,onError:(P,p,D)=>{v.push({error:P,offset:p,length:D})}},r),c[0]}e.parse=n;function u(i,v=[],r=R.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(P){s.type==="property"&&(s.length=P-s.offset,s=s.parent)}function h(P){return s.children.push(P),P}o(i,{onObjectBegin:P=>{s=h({type:"object",offset:P,length:-1,parent:s,children:[]})},onObjectProperty:(P,p,D)=>{s=h({type:"property",offset:p,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:P,offset:p,length:D,parent:s})},onObjectEnd:(P,p)=>{s.length=P+p-s.offset,s=s.parent,c(P+p)},onArrayBegin:(P,p)=>{s=h({type:"array",offset:P,length:-1,parent:s,children:[]})},onArrayEnd:(P,p)=>{s.length=P+p-s.offset,s=s.parent,c(P+p)},onLiteralValue:(P,p,D)=>{h({type:y(P),offset:p,length:D,parent:s,value:P}),c(p+D)},onSeparator:(P,p,D)=>{s.type==="property"&&(P===":"?s.colonOffset=p:P===","&&c(p))},onError:(P,p,D)=>{v.push({error:P,offset:p,length:D})}},r);const k=s.children[0];return k&&delete k.parent,k}e.parseTree=u;function l(i,v){if(!i)return;let r=i;for(let s of v)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let c=!1;for(const h of r.children)if(Array.isArray(h.children)&&h.children[0].value===s){r=h.children[1],c=!0;break}if(!c)return}else{const c=s;if(r.type!=="array"||c<0||!Array.isArray(r.children)||c>=r.children.length)return;r=r.children[c]}return r}e.findNodeAtLocation=l;function a(i){if(!i.parent||!i.parent.children)return[];const v=a(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;v.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&v.push(r)}return v}e.getNodePath=a;function w(i){switch(i.type){case"array":return i.children.map(w);case"object":const v=Object.create(null);for(let r of i.children){const s=r.children[1];s&&(v[r.children[0].value]=w(s))}return v;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=w;function I(i,v,r=!1){return v>=i.offset&&v<i.offset+i.length||r&&v===i.offset+i.length}e.contains=I;function S(i,v,r=!1){if(I(i,v,r)){const s=i.children;if(Array.isArray(s))for(let c=0;c<s.length&&s[c].offset<=v;c++){const h=S(s[c],v,r);if(h)return h}return i}}e.findNodeAtOffset=S;function o(i,v,r=R.DEFAULT){const s=F(i,!1);function c(oe){return oe?()=>oe(s.getTokenOffset(),s.getTokenLength()):()=>!0}function h(oe){return oe?ve=>oe(ve,s.getTokenOffset(),s.getTokenLength()):()=>!0}const g=c(v.onObjectBegin),k=h(v.onObjectProperty),P=c(v.onObjectEnd),p=c(v.onArrayBegin),D=c(v.onArrayEnd),f=h(v.onLiteralValue),A=h(v.onSeparator),L=c(v.onComment),V=h(v.onError),G=r&&r.disallowComments,$=r&&r.allowTrailingComma;function K(){for(;;){const oe=s.scan();switch(s.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:G||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(oe){case 12:case 13:G?W(10):L();break;case 16:W(1);break;case 15:case 14:break;default:return oe}}}function W(oe,ve=[],Fe=[]){if(V(oe),ve.length+Fe.length>0){let Me=s.getToken();for(;Me!==17;){if(ve.indexOf(Me)!==-1){K();break}else if(Fe.indexOf(Me)!==-1)break;Me=K()}}}function U(oe){const ve=s.getTokenValue();return oe?f(ve):k(ve),K(),!0}function z(){switch(s.getToken()){case 11:let oe=0;try{oe=JSON.parse(s.getTokenValue()),typeof oe!="number"&&(W(2),oe=0)}catch(ve){W(2)}f(oe);break;case 7:f(null);break;case 8:f(!0);break;case 9:f(!1);break;default:return!1}return K(),!0}function Y(){return s.getToken()!==10?(W(3,[],[2,5]),!1):(U(!1),s.getToken()===6?(A(":"),K(),ue()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function re(){g(),K();let oe=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(oe||W(4,[],[]),A(","),K(),s.getToken()===2&&$)break}else oe&&W(6,[],[]);Y()||W(4,[],[2,5]),oe=!0}return P(),s.getToken()!==2?W(7,[2],[]):K(),!0}function j(){p(),K();let oe=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(oe||W(4,[],[]),A(","),K(),s.getToken()===4&&$)break}else oe&&W(6,[],[]);ue()||W(4,[],[4,5]),oe=!0}return D(),s.getToken()!==4?W(8,[4],[]):K(),!0}function ue(){switch(s.getToken()){case 3:return j();case 1:return re();case 10:return U(!0);default:return z()}}return K(),s.getToken()===17?r.allowEmptyContent?!0:(W(4,[],[]),!1):ue()?(s.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=o;function m(i,v){let r=F(i),s=[],c,h=0,g;do switch(g=r.getPosition(),c=r.scan(),c){case 12:case 13:case 17:h!==g&&s.push(i.substring(h,g)),v!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,v)),h=r.getPosition();break}while(c!==17);return s.join("")}e.stripComments=m;function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=y}),define(we[103],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(b){this.executor=b,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(b){this._error=b}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(b){return new d(()=>b(this.getValue()))}}e.Lazy=d}),function(ne,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ne=typeof globalThis!="undefined"?globalThis:ne||self,ne.marked=e())}(this,function(){"use strict";function ne(Pe,ye){for(var Ce=0;Ce<ye.length;Ce++){var Z=ye[Ce];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(Pe,Z.key,Z)}}function e(Pe,ye,Ce){return ye&&ne(Pe.prototype,ye),Ce&&ne(Pe,Ce),Pe}function d(Pe,ye){if(!!Pe){if(typeof Pe=="string")return M(Pe,ye);var Ce=Object.prototype.toString.call(Pe).slice(8,-1);if(Ce==="Object"&&Pe.constructor&&(Ce=Pe.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Pe);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return M(Pe,ye)}}function M(Pe,ye){(ye==null||ye>Pe.length)&&(ye=Pe.length);for(var Ce=0,Z=new Array(ye);Ce<ye;Ce++)Z[Ce]=Pe[Ce];return Z}function b(Pe,ye){var Ce=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(Ce)return(Ce=Ce.call(Pe)).next.bind(Ce);if(Array.isArray(Pe)||(Ce=d(Pe))||ye&&Pe&&typeof Pe.length=="number"){Ce&&(Pe=Ce);var Z=0;return function(){return Z>=Pe.length?{done:!0}:{done:!1,value:Pe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var R={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function C(Pe){R.exports.defaults=Pe}R.exports={defaults:F(),getDefaults:F,changeDefaults:C};var _=/[&<>"']/,T=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(ye){return n[ye]};function l(Pe,ye){if(ye){if(_.test(Pe))return Pe.replace(T,u)}else if(t.test(Pe))return Pe.replace(E,u);return Pe}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(Pe){return Pe.replace(a,function(ye,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var I=/(^|[^\[])\^/g;function S(Pe,ye){Pe=Pe.source||Pe,ye=ye||"";var Ce={replace:function(ce,ge){return ge=ge.source||ge,ge=ge.replace(I,"$1"),Pe=Pe.replace(ce,ge),Ce},getRegex:function(){return new RegExp(Pe,ye)}};return Ce}var o=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function y(Pe,ye,Ce){if(Pe){var Z;try{Z=decodeURIComponent(w(Ce)).replace(o,"").toLowerCase()}catch(ce){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ye&&!m.test(Ce)&&(Ce=c(ye,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(ce){return null}return Ce}var i={},v=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Pe,ye){i[" "+Pe]||(v.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=P(Pe,"/",!0)),Pe=i[" "+Pe];var Ce=Pe.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ce?ye:Pe.replace(r,"$1")+ye:ye.charAt(0)==="/"?Ce?ye:Pe.replace(s,"$1")+ye:Pe+ye}var h={exec:function(){}};function g(Pe){for(var ye=1,Ce,Z;ye<arguments.length;ye++){Ce=arguments[ye];for(Z in Ce)Object.prototype.hasOwnProperty.call(Ce,Z)&&(Pe[Z]=Ce[Z])}return Pe}function k(Pe,ye){var Ce=Pe.replace(/\|/g,function(ge,fe,Ie){for(var xe=!1,Le=fe;--Le>=0&&Ie[Le]==="\\";)xe=!xe;return xe?"|":" |"}),Z=Ce.split(/ \|/),ce=0;if(Z[0].trim()||Z.shift(),Z[Z.length-1].trim()||Z.pop(),Z.length>ye)Z.splice(ye);else for(;Z.length<ye;)Z.push("");for(;ce<Z.length;ce++)Z[ce]=Z[ce].trim().replace(/\\\|/g,"|");return Z}function P(Pe,ye,Ce){var Z=Pe.length;if(Z===0)return"";for(var ce=0;ce<Z;){var ge=Pe.charAt(Z-ce-1);if(ge===ye&&!Ce)ce++;else if(ge!==ye&&Ce)ce++;else break}return Pe.substr(0,Z-ce)}function p(Pe,ye){if(Pe.indexOf(ye[1])===-1)return-1;for(var Ce=Pe.length,Z=0,ce=0;ce<Ce;ce++)if(Pe[ce]==="\\")ce++;else if(Pe[ce]===ye[0])Z++;else if(Pe[ce]===ye[1]&&(Z--,Z<0))return ce;return-1}function D(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function f(Pe,ye){if(ye<1)return"";for(var Ce="";ye>1;)ye&1&&(Ce+=Pe),ye>>=1,Pe+=Pe;return Ce+Pe}var A={escape:l,unescape:w,edit:S,cleanUrl:y,resolveUrl:c,noopTest:h,merge:g,splitCells:k,rtrim:P,findClosingBracket:p,checkSanitizeDeprecation:D,repeatString:f},L=R.exports.defaults,V=A.rtrim,G=A.splitCells,$=A.escape,K=A.findClosingBracket;function W(Pe,ye,Ce,Z){var ce=ye.href,ge=ye.title?$(ye.title):null,fe=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){Z.state.inLink=!0;var Ie={type:"link",raw:Ce,href:ce,title:ge,text:fe,tokens:Z.inlineTokens(fe,[])};return Z.state.inLink=!1,Ie}else return{type:"image",raw:Ce,href:ce,title:ge,text:$(fe)}}function U(Pe,ye){var Ce=Pe.match(/^(\s+)(?:```)/);if(Ce===null)return ye;var Z=Ce[1];return ye.split(`
`).map(function(ce){var ge=ce.match(/^\s+/);if(ge===null)return ce;var fe=ge[0];return fe.length>=Z.length?ce.slice(Z.length):ce}).join(`
`)}var z=function(){function Pe(Ce){this.options=Ce||L}var ye=Pe.prototype;return ye.space=function(Z){var ce=this.rules.block.newline.exec(Z);if(ce)return ce[0].length>1?{type:"space",raw:ce[0]}:{raw:`
`}},ye.code=function(Z){var ce=this.rules.block.code.exec(Z);if(ce){var ge=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:V(ge,`
`)}}},ye.fences=function(Z){var ce=this.rules.block.fences.exec(Z);if(ce){var ge=ce[0],fe=U(ge,ce[3]||"");return{type:"code",raw:ge,lang:ce[2]?ce[2].trim():ce[2],text:fe}}},ye.heading=function(Z){var ce=this.rules.block.heading.exec(Z);if(ce){var ge=ce[2].trim();if(/#$/.test(ge)){var fe=V(ge,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(ge=fe.trim())}var Ie={type:"heading",raw:ce[0],depth:ce[1].length,text:ge,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},ye.hr=function(Z){var ce=this.rules.block.hr.exec(Z);if(ce)return{type:"hr",raw:ce[0]}},ye.blockquote=function(Z){var ce=this.rules.block.blockquote.exec(Z);if(ce){var ge=ce[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(Z){var ce=this.rules.block.list.exec(Z);if(ce){var ge,fe,Ie,xe,Le,Ve,Ze,ie,pe,se,B=ce[1].trim(),De=B.length>1,Se={type:"list",raw:"",ordered:De,start:De?+B.slice(0,-1):"",loose:!1,items:[]};B=De?"\\d{1,9}\\"+B.slice(-1):"\\"+B,this.options.pedantic&&(B=De?B:"[*+-]");for(var qe=new RegExp("^( {0,3}"+B+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");Z&&!(this.rules.block.hr.test(Z)||!(ce=qe.exec(Z)));){pe=ce[2].split(`
`),this.options.pedantic?(xe=2,se=pe[0].trimLeft()):(xe=ce[2].search(/[^ ]/),xe=ce[1].length+(xe>4?1:xe),se=pe[0].slice(xe-ce[1].length)),Ve=!1,ge=ce[0],!pe[0]&&/^ *$/.test(pe[1])&&(ge=ce[1]+pe.slice(0,2).join(`
`)+`
`,Se.loose=!0,pe=[]);var We=new RegExp("^ {0,"+Math.min(3,xe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<pe.length;Le++){if(ie=pe[Le],this.options.pedantic&&(ie=ie.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),We.test(ie)){ge=ce[1]+pe.slice(0,Le).join(`
`)+`
`;break}if(!Ve){ie.trim()||(Ve=!0),ie.search(/[^ ]/)>=xe?se+=`
`+ie.slice(xe):se+=`
`+ie;continue}if(ie.search(/[^ ]/)>=xe||!ie.trim()){se+=`
`+ie.slice(xe);continue}else{ge=ce[1]+pe.slice(0,Le).join(`
`)+`
`;break}}Se.loose||(Ze?Se.loose=!0:/\n *\n *$/.test(ge)&&(Ze=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(se),fe&&(Ie=fe[0]!=="[ ] ",se=se.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:ge,task:!!fe,checked:Ie,loose:!1,text:se}),Se.raw+=ge,Z=Z.slice(ge.length)}Se.items[Se.items.length-1].raw=ge.trimRight(),Se.items[Se.items.length-1].text=se.trimRight(),Se.raw=Se.raw.trimRight();var tt=Se.items.length;for(Le=0;Le<tt;Le++)this.lexer.state.top=!1,Se.items[Le].tokens=this.lexer.blockTokens(Se.items[Le].text,[]),Se.items[Le].tokens.some(function(mt){return mt.type==="space"})&&(Se.loose=!0,Se.items[Le].loose=!0);return Se}},ye.html=function(Z){var ce=this.rules.block.html.exec(Z);if(ce){var ge={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(ce[0]):$(ce[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(Z){var ce=this.rules.block.def.exec(Z);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ge=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:ce[0],href:ce[2],title:ce[3]}}},ye.table=function(Z){var ce=this.rules.block.table.exec(Z);if(ce){var ge={type:"table",header:G(ce[1]).map(function(Ze){return{text:Ze}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]?ce[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=ce[0];var fe=ge.align.length,Ie,xe,Le,Ve;for(Ie=0;Ie<fe;Ie++)/^ *-+: *$/.test(ge.align[Ie])?ge.align[Ie]="right":/^ *:-+: *$/.test(ge.align[Ie])?ge.align[Ie]="center":/^ *:-+ *$/.test(ge.align[Ie])?ge.align[Ie]="left":ge.align[Ie]=null;for(fe=ge.rows.length,Ie=0;Ie<fe;Ie++)ge.rows[Ie]=G(ge.rows[Ie],ge.header.length).map(function(Ze){return{text:Ze}});for(fe=ge.header.length,xe=0;xe<fe;xe++)ge.header[xe].tokens=[],this.lexer.inlineTokens(ge.header[xe].text,ge.header[xe].tokens);for(fe=ge.rows.length,xe=0;xe<fe;xe++)for(Ve=ge.rows[xe],Le=0;Le<Ve.length;Le++)Ve[Le].tokens=[],this.lexer.inlineTokens(Ve[Le].text,Ve[Le].tokens);return ge}}},ye.lheading=function(Z){var ce=this.rules.block.lheading.exec(Z);if(ce){var ge={type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(Z){var ce=this.rules.block.paragraph.exec(Z);if(ce){var ge={type:"paragraph",raw:ce[0],text:ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(Z){var ce=this.rules.block.text.exec(Z);if(ce){var ge={type:"text",raw:ce[0],text:ce[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(Z){var ce=this.rules.inline.escape.exec(Z);if(ce)return{type:"escape",raw:ce[0],text:$(ce[1])}},ye.tag=function(Z){var ce=this.rules.inline.tag.exec(Z);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):$(ce[0]):ce[0]}},ye.link=function(Z){var ce=this.rules.inline.link.exec(Z);if(ce){var ge=ce[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var fe=V(ge.slice(0,-1),"\\");if((ge.length-fe.length)%2==0)return}else{var Ie=K(ce[2],"()");if(Ie>-1){var xe=ce[0].indexOf("!")===0?5:4,Le=xe+ce[1].length+Ie;ce[2]=ce[2].substring(0,Ie),ce[0]=ce[0].substring(0,Le).trim(),ce[3]=""}}var Ve=ce[2],Ze="";if(this.options.pedantic){var ie=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);ie&&(Ve=ie[1],Ze=ie[3])}else Ze=ce[3]?ce[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(ge)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),W(ce,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:Ze&&Ze.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},ye.reflink=function(Z,ce){var ge;if((ge=this.rules.inline.reflink.exec(Z))||(ge=this.rules.inline.nolink.exec(Z))){var fe=(ge[2]||ge[1]).replace(/\s+/g," ");if(fe=ce[fe.toLowerCase()],!fe||!fe.href){var Ie=ge[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return W(ge,fe,ge[0],this.lexer)}},ye.emStrong=function(Z,ce,ge){ge===void 0&&(ge="");var fe=this.rules.inline.emStrong.lDelim.exec(Z);if(!!fe&&!(fe[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=fe[1]||fe[2]||"";if(!Ie||Ie&&(ge===""||this.rules.inline.punctuation.exec(ge))){var xe=fe[0].length-1,Le,Ve,Ze=xe,ie=0,pe=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ce=ce.slice(-1*Z.length+xe);(fe=pe.exec(ce))!=null;)if(Le=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Le){if(Ve=Le.length,fe[3]||fe[4]){Ze+=Ve;continue}else if((fe[5]||fe[6])&&xe%3&&!((xe+Ve)%3)){ie+=Ve;continue}if(Ze-=Ve,!(Ze>0)){if(Ve=Math.min(Ve,Ve+Ze+ie),Math.min(xe,Ve)%2){var se=Z.slice(1,xe+fe.index+Ve);return{type:"em",raw:Z.slice(0,xe+fe.index+Ve+1),text:se,tokens:this.lexer.inlineTokens(se,[])}}var B=Z.slice(2,xe+fe.index+Ve-1);return{type:"strong",raw:Z.slice(0,xe+fe.index+Ve+1),text:B,tokens:this.lexer.inlineTokens(B,[])}}}}}},ye.codespan=function(Z){var ce=this.rules.inline.code.exec(Z);if(ce){var ge=ce[2].replace(/\n/g," "),fe=/[^ ]/.test(ge),Ie=/^ /.test(ge)&&/ $/.test(ge);return fe&&Ie&&(ge=ge.substring(1,ge.length-1)),ge=$(ge,!0),{type:"codespan",raw:ce[0],text:ge}}},ye.br=function(Z){var ce=this.rules.inline.br.exec(Z);if(ce)return{type:"br",raw:ce[0]}},ye.del=function(Z){var ce=this.rules.inline.del.exec(Z);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2],[])}},ye.autolink=function(Z,ce){var ge=this.rules.inline.autolink.exec(Z);if(ge){var fe,Ie;return ge[2]==="@"?(fe=$(this.options.mangle?ce(ge[1]):ge[1]),Ie="mailto:"+fe):(fe=$(ge[1]),Ie=fe),{type:"link",raw:ge[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.url=function(Z,ce){var ge;if(ge=this.rules.inline.url.exec(Z)){var fe,Ie;if(ge[2]==="@")fe=$(this.options.mangle?ce(ge[0]):ge[0]),Ie="mailto:"+fe;else{var xe;do xe=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(xe!==ge[0]);fe=$(ge[0]),ge[1]==="www."?Ie="http://"+fe:Ie=fe}return{type:"link",raw:ge[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.inlineText=function(Z,ce){var ge=this.rules.inline.text.exec(Z);if(ge){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):$(ge[0]):ge[0]:fe=$(this.options.smartypants?ce(ge[0]):ge[0]),{type:"text",raw:ge[0],text:fe}}},Pe}(),Y=A.noopTest,re=A.edit,j=A.merge,ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:Y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=re(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.listItemStart=re(/^( *)(bull) */).replace("bull",ue.bullet).getRegex(),ue.list=re(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=re(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=re(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=re(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=j({},ue),ue.gfm=j({},ue.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.table=re(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=j({},ue.normal,{html:re(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Y,paragraph:re(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=re(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=re(ue._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=re(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=re(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=re(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=re(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=re(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=re(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=re(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=re(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=j({},oe),oe.pedantic=j({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:re(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:re(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=j({},oe.normal,{escape:re(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=re(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=j({},oe.gfm,{br:re(oe.br).replace("{2,}","*").getRegex(),text:re(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:ue,inline:oe},Fe=z,Me=R.exports.defaults,Oe=ve.block,Ye=ve.inline,ze=A.repeatString;function je(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(Pe){var ye="",Ce,Z,ce=Pe.length;for(Ce=0;Ce<ce;Ce++)Z=Pe.charCodeAt(Ce),Math.random()>.5&&(Z="x"+Z.toString(16)),ye+="&#"+Z+";";return ye}var Q=function(){function Pe(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Me,this.options.tokenizer=this.options.tokenizer||new Fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:Oe.normal,inline:Ye.normal};this.options.pedantic?(Z.block=Oe.pedantic,Z.inline=Ye.pedantic):this.options.gfm&&(Z.block=Oe.gfm,this.options.breaks?Z.inline=Ye.breaks:Z.inline=Ye.gfm),this.tokenizer.rules=Z}Pe.lex=function(Z,ce){var ge=new Pe(ce);return ge.lex(Z)},Pe.lexInline=function(Z,ce){var ge=new Pe(ce);return ge.inlineTokens(Z)};var ye=Pe.prototype;return ye.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},ye.blockTokens=function(Z,ce){var ge=this;ce===void 0&&(ce=[]),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var fe,Ie,xe,Le;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ze){return(fe=Ze.call({lexer:ge},Z,ce))?(Z=Z.substring(fe.raw.length),ce.push(fe),!0):!1}))){if(fe=this.tokenizer.space(Z)){Z=Z.substring(fe.raw.length),fe.type&&ce.push(fe);continue}if(fe=this.tokenizer.code(Z)){Z=Z.substring(fe.raw.length),Ie=ce[ce.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(fe);continue}if(fe=this.tokenizer.fences(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.heading(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.hr(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.blockquote(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.list(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.html(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.def(Z)){Z=Z.substring(fe.raw.length),Ie=ce[ce.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.lheading(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(xe=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ze=Infinity,ie=Z.slice(1),pe=void 0;ge.options.extensions.startBlock.forEach(function(se){pe=se.call({lexer:this},ie),typeof pe=="number"&&pe>=0&&(Ze=Math.min(Ze,pe))}),Ze<Infinity&&Ze>=0&&(xe=Z.substring(0,Ze+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(xe))){Ie=ce[ce.length-1],Le&&Ie.type==="paragraph"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(fe),Le=xe.length!==Z.length,Z=Z.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(Z)){Z=Z.substring(fe.raw.length),Ie=ce[ce.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(fe);continue}if(Z){var Ve="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return this.state.top=!0,ce},ye.inline=function(Z,ce){this.inlineQueue.push({src:Z,tokens:ce})},ye.inlineTokens=function(Z,ce){var ge=this;ce===void 0&&(ce=[]);var fe,Ie,xe,Le=Z,Ve,Ze,ie;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)pe.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ve.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Ze||(ie=""),Ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(B){return(fe=B.call({lexer:ge},Z,ce))?(Z=Z.substring(fe.raw.length),ce.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.tag(Z)){Z=Z.substring(fe.raw.length),Ie=ce[ce.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ce.push(fe);continue}if(fe=this.tokenizer.link(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(fe.raw.length),Ie=ce[ce.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ce.push(fe);continue}if(fe=this.tokenizer.emStrong(Z,Le,ie)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.codespan(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.br(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.del(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.autolink(Z,x)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(Z,x))){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(xe=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var B=Infinity,De=Z.slice(1),Se=void 0;ge.options.extensions.startInline.forEach(function(qe){Se=qe.call({lexer:this},De),typeof Se=="number"&&Se>=0&&(B=Math.min(B,Se))}),B<Infinity&&B>=0&&(xe=Z.substring(0,B+1))}(),fe=this.tokenizer.inlineText(xe,je)){Z=Z.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(ie=fe.raw.slice(-1)),Ze=!0,Ie=ce[ce.length-1],Ie&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ce.push(fe);continue}if(Z){var se="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(se);break}else throw new Error(se)}}return ce},e(Pe,null,[{key:"rules",get:function(){return{block:Oe,inline:Ye}}}]),Pe}(),ee=R.exports.defaults,le=A.cleanUrl,q=A.escape,ae=function(){function Pe(Ce){this.options=Ce||ee}var ye=Pe.prototype;return ye.code=function(Z,ce,ge){var fe=(ce||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(Z,fe);Ie!=null&&Ie!==Z&&(ge=!0,Z=Ie)}return Z=Z.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+q(fe,!0)+'">'+(ge?Z:q(Z,!0))+`</code></pre>
`:"<pre><code>"+(ge?Z:q(Z,!0))+`</code></pre>
`},ye.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ye.html=function(Z){return Z},ye.heading=function(Z,ce,ge,fe){return this.options.headerIds?"<h"+ce+' id="'+this.options.headerPrefix+fe.slug(ge)+'">'+Z+"</h"+ce+`>
`:"<h"+ce+">"+Z+"</h"+ce+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(Z,ce,ge){var fe=ce?"ol":"ul",Ie=ce&&ge!==1?' start="'+ge+'"':"";return"<"+fe+Ie+`>
`+Z+"</"+fe+`>
`},ye.listitem=function(Z){return"<li>"+Z+`</li>
`},ye.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(Z){return"<p>"+Z+`</p>
`},ye.table=function(Z,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ce+`</table>
`},ye.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ye.tablecell=function(Z,ce){var ge=ce.header?"th":"td",fe=ce.align?"<"+ge+' align="'+ce.align+'">':"<"+ge+">";return fe+Z+"</"+ge+`>
`},ye.strong=function(Z){return"<strong>"+Z+"</strong>"},ye.em=function(Z){return"<em>"+Z+"</em>"},ye.codespan=function(Z){return"<code>"+Z+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(Z){return"<del>"+Z+"</del>"},ye.link=function(Z,ce,ge){if(Z=le(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var fe='<a href="'+q(Z)+'"';return ce&&(fe+=' title="'+ce+'"'),fe+=">"+ge+"</a>",fe},ye.image=function(Z,ce,ge){if(Z=le(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var fe='<img src="'+Z+'" alt="'+ge+'"';return ce&&(fe+=' title="'+ce+'"'),fe+=this.options.xhtml?"/>":">",fe},ye.text=function(Z){return Z},Pe}(),he=function(){function Pe(){}var ye=Pe.prototype;return ye.strong=function(Z){return Z},ye.em=function(Z){return Z},ye.codespan=function(Z){return Z},ye.del=function(Z){return Z},ye.html=function(Z){return Z},ye.text=function(Z){return Z},ye.link=function(Z,ce,ge){return""+ge},ye.image=function(Z,ce,ge){return""+ge},ye.br=function(){return""},Pe}(),Te=function(){function Pe(){this.seen={}}var ye=Pe.prototype;return ye.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(Z,ce){var ge=Z,fe=0;if(this.seen.hasOwnProperty(ge)){fe=this.seen[Z];do fe++,ge=Z+"-"+fe;while(this.seen.hasOwnProperty(ge))}return ce||(this.seen[Z]=fe,this.seen[ge]=0),ge},ye.slug=function(Z,ce){ce===void 0&&(ce={});var ge=this.serialize(Z);return this.getNextSafeSlug(ge,ce.dryrun)},Pe}(),Be=ae,$e=he,Qe=Te,_e=R.exports.defaults,rt=A.unescape,H=function(){function Pe(Ce){this.options=Ce||_e,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $e,this.slugger=new Qe}Pe.parse=function(Z,ce){var ge=new Pe(ce);return ge.parse(Z)},Pe.parseInline=function(Z,ce){var ge=new Pe(ce);return ge.parseInline(Z)};var ye=Pe.prototype;return ye.parse=function(Z,ce){ce===void 0&&(ce=!0);var ge="",fe,Ie,xe,Le,Ve,Ze,ie,pe,se,B,De,Se,qe,We,tt,mt,wt,nt,ct,lt=Z.length;for(fe=0;fe<lt;fe++){if(B=Z[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(ct=this.options.extensions.renderers[B.type].call({parser:this},B),ct!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(B.type))){ge+=ct||"";continue}switch(B.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(B.tokens),B.depth,rt(this.parseInline(B.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(B.text,B.lang,B.escaped);continue}case"table":{for(pe="",ie="",Le=B.header.length,Ie=0;Ie<Le;Ie++)ie+=this.renderer.tablecell(this.parseInline(B.header[Ie].tokens),{header:!0,align:B.align[Ie]});for(pe+=this.renderer.tablerow(ie),se="",Le=B.rows.length,Ie=0;Ie<Le;Ie++){for(Ze=B.rows[Ie],ie="",Ve=Ze.length,xe=0;xe<Ve;xe++)ie+=this.renderer.tablecell(this.parseInline(Ze[xe].tokens),{header:!1,align:B.align[xe]});se+=this.renderer.tablerow(ie)}ge+=this.renderer.table(pe,se);continue}case"blockquote":{se=this.parse(B.tokens),ge+=this.renderer.blockquote(se);continue}case"list":{for(De=B.ordered,Se=B.start,qe=B.loose,Le=B.items.length,se="",Ie=0;Ie<Le;Ie++)tt=B.items[Ie],mt=tt.checked,wt=tt.task,We="",tt.task&&(nt=this.renderer.checkbox(mt),qe?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=nt+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=nt+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:nt}):We+=nt),We+=this.parse(tt.tokens,qe),se+=this.renderer.listitem(We,wt,mt);ge+=this.renderer.list(se,De,Se);continue}case"html":{ge+=this.renderer.html(B.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(B.tokens));continue}case"text":{for(se=B.tokens?this.parseInline(B.tokens):B.text;fe+1<lt&&Z[fe+1].type==="text";)B=Z[++fe],se+=`
`+(B.tokens?this.parseInline(B.tokens):B.text);ge+=ce?this.renderer.paragraph(se):se;continue}default:{var Tt='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(Tt);return}else throw new Error(Tt)}}}return ge},ye.parseInline=function(Z,ce){ce=ce||this.renderer;var ge="",fe,Ie,xe,Le=Z.length;for(fe=0;fe<Le;fe++){if(Ie=Z[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(xe=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),xe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){ge+=xe||"";continue}switch(Ie.type){case"escape":{ge+=ce.text(Ie.text);break}case"html":{ge+=ce.html(Ie.text);break}case"link":{ge+=ce.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ce));break}case"image":{ge+=ce.image(Ie.href,Ie.title,Ie.text);break}case"strong":{ge+=ce.strong(this.parseInline(Ie.tokens,ce));break}case"em":{ge+=ce.em(this.parseInline(Ie.tokens,ce));break}case"codespan":{ge+=ce.codespan(Ie.text);break}case"br":{ge+=ce.br();break}case"del":{ge+=ce.del(this.parseInline(Ie.tokens,ce));break}case"text":{ge+=ce.text(Ie.text);break}default:{var Ve='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(Ve);return}else throw new Error(Ve)}}}return ge},Pe}(),J=Q,me=H,Ne=z,Ke=ae,ot=he,at=Te,vt=A.merge,kt=A.checkSanitizeDeprecation,ht=A.escape,yt=R.exports.getDefaults,It=R.exports.changeDefaults,ft=R.exports.defaults;function Je(Pe,ye,Ce){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ye=="function"&&(Ce=ye,ye=null),ye=vt({},Je.defaults,ye||{}),kt(ye),Ce){var Z=ye.highlight,ce;try{ce=J.lex(Pe,ye)}catch(xe){return Ce(xe)}var ge=function(Le){var Ve;if(!Le)try{ye.walkTokens&&Je.walkTokens(ce,ye.walkTokens),Ve=me.parse(ce,ye)}catch(Ze){Le=Ze}return ye.highlight=Z,Le?Ce(Le):Ce(null,Ve)};if(!Z||Z.length<3||(delete ye.highlight,!ce.length))return ge();var fe=0;Je.walkTokens(ce,function(xe){xe.type==="code"&&(fe++,setTimeout(function(){Z(xe.text,xe.lang,function(Le,Ve){if(Le)return ge(Le);Ve!=null&&Ve!==xe.text&&(xe.text=Ve,xe.escaped=!0),fe--,fe===0&&ge()})},0))}),fe===0&&ge();return}try{var Ie=J.lex(Pe,ye);return ye.walkTokens&&Je.walkTokens(Ie,ye.walkTokens),me.parse(Ie,ye)}catch(xe){if(xe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ht(xe.message+"",!0)+"</pre>";throw xe}}Je.options=Je.setOptions=function(Pe){return vt(Je.defaults,Pe),It(Je.defaults),Je},Je.getDefaults=yt,Je.defaults=ft,Je.use=function(){for(var Pe=this,ye=arguments.length,Ce=new Array(ye),Z=0;Z<ye;Z++)Ce[Z]=arguments[Z];var ce=vt.apply(void 0,[{}].concat(Ce)),ge=Je.defaults.extensions||{renderers:{},childTokens:{}},fe;Ce.forEach(function(Ie){if(Ie.extensions&&(fe=!0,Ie.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var Ve=ge.renderers?ge.renderers[Le.name]:null;Ve?ge.renderers[Le.name]=function(){for(var Ze=arguments.length,ie=new Array(Ze),pe=0;pe<Ze;pe++)ie[pe]=arguments[pe];var se=Le.renderer.apply(this,ie);return se===!1&&(se=Ve.apply(this,ie)),se}:ge.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Le.level]?ge[Le.level].unshift(Le.tokenizer):ge[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?ge.startBlock?ge.startBlock.push(Le.start):ge.startBlock=[Le.start]:Le.level==="inline"&&(ge.startInline?ge.startInline.push(Le.start):ge.startInline=[Le.start]))}Le.childTokens&&(ge.childTokens[Le.name]=Le.childTokens)})),Ie.renderer&&function(){var Le=Je.defaults.renderer||new Ke,Ve=function(pe){var se=Le[pe];Le[pe]=function(){for(var B=arguments.length,De=new Array(B),Se=0;Se<B;Se++)De[Se]=arguments[Se];var qe=Ie.renderer[pe].apply(Le,De);return qe===!1&&(qe=se.apply(Le,De)),qe}};for(var Ze in Ie.renderer)Ve(Ze);ce.renderer=Le}(),Ie.tokenizer&&function(){var Le=Je.defaults.tokenizer||new Ne,Ve=function(pe){var se=Le[pe];Le[pe]=function(){for(var B=arguments.length,De=new Array(B),Se=0;Se<B;Se++)De[Se]=arguments[Se];var qe=Ie.tokenizer[pe].apply(Le,De);return qe===!1&&(qe=se.apply(Le,De)),qe}};for(var Ze in Ie.tokenizer)Ve(Ze);ce.tokenizer=Le}(),Ie.walkTokens){var xe=Je.defaults.walkTokens;ce.walkTokens=function(Le){Ie.walkTokens.call(Pe,Le),xe&&xe(Le)}}fe&&(ce.extensions=ge),Je.setOptions(ce)})},Je.walkTokens=function(Pe,ye){for(var Ce=function(){var fe=ce.value;switch(ye(fe),fe.type){case"table":{for(var Ie=b(fe.header),xe;!(xe=Ie()).done;){var Le=xe.value;Je.walkTokens(Le.tokens,ye)}for(var Ve=b(fe.rows),Ze;!(Ze=Ve()).done;)for(var ie=Ze.value,pe=b(ie),se;!(se=pe()).done;){var B=se.value;Je.walkTokens(B.tokens,ye)}break}case"list":{Je.walkTokens(fe.items,ye);break}default:Je.defaults.extensions&&Je.defaults.extensions.childTokens&&Je.defaults.extensions.childTokens[fe.type]?Je.defaults.extensions.childTokens[fe.type].forEach(function(De){Je.walkTokens(fe[De],ye)}):fe.tokens&&Je.walkTokens(fe.tokens,ye)}},Z=b(Pe),ce;!(ce=Z()).done;)Ce()},Je.parseInline=function(Pe,ye){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ye=vt({},Je.defaults,ye||{}),kt(ye);try{var Ce=J.lexInline(Pe,ye);return ye.walkTokens&&Je.walkTokens(Ce,ye.walkTokens),me.parseInline(Ce,ye)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ht(Z.message+"",!0)+"</pre>";throw Z}},Je.Parser=me,Je.parser=me.parse,Je.Renderer=Ke,Je.TextRenderer=ot,Je.Lexer=J,Je.lexer=J.lex,Je.Tokenizer=Ne,Je.Slugger=at,Je.parse=Je;var Et=Je;return Et}),define(we[75],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(F,C,_){return Math.min(Math.max(F,C),_)}e.clamp=d;function M(F,C){return(C+F%C)%C}e.rot=M;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class R{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=R}),function(){function ne(b){const R=[];typeof b=="number"&&R.push("code/timeOrigin",b);function F(_){R.push(_,Date.now())}function C(){const _=[];for(let T=0;T<R.length;T+=2)_.push({name:R[T],startTime:R[T+1]});return _}return{mark:F,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const F of performance.getEntriesByType("mark"))R.push({name:F.name,startTime:Math.round(b+F.startTime)});return R}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function d(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=d(M))}(),define(we[104],be([0,1]),function(ne,e){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(C,_,T){this.level=C,this.key=_,this.value=T,this.forward=[]}}const b=void 0;class R{constructor(C,_=2**16){this.comparator=C,this[d]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(_)|0),this._header=new M(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new M(this._maxLevel,b,b)}has(C){return Boolean(R._search(this,C,this.comparator))}get(C){return R._search(this,C,this.comparator)?.value}set(C,_){return R._insert(this,C,_,this.comparator)&&(this._size+=1),this}delete(C){const _=R._delete(this,C,this.comparator);return _&&(this._size-=1),_}forEach(C,_){let T=this._header.forward[0];for(;T;)C.call(_,T.value,T.key,this),T=T.forward[0]}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",_=this._header.forward[0];for(;_;)C+=`node(${_.key}, ${_.value}, lvl:${_.level})`,_=_.forward[0];return C}static _search(C,_,T){let t=C._header;for(let E=C._level-1;E>=0;E--)for(;t.forward[E]&&T(t.forward[E].key,_)<0;)t=t.forward[E];if(t=t.forward[0],t&&T(t.key,_)===0)return t}static _insert(C,_,T,t){let E=[],n=C._header;for(let u=C._level-1;u>=0;u--){for(;n.forward[u]&&t(n.forward[u].key,_)<0;)n=n.forward[u];E[u]=n}if(n=n.forward[0],n&&t(n.key,_)===0)return n.value=T,!1;{let u=R._randomLevel(C);if(u>C._level){for(let l=C._level;l<u;l++)E[l]=C._header;C._level=u}n=new M(u,_,T);for(let l=0;l<u;l++)n.forward[l]=E[l].forward[l],E[l].forward[l]=n;return!0}}static _randomLevel(C,_=.5){let T=1;for(;Math.random()<_&&T<C._maxLevel;)T+=1;return T}static _delete(C,_,T){let t=[],E=C._header;for(let n=C._level-1;n>=0;n--){for(;E.forward[n]&&T(E.forward[n].key,_)<0;)E=E.forward[n];t[n]=E}if(E=E.forward[0],!E||T(E.key,_)!==0)return!1;for(let n=0;n<C._level&&t[n].forward[n]===E;n++)t[n].forward[n]=E.forward[n];for(;C._level>0&&C._header.forward[C._level-1]===b;)C._level-=1;return!0}}e.SkipList=R}),define(we[34],be([0,1,3]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new d.Emitter}add(E){const n=this._icons.get(E.id);n?E.description?n.description=E.description:console.error(`Duplicate registration of codicon ${E.id}`):(this._icons.set(E.id,E),this._onDidRegister.fire(E))}get(E){return this._icons.get(E)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const b=new M;e.iconRegistry=b;function R(t,E){return new C(t,E)}e.registerCodicon=R;function F(t){return t?t.replace(/\$\((.*?)\)/g,(E,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=F;class C{constructor(E,n,u){this.id=E,this.definition=n,this.description=u,b.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function _(t,E){const n=["codicon","codicon-"+t];return E&&n.push("codicon-modifier-"+E),n}e.getClassNamesArray=_;var T;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const E=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(a){if(a instanceof C)return["codicon","codicon-"+a.id];const w=E.exec(a.id);if(!w)return n(C.error);let[,I,S]=w;const o=["codicon","codicon-"+I];return S&&o.push("codicon-modifier-"+S.substr(1)),o}t.asClassNameArray=n;function u(a){return n(a).join(" ")}t.asClassName=u;function l(a){return"."+n(a).join(".")}t.asCSSSelector=l})(T=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(we[105],be([0,1,16,6]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function b(o){const m=o;return m?[m.on,m.pause,m.resume,m.destroy].every(y=>typeof y=="function"):!1}e.isReadableStream=b;function R(o){const m=o;return m?b(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=R;function F(o,m){return new C(o,m)}e.newWriteableStream=F;class C{constructor(m,y){this.reducer=m,this.options=y,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(y=>this.pendingWritePromises.push(y))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(y=>y(m))}emitError(m){this.listeners.error.length===0?(0,d.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(y=>y(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,y){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(y),this.resume();break;case"end":this.listeners.end.push(y),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(y),this.state.flowing&&this.flowErrors();break}}removeListener(m,y){if(this.state.destroyed)return;let i;switch(m){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const v=i.indexOf(y);v>=0&&i.splice(v,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const y=[...this.pendingWritePromises];this.pendingWritePromises.length=0,y.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(o,m){const y=[];let i;for(;(i=o.read())!==null;)y.push(i);return m(y)}e.consumeReadable=_;function T(o,m,y){const i=[];let v;for(;(v=o.read())!==null&&i.length<y;)i.push(v);return v===null&&i.length>0?m(i):{read:()=>{if(i.length>0)return i.shift();if(typeof v!="undefined"){const r=v;return v=void 0,r}return o.read()}}}e.peekReadable=T;function t(o,m){return new Promise((y,i)=>{const v=[];E(o,{onData:r=>{m&&v.push(r)},onError:r=>{m?i(r):y(void 0)},onEnd:()=>{y(m?m(v):void 0)}})})}e.consumeStream=t;function E(o,m){o.on("error",y=>m.onError(y)),o.on("end",()=>m.onEnd()),o.on("data",y=>m.onData(y))}e.listenStream=E;function n(o,m){return new Promise((y,i)=>{const v=new M.DisposableStore,r=[],s=g=>{if(r.push(g),r.length>m)return v.dispose(),o.pause(),y({stream:o,buffer:r,ended:!1})},c=g=>i(g),h=()=>y({stream:o,buffer:r,ended:!0});v.add((0,M.toDisposable)(()=>o.removeListener("error",c))),o.on("error",c),v.add((0,M.toDisposable)(()=>o.removeListener("end",h))),o.on("end",h),v.add((0,M.toDisposable)(()=>o.removeListener("data",s))),o.on("data",s)})}e.peekStream=n;function u(o,m){const y=F(m);return y.end(o),y}e.toStream=u;function l(){const o=F(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=l;function a(o){let m=!1;return{read:()=>m?null:(m=!0,o)}}e.toReadable=a;function w(o,m,y){const i=F(y);return E(o,{onData:v=>i.write(m.data(v)),onError:v=>i.error(m.error?m.error(v):v),onEnd:()=>i.end()}),i}e.transform=w;function I(o,m,y){let i=!1;return{read:()=>{const v=m.read();return i?v:(i=!0,v!==null?y([o,v]):o)}}}e.prefixedReadable=I;function S(o,m,y){let i=!1;const v=F(y);return E(m,{onData:r=>i?v.write(r):(i=!0,v.write(y([o,r]))),onError:r=>v.error(r),onEnd:()=>{i||(i=!0,v.write(o)),v.end()}}),v}e.prefixedStream=S}),define(we[22],be([0,1,105]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let b,R;class F{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return M?new F(Buffer.allocUnsafe(s)):new F(new Uint8Array(s))}static wrap(s){return M&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new F(s)}static fromString(s,c){return!(c?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(s)):(b||(b=new TextEncoder),new F(b.encode(s)))}static concat(s,c){if(typeof c=="undefined"){c=0;for(let k=0,P=s.length;k<P;k++)c+=s[k].byteLength}const h=F.alloc(c);let g=0;for(let k=0,P=s.length;k<P;k++){const p=s[k];h.set(p,g),g+=p.byteLength}return h}toString(){return M?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(s,c){return new F(this.buffer.subarray(s,c))}set(s,c){s instanceof F?this.buffer.set(s.buffer,c):this.buffer.set(s,c)}readUInt32BE(s){return T(this.buffer,s)}writeUInt32BE(s,c){t(this.buffer,s,c)}readUInt32LE(s){return E(this.buffer,s)}writeUInt32LE(s,c){n(this.buffer,s,c)}readUInt8(s){return u(this.buffer,s)}writeUInt8(s,c){l(this.buffer,s,c)}}e.VSBuffer=F;function C(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0}e.readUInt16LE=C;function _(r,s,c){r[c+0]=s&255,s=s>>>8,r[c+1]=s&255}e.writeUInt16LE=_;function T(r,s){return r[s]*2**24+r[s+1]*2**16+r[s+2]*2**8+r[s+3]}e.readUInt32BE=T;function t(r,s,c){r[c+3]=s,s=s>>>8,r[c+2]=s,s=s>>>8,r[c+1]=s,s=s>>>8,r[c]=s}e.writeUInt32BE=t;function E(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0|r[s+2]<<16>>>0|r[s+3]<<24>>>0}e.readUInt32LE=E;function n(r,s,c){r[c+0]=s&255,s=s>>>8,r[c+1]=s&255,s=s>>>8,r[c+2]=s&255,s=s>>>8,r[c+3]=s&255}e.writeUInt32LE=n;function u(r,s){return r[s]}e.readUInt8=u;function l(r,s,c){r[c]=s}e.writeUInt8=l;function a(r){return d.consumeReadable(r,s=>F.concat(s))}e.readableToBuffer=a;function w(r){return d.toReadable(r)}e.bufferToReadable=w;function I(r){return d.consumeStream(r,s=>F.concat(s))}e.streamToBuffer=I;async function S(r){return r.ended?F.concat(r.buffer):F.concat([...r.buffer,await I(r.stream)])}e.bufferedStreamToBuffer=S;function o(r){return d.toStream(r,s=>F.concat(s))}e.bufferToStream=o;function m(r){return d.transform(r,{data:s=>typeof s=="string"?F.fromString(s):F.wrap(s)},s=>F.concat(s))}e.streamToBufferReadableStream=m;function y(r){return d.newWriteableStream(s=>F.concat(s),r)}e.newWriteableBufferStream=y;function i(r,s){return d.prefixedReadable(r,s,c=>F.concat(c))}e.prefixedBufferReadable=i;function v(r,s){return d.prefixedStream(r,s,c=>F.concat(c))}e.prefixedBufferStream=v}),define(we[35],be([0,1,9]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(M||(M={})),function(b){const R="error",F="warning",C="warn",_="info",T="ignore";function t(n){return n?d.equalsIgnoreCase(R,n)?b.Error:d.equalsIgnoreCase(F,n)||d.equalsIgnoreCase(C,n)?b.Warning:d.equalsIgnoreCase(_,n)?b.Info:b.Ignore:b.Ignore}b.fromValue=t;function E(n){switch(n){case b.Error:return R;case b.Warning:return F;case b.Info:return _;default:return T}}b.toString=E}(M||(M={})),e.default=M}),define(we[43],be([0,1,17,26,9,10]),function(ne,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(r){return r===47||r===92}e.isPathSeparator=F;function C(r){return r.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=C;function _(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=_;function T(r,s=d.posix.sep){if(!r)return"";const c=r.length,h=r.charCodeAt(0);if(F(h)){if(F(r.charCodeAt(1))&&!F(r.charCodeAt(2))){let k=3;const P=k;for(;k<c&&!F(r.charCodeAt(k));k++);if(P!==k&&!F(r.charCodeAt(k+1))){for(k+=1;k<c;k++)if(F(r.charCodeAt(k)))return r.slice(0,k+1).replace(/[\\/]/g,s)}}return s}else if(I(h)&&r.charCodeAt(1)===58)return F(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let g=r.indexOf("://");if(g!==-1){for(g+=3;g<c;g++)if(F(r.charCodeAt(g)))return r.slice(0,g+1)}return""}e.getRoot=T;function t(r){if(!M.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let c=2;const h=c;for(;c<r.length&&(s=r.charCodeAt(c),s!==92);c++);return!(h===c||(s=r.charCodeAt(c+1),isNaN(s)||s===92))}e.isUNC=t;const E=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(r,s=M.isWindows){const c=s?E:n;return!(!r||r.length===0||/^\s+$/.test(r)||(c.lastIndex=0,c.test(r))||s&&u.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=l;function a(r,s,c){const h=r===s;return!c||h?h:!r||!s?!1:(0,b.equalsIgnoreCase)(r,s)}e.isEqual=a;function w(r,s,c,h=d.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(c){if(!(0,b.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let k=s.length;return s.charAt(s.length-1)===h&&k--,r.charAt(k)===h}return s.charAt(s.length-1)!==h&&(s+=h),r.indexOf(s)===0}e.isEqualOrParent=w;function I(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=I;function S(r,s){return M.isWindows&&r.endsWith(":")&&(r+=d.sep),(0,d.isAbsolute)(r)||(r=(0,d.join)(s,r)),r=(0,d.normalize)(r),M.isWindows?(r=(0,b.rtrim)(r,d.sep),r.endsWith(":")&&(r+=d.sep)):(r=(0,b.rtrim)(r,d.sep),r||(r=d.sep)),r}e.sanitizeFilePath=S;function o(r){const s=(0,d.normalize)(r);return M.isWindows?r.length>3?!1:m(s)&&(r.length===2||s.charCodeAt(2)===92):s===d.posix.sep}e.isRootOrDriveLetter=o;function m(r){return M.isWindows?I(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function y(r){return m(r)?r[0]:void 0}e.getDriveLetter=y;function i(r,s,c){return s.length>r.length?-1:r===s?0:(c&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=i;function v(r){const s=r.split(":");let c,h,g;if(s.forEach(k=>{const P=Number(k);(0,R.isNumber)(P)?h===void 0?h=P:g===void 0&&(g=P):c=c?[c,k].join(":"):k}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:h!==void 0?h:void 0,column:g!==void 0?g:h!==void 0?1:void 0}}e.parseLineAndColumnAware=v}),define(we[23],be([0,1,10]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const w=Array.isArray(a)?[]:{};return Object.keys(a).forEach(I=>{a[I]&&typeof a[I]=="object"?w[I]=M(a[I]):w[I]=a[I]}),w}e.deepClone=M;function b(a){if(!a||typeof a!="object")return a;const w=[a];for(;w.length>0;){const I=w.shift();Object.freeze(I);for(const S in I)if(R.call(I,S)){const o=I[S];typeof o=="object"&&!Object.isFrozen(o)&&w.push(o)}}return a}e.deepFreeze=b;const R=Object.prototype.hasOwnProperty;function F(a,w){return C(a,w,new Set)}e.cloneAndChange=F;function C(a,w,I){if((0,d.isUndefinedOrNull)(a))return a;const S=w(a);if(typeof S!="undefined")return S;if((0,d.isArray)(a)){const o=[];for(const m of a)o.push(C(m,w,I));return o}if((0,d.isObject)(a)){if(I.has(a))throw new Error("Cannot clone recursive data-structure");I.add(a);const o={};for(let m in a)R.call(a,m)&&(o[m]=C(a[m],w,I));return I.delete(a),o}return a}function _(a,w,I=!0){return(0,d.isObject)(a)?((0,d.isObject)(w)&&Object.keys(w).forEach(S=>{S in a?I&&((0,d.isObject)(a[S])&&(0,d.isObject)(w[S])?_(a[S],w[S],I):a[S]=w[S]):a[S]=w[S]}),a):w}e.mixin=_;function T(a,w){if(a===w)return!0;if(a==null||w===null||w===void 0||typeof a!=typeof w||typeof a!="object"||Array.isArray(a)!==Array.isArray(w))return!1;let I,S;if(Array.isArray(a)){if(a.length!==w.length)return!1;for(I=0;I<a.length;I++)if(!T(a[I],w[I]))return!1}else{const o=[];for(S in a)o.push(S);o.sort();const m=[];for(S in w)m.push(S);if(m.sort(),!T(o,m))return!1;for(I=0;I<o.length;I++)if(!T(a[o[I]],w[o[I]]))return!1}return!0}e.equals=T;function t(a){const w=new Set;return JSON.stringify(a,(I,S)=>{if((0,d.isObject)(S)||Array.isArray(S)){if(w.has(S))return"[Circular]";w.add(S)}return S})}e.safeStringify=t;function E(a,w,I){const S=w(a);return typeof S=="undefined"?I:S}e.getOrDefault=E;function n(a,w){const I=Object.create(null);return!a||!w||Object.keys(w).forEach(o=>{const m=a[o],y=w[o];T(m,y)||(I[o]=y)}),I}e.distinct=n;function u(a,w){const I=w.toLowerCase(),S=Object.keys(a).find(o=>o.toLowerCase()===I);return S?a[S]:a[w]}e.getCaseInsensitive=u;function l(a,w){const I=Object.create(null);for(const S of Object.keys(a))w(S,a[S])&&(I[S]=a[S]);return I}e.filter=l});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,d):b?b.value=d:e.set(ne,d),d},Ae=this&&this.__classPrivateFieldGet||function(ne,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[20],be([0,1,13,9,2]),function(ne,e,d,M,b){"use strict";var R,F,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function _(v,r,s){let c=v.get(r);return c===void 0&&(c=s,v.set(r,c)),c}e.getOrSet=_;function T(v){const r=[];return v.forEach((s,c)=>{r.push(`${c} => ${s}`)}),`Map(${v.size}) {${r.join(", ")}}`}e.mapToString=T;function t(v){const r=[];return v.forEach(s=>{r.push(s)}),`Set(${v.size}) {${r.join(", ")}}`}e.setToString=t;class E{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=E;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class u{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=u;var l;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(l||(l={}));class a{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new u(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class w{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(r){this._iter=r}static forUris(r=()=>!1){return new I(new a(r))}static forPaths(){return new I(new u)}static forStrings(){return new I(new E)}static forConfigKeys(){return new I(new n)}clear(){this._root=void 0}set(r,s){const c=this._iter.reset(r);let h;for(this._root||(this._root=new w,this._root.segment=c.value()),h=this._root;;){const k=c.cmp(h.segment);if(k>0)h.left||(h.left=new w,h.left.segment=c.value()),h=h.left;else if(k<0)h.right||(h.right=new w,h.right.segment=c.value()),h=h.right;else if(c.hasNext())c.next(),h.mid||(h.mid=new w,h.mid.segment=c.value()),h=h.mid;else break}const g=h.value;return h.value=s,h.key=r,g}fill(r,s){const c=s.slice(0);(0,d.shuffle)(c);for(let h of c)this.set(h,r)}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let c=this._root;for(;c;){const h=s.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const c=this._iter.reset(r),h=[];let g=this._root;for(;g;){const k=c.cmp(g.segment);if(k>0)h.push([1,g]),g=g.left;else if(k<0)h.push([-1,g]),g=g.right;else if(c.hasNext())c.next(),h.push([0,g]),g=g.mid;else{for(s?(g.left=void 0,g.mid=void 0,g.right=void 0):g.value=void 0;h.length>0&&g.isEmpty();){let[P,p]=h.pop();switch(P){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}g=p}break}}}findSubstr(r){const s=this._iter.reset(r);let c=this._root,h;for(;c;){const g=s.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if(s.hasNext())s.next(),h=c.value||h,c=c.mid;else break}return c&&c.value||h}findSuperstr(r){const s=this._iter.reset(r);let c=this._root;for(;c;){const h=s.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(r){for(const[s,c]of this)r(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const c=s.pop();c&&(c.value&&(yield[c.key,c.value]),c.left&&s.push(c.left),c.mid&&s.push(c.mid),c.right&&s.push(c.right))}}}e.TernarySearchTree=I;class S{constructor(r,s){this[R]="ResourceMap",r instanceof S?(this.map=new Map(r.map),this.toKey=s??S.defaultToKey):(this.map=new Map,this.toKey=r??S.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[c,h]of this.map)r(h,b.URI.parse(c),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield b.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[b.URI.parse(r[0]),r[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[b.URI.parse(r[0]),r[1]]}}e.ResourceMap=S,S.defaultToKey=v=>v.toString();var o;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class m{constructor(){this[F]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const c=this._map.get(r);if(!!c)return s!==0&&this.touch(c,s),c.value}set(r,s,c=0){let h=this._map.get(r);if(h)h.value=s,c!==0&&this.touch(h,c);else{switch(h={key:r,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const c=this._state;let h=this._head;for(;h;){if(s?r.bind(s)(h.value,h.key,this):r(h.value,h.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,s=this._state;let c=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const g={value:c.key,done:!1};return c=c.next,g}else return{value:void 0,done:!0}}};return h}values(){const r=this,s=this._state;let c=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const g={value:c.value,done:!1};return c=c.next,g}else return{value:void 0,done:!0}}};return h}entries(){const r=this,s=this._state;let c=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const g={value:[c.key,c.value],done:!1};return c=c.next,g}else return{value:void 0,done:!0}}};return h}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>r;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,c=r.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const c=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(c.previous=h,h.next=c),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const c=r.next,h=r.previous;r===this._head?(c.previous=void 0,this._head=c):(c.previous=h,h.next=c),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,c)=>{r.push([c,s])}),r}fromJSON(r){this.clear();for(const[s,c]of r)this.set(s,c)}}e.LinkedMap=m;class y extends m{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=y;class i{constructor(r){C.set(this,void 0),Xe(this,C,r,"f")}get size(){return Ae(this,C,"f").size}forEach(r,s){Ae(this,C,"f").forEach(r,s)}get(r){return Ae(this,C,"f").get(r)}has(r){return Ae(this,C,"f").has(r)}entries(){return Ae(this,C,"f").entries()}keys(){return Ae(this,C,"f").keys()}values(){return Ae(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Ae(this,C,"f").entries()}}e.ReadonlyMapView=i}),define(we[106],be([0,1,20,9]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...q){return function(ae,he){for(let Te=0,Be=q.length;Te<Be;Te++){const $e=q[Te](ae,he);if($e)return $e}return null}}e.or=b,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(q,ae,he){if(!he||he.length<ae.length)return null;let Te;return q?Te=M.startsWithIgnoreCase(he,ae):Te=he.indexOf(ae)===0,Te?ae.length>0?[{start:0,end:ae.length}]:[]:null}function F(q,ae){const he=ae.toLowerCase().indexOf(q.toLowerCase());return he===-1?null:[{start:he,end:he+q.length}]}e.matchesContiguousSubString=F;function C(q,ae){return _(q.toLowerCase(),ae.toLowerCase(),0,0)}e.matchesSubString=C;function _(q,ae,he,Te){if(he===q.length)return[];if(Te===ae.length)return null;if(q[he]===ae[Te]){let Be=null;return(Be=_(q,ae,he+1,Te+1))?I({start:Te,end:Te+1},Be):null}return _(q,ae,he,Te+1)}function T(q){return 97<=q&&q<=122}function t(q){return 65<=q&&q<=90}e.isUpper=t;function E(q){return 48<=q&&q<=57}function n(q){return q===32||q===9||q===10||q===13}const u=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>u.add(q.charCodeAt(0)));function l(q){return n(q)||u.has(q)}function a(q,ae){return q===ae||l(q)&&l(ae)}function w(q){return T(q)||t(q)||E(q)}function I(q,ae){return ae.length===0?ae=[q]:q.end===ae[0].start?ae[0].start=q.start:ae.unshift(q),ae}function S(q,ae){for(let he=ae;he<q.length;he++){const Te=q.charCodeAt(he);if(t(Te)||E(Te)||he>0&&!w(q.charCodeAt(he-1)))return he}return q.length}function o(q,ae,he,Te){if(he===q.length)return[];if(Te===ae.length)return null;if(q[he]!==ae[Te].toLowerCase())return null;{let Be=null,$e=Te+1;for(Be=o(q,ae,he+1,Te+1);!Be&&($e=S(ae,$e))<ae.length;)Be=o(q,ae,he+1,$e),$e++;return Be===null?null:I({start:Te,end:Te+1},Be)}}function m(q){let ae=0,he=0,Te=0,Be=0,$e=0;for(let J=0;J<q.length;J++)$e=q.charCodeAt(J),t($e)&&ae++,T($e)&&he++,w($e)&&Te++,E($e)&&Be++;const Qe=ae/q.length,_e=he/q.length,rt=Te/q.length,H=Be/q.length;return{upperPercent:Qe,lowerPercent:_e,alphaPercent:rt,numericPercent:H}}function y(q){const{upperPercent:ae,lowerPercent:he}=q;return he===0&&ae>.6}function i(q){const{upperPercent:ae,lowerPercent:he,alphaPercent:Te,numericPercent:Be}=q;return he>.2&&ae<.8&&Te>.6&&Be<.2}function v(q){let ae=0,he=0,Te=0,Be=0;for(let $e=0;$e<q.length;$e++)Te=q.charCodeAt($e),t(Te)&&ae++,T(Te)&&he++,n(Te)&&Be++;return(ae===0||he===0)&&Be===0?q.length<=30:ae<=5}function r(q,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!v(q)||ae.length>60)return null;const he=m(ae);if(!i(he)){if(!y(he))return null;ae=ae.toLowerCase()}let Te=null,Be=0;for(q=q.toLowerCase();Be<ae.length&&(Te=o(q,ae,0,Be))===null;)Be=S(ae,Be+1);return Te}e.matchesCamelCase=r;function s(q,ae,he=!1){if(!ae||ae.length===0)return null;let Te=null,Be=0;for(q=q.toLowerCase(),ae=ae.toLowerCase();Be<ae.length&&(Te=c(q,ae,0,Be,he))===null;)Be=h(ae,Be+1);return Te}e.matchesWords=s;function c(q,ae,he,Te,Be){if(he===q.length)return[];if(Te===ae.length)return null;if(a(q.charCodeAt(he),ae.charCodeAt(Te))){let $e=null,Qe=Te+1;if($e=c(q,ae,he+1,Te+1,Be),!Be)for(;!$e&&(Qe=h(ae,Qe))<ae.length;)$e=c(q,ae,he+1,Qe,Be),Qe++;return $e===null?null:I({start:Te,end:Te+1},$e)}else return null}function h(q,ae){for(let he=ae;he<q.length;he++)if(l(q.charCodeAt(he))||he>0&&l(q.charCodeAt(he-1)))return he;return q.length}const g=b(e.matchesPrefix,r,F),k=b(e.matchesPrefix,r,C),P=new d.LRUCache(1e4);function p(q,ae,he=!1){if(typeof q!="string"||typeof ae!="string")return null;let Te=P.get(q);Te||(Te=new RegExp(M.convertSimple2RegExpPattern(q),"i"),P.set(q,Te));const Be=Te.exec(ae);return Be?[{start:Be.index,end:Be.index+Be[0].length}]:he?k(q,ae):g(q,ae)}e.matchesFuzzy=p;function D(q,ae){const he=Ye(q,q.toLowerCase(),0,ae,ae.toLowerCase(),0,!0);return he?A(he):null}e.matchesFuzzy2=D;function f(q,ae,he,Te,Be,$e){const Qe=Math.min(13,q.length);for(;he<Qe;he++){const _e=Ye(q,ae,he,Te,Be,$e,!1);if(_e)return _e}return[0,$e]}e.anyScore=f;function A(q){if(typeof q=="undefined")return[];const ae=[],he=q[1];for(let Te=q.length-1;Te>1;Te--){const Be=q[Te]+he,$e=ae[ae.length-1];$e&&$e.end===Be?$e.end=Be+1:ae.push({start:Be,end:Be+1})}return ae}e.createMatches=A;const L=128;function V(){const q=[],ae=[];for(let he=0;he<=L;he++)ae[he]=0;for(let he=0;he<=L;he++)q.push(ae.slice(0));return q}function G(q){const ae=[];for(let he=0;he<=q;he++)ae[he]=0;return ae}const $=G(2*L),K=G(2*L),W=V(),U=V(),z=V(),Y=!1;function re(q,ae,he,Te,Be){function $e(_e,rt,H=" "){for(;_e.length<rt;)_e=H+_e;return _e}let Qe=` |   |${Te.split("").map(_e=>$e(_e,3)).join("|")}
`;for(let _e=0;_e<=he;_e++)_e===0?Qe+=" |":Qe+=`${ae[_e-1]}|`,Qe+=q[_e].slice(0,Be+1).map(rt=>$e(rt.toString(),3)).join("|")+`
`;return Qe}function j(q,ae,he,Te){q=q.substr(ae),he=he.substr(Te),console.log(re(U,q,q.length,he,he.length)),console.log(re(z,q,q.length,he,he.length)),console.log(re(W,q,q.length,he,he.length))}function ue(q,ae){if(ae<0||ae>=q.length)return!1;const he=q.codePointAt(ae);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(he)}}function oe(q,ae){if(ae<0||ae>=q.length)return!1;switch(q.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function ve(q,ae,he){return ae[q]!==he[q]}function Fe(q,ae,he,Te,Be,$e,Qe=!1){for(;ae<he&&Be<$e;)q[ae]===Te[Be]&&(Qe&&($[ae]=Be),ae+=1),Be+=1;return ae===he}e.isPatternInWord=Fe;var Me;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var Oe;(function(q){q.Default=[-100,0];function ae(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}q.isDefault=ae})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function Ye(q,ae,he,Te,Be,$e,Qe){const _e=q.length>L?L:q.length,rt=Te.length>L?L:Te.length;if(he>=_e||$e>=rt||_e-he>rt-$e||!Fe(ae,he,_e,Be,$e,rt,!0))return;ze(_e,rt,he,$e,ae,Be);let H=1,J=1,me=he,Ne=$e;const Ke=[!1];for(H=1,me=he;me<_e;H++,me++){const ht=$[me],yt=K[me],It=me+1<_e?K[me+1]:rt;for(J=ht-$e+1,Ne=ht;Ne<It;J++,Ne++){let ft=Number.MIN_SAFE_INTEGER,Je=!1;Ne<=yt&&(ft=je(q,ae,me,he,Te,Be,Ne,rt,$e,W[H-1][J-1]===0,Ke));let Et=0;ft!==Number.MAX_SAFE_INTEGER&&(Je=!0,Et=ft+U[H-1][J-1]);const Pe=Ne>ht,ye=Pe?U[H][J-1]+(W[H][J-1]>0?-5:0):0,Ce=Ne>ht+1&&W[H][J-1]>0,Z=Ce?U[H][J-2]+(W[H][J-2]>0?-5:0):0;if(Ce&&(!Pe||Z>=ye)&&(!Je||Z>=Et))U[H][J]=Z,z[H][J]=3,W[H][J]=0;else if(Pe&&(!Je||ye>=Et))U[H][J]=ye,z[H][J]=2,W[H][J]=0;else if(Je)U[H][J]=Et,z[H][J]=1,W[H][J]=W[H-1][J-1]+1;else throw new Error("not possible")}}if(Y&&j(q,he,Te,$e),!Ke[0]&&!Qe)return;H--,J--;const ot=[U[H][J],$e];let at=0,vt=0;for(;H>=1;){let ht=J;do{const yt=z[H][ht];if(yt===3)ht=ht-2;else if(yt===2)ht=ht-1;else break}while(ht>=1);at>1&&ae[he+H-1]===Be[$e+J-1]&&!ve(ht+$e-1,Te,Be)&&at+1>W[H][ht]&&(ht=J),ht===J?at++:at=1,vt||(vt=ht),H--,J=ht-1,ot.push(J)}rt===_e&&(ot[0]+=2);const kt=vt-_e;return ot[0]-=kt,ot}e.fuzzyScore=Ye;function ze(q,ae,he,Te,Be,$e){let Qe=q-1,_e=ae-1;for(;Qe>=he&&_e>=Te;)Be[Qe]===$e[_e]&&(K[Qe]=_e,Qe--),_e--}function je(q,ae,he,Te,Be,$e,Qe,_e,rt,H,J){if(ae[he]!==$e[Qe])return Number.MIN_SAFE_INTEGER;let me=1,Ne=!1;return Qe===he-Te?me=q[he]===Be[Qe]?7:5:ve(Qe,Be,$e)&&(Qe===0||!ve(Qe-1,Be,$e))?(me=q[he]===Be[Qe]?7:5,Ne=!0):ue($e,Qe)&&(Qe===0||!ue($e,Qe-1))?me=5:(ue($e,Qe-1)||oe($e,Qe-1))&&(me=5,Ne=!0),me>1&&he===Te&&(J[0]=!0),Ne||(Ne=ve(Qe,Be,$e)||ue($e,Qe-1)||oe($e,Qe-1)),he===Te?Qe>rt&&(me-=Ne?3:5):H?me+=Ne?2:0:me+=Ne?0:1,Qe+1===_e&&(me-=Ne?3:5),me}function x(q,ae,he,Te,Be,$e,Qe){return ee(q,ae,he,Te,Be,$e,!0,Qe)}e.fuzzyScoreGracefulAggressive=x;function Q(q,ae,he,Te,Be,$e,Qe){return ee(q,ae,he,Te,Be,$e,!1,Qe)}e.fuzzyScoreGraceful=Q;function ee(q,ae,he,Te,Be,$e,Qe,_e){let rt=Ye(q,ae,he,Te,Be,$e,_e);if(rt&&!Qe)return rt;if(q.length>=3){const H=Math.min(7,q.length-1);for(let J=he+1;J<H;J++){const me=le(q,J);if(me){const Ne=Ye(me,me.toLowerCase(),he,Te,Be,$e,_e);Ne&&(Ne[0]-=3,(!rt||Ne[0]>rt[0])&&(rt=Ne))}}}return rt}function le(q,ae){if(ae+1>=q.length)return;const he=q[ae],Te=q[ae+1];if(he!==Te)return q.slice(0,ae)+Te+he+q.slice(ae+2)}}),define(we[107],be([0,1,34,106,9]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const R=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(`(\\\\)?${R.source}`,"g");function C(a){return a.replace(F,(w,I)=>I?w:`\\${w}`)}e.escapeIcons=C;const _=new RegExp(`\\\\${R.source}`,"g");function T(a){return a.replace(_,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=T;const t=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function E(a){return a.indexOf(e.iconStartMarker)===-1?a:a.replace(t,(w,I,S,o)=>S?w:I||o||"")}e.stripIcons=E;function n(a){const w=a.indexOf(e.iconStartMarker);return w===-1?{text:a}:u(a,w)}e.parseLabelWithIcons=n;function u(a,w){const I=[];let S="";function o(h){if(h){S+=h;for(const g of h)I.push(i)}}let m=-1,y="",i=0,v,r,s=w;const c=a.length;for(o(a.substr(0,w));s<c;)v=a[s],r=a[s+1],v===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(m=s,o(y),y=e.iconStartMarker,s++):v===")"&&m!==-1?(i+=s-m+1,m=-1,y=""):m!==-1?/^[a-z0-9\-]$/i.test(v)?y+=v:(o(y),m=-1,y=""):o(v),s++;return o(y),{text:S,iconOffsets:I}}function l(a,w,I=!1){const{text:S,iconOffsets:o}=w;if(!o||o.length===0)return(0,M.matchesFuzzy)(a,S,I);const m=(0,b.ltrim)(S," "),y=S.length-m.length,i=(0,M.matchesFuzzy)(a,m,I);if(i)for(const v of i){const r=o[v.start+y]+y;v.start+=r,v.end+=r}return i}e.matchesFuzzyIconAware=l}),define(we[76],be([0,1,16,107]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(b=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class R{constructor(u="",l=!1){if(this.value=u,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(u,l=0){return this.value+=T(this.supportThemeIcons?(0,M.escapeIcons)(u):u).replace(/([ \t]+)/g,(a,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,l){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=R;function F(n){return C(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function C(n){return n instanceof R?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function _(n,u){return n===u?!0:!n||!u?!1:n.value===u.value&&n.isTrusted===u.isTrusted&&n.supportThemeIcons===u.supportThemeIcons}e.markdownStringEqual=_;function T(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function E(n){const u=[],l=n.split("|").map(w=>w.trim());n=l[0];const a=l[1];if(a){const w=/height=(\d+)/.exec(a),I=/width=(\d+)/.exec(a),S=w?w[1]:"",o=I?I[1]:"",m=isFinite(parseInt(o)),y=isFinite(parseInt(S));m&&u.push(`width="${o}"`),y&&u.push(`height="${S}"`)}return{href:n,dimensions:u}}e.parseHrefAndDimensions=E}),define(we[54],be([0,1,22,9,2]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function R(t){return JSON.stringify(t,_)}e.stringify=R;function F(t){let E=JSON.parse(t);return E=T(E),E}e.parse=F;var C;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function _(t,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,M.regExpFlags)(E)}:E}function T(t,E=0){if(!t||E>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return b.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof d.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=T(t[n],E+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=T(t[n],E+1))}return t}e.revive=T}),define(we[11],be([0,1,26,2]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var b;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(b=e.Schemas||(e.Schemas={}));class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,T,t){this._hosts[_]=T,this._ports[_]=t}setConnectionToken(_,T){this._connectionTokens[_]=T}rewrite(_){if(this._delegate)return this._delegate(_);const T=_.authority;let t=this._hosts[T];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const E=this._ports[T],n=this._connectionTokens[T];let u=`path=${encodeURIComponent(_.path)}`;return typeof n=="string"&&(u+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:d.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${t}:${E}`,path:"/vscode-remote-resource",query:u})}}e.RemoteAuthorities=new R;class F{asBrowserUri(_,T){const t=this.toUri(_,T);return t.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===b.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${b.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:b.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(_,T){const t=this.toUri(_,T);return t.scheme===b.vscodeFileResource?t.with({scheme:b.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(_,T){return M.URI.isUri(_)?_:M.URI.parse(T.toUrl(_))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(we[24],be([0,1,43,11,17,26,9,2]),function(ne,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(u){return(0,C.uriToFsPath)(u,!0)}e.originalFSPath=_;class T{constructor(l){this._ignorePathCasing=l}compare(l,a,w=!1){return l===a?0:(0,F.compare)(this.getComparisonKey(l,w),this.getComparisonKey(a,w))}isEqual(l,a,w=!1){return l===a?!0:!l||!a?!1:this.getComparisonKey(l,w)===this.getComparisonKey(a,w)}getComparisonKey(l,a=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,a,w=!1){if(l.scheme===a.scheme){if(l.scheme===M.Schemas.file)return d.isEqualOrParent(_(l),_(a),this._ignorePathCasing(l))&&l.query===a.query&&(w||l.fragment===a.fragment);if((0,e.isEqualAuthority)(l.authority,a.authority))return d.isEqualOrParent(l.path,a.path,this._ignorePathCasing(l),"/")&&l.query===a.query&&(w||l.fragment===a.fragment)}return!1}joinPath(l,...a){return C.URI.joinPath(l,...a)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return b.posix.basename(l.path)}extname(l){return b.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let a;return l.scheme===M.Schemas.file?a=C.URI.file(b.dirname(_(l))).path:(a=b.posix.dirname(l.path),l.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),a="/")),l.with({path:a})}normalizePath(l){if(!l.path.length)return l;let a;return l.scheme===M.Schemas.file?a=C.URI.file(b.normalize(_(l))).path:a=b.posix.normalize(l.path),l.with({path:a})}relativePath(l,a){if(l.scheme!==a.scheme||!(0,e.isEqualAuthority)(l.authority,a.authority))return;if(l.scheme===M.Schemas.file){const S=b.relative(_(l),_(a));return R.isWindows?d.toSlashes(S):S}let w=l.path||"/",I=a.path||"/";if(this._ignorePathCasing(l)){let S=0;for(const o=Math.min(w.length,I.length);S<o&&!(w.charCodeAt(S)!==I.charCodeAt(S)&&w.charAt(S).toLowerCase()!==I.charAt(S).toLowerCase());S++);w=I.substr(0,S)+w.substr(S)}return b.posix.relative(w,I)}resolvePath(l,a){if(l.scheme===M.Schemas.file){const w=C.URI.file(b.resolve(_(l),a));return l.with({authority:w.authority,path:w.path})}return a=d.toPosixPath(a),l.with({path:b.posix.resolve(l.path,a)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,a){return l===a||(0,F.equalsIgnoreCase)(l,a)}hasTrailingPathSeparator(l,a=b.sep){if(l.scheme===M.Schemas.file){const w=_(l);return w.length>d.getRoot(w).length&&w[w.length-1]===a}else{const w=l.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,a=b.sep){return(0,e.hasTrailingPathSeparator)(l,a)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,a=b.sep){let w=!1;if(l.scheme===M.Schemas.file){const I=_(l);w=I!==void 0&&I.length===d.getRoot(I).length&&I[I.length-1]===a}else{a="/";const I=l.path;w=I.length===1&&I.charCodeAt(I.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(l,a)?l.with({path:l.path+"/"}):l}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(u=>u.scheme===M.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new T(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(u,l){const a=[];for(let w=0;w<u.length;w++){const I=l(u[w]);u.some((S,o)=>o===w?!1:(0,e.isEqualOrParent)(I,l(S)))||a.push(u[w])}return a}e.distinctParents=t;var E;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function l(a){const w=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(o=>{const[m,y]=o.split(":");m&&y&&w.set(m,y)});const S=a.path.substring(0,a.path.indexOf(";"));return S&&w.set(u.META_DATA_MIME,S),w}u.parseMetaData=l})(E=e.DataUri||(e.DataUri={}));function n(u,l,a){if(l){let w=u.path;return w&&w[0]!==b.posix.sep&&(w=b.posix.sep+w),u.with({scheme:a,authority:l,path:w})}return u.with({scheme:a})}e.toLocalResource=n}),define(we[14],be([0,1,21,16,3,6,24]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(W){return!!W&&typeof W.then=="function"}e.isThenable=C;function _(W){const U=new d.CancellationTokenSource,z=W(U.token),Y=new Promise((re,j)=>{const ue=U.token.onCancellationRequested(()=>{ue.dispose(),U.dispose(),j((0,M.canceled)())});Promise.resolve(z).then(oe=>{ue.dispose(),U.dispose(),re(oe)},oe=>{ue.dispose(),U.dispose(),j(oe)})});return new class{cancel(){U.cancel()}then(re,j){return Y.then(re,j)}catch(re){return this.then(void 0,re)}finally(re){return Y.finally(re)}}}e.createCancelablePromise=_;function T(W,U,z){return Promise.race([W,new Promise(Y=>U.onCancellationRequested(()=>Y(z)))])}e.raceCancellation=T;async function t(W){let U=-1;const z=W.map((re,j)=>re.then(ue=>(U=j,ue))),Y=await Promise.race(z);return W.forEach((re,j)=>{j!==U&&re.cancel()}),Y}e.raceCancellablePromises=t;function E(W,U,z){let Y;const re=setTimeout(()=>{Y?.(void 0),z?.()},U);return Promise.race([W.finally(()=>clearTimeout(re)),new Promise(j=>Y=j)])}e.raceTimeout=E;function n(W){return new Promise((U,z)=>{const Y=W();C(Y)?Y.then(U,z):U(Y)})}e.asPromise=n;class u{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const Y=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Y};this.queuedPromise=new Promise(Y=>{this.activePromise.then(z,z).then(Y)})}return new Promise((z,Y)=>{this.queuedPromise.then(z,Y)})}return this.activePromise=U(),new Promise((z,Y)=>{this.activePromise.then(re=>{this.activePromise=null,z(re)},re=>{this.activePromise=null,Y(re)})})}}e.Throttler=u;class l{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=l;class a{constructor(){this.promiseMap=new Map}queue(U,z){const re=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(U)===re&&this.promiseMap.delete(U)});return this.promiseMap.set(U,re),re}}e.SequencerByKey=a;class w{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,z=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Y,re)=>{this.doResolve=Y,this.doReject=re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Y=this.task;return this.task=null,Y()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class I{constructor(U){this.delayer=new w(U),this.throttler=new u}trigger(U,z){return this.delayer.trigger(()=>this.throttler.queue(U),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class S{constructor(){this._isOpen=!1,this._promise=new Promise((U,z)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=S;class o extends S{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function m(W,U){return U?new Promise((z,Y)=>{const re=setTimeout(()=>{j.dispose(),z()},W),j=U.onCancellationRequested(()=>{clearTimeout(re),j.dispose(),Y((0,M.canceled)())})}):_(z=>m(W,z))}e.timeout=m;function y(W,U=0){const z=setTimeout(W,U);return(0,R.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=y;function i(W){const U=[];let z=0;const Y=W.length;function re(){return z<Y?W[z++]():null}function j(ue){ue!=null&&U.push(ue);const oe=re();return oe?oe.then(j):Promise.resolve(U)}return Promise.resolve(null).then(j)}e.sequence=i;function v(W,U=Y=>!!Y,z=null){let Y=0;const re=W.length,j=()=>{if(Y>=re)return Promise.resolve(z);const ue=W[Y++];return Promise.resolve(ue()).then(ve=>U(ve)?Promise.resolve(ve):j())};return j()}e.first=v;function r(W,U=Y=>!!Y,z=null){if(W.length===0)return Promise.resolve(z);let Y=W.length;const re=()=>{Y=-1;for(const j of W)j.cancel?.()};return new Promise((j,ue)=>{for(const oe of W)oe.then(ve=>{--Y>=0&&U(ve)?(re(),j(ve)):Y===0&&j(z)}).catch(ve=>{--Y>=0&&(re(),ue(ve))})})}e.firstParallel=r;class s{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new b.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((z,Y)=>{this.outstandingPromises.push({factory:U,c:z,e:Y}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const z=U.factory();z.then(U.c,U.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class c extends s{constructor(){super(1)}}e.Queue=c;class h{constructor(){this.queues=new Map}queueFor(U,z=F.extUri){const Y=z.getComparisonKey(U);let re=this.queues.get(Y);return re||(re=new c,b.Event.once(re.onFinished)(()=>{re?.dispose(),this.queues.delete(Y)}),this.queues.set(Y,re)),re}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=h;class g{constructor(U,z){this._token=-1,typeof U=="function"&&typeof z=="number"&&this.setIfNotSet(U,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},z)}setIfNotSet(U,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},z))}}e.TimeoutTimer=g;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,z){this.cancel(),this._token=setInterval(()=>{U()},z)}}e.IntervalTimer=k;class P{constructor(U,z){this.timeoutToken=-1,this.runner=U,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class p{constructor(U,z){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=z,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=p;class D extends P{constructor(U,z){super(U,z);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=D;class f extends R.Disposable{constructor(U,z,Y,re){super();this.maxWorkChunkSize=U,this.maxPendingWork=z,this.throttleDelay=Y,this.handler=re,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new P(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=f,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=U=>{const z=setTimeout(()=>U(W));let Y=!1;return{dispose(){Y||(Y=!0,clearTimeout(z))}}}}else e.runWhenIdle=(W,U)=>{const z=requestIdleCallback(W,typeof U=="number"?{timeout:U}:void 0);let Y=!1;return{dispose(){Y||(Y=!0,cancelIdleCallback(z))}}}}();class A{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=A;async function L(W,U,z){let Y;for(let re=0;re<z;re++)try{return await W()}catch(j){Y=j,await m(U)}throw Y}e.retry=L;class V{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,z,Y){return this._pending={taskId:U,cancel:()=>Y?.(),promise:z},z.then(()=>this.donePending(U),()=>this.donePending(U)),z}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let z,Y;const re=new Promise((j,ue)=>{z=j,Y=ue});this._next={run:U,promise:re,promiseResolve:z,promiseReject:Y}}return this._next.promise}}e.TaskSequentializer=V;class G{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,z)=>{this.completeCallback=U,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(z=>{this.completeCallback(U),this.resolved=!0,z()})}error(U){return new Promise(z=>{this.errorCallback(U),this.rejected=!0,z()})}cancel(){new Promise(U=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=$;var K;(function(W){async function U(z){let Y;const re=await Promise.all(z.map(j=>j.then(ue=>ue,ue=>{Y||(Y=ue)})));if(typeof Y!="undefined")throw Y;return re}W.settled=U})(K=e.Promises||(e.Promises={}))}),define(we[108],be([0,1,14,17]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new d.IdleValue(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),R=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(P,p,D=!1){const f=P||"",A=p||"",L=b.value.collator.compare(f,A);return b.value.collatorIsNumeric&&L===0&&f!==A?f<A?-1:1:L}e.compareFileNames=C;function _(P,p){const D=R.value.collator;return P=P||"",p=p||"",y(D,P,p)}e.compareFileNamesDefault=_;function T(P,p){const D=R.value.collator;return P=P||"",p=p||"",s(P,p)||y(D,P,p)}e.compareFileNamesUpper=T;function t(P,p){const D=R.value.collator;return P=P||"",p=p||"",r(P,p)||y(D,P,p)}e.compareFileNamesLower=t;function E(P,p){return P=P||"",p=p||"",P===p?0:P<p?-1:1}e.compareFileNamesUnicode=E;function n(P,p,D=!1){D||(P=P&&P.toLowerCase(),p=p&&p.toLowerCase());const[f,A]=o(P),[L,V]=o(p);return f!==L?f<L?-1:1:A===V?0:A<V?-1:1}e.noIntlCompareFileNames=n;function u(P,p){const[D,f]=o(P),[A,L]=o(p);let V=b.value.collator.compare(f,L);if(V===0){if(b.value.collatorIsNumeric&&f!==L)return f<L?-1:1;if(V=b.value.collator.compare(D,A),b.value.collatorIsNumeric&&V===0&&D!==A)return D<A?-1:1}return V}e.compareFileExtensions=u;function l(P,p){P=P||"",p=p||"";const D=m(P),f=m(p),A=R.value.collator,L=F.value.collator;return y(L,D,f)||y(A,P,p)}e.compareFileExtensionsDefault=l;function a(P,p){P=P||"",p=p||"";const D=m(P),f=m(p),A=R.value.collator,L=F.value.collator;return y(L,D,f)||s(P,p)||y(A,P,p)}e.compareFileExtensionsUpper=a;function w(P,p){P=P||"",p=p||"";const D=m(P),f=m(p),A=R.value.collator,L=F.value.collator;return y(L,D,f)||r(P,p)||y(A,P,p)}e.compareFileExtensionsLower=w;function I(P,p){P=P||"",p=p||"";const D=m(P).toLowerCase(),f=m(p).toLowerCase();return D!==f?D<f?-1:1:P!==p?P<p?-1:1:0}e.compareFileExtensionsUnicode=I;const S=/^(.*?)(\.([^.]*))?$/;function o(P,p=!1){const D=P?S.exec(P):[];let f=[D&&D[1]||"",D&&D[3]||""];return p&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function m(P){const p=P?S.exec(P):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function y(P,p,D){let f=P.compare(p,D);return f!==0?f:p.length!==D.length?p.length<D.length?-1:1:0}function i(P){const p=P.charAt(0);return p.toLocaleUpperCase()!==p}function v(P){const p=P.charAt(0);return p.toLocaleLowerCase()!==p}function r(P,p){return i(P)&&v(p)?-1:v(P)&&i(p)?1:0}function s(P,p){return v(P)&&i(p)?-1:i(P)&&v(p)?1:0}function c(P,p,D=!1){return D||(P=P&&P.toLowerCase(),p=p&&p.toLowerCase()),P===p?0:P<p?-1:1}function h(P,p,D=!1){const f=P.split(M.sep),A=p.split(M.sep),L=f.length-1,V=A.length-1;let G,$;for(let K=0;;K++){if(G=L===K,$=V===K,G&&$)return C(f[K],A[K],D);if(G)return-1;if($)return 1;const W=c(f[K],A[K],D);if(W!==0)return W}}e.comparePaths=h;function g(P,p,D){const f=P.toLowerCase(),A=p.toLowerCase(),L=k(P,p,D);if(L)return L;const V=f.endsWith(D),G=A.endsWith(D);if(V!==G)return V?-1:1;const $=C(f,A);return $!==0?$:f.localeCompare(A)}e.compareAnything=g;function k(P,p,D){const f=P.toLowerCase(),A=p.toLowerCase(),L=f.startsWith(D),V=A.startsWith(D);if(L!==V)return L?-1:1;if(L&&V){if(f.length<A.length)return-1;if(f.length>A.length)return 1}return 0}e.compareByPrefix=k}),define(we[27],be([0,1,14,43,20,17,9]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const _="**",T="/",t="[/\\\\]",E="[^/\\\\]",n=/\//g;function u(Y){switch(Y){case 0:return"";case 1:return`${E}*?`;default:return`(?:${t}|${E}+${t}|${t}${E}+)*?`}}function l(Y,re){if(!Y)return[];const j=[];let ue=!1,oe=!1,ve="";for(const Fe of Y){switch(Fe){case re:if(!ue&&!oe){j.push(ve),ve="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ve+=Fe}return ve&&j.push(ve),j}e.splitGlobAware=l;function a(Y){if(!Y)return"";let re="";const j=l(Y,T);if(j.every(ue=>ue===_))re=".*";else{let ue=!1;j.forEach((oe,ve)=>{if(oe===_){ue||(re+=u(2),ue=!0);return}let Fe=!1,Me="",Oe=!1,Ye="";for(const ze of oe){if(ze!=="}"&&Fe){Me+=ze;continue}if(Oe&&(ze!=="]"||!Ye)){let je;ze==="-"?je=ze:(ze==="^"||ze==="!")&&!Ye?je="^":ze===T?je="":je=F.escapeRegExpCharacters(ze),Ye+=je;continue}switch(ze){case"{":Fe=!0;continue;case"[":Oe=!0;continue;case"}":re+=`(?:${l(Me,",").map(Q=>a(Q)).join("|")})`,Fe=!1,Me="";break;case"]":re+="["+Ye+"]",Oe=!1,Ye="";break;case"?":re+=E;continue;case"*":re+=u(1);continue;default:re+=F.escapeRegExpCharacters(ze)}}ve<j.length-1&&(j[ve+1]!==_||ve+2<j.length)&&(re+=t),ue=!1})}return re}const w=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new b.LRUCache(1e4),v=function(){return!1},r=function(){return null};function s(Y,re){if(!Y)return r;let j;typeof Y!="string"?j=Y.pattern:j=Y,j=j.trim();const ue=`${j}_${!!re.trimForExclusions}`;let oe=i.get(ue);if(oe)return c(oe,Y);let ve;if(w.test(j)){const Fe=j.substr(4);oe=function(Me,Oe){return typeof Me=="string"&&Me.endsWith(Fe)?j:null}}else(ve=I.exec(h(j,re)))?oe=g(ve[1],j):(re.trimForExclusions?o:S).test(j)?oe=k(j,re):(ve=m.exec(h(j,re)))?oe=P(ve[1].substr(1),j,!0):(ve=y.exec(h(j,re)))?oe=P(ve[1],j,!1):oe=p(j);return i.set(ue,oe),c(oe,Y)}function c(Y,re){return typeof re=="string"?Y:function(j,ue){return M.isEqualOrParent(j,re.base)?Y(R.relative(re.base,j),ue):null}}function h(Y,re){return re.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function g(Y,re){const j=`/${Y}`,ue=`\\${Y}`,oe=function(Fe,Me){return typeof Fe!="string"?null:Me?Me===Y?re:null:Fe===Y||Fe.endsWith(j)||Fe.endsWith(ue)?re:null},ve=[Y];return oe.basenames=ve,oe.patterns=[re],oe.allBasenames=ve,oe}function k(Y,re){const j=z(Y.slice(1,-1).split(",").map(Me=>s(Me,re)).filter(Me=>Me!==r),Y),ue=j.length;if(!ue)return r;if(ue===1)return j[0];const oe=function(Me,Oe){for(let Ye=0,ze=j.length;Ye<ze;Ye++)if(j[Ye](Me,Oe))return Y;return null},ve=j.find(Me=>!!Me.allBasenames);ve&&(oe.allBasenames=ve.allBasenames);const Fe=j.reduce((Me,Oe)=>Oe.allPaths?Me.concat(Oe.allPaths):Me,[]);return Fe.length&&(oe.allPaths=Fe),oe}function P(Y,re,j){const ue=R.sep===R.posix.sep,oe=ue?Y:Y.replace(n,R.sep),ve=R.sep+oe,Fe=R.posix.sep+Y,Me=j?function(Oe,Ye){return typeof Oe=="string"&&(Oe===oe||Oe.endsWith(ve)||!ue&&(Oe===Y||Oe.endsWith(Fe)))?re:null}:function(Oe,Ye){return typeof Oe=="string"&&(Oe===oe||!ue&&Oe===Y)?re:null};return Me.allPaths=[(j?"*/":"./")+Y],Me}function p(Y){try{const re=new RegExp(`^${a(Y)}$`);return function(j){return re.lastIndex=0,typeof j=="string"&&re.test(j)?Y:null}}catch(re){return r}}function D(Y,re,j){return!Y||typeof re!="string"?!1:f(Y)(re,void 0,j)}e.match=D;function f(Y,re={}){if(!Y)return v;if(typeof Y=="string"||G(Y)){const j=s(Y,re);if(j===r)return v;const ue=function(oe,ve){return!!j(oe,ve)};return j.allBasenames&&(ue.allBasenames=j.allBasenames),j.allPaths&&(ue.allPaths=j.allPaths),ue}return W(Y,re)}e.parse=f;function A(Y){if(!Y)return;let re;return j=>(re||(re=(Y()||Promise.resolve([])).then(ue=>ue?V(ue):{})),re.then(ue=>!!ue[j]))}e.hasSiblingPromiseFn=A;function L(Y){if(!Y)return;let re;return j=>{if(!re){const ue=Y();re=ue?V(ue):{}}return!!re[j]}}e.hasSiblingFn=L;function V(Y){const re={};for(const j of Y)re[j]=!0;return re}function G(Y){const re=Y;return re&&typeof re.base=="string"&&typeof re.pattern=="string"}e.isRelativePattern=G;function $(Y){return Y.allBasenames||[]}e.getBasenameTerms=$;function K(Y){return Y.allPaths||[]}e.getPathTerms=K;function W(Y,re){const j=z(Object.getOwnPropertyNames(Y).map(Me=>U(Me,Y[Me],re)).filter(Me=>Me!==r)),ue=j.length;if(!ue)return r;if(!j.some(Me=>!!Me.requiresSiblings)){if(ue===1)return j[0];const Me=function(ze,je){for(let x=0,Q=j.length;x<Q;x++){const ee=j[x](ze,je);if(ee)return ee}return null},Oe=j.find(ze=>!!ze.allBasenames);Oe&&(Me.allBasenames=Oe.allBasenames);const Ye=j.reduce((ze,je)=>je.allPaths?ze.concat(je.allPaths):ze,[]);return Ye.length&&(Me.allPaths=Ye),Me}const oe=function(Me,Oe,Ye){let ze;for(let je=0,x=j.length;je<x;je++){const Q=j[je];Q.requiresSiblings&&Ye&&(Oe||(Oe=R.basename(Me)),ze||(ze=Oe.substr(0,Oe.length-R.extname(Me).length)));const ee=Q(Me,Oe,ze,Ye);if(ee)return ee}return null},ve=j.find(Me=>!!Me.allBasenames);ve&&(oe.allBasenames=ve.allBasenames);const Fe=j.reduce((Me,Oe)=>Oe.allPaths?Me.concat(Oe.allPaths):Me,[]);return Fe.length&&(oe.allPaths=Fe),oe}function U(Y,re,j){if(re===!1)return r;const ue=s(Y,j);if(ue===r)return r;if(typeof re=="boolean")return ue;if(re){const oe=re.when;if(typeof oe=="string"){const ve=(Fe,Me,Oe,Ye)=>{if(!Ye||!ue(Fe,Me))return null;const ze=oe.replace("$(basename)",Oe),je=Ye(ze);return(0,d.isThenable)(je)?je.then(x=>x?Y:null):je?Y:null};return ve.requiresSiblings=!0,ve}}return ue}function z(Y,re){const j=Y.filter(Me=>!!Me.basenames);if(j.length<2)return Y;const ue=j.reduce((Me,Oe)=>{const Ye=Oe.basenames;return Ye?Me.concat(Ye):Me},[]);let oe;if(re){oe=[];for(let Me=0,Oe=ue.length;Me<Oe;Me++)oe.push(re)}else oe=j.reduce((Me,Oe)=>{const Ye=Oe.patterns;return Ye?Me.concat(Ye):Me},[]);const ve=function(Me,Oe){if(typeof Me!="string")return null;if(!Oe){let ze;for(ze=Me.length;ze>0;ze--){const je=Me.charCodeAt(ze-1);if(je===47||je===92)break}Oe=Me.substr(ze)}const Ye=ue.indexOf(Oe);return Ye!==-1?oe[Ye]:null};ve.basenames=ue,ve.patterns=oe,ve.allBasenames=ue;const Fe=Y.filter(Me=>!Me.basenames);return Fe.push(ve),Fe}}),define(we[77],be([0,1,43,11,17,26,24,9,2]),function(ne,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(s,c,h){if(typeof s=="string"&&(s=_.URI.file(s)),h){const k=h.getWorkspaceFolder(s);if(k){const P=h.getWorkspace().folders.length>1;let p;if((0,F.isEqual)(k.uri,s)?p="":p=(0,F.relativePath)(k.uri,s),P){const D=k.name?k.name:(0,F.basename)(k.uri);p=p?D+" \u2022 "+p:D}return p}}if(s.scheme!==M.Schemas.file&&s.scheme!==M.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(s.fsPath))return(0,b.normalize)(E(s.fsPath));let g=(0,b.normalize)(s.fsPath);return!R.isWindows&&c?.userHome&&(g=u(g,c.userHome.fsPath)),g}e.getPathLabel=T;function t(s){if(!s)return;typeof s=="string"&&(s=_.URI.file(s));const c=(0,F.basename)(s)||(s.scheme===M.Schemas.file?s.fsPath:s.path);return R.isWindows&&(0,d.isRootOrDriveLetter)(c)?E(c):c}e.getBaseLabel=t;function E(s){return(0,d.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=E;let n=Object.create(null);function u(s,c){if(R.isWindows||!s||!c)return s;let h=n.original===c?n.normalized:void 0;return h||(h=`${(0,C.rtrim)(c,b.posix.sep)}${b.posix.sep}`,n={original:c,normalized:h}),(R.isLinux?s.startsWith(h):(0,C.startsWithIgnoreCase)(s,h))&&(s=`~/${s.substr(h.length)}`),s}e.tildify=u;function l(s,c){return s.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=l;const a="\u2026",w="\\\\",I="~";function S(s,c=b.sep){const h=new Array(s.length);let g=!1;for(let k=0;k<s.length;k++){let P=s[k];if(P===""){h[k]=`.${c}`;continue}if(!P){h[k]=P;continue}g=!0;let p="";P.indexOf(w)===0?(p=P.substr(0,P.indexOf(w)+w.length),P=P.substr(P.indexOf(w)+w.length)):P.indexOf(c)===0?(p=P.substr(0,P.indexOf(c)+c.length),P=P.substr(P.indexOf(c)+c.length)):P.indexOf(I)===0&&(p=P.substr(0,P.indexOf(I)+I.length),P=P.substr(P.indexOf(I)+I.length));const D=P.split(c);for(let f=1;g&&f<=D.length;f++)for(let A=D.length-f;g&&A>=0;A--){g=!1;let L=D.slice(A,A+f).join(c);for(let V=0;!g&&V<s.length;V++)if(V!==k&&s[V]&&s[V].indexOf(L)>-1){const G=A+f===D.length,$=A>0&&s[V].indexOf(c)>-1?c+L:L,K=s[V].endsWith($);g=!G||K}if(!g){let V="";(D[0].endsWith(":")||p!=="")&&(A===1&&(A=0,f++,L=D[0]+c+L),A>0&&(V=D[0]+c),V=p+V),A>0&&(V=V+a+c),V=V+L,A+f<D.length&&(V=V+c+a),h[k]=V}}g&&(h[k]=P)}return h}e.shorten=S;var o;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function m(s,c=Object.create(null)){const h=[];let g=!1,k="";for(const P of s)if(P==="$"||g&&P==="{")k&&h.push({value:k,type:o.TEXT}),k="",g=!0;else if(P==="}"&&g){const p=c[k];if(typeof p=="string")p.length&&h.push({value:p,type:o.VARIABLE});else if(p){const D=h[h.length-1];(!D||D.type!==o.SEPARATOR)&&h.push({value:p.label,type:o.SEPARATOR})}k="",g=!1}else k+=P;return k&&!g&&h.push({value:k,type:o.TEXT}),h.filter((P,p)=>{if(P.type===o.SEPARATOR){const D=h[p-1],f=h[p+1];return[D,f].every(A=>A&&(A.type===o.VARIABLE||A.type===o.TEXT)&&A.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=m;function y(s,c){return R.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):s.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function i(s,c){return R.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,""):R.isWindows?s.replace(/&&|&/g,h=>h==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function v(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=v;function r(s){const c=s.indexOf("/")!==-1?b.posix:b.win32,h=c.basename(s),g=c.dirname(s);return h.length?{name:h,parentPath:g}:{name:g,parentPath:""}}e.splitName=r}),define(we[78],be([0,1,27,11,17,24,9]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(C=e.Mimes||(e.Mimes={}));let _=[],T=[],t=[];function E(s,c=!1){const h=n(s);_.push(h),h.userConfigured?t.push(h):T.push(h),c&&!h.userConfigured&&_.forEach(g=>{g.mime===h.mime||g.userConfigured||(h.extension&&g.extension===h.extension&&console.warn(`Overwriting extension <<${h.extension}>> to now point to mime <<${h.mime}>>`),h.filename&&g.filename===h.filename&&console.warn(`Overwriting filename <<${h.filename}>> to now point to mime <<${h.mime}>>`),h.filepattern&&g.filepattern===h.filepattern&&console.warn(`Overwriting filepattern <<${h.filepattern}>> to now point to mime <<${h.mime}>>`),h.firstline&&g.firstline===h.firstline&&console.warn(`Overwriting firstline <<${h.firstline}>> to now point to mime <<${h.mime}>>`))})}e.registerTextMime=E;function n(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?(0,d.parse)(s.filepattern.toLowerCase()):void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(b.posix.sep)>=0:!1}}function u(s){s?(_=_.filter(c=>!c.userConfigured),t=[]):(_=[],T=[],t=[])}e.clearTextMimes=u;function l(s,c){let h;if(s)switch(s.scheme){case M.Schemas.file:h=s.fsPath;break;case M.Schemas.data:h=R.DataUri.parseMetaData(s).get(R.DataUri.META_DATA_LABEL);break;default:h=s.path}if(!h)return[C.unknown];h=h.toLowerCase();const g=(0,b.basename)(h),k=a(h,g,t);if(k)return[k,C.text];const P=a(h,g,T);if(P)return[P,C.text];if(c){const p=w(c);if(p)return[p,C.text]}return[C.unknown]}e.guessMimeTypes=l;function a(s,c,h){let g=null,k=null,P=null;for(let p=h.length-1;p>=0;p--){const D=h[p];if(c===D.filenameLowercase){g=D;break}if(D.filepattern&&(!k||D.filepattern.length>k.filepattern.length)){const f=D.filepatternOnPath?s:c;D.filepatternLowercase?.(f)&&(k=D)}D.extension&&(!P||D.extension.length>P.extension.length)&&c.endsWith(D.extensionLowercase)&&(P=D)}return g?g.mime:k?k.mime:P?P.mime:null}function w(s){if((0,F.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let c=_.length-1;c>=0;c--){const h=_[c];if(!h.firstline)continue;const g=s.match(h.firstline);if(g&&g.length>0)return h.mime}return null}function I(s){return s?typeof s=="string"?s===C.binary||s===C.text||s===C.unknown:s.length===1&&I(s[0]):!0}e.isUnspecific=I;const S={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function m(s){const c=(0,b.extname)(s),h=S[c.toLowerCase()];return h!==void 0?h:y(s)}e.getMediaOrTextMime=m;function y(s){const c=(0,b.extname)(s);return o[c.toLowerCase()]}e.getMediaMime=y;function i(s){for(const c in o)if(o[c]===s)return c}e.getExtensionForMimeType=i;const v=/^(.+)\/(.+?)(;.+)?$/;function r(s,c){const h=v.exec(s);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:c?void 0:s}e.normalizeMimeType=r}),define(we[109],be([0,1,2]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class b{constructor(E){this._uriTransformer=E}transformIncoming(E){const n=this._uriTransformer.transformIncoming(E);return n===E?E:M(d.URI.from(n))}transformOutgoing(E){const n=this._uriTransformer.transformOutgoing(E);return n===E?E:M(d.URI.from(n))}transformOutgoingURI(E){const n=this._uriTransformer.transformOutgoing(E);return n===E?E:d.URI.from(n)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function R(t,E,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof d.URI)return E.transformOutgoing(t);for(let u in t)if(Object.hasOwnProperty.call(t,u)){const l=R(t[u],E,n+1);l!==null&&(t[u]=l)}}return null}function F(t,E){const n=R(t,E,0);return n===null?t:n}e.transformOutgoingURIs=F;function C(t,E,n,u){if(!t||u>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?d.URI.revive(E.transformIncoming(t)):E.transformIncoming(t);for(let l in t)if(Object.hasOwnProperty.call(t,l)){const a=C(t[l],E,n,u+1);a!==null&&(t[l]=a)}}return null}function _(t,E){const n=C(t,E,!1,0);return n===null?t:n}e.transformIncomingURIs=_;function T(t,E){const n=C(t,E,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=T}),define(we[36],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(_){return d.test(_)}e.isUUID=M;const b=new Uint8Array(16),R=[];for(let _=0;_<256;_++)R.push(_.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(_){for(let T=0;T<_.length;T++)_[T]=Math.floor(Math.random()*256);return _};function C(){F(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let _=0,T="";return T+=R[b[_++]],T+=R[b[_++]],T+=R[b[_++]],T+=R[b[_++]],T+="-",T+=R[b[_++]],T+=R[b[_++]],T+="-",T+=R[b[_++]],T+=R[b[_++]],T+="-",T+=R[b[_++]],T+=R[b[_++]],T+="-",T+=R[b[_++]],T+=R[b[_++]],T+=R[b[_++]],T+=R[b[_++]],T+=R[b[_++]],T+=R[b[_++]],T}e.generateUuid=C}),define(we[110],be([0,1,226]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class b extends d.CharacterClassifier{constructor(C){super(0);for(let _=0,T=C.length;_<T;_++)this.set(C.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=b;function R(F){let C={};return _=>(C.hasOwnProperty(_)||(C[_]=F(_)),C[_])}e.getMapForWordSeparators=R(F=>new b(F))}),define(we[79],be([0,1,23]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var b;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(b=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(R=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class _{constructor(w){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,w.tabSize|0),this.indentSize=w.tabSize|0,this.insertSpaces=Boolean(w.insertSpaces),this.defaultEOL=w.defaultEOL|0,this.trimAutoWhitespace=Boolean(w.trimAutoWhitespace),this.bracketPairColorizationOptions=w.bracketPairColorizationOptions}equals(w){return this.tabSize===w.tabSize&&this.indentSize===w.indentSize&&this.insertSpaces===w.insertSpaces&&this.defaultEOL===w.defaultEOL&&this.trimAutoWhitespace===w.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,w.bracketPairColorizationOptions)}createChangeEvent(w){return{tabSize:this.tabSize!==w.tabSize,indentSize:this.indentSize!==w.indentSize,insertSpaces:this.insertSpaces!==w.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==w.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class T{constructor(w,I){this._findMatchBrand=void 0,this.range=w,this.matches=I}}e.FindMatch=T;var t;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var E;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right",a[a.None=2]="None"})(E=e.PositionAffinity||(e.PositionAffinity={}));var n;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(n=e.ModelConstants||(e.ModelConstants={}));class u{constructor(w,I,S,o,m,y){this.identifier=w,this.range=I,this.text=S,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=m,this._isTracked=y}}e.ValidAnnotatedEditOperation=u;class l{constructor(w,I,S){this.reverseEdits=w,this.changes=I,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=l}),define(we[111],be([0,1,9,110,112,44,79]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class _{constructor(o,m,y,i){this.searchString=o,this.isRegex=m,this.matchCase=y,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=T(this.searchString):o=this.searchString.indexOf(`
`)>=0;let m=null;try{m=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(i){return null}if(!m)return null;let y=!this.isRegex&&!o;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new t(m,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}e.SearchParams=_;function T(S){if(!S||S.length===0)return!1;for(let o=0,m=S.length;o<m;o++)if(S.charCodeAt(o)===92){if(o++,o>=m)break;const i=S.charCodeAt(o);if(i===110||i===114||i===87||i===119)return!0}return!1}e.isMultilineRegexSource=T;class t{constructor(o,m,y){this.regex=o,this.wordSeparators=m,this.simpleSearch=y}}e.SearchData=t;function E(S,o,m){if(!m)return new F.FindMatch(S,null);let y=[];for(let i=0,v=o.length;i<v;i++)y[i]=o[i];return new F.FindMatch(S,y)}e.createFindMatch=E;class n{constructor(o){let m=[],y=0;for(let i=0,v=o.length;i<v;i++)o.charCodeAt(i)===10&&(m[y++]=i);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(o){const m=this._lineFeedsOffsets;let y=0,i=m.length-1;if(i===-1||o<=m[0])return 0;for(;y<i;){const v=y+((i-y)/2>>0);m[v]>=o?i=v-1:m[v+1]>=o?(y=v,i=v):y=v+1}return y+1}}class u{static findMatches(o,m,y,i,v){const r=m.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(o,y,new I(r.wordSeparators,r.regex),i,v):this._doFindMatchesLineByLine(o,y,r,i,v):[]}static _getMultilineMatchRange(o,m,y,i,v,r){let s,c=0;i?(c=i.findLineFeedCountBeforeOffset(v),s=m+v+c):s=m+v;let h;if(i){let p=i.findLineFeedCountBeforeOffset(v+r.length)-c;h=s+r.length+p}else h=s+r.length;const g=o.getPositionAt(s),k=o.getPositionAt(h);return new R.Range(g.lineNumber,g.column,k.lineNumber,k.column)}static _doFindMatchesMultiline(o,m,y,i,v){const r=o.getOffsetAt(m.getStartPosition()),s=o.getValueInRange(m,1),c=o.getEOL()===`\r
`?new n(s):null,h=[];let g=0,k;for(y.reset(0);k=y.next(s);)if(h[g++]=E(this._getMultilineMatchRange(o,r,s,c,k.index,k[0]),k,i),g>=v)return h;return h}static _doFindMatchesLineByLine(o,m,y,i,v){const r=[];let s=0;if(m.startLineNumber===m.endLineNumber){const h=o.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return s=this._findMatchesInLine(y,h,m.startLineNumber,m.startColumn-1,s,r,i,v),r}const c=o.getLineContent(m.startLineNumber).substring(m.startColumn-1);s=this._findMatchesInLine(y,c,m.startLineNumber,m.startColumn-1,s,r,i,v);for(let h=m.startLineNumber+1;h<m.endLineNumber&&s<v;h++)s=this._findMatchesInLine(y,o.getLineContent(h),h,0,s,r,i,v);if(s<v){const h=o.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);s=this._findMatchesInLine(y,h,m.endLineNumber,0,s,r,i,v)}return r}static _findMatchesInLine(o,m,y,i,v,r,s,c){const h=o.wordSeparators;if(!s&&o.simpleSearch){const P=o.simpleSearch,p=P.length,D=m.length;let f=-p;for(;(f=m.indexOf(P,f+p))!==-1;)if((!h||w(h,m,D,f,p))&&(r[v++]=new F.FindMatch(new R.Range(y,f+1+i,y,f+1+p+i),null),v>=c))return v;return v}const g=new I(o.wordSeparators,o.regex);let k;g.reset(0);do if(k=g.next(m),k&&(r[v++]=E(new R.Range(y,k.index+1+i,y,k.index+1+k[0].length+i),k,s),v>=c))return v;while(k);return v}static findNextMatch(o,m,y,i){const v=m.parseSearchRequest();if(!v)return null;const r=new I(v.wordSeparators,v.regex);return v.regex.multiline?this._doFindNextMatchMultiline(o,y,r,i):this._doFindNextMatchLineByLine(o,y,r,i)}static _doFindNextMatchMultiline(o,m,y,i){const v=new b.Position(m.lineNumber,1),r=o.getOffsetAt(v),s=o.getLineCount(),c=o.getValueInRange(new R.Range(v.lineNumber,v.column,s,o.getLineMaxColumn(s)),1),h=o.getEOL()===`\r
`?new n(c):null;y.reset(m.column-1);let g=y.next(c);return g?E(this._getMultilineMatchRange(o,r,c,h,g.index,g[0]),g,i):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(o,new b.Position(1,1),y,i):null}static _doFindNextMatchLineByLine(o,m,y,i){const v=o.getLineCount(),r=m.lineNumber,s=o.getLineContent(r),c=this._findFirstMatchInLine(y,s,r,m.column,i);if(c)return c;for(let h=1;h<=v;h++){const g=(r+h-1)%v,k=o.getLineContent(g+1),P=this._findFirstMatchInLine(y,k,g+1,1,i);if(P)return P}return null}static _findFirstMatchInLine(o,m,y,i,v){o.reset(i-1);const r=o.next(m);return r?E(new R.Range(y,r.index+1,y,r.index+1+r[0].length),r,v):null}static findPreviousMatch(o,m,y,i){const v=m.parseSearchRequest();if(!v)return null;const r=new I(v.wordSeparators,v.regex);return v.regex.multiline?this._doFindPreviousMatchMultiline(o,y,r,i):this._doFindPreviousMatchLineByLine(o,y,r,i)}static _doFindPreviousMatchMultiline(o,m,y,i){const v=this._doFindMatchesMultiline(o,new R.Range(1,1,m.lineNumber,m.column),y,i,10*C);if(v.length>0)return v[v.length-1];const r=o.getLineCount();return m.lineNumber!==r||m.column!==o.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(o,new b.Position(r,o.getLineMaxColumn(r)),y,i):null}static _doFindPreviousMatchLineByLine(o,m,y,i){const v=o.getLineCount(),r=m.lineNumber,s=o.getLineContent(r).substring(0,m.column-1),c=this._findLastMatchInLine(y,s,r,i);if(c)return c;for(let h=1;h<=v;h++){const g=(v+r-h-1)%v,k=o.getLineContent(g+1),P=this._findLastMatchInLine(y,k,g+1,i);if(P)return P}return null}static _findLastMatchInLine(o,m,y,i){let v=null,r;for(o.reset(0);r=o.next(m);)v=E(new R.Range(y,r.index+1,y,r.index+1+r[0].length),r,i);return v}}e.TextModelSearch=u;function l(S,o,m,y,i){if(y===0)return!0;const v=o.charCodeAt(y-1);if(S.get(v)!==0||v===13||v===10)return!0;if(i>0){const r=o.charCodeAt(y);if(S.get(r)!==0)return!0}return!1}function a(S,o,m,y,i){if(y+i===m)return!0;const v=o.charCodeAt(y+i);if(S.get(v)!==0||v===13||v===10)return!0;if(i>0){const r=o.charCodeAt(y+i-1);if(S.get(r)!==0)return!0}return!1}function w(S,o,m,y,i){return l(S,o,m,y,i)&&a(S,o,m,y,i)}e.isValidMatch=w;class I{constructor(o,m){this._wordSeparators=o,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const m=o.length;let y;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(y=this._searchRegex.exec(o),!y))return null;const i=y.index,v=y[0].length;if(i===this._prevMatchStartIndex&&v===this._prevMatchLength){if(v===0){d.getNextCodePoint(o,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=v,!this._wordSeparators||w(this._wordSeparators,o,m,i,v))return y}while(y);return null}}e.Searcher=I}),define(we[113],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class M{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let _=0,T=C.notIn.length;_<T;_++)switch(C.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=M;class b{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of C)R(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),R(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),R(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),R(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&R(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=b;function R(F,C,_){F.has(C)?F.get(C).push(_):F.set(C,[_])}}),define(we[55],be([0,1,27,17]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(R,F,C,_){if(Array.isArray(R)){let T=0;for(const t of R){const E=b(t,F,C,_);if(E===10)return E;E>T&&(T=E)}return T}else{if(typeof R=="string")return _?R==="*"?5:R===C?10:0:0;if(R){const{language:T,pattern:t,scheme:E,hasAccessToAllModels:n}=R;if(!_&&!n)return 0;let u=0;if(E)if(E===F.scheme)u=10;else if(E==="*")u=5;else return 0;if(T)if(T===C)u=10;else if(T==="*")u=Math.max(u,5);else return 0;if(t){let l;if(typeof t=="string"?l=t:l={...t,base:(0,M.normalize)(t.base)},l===F.fsPath||(0,d.match)(l,F.fsPath))u=10;else return 0}return u}else return 0}}e.score=b}),define(we[114],be([0,1,3,6]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class b{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,C){return this._map.set(F,C),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===C&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,C){let _=null,T=!1;return this._promises.set(F,C.then(t=>{this._promises.delete(F),!(T||!t)&&(_=this.register(F,t))})),(0,M.toDisposable)(()=>{T=!0,_&&_.dispose()})}getPromise(F){const C=this.get(F);if(C)return Promise.resolve(C);const _=this._promises.get(F);return _?_.then(T=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=b}),define(we[80],be([0,1,22,26]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(b||(b={}));function R(E){for(let n=0,u=E.length;n<u;n+=4){const l=E[n+0],a=E[n+1],w=E[n+2],I=E[n+3];E[n+0]=I,E[n+1]=w,E[n+2]=a,E[n+3]=l}}function F(E){const n=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return M.isLittleEndian()||R(n),d.VSBuffer.wrap(n)}function C(E){const n=E.buffer;if(M.isLittleEndian()||R(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const u=new Uint8Array(n.byteLength);return u.set(n),new Uint32Array(u.buffer,u.byteOffset,u.length/4)}}function _(E){const n=new Uint32Array(T(E));let u=0;if(n[u++]=E.id,E.type==="full")n[u++]=1,n[u++]=E.data.length,n.set(E.data,u),u+=E.data.length;else{n[u++]=2,n[u++]=E.deltas.length;for(const l of E.deltas)n[u++]=l.start,n[u++]=l.deleteCount,l.data?(n[u++]=l.data.length,n.set(l.data,u),u+=l.data.length):n[u++]=0}return F(n)}e.encodeSemanticTokensDto=_;function T(E){let n=0;if(n+=1+1,E.type==="full")n+=1+E.data.length;else{n+=1,n+=(1+1+1)*E.deltas.length;for(const u of E.deltas)u.data&&(n+=u.data.length)}return n}function t(E){const n=C(E);let u=0;const l=n[u++];if(n[u++]===1){const S=n[u++],o=n.subarray(u,u+S);return u+=S,{id:l,type:"full",data:o}}const w=n[u++];let I=[];for(let S=0;S<w;S++){const o=n[u++],m=n[u++],y=n[u++];let i;y>0&&(i=n.subarray(u,u+y),u+=y),I[S]={start:o,deleteCount:m,data:i}}return{id:l,type:"delta",deltas:I}}e.decodeSemanticTokensDto=t}),define(we[115],be([18,19]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(we[56],be([0,1,13,10,115]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function R(T,t){return t&&(T.stack||T.stacktrace)?b.localize(0,null,C(T),F(T.stack)||F(T.stacktrace)):C(T)}function F(T){return Array.isArray(T)?T.join(`
`):T}function C(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?b.localize(1,null,T.message):T.message||b.localize(2,null)}function _(T=null,t=!1){if(!T)return b.localize(3,null);if(Array.isArray(T)){const E=d.coalesce(T),n=_(E[0],t);return E.length>1?b.localize(4,null,n,E.length):n}if(M.isString(T))return T;if(T.detail){const E=T.detail;if(E.error)return R(E.error,t);if(E.exception)return R(E.exception,t)}return T.stack?R(T,t):T.message?T.message:b.localize(5,null)}e.toErrorMessage=_}),define(we[116],be([18,19]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(we[117],be([0,1,116,26,118]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var R;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(R=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=F;class C{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,me){this._values[J]=me}}e.ValidatedEditorOptions=C;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class T{constructor(J,me,Ne,Ke){this.id=J,this.name=me,this.defaultValue=Ne,this.schema=Ke}compute(J,me,Ne){return Ne}}class t{constructor(J,me=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(J){return this.defaultValue}}class E{constructor(J,me,Ne,Ke){this.id=J,this.name=me,this.defaultValue=Ne,this.schema=Ke}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,me,Ne){return Ne}}function n(H,J){return typeof H=="undefined"?J:H==="false"?!1:Boolean(H)}e.boolean=n;class u extends E{constructor(J,me,Ne,Ke=void 0){typeof Ke!="undefined"&&(Ke.type="boolean",Ke.default=Ne),super(J,me,Ne,Ke)}validate(J){return n(J,this.defaultValue)}}function l(H,J,me,Ne){if(typeof H=="undefined")return J;let Ke=parseInt(H,10);return isNaN(Ke)?J:(Ke=Math.max(me,Ke),Ke=Math.min(Ne,Ke),Ke|0)}e.clampedInt=l;class a extends E{constructor(J,me,Ne,Ke,ot,at=void 0){typeof at!="undefined"&&(at.type="integer",at.default=Ne,at.minimum=Ke,at.maximum=ot),super(J,me,Ne,at),this.minimum=Ke,this.maximum=ot}static clampedInt(J,me,Ne,Ke){return l(J,me,Ne,Ke)}validate(J){return a.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class w extends E{constructor(J,me,Ne,Ke,ot){typeof ot!="undefined"&&(ot.type="number",ot.default=Ne),super(J,me,Ne,ot),this.validationFn=Ke}static clamp(J,me,Ne){return J<me?me:J>Ne?Ne:J}static float(J,me){if(typeof J=="number")return J;if(typeof J=="undefined")return me;const Ne=parseFloat(J);return isNaN(Ne)?me:Ne}validate(J){return this.validationFn(w.float(J,this.defaultValue))}}class I extends E{static string(J,me){return typeof J!="string"?me:J}constructor(J,me,Ne,Ke=void 0){typeof Ke!="undefined"&&(Ke.type="string",Ke.default=Ne),super(J,me,Ne,Ke)}validate(J){return I.string(J,this.defaultValue)}}function S(H,J,me){return typeof H!="string"||me.indexOf(H)===-1?J:H}e.stringSet=S;class o extends E{constructor(J,me,Ne,Ke,ot=void 0){typeof ot!="undefined"&&(ot.type="string",ot.enum=Ke,ot.default=Ne),super(J,me,Ne,ot),this._allowedValues=Ke}validate(J){return S(J,this.defaultValue,this._allowedValues)}}class m extends T{constructor(J,me,Ne,Ke,ot,at,vt=void 0){typeof vt!="undefined"&&(vt.type="string",vt.enum=ot,vt.default=Ke),super(J,me,Ne,vt),this._allowedValues=ot,this._convert=at}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function y(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,me,Ne){return Ne===0?J.accessibilitySupport:Ne}}class v extends T{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:d.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertSpace:n(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var c;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(c=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function h(H){switch(H){case c.Line:return"line";case c.Block:return"block";case c.Underline:return"underline";case c.LineThin:return"line-thin";case c.BlockOutline:return"block-outline";case c.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function g(H){switch(H){case"line":return c.Line;case"block":return c.Block;case"underline":return c.Underline;case"line-thin":return c.LineThin;case"block-outline":return c.BlockOutline;case"underline-thin":return c.UnderlineThin}}class k extends t{constructor(){super(127,[65,32])}compute(J,me,Ne){const Ke=["monaco-editor"];return me.get(32)&&Ke.push(me.get(32)),J.extraEditorClassName&&Ke.push(J.extraEditorClassName),me.get(65)==="default"?Ke.push("mouse-default"):me.get(65)==="copy"&&Ke.push("mouse-copy"),me.get(100)&&Ke.push("showUnused"),me.get(125)&&Ke.push("showDeprecated"),Ke.join(" ")}}class P extends u{constructor(){super(31,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(J,me,Ne){return Ne&&J.emptySelectionClipboard}}class p extends T{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:d.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:d.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{cursorMoveOnType:n(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":S(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":S(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(me.loop,this.defaultValue.loop)}}}class D extends T{constructor(){super(43,"fontLigatures",D.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?D.OFF:J==="true"?D.ON:J:Boolean(J)?D.ON:D.OFF}}e.EditorFontLigatures=D,D.OFF='"liga" off, "calt" off',D.ON='"liga" on, "calt" on';class f extends t{constructor(){super(42)}compute(J,me,Ne){return J.fontInfo}}class A extends E{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(J){let me=w.float(J,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:w.clamp(me,6,100)}compute(J,me,Ne){return J.fontInfo.fontSize}}class L extends T{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:L.MINIMUM_VALUE,maximum:L.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:L.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(a.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,L.MINIMUM_VALUE,L.MAXIMUM_VALUE))}}L.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],L.MINIMUM_VALUE=1,L.MAXIMUM_VALUE=1e3;class V extends T{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Ne,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Ne,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Ne,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Ne,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Ne,description:d.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{multiple:S(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??S(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??S(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??S(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??S(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??S(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:I.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:I.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:I.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:I.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:I.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class G extends T{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:d.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),delay:a.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:n(me.sticky,this.defaultValue.sticky)}}}var $;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})($=e.RenderMinimap||(e.RenderMinimap={}));class K extends t{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(J,me,Ne){return K.computeLayout(me,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const me=J.height/J.lineHeight,Ne=J.scrollBeyondLastLine?me-1:0,Ke=(J.viewLineCount+Ne)/(J.pixelRatio*J.height),ot=Math.floor(J.viewLineCount/Ke);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Ne,desiredRatio:Ke,minimapLineCount:ot}}static _computeMinimapLayout(J,me){const Ne=J.outerWidth,Ke=J.outerHeight,ot=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*Ke),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ke};const at=me.stableMinimapLayoutInput,vt=at&&J.outerHeight===at.outerHeight&&J.lineHeight===at.lineHeight&&J.typicalHalfwidthCharacterWidth===at.typicalHalfwidthCharacterWidth&&J.pixelRatio===at.pixelRatio&&J.scrollBeyondLastLine===at.scrollBeyondLastLine&&J.minimap.enabled===at.minimap.enabled&&J.minimap.side===at.minimap.side&&J.minimap.size===at.minimap.size&&J.minimap.showSlider===at.minimap.showSlider&&J.minimap.renderCharacters===at.minimap.renderCharacters&&J.minimap.maxColumn===at.minimap.maxColumn&&J.minimap.scale===at.minimap.scale&&J.verticalScrollbarWidth===at.verticalScrollbarWidth&&J.isViewportWrapping===at.isViewportWrapping,kt=J.lineHeight,ht=J.typicalHalfwidthCharacterWidth,yt=J.scrollBeyondLastLine,It=J.minimap.renderCharacters;let ft=ot>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Je=J.minimap.maxColumn,Et=J.minimap.size,Pe=J.minimap.side,ye=J.verticalScrollbarWidth,Ce=J.viewLineCount,Z=J.remainingWidth,ce=J.isViewportWrapping,ge=It?2:3;let fe=Math.floor(ot*Ke);const Ie=fe/ot;let xe=!1,Le=!1,Ve=ge*ft,Ze=ft/ot,ie=1;if(Et==="fill"||Et==="fit"){const{typicalViewportLineCount:We,extraLinesBeyondLastLine:tt,desiredRatio:mt,minimapLineCount:wt}=K.computeContainedMinimapLineCount({viewLineCount:Ce,scrollBeyondLastLine:yt,height:Ke,lineHeight:kt,pixelRatio:ot});if(Ce/wt>1)xe=!0,Le=!0,ft=1,Ve=1,Ze=ft/ot;else{let ct=!1,lt=ft+1;if(Et==="fit"){const Tt=Math.ceil((Ce+tt)*Ve);ce&&vt&&Z<=me.stableFitRemainingWidth?(ct=!0,lt=me.stableFitMaxMinimapScale):ct=Tt>fe}if(Et==="fill"||ct){xe=!0;const Tt=ft;Ve=Math.min(kt*ot,Math.max(1,Math.floor(1/mt))),ce&&vt&&Z<=me.stableFitRemainingWidth&&(lt=me.stableFitMaxMinimapScale),ft=Math.min(lt,Math.max(1,Math.floor(Ve/ge))),ft>Tt&&(ie=Math.min(2,ft/Tt)),Ze=ft/ot/ie,fe=Math.ceil(Math.max(We,Ce+tt)*Ve),ce?(me.stableMinimapLayoutInput=J,me.stableFitRemainingWidth=Z,me.stableFitMaxMinimapScale=ft):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const pe=Math.floor(Je*Ze),se=Math.min(pe,Math.max(0,Math.floor((Z-ye-2)*Ze/(ht+Ze)))+e.MINIMAP_GUTTER_WIDTH);let B=Math.floor(ot*se);const De=B/ot;B=Math.floor(B*ie);const Se=It?1:2,qe=Pe==="left"?0:Ne-se-ye;return{renderMinimap:Se,minimapLeft:qe,minimapWidth:se,minimapHeightIsEditorHeight:xe,minimapIsSampling:Le,minimapScale:ft,minimapLineHeight:Ve,minimapCanvasInnerWidth:B,minimapCanvasInnerHeight:fe,minimapCanvasOuterWidth:De,minimapCanvasOuterHeight:Ie}}static computeLayout(J,me){const Ne=me.outerWidth|0,Ke=me.outerHeight|0,ot=me.lineHeight|0,at=me.lineNumbersDigitCount|0,vt=me.typicalHalfwidthCharacterWidth,kt=me.maxDigitWidth,ht=me.pixelRatio,yt=me.viewLineCount,It=J.get(122),ft=It==="inherit"?J.get(121):It,Je=ft==="inherit"?J.get(117):ft,Et=J.get(120),Pe=J.get(2),ye=me.isDominatedByLongLines,Ce=J.get(48),Z=J.get(59).renderType!==0,ce=J.get(60),ge=J.get(94),fe=J.get(64),Ie=J.get(92),xe=Ie.verticalScrollbarSize,Le=Ie.verticalHasArrows,Ve=Ie.arrowSize,Ze=Ie.horizontalScrollbarSize,ie=J.get(57),pe=J.get(36);let se;if(typeof ie=="string"&&/^\d+(\.\d+)?ch$/.test(ie)){const $t=parseFloat(ie.substr(0,ie.length-2));se=a.clampedInt($t*vt,0,0,1e3)}else se=a.clampedInt(ie,0,0,1e3);pe&&(se+=16);let B=0;if(Z){const $t=Math.max(at,ce);B=Math.round($t*kt)}let De=0;Ce&&(De=ot);let Se=0,qe=Se+De,We=qe+B,tt=We+se;const mt=Ne-De-B-se;let wt=!1,nt=!1,ct=-1;Pe!==2&&(ft==="inherit"&&ye?(wt=!0,nt=!0):Je==="on"||Je==="bounded"?nt=!0:Je==="wordWrapColumn"&&(ct=Et));const lt=K._computeMinimapLayout({outerWidth:Ne,outerHeight:Ke,lineHeight:ot,typicalHalfwidthCharacterWidth:vt,pixelRatio:ht,scrollBeyondLastLine:ge,minimap:fe,verticalScrollbarWidth:xe,viewLineCount:yt,remainingWidth:mt,isViewportWrapping:nt},me.memory||new _);lt.renderMinimap!==0&&lt.minimapLeft===0&&(Se+=lt.minimapWidth,qe+=lt.minimapWidth,We+=lt.minimapWidth,tt+=lt.minimapWidth);const Tt=mt-lt.minimapWidth,_t=Math.max(1,Math.floor((Tt-xe-2)/vt)),Ut=Le?Ve:0;return nt&&(ct=Math.max(1,_t),Je==="bounded"&&(ct=Math.min(ct,Et))),{width:Ne,height:Ke,glyphMarginLeft:Se,glyphMarginWidth:De,lineNumbersLeft:qe,lineNumbersWidth:B,decorationsLeft:We,decorationsWidth:se,contentLeft:tt,contentWidth:Tt,minimap:lt,viewportColumn:_t,isWordWrapMinified:wt,isViewportWrapping:nt,wrappingColumn:ct,verticalScrollbarWidth:xe,horizontalScrollbarHeight:Ze,overviewRuler:{top:Ut,width:xe,height:Ke-2*Ut,right:0}}}}e.EditorLayoutInfoComputer=K;class W extends T{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:d.localize(42,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class U extends T{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:d.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:d.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:d.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:I.string(me.fontFamily,this.defaultValue.fontFamily)}}}class z extends w{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>w.clamp(J,0,150),{markdownDescription:d.localize(46,null)})}compute(J,me,Ne){return J.fontInfo.lineHeight}}class Y extends T{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:d.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(48,null),d.localize(49,null),d.localize(50,null)],default:J.size,description:d.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:d.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:d.localize(53,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:d.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:d.localize(56,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),size:S(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:S(me.side,this.defaultValue.side,["right","left"]),showSlider:S(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(me.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(me.scale,1,1,3),maxColumn:a.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function re(H){return H==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{top:a.clampedInt(me.top,0,0,1e3),bottom:a.clampedInt(me.bottom,0,0,1e3)}}}class ue extends T{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:d.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:d.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),cycle:n(me.cycle,this.defaultValue.cycle)}}}class oe extends t{constructor(){super(128)}compute(J,me,Ne){return J.pixelRatio}}class ve extends T{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:d.localize(61,null)},comments:{type:"boolean",default:J.comments,description:d.localize(62,null)},other:{type:"boolean",default:J.other,description:d.localize(63,null)}}}],default:J,description:d.localize(64,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const me=J,Ne={other:n(me.other,this.defaultValue.other),comments:n(me.comments,this.defaultValue.comments),strings:n(me.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var Fe;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(65,null),d.localize(66,null),d.localize(67,null),d.localize(68,null)],default:"on",description:d.localize(69,null)})}validate(J){let me=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(me=4,Ne=J):J==="interval"?me=3:J==="relative"?me=2:J==="on"?me=1:me=0),{renderType:me,renderFn:Ne}}}function Oe(H){const J=H.get(87);return J==="editable"?H.get(80):J!=="on"}e.filterValidationDecorations=Oe;class Ye extends T{constructor(){const J=[],me={type:"number",description:d.localize(70,null)};super(91,"rulers",J,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:d.localize(71,null),format:"color-hex"}}}]},default:J,description:d.localize(72,null)})}validate(J){if(Array.isArray(J)){let me=[];for(let Ne of J)if(typeof Ne=="number")me.push({column:a.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Ke=Ne;me.push({column:a.clampedInt(Ke.column,0,0,1e4),color:Ke.color})}return me.sort((Ne,Ke)=>Ne.column-Ke.column),me}return this.defaultValue}}function ze(H,J){if(typeof H!="string")return J;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class je extends T{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(73,null),d.localize(74,null),d.localize(75,null)],default:"auto",description:d.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(77,null),d.localize(78,null),d.localize(79,null)],default:"auto",description:d.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:d.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:d.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J,Ne=a.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ke=a.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ze(me.vertical,this.defaultValue.vertical),horizontal:ze(me.horizontal,this.defaultValue.horizontal),useShadows:n(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:a.clampedInt(me.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Ke,verticalSliderSize:a.clampedInt(me.verticalSliderSize,Ke,0,1e3),scrollByPage:n(me.scrollByPage,this.defaultValue.scrollByPage)}}}class x extends T{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:d.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),mode:S(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Q extends T{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:d.localize(85,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class ee extends T{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(86,null),d.localize(87,null)],default:J.insertMode,description:d.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:d.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:d.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:d.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:d.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:d.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:d.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:d.localize(95,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:d.localize(96,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(97,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(98,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(99,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(100,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(101,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(102,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(103,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(104,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(105,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(106,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(107,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(108,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(109,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(110,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(111,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(112,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(113,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(114,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(115,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(116,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(117,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertMode:S(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(me.showIcons,this.defaultValue.showIcons),showStatusBar:n(me.showStatusBar,this.defaultValue.showStatusBar),preview:n(me.preview,this.defaultValue.preview),previewMode:S(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(me.showMethods,this.defaultValue.showMethods),showFunctions:n(me.showFunctions,this.defaultValue.showFunctions),showConstructors:n(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(me.showDeprecated,this.defaultValue.showDeprecated),showFields:n(me.showFields,this.defaultValue.showFields),showVariables:n(me.showVariables,this.defaultValue.showVariables),showClasses:n(me.showClasses,this.defaultValue.showClasses),showStructs:n(me.showStructs,this.defaultValue.showStructs),showInterfaces:n(me.showInterfaces,this.defaultValue.showInterfaces),showModules:n(me.showModules,this.defaultValue.showModules),showProperties:n(me.showProperties,this.defaultValue.showProperties),showEvents:n(me.showEvents,this.defaultValue.showEvents),showOperators:n(me.showOperators,this.defaultValue.showOperators),showUnits:n(me.showUnits,this.defaultValue.showUnits),showValues:n(me.showValues,this.defaultValue.showValues),showConstants:n(me.showConstants,this.defaultValue.showConstants),showEnums:n(me.showEnums,this.defaultValue.showEnums),showEnumMembers:n(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(me.showKeywords,this.defaultValue.showKeywords),showWords:n(me.showWords,this.defaultValue.showWords),showColors:n(me.showColors,this.defaultValue.showColors),showFiles:n(me.showFiles,this.defaultValue.showFiles),showReferences:n(me.showReferences,this.defaultValue.showReferences),showFolders:n(me.showFolders,this.defaultValue.showFolders),showTypeParameters:n(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(me.showSnippets,this.defaultValue.showSnippets),showUsers:n(me.showUsers,this.defaultValue.showUsers),showIssues:n(me.showIssues,this.defaultValue.showIssues)}}}class le extends T{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(128,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class q extends t{constructor(){super(129,[80])}compute(J,me,Ne){return me.get(80)?!0:J.tabFocusMode}}var ae;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(ae=e.WrappingIndent||(e.WrappingIndent={}));function he(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Te extends t{constructor(){super(131,[130])}compute(J,me,Ne){const Ke=me.get(130);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ke.isWordWrapMinified,isViewportWrapping:Ke.isViewportWrapping,wrappingColumn:Ke.wrappingColumn}}}const Be="Consolas, 'Courier New', monospace",$e="Menlo, Monaco, 'Courier New', monospace",Qe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?$e:M.isLinux?Qe:Be,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function _e(H){return e.editorOptionsRegistry[H.id]=H,H}var rt;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.bracketPairColorization=12]="bracketPairColorization",H[H.codeLens=13]="codeLens",H[H.codeLensFontFamily=14]="codeLensFontFamily",H[H.codeLensFontSize=15]="codeLensFontSize",H[H.colorDecorators=16]="colorDecorators",H[H.columnSelection=17]="columnSelection",H[H.comments=18]="comments",H[H.contextmenu=19]="contextmenu",H[H.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",H[H.cursorBlinking=21]="cursorBlinking",H[H.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",H[H.cursorStyle=23]="cursorStyle",H[H.cursorSurroundingLines=24]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",H[H.cursorWidth=26]="cursorWidth",H[H.disableLayerHinting=27]="disableLayerHinting",H[H.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",H[H.domReadOnly=29]="domReadOnly",H[H.dragAndDrop=30]="dragAndDrop",H[H.emptySelectionClipboard=31]="emptySelectionClipboard",H[H.extraEditorClassName=32]="extraEditorClassName",H[H.fastScrollSensitivity=33]="fastScrollSensitivity",H[H.find=34]="find",H[H.fixedOverflowWidgets=35]="fixedOverflowWidgets",H[H.folding=36]="folding",H[H.foldingStrategy=37]="foldingStrategy",H[H.foldingHighlight=38]="foldingHighlight",H[H.foldingImportsByDefault=39]="foldingImportsByDefault",H[H.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=41]="fontFamily",H[H.fontInfo=42]="fontInfo",H[H.fontLigatures=43]="fontLigatures",H[H.fontSize=44]="fontSize",H[H.fontWeight=45]="fontWeight",H[H.formatOnPaste=46]="formatOnPaste",H[H.formatOnType=47]="formatOnType",H[H.glyphMargin=48]="glyphMargin",H[H.gotoLocation=49]="gotoLocation",H[H.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",H[H.hover=52]="hover",H[H.inDiffEditor=53]="inDiffEditor",H[H.inlineSuggest=54]="inlineSuggest",H[H.letterSpacing=55]="letterSpacing",H[H.lightbulb=56]="lightbulb",H[H.lineDecorationsWidth=57]="lineDecorationsWidth",H[H.lineHeight=58]="lineHeight",H[H.lineNumbers=59]="lineNumbers",H[H.lineNumbersMinChars=60]="lineNumbersMinChars",H[H.linkedEditing=61]="linkedEditing",H[H.links=62]="links",H[H.matchBrackets=63]="matchBrackets",H[H.minimap=64]="minimap",H[H.mouseStyle=65]="mouseStyle",H[H.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=67]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",H[H.multiCursorModifier=69]="multiCursorModifier",H[H.multiCursorPaste=70]="multiCursorPaste",H[H.occurrencesHighlight=71]="occurrencesHighlight",H[H.overviewRulerBorder=72]="overviewRulerBorder",H[H.overviewRulerLanes=73]="overviewRulerLanes",H[H.padding=74]="padding",H[H.parameterHints=75]="parameterHints",H[H.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",H[H.quickSuggestions=78]="quickSuggestions",H[H.quickSuggestionsDelay=79]="quickSuggestionsDelay",H[H.readOnly=80]="readOnly",H[H.renameOnType=81]="renameOnType",H[H.renderControlCharacters=82]="renderControlCharacters",H[H.renderIndentGuides=83]="renderIndentGuides",H[H.renderFinalNewline=84]="renderFinalNewline",H[H.renderLineHighlight=85]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=87]="renderValidationDecorations",H[H.renderWhitespace=88]="renderWhitespace",H[H.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",H[H.roundedSelection=90]="roundedSelection",H[H.rulers=91]="rulers",H[H.scrollbar=92]="scrollbar",H[H.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=94]="scrollBeyondLastLine",H[H.scrollPredominantAxis=95]="scrollPredominantAxis",H[H.selectionClipboard=96]="selectionClipboard",H[H.selectionHighlight=97]="selectionHighlight",H[H.selectOnLineNumbers=98]="selectOnLineNumbers",H[H.showFoldingControls=99]="showFoldingControls",H[H.showUnused=100]="showUnused",H[H.snippetSuggestions=101]="snippetSuggestions",H[H.smartSelect=102]="smartSelect",H[H.smoothScrolling=103]="smoothScrolling",H[H.stickyTabStops=104]="stickyTabStops",H[H.stopRenderingLineAfter=105]="stopRenderingLineAfter",H[H.suggest=106]="suggest",H[H.suggestFontSize=107]="suggestFontSize",H[H.suggestLineHeight=108]="suggestLineHeight",H[H.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",H[H.suggestSelection=110]="suggestSelection",H[H.tabCompletion=111]="tabCompletion",H[H.tabIndex=112]="tabIndex",H[H.unusualLineTerminators=113]="unusualLineTerminators",H[H.useShadowDOM=114]="useShadowDOM",H[H.useTabStops=115]="useTabStops",H[H.wordSeparators=116]="wordSeparators",H[H.wordWrap=117]="wordWrap",H[H.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=120]="wordWrapColumn",H[H.wordWrapOverride1=121]="wordWrapOverride1",H[H.wordWrapOverride2=122]="wordWrapOverride2",H[H.wrappingIndent=123]="wrappingIndent",H[H.wrappingStrategy=124]="wrappingStrategy",H[H.showDeprecated=125]="showDeprecated",H[H.inlayHints=126]="inlayHints",H[H.editorClassName=127]="editorClassName",H[H.pixelRatio=128]="pixelRatio",H[H.tabFocusMode=129]="tabFocusMode",H[H.layoutInfo=130]="layoutInfo",H[H.wrappingInfo=131]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(129,null)})),acceptSuggestionOnEnter:_e(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(130,null),""],markdownDescription:d.localize(131,null)})),accessibilitySupport:_e(new i),accessibilityPageSize:_e(new a(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(132,null)})),ariaLabel:_e(new I(4,"ariaLabel",d.localize(133,null))),autoClosingBrackets:_e(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(134,null),d.localize(135,null),""],description:d.localize(136,null)})),autoClosingDelete:_e(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(137,null),""],description:d.localize(138,null)})),autoClosingOvertype:_e(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(139,null),""],description:d.localize(140,null)})),autoClosingQuotes:_e(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(141,null),d.localize(142,null),""],description:d.localize(143,null)})),autoIndent:_e(new m(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[d.localize(144,null),d.localize(145,null),d.localize(146,null),d.localize(147,null),d.localize(148,null)],description:d.localize(149,null)})),automaticLayout:_e(new u(10,"automaticLayout",!1)),autoSurround:_e(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(150,null),d.localize(151,null),d.localize(152,null),""],description:d.localize(153,null)})),bracketPairColorization:_e(new Q),stickyTabStops:_e(new u(104,"stickyTabStops",!1,{description:d.localize(154,null)})),codeLens:_e(new u(13,"codeLens",!0,{description:d.localize(155,null)})),codeLensFontFamily:_e(new I(14,"codeLensFontFamily","",{description:d.localize(156,null)})),codeLensFontSize:_e(new a(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(157,null)})),colorDecorators:_e(new u(16,"colorDecorators",!0,{description:d.localize(158,null)})),columnSelection:_e(new u(17,"columnSelection",!1,{description:d.localize(159,null)})),comments:_e(new v),contextmenu:_e(new u(19,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new u(20,"copyWithSyntaxHighlighting",!0,{description:d.localize(160,null)})),cursorBlinking:_e(new m(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:d.localize(161,null)})),cursorSmoothCaretAnimation:_e(new u(22,"cursorSmoothCaretAnimation",!1,{description:d.localize(162,null)})),cursorStyle:_e(new m(23,"cursorStyle",c.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],g,{description:d.localize(163,null)})),cursorSurroundingLines:_e(new a(24,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(164,null)})),cursorSurroundingLinesStyle:_e(new o(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(165,null),d.localize(166,null)],description:d.localize(167,null)})),cursorWidth:_e(new a(26,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(168,null)})),disableLayerHinting:_e(new u(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new u(28,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new u(29,"domReadOnly",!1)),dragAndDrop:_e(new u(30,"dragAndDrop",!0,{description:d.localize(169,null)})),emptySelectionClipboard:_e(new P),extraEditorClassName:_e(new I(32,"extraEditorClassName","")),fastScrollSensitivity:_e(new w(33,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:d.localize(170,null)})),find:_e(new p),fixedOverflowWidgets:_e(new u(35,"fixedOverflowWidgets",!1)),folding:_e(new u(36,"folding",!0,{description:d.localize(171,null)})),foldingStrategy:_e(new o(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(172,null),d.localize(173,null)],description:d.localize(174,null)})),foldingHighlight:_e(new u(38,"foldingHighlight",!0,{description:d.localize(175,null)})),foldingImportsByDefault:_e(new u(39,"foldingImportsByDefault",!1,{description:d.localize(176,null)})),unfoldOnClickAfterEndOfLine:_e(new u(40,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(177,null)})),fontFamily:_e(new I(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(178,null)})),fontInfo:_e(new f),fontLigatures2:_e(new D),fontSize:_e(new A),fontWeight:_e(new L),formatOnPaste:_e(new u(46,"formatOnPaste",!1,{description:d.localize(179,null)})),formatOnType:_e(new u(47,"formatOnType",!1,{description:d.localize(180,null)})),glyphMargin:_e(new u(48,"glyphMargin",!0,{description:d.localize(181,null)})),gotoLocation:_e(new V),hideCursorInOverviewRuler:_e(new u(50,"hideCursorInOverviewRuler",!1,{description:d.localize(182,null)})),highlightActiveIndentGuide:_e(new u(51,"highlightActiveIndentGuide",!0,{description:d.localize(183,null)})),hover:_e(new G),inDiffEditor:_e(new u(53,"inDiffEditor",!1)),letterSpacing:_e(new w(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>w.clamp(H,-5,20),{description:d.localize(184,null)})),lightbulb:_e(new W),lineDecorationsWidth:_e(new E(57,"lineDecorationsWidth",10)),lineHeight:_e(new z),lineNumbers:_e(new Me),lineNumbersMinChars:_e(new a(60,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new u(61,"linkedEditing",!1,{description:d.localize(185,null)})),links:_e(new u(62,"links",!0,{description:d.localize(186,null)})),matchBrackets:_e(new o(63,"matchBrackets","always",["always","near","never"],{description:d.localize(187,null)})),minimap:_e(new Y),mouseStyle:_e(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new w(66,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:d.localize(188,null)})),mouseWheelZoom:_e(new u(67,"mouseWheelZoom",!1,{markdownDescription:d.localize(189,null)})),multiCursorMergeOverlapping:_e(new u(68,"multiCursorMergeOverlapping",!0,{description:d.localize(190,null)})),multiCursorModifier:_e(new m(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],re,{markdownEnumDescriptions:[d.localize(191,null),d.localize(192,null)],markdownDescription:d.localize(193,null)})),multiCursorPaste:_e(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(194,null),d.localize(195,null)],markdownDescription:d.localize(196,null)})),occurrencesHighlight:_e(new u(71,"occurrencesHighlight",!0,{description:d.localize(197,null)})),overviewRulerBorder:_e(new u(72,"overviewRulerBorder",!0,{description:d.localize(198,null)})),overviewRulerLanes:_e(new a(73,"overviewRulerLanes",3,0,3)),padding:_e(new j),parameterHints:_e(new ue),peekWidgetDefaultFocus:_e(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(199,null),d.localize(200,null)],description:d.localize(201,null)})),definitionLinkOpensInPeek:_e(new u(77,"definitionLinkOpensInPeek",!1,{description:d.localize(202,null)})),quickSuggestions:_e(new ve),quickSuggestionsDelay:_e(new a(79,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(203,null)})),readOnly:_e(new u(80,"readOnly",!1)),renameOnType:_e(new u(81,"renameOnType",!1,{description:d.localize(204,null),markdownDeprecationMessage:d.localize(205,null)})),renderControlCharacters:_e(new u(82,"renderControlCharacters",!1,{description:d.localize(206,null)})),renderIndentGuides:_e(new u(83,"renderIndentGuides",!0,{description:d.localize(207,null)})),renderFinalNewline:_e(new u(84,"renderFinalNewline",!0,{description:d.localize(208,null)})),renderLineHighlight:_e(new o(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(209,null)],description:d.localize(210,null)})),renderLineHighlightOnlyWhenFocus:_e(new u(86,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(211,null)})),renderValidationDecorations:_e(new o(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new o(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(212,null),d.localize(213,null),d.localize(214,null),""],description:d.localize(215,null)})),revealHorizontalRightPadding:_e(new a(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new u(90,"roundedSelection",!0,{description:d.localize(216,null)})),rulers:_e(new Ye),scrollbar:_e(new je),scrollBeyondLastColumn:_e(new a(93,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(217,null)})),scrollBeyondLastLine:_e(new u(94,"scrollBeyondLastLine",!0,{description:d.localize(218,null)})),scrollPredominantAxis:_e(new u(95,"scrollPredominantAxis",!0,{description:d.localize(219,null)})),selectionClipboard:_e(new u(96,"selectionClipboard",!0,{description:d.localize(220,null),included:M.isLinux})),selectionHighlight:_e(new u(97,"selectionHighlight",!0,{description:d.localize(221,null)})),selectOnLineNumbers:_e(new u(98,"selectOnLineNumbers",!0)),showFoldingControls:_e(new o(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(222,null),d.localize(223,null)],description:d.localize(224,null)})),showUnused:_e(new u(100,"showUnused",!0,{description:d.localize(225,null)})),showDeprecated:_e(new u(125,"showDeprecated",!0,{description:d.localize(226,null)})),inlayHints:_e(new U),snippetSuggestions:_e(new o(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(227,null),d.localize(228,null),d.localize(229,null),d.localize(230,null)],description:d.localize(231,null)})),smartSelect:_e(new le),smoothScrolling:_e(new u(103,"smoothScrolling",!1,{description:d.localize(232,null)})),stopRenderingLineAfter:_e(new a(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new ee),inlineSuggest:_e(new x),suggestFontSize:_e(new a(107,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(233,null)})),suggestLineHeight:_e(new a(108,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(234,null)})),suggestOnTriggerCharacters:_e(new u(109,"suggestOnTriggerCharacters",!0,{description:d.localize(235,null)})),suggestSelection:_e(new o(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(236,null),d.localize(237,null),d.localize(238,null)],description:d.localize(239,null)})),tabCompletion:_e(new o(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(240,null),d.localize(241,null),d.localize(242,null)],description:d.localize(243,null)})),tabIndex:_e(new a(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new o(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(244,null),d.localize(245,null),d.localize(246,null)],description:d.localize(247,null)})),useShadowDOM:_e(new u(114,"useShadowDOM",!0)),useTabStops:_e(new u(115,"useTabStops",!0,{description:d.localize(248,null)})),wordSeparators:_e(new I(116,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:d.localize(249,null)})),wordWrap:_e(new o(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(250,null),d.localize(251,null),d.localize(252,null),d.localize(253,null)],description:d.localize(254,null)})),wordWrapBreakAfterCharacters:_e(new I(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new I(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new a(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(255,null)})),wordWrapOverride1:_e(new o(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new o(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new m(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],he,{enumDescriptions:[d.localize(256,null),d.localize(257,null),d.localize(258,null),d.localize(259,null)],description:d.localize(260,null)})),wrappingStrategy:_e(new o(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(261,null),d.localize(262,null)],description:d.localize(263,null)})),editorClassName:_e(new k),pixelRatio:_e(new oe),tabFocusMode:_e(new q),layoutInfo:_e(new K),wrappingInfo:_e(new Te)}}),define(we[119],be([18,19]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[120],be([18,19]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[121],be([18,19]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(we[122],be([18,19]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(we[123],be([18,19]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define(we[124],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[125],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[126],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(we[127],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[128],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[129],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[130],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[131],be([18,19]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(we[132],be([18,19]),function(ne,e){return ne.create("vs/workbench/common/views",e)}),define(we[133],be([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[134],be([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[135],be([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[136],be([18,19]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[137],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var b;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(b=e.EditorOpenContext||(e.EditorOpenContext={}));var R;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(R=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[138],be([0,1,120]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function R(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=R;function F(n){if(!R(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let u=n.match(M);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=F;function C(n){if(!n)return null;let u=n.majorBase,l=n.majorMustEqual,a=n.minorBase,w=n.minorMustEqual,I=n.patchBase,S=n.patchMustEqual;n.hasCaret&&(u===0||(w=!1),S=!1);let o=0;if(n.preRelease){const m=b.exec(n.preRelease);if(m){const[,y,i,v]=m;o=Date.UTC(Number(y),Number(i)-1,Number(v))}}return{majorBase:u,majorMustEqual:l,minorBase:a,minorMustEqual:w,patchBase:I,patchMustEqual:S,isMinimum:n.hasGreaterEquals,notBefore:o}}e.normalizeVersion=C;function _(n,u,l){let a;typeof n=="string"?a=C(F(n)):a=n;let w;u instanceof Date?w=u.getTime():typeof u=="string"&&(w=new Date(u).getTime());let I;if(typeof l=="string"?I=C(F(l)):I=l,!a||!I)return!1;let S=a.majorBase,o=a.minorBase,m=a.patchBase,y=I.majorBase,i=I.minorBase,v=I.patchBase,r=I.notBefore,s=I.majorMustEqual,c=I.minorMustEqual,h=I.patchMustEqual;return I.isMinimum?S>y?!0:S<y?!1:o>i?!0:o<i||w&&w<r?!1:m>=v:(S===1&&y===0&&(!s||!c||!h)&&(y=1,i=0,v=0,s=!0,c=!1,h=!1),S<y?!1:S>y?!s:o<i?!1:o>i?!c:m<v?!1:m>v?!h:!(w&&w<r))}e.isValidVersion=_;function T(n,u,l,a){return l.isBuiltin||typeof l.main=="undefined"?!0:E(n,u,l.engines.vscode,a)}e.isValidExtensionVersion=T;function t(n,u,l){return n==="*"||E(u,l,n)}e.isEngineValid=t;function E(n,u,l,a=[]){let w=C(F(l));if(!w)return a.push(d.localize(0,null,l)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return a.push(d.localize(1,null,l)),!1}else if(!w.majorMustEqual)return a.push(d.localize(2,null,l)),!1;return _(n,u,w)?!0:(a.push(d.localize(3,null,n,l)),!1)}}),define(we[81],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(b,R=[],F=!1){this.ctor=b,this.staticArguments=R,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=d}),define(we[57],be([0,1,81]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function b(F,C,_){C instanceof d.SyncDescriptor||(C=new d.SyncDescriptor(C,[],_)),M.push([F,C])}e.registerSingleton=b;function R(){return M}e.getSingletonServiceDescriptors=R}),define(we[139],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=d;class M{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let F of this._nodes.values())F.outgoing.size===0&&R.push(F);return R}insertEdge(R,F){const C=this.lookupOrInsertNode(R),_=this.lookupOrInsertNode(F);C.outgoing.set(this._hashFn(F),_),_.incoming.set(this._hashFn(R),C)}removeNode(R){const F=this._hashFn(R);this._nodes.delete(F);for(let C of this._nodes.values())C.outgoing.delete(F),C.incoming.delete(F)}lookupOrInsertNode(R){const F=this._hashFn(R);let C=this._nodes.get(F);return C||(C=new d(R),this._nodes.set(F,C)),C}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[F,C]of this._nodes)R.push(`${F}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,F]of this._nodes){const C=new Set([R]),_=this._findCycle(F,C);if(_)return _}}_findCycle(R,F){for(let[C,_]of R.outgoing){if(F.has(C))return[...F,C].join(" -> ");F.add(C);const T=this._findCycle(_,F);if(T)return T;F.delete(C)}}}e.Graph=M}),define(we[4],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function _(T){return T[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=_})(d=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function M(C,_,T,t){_[d.DI_TARGET]===_?_[d.DI_DEPENDENCIES].push({id:C,index:T,optional:t}):(_[d.DI_DEPENDENCIES]=[{id:C,index:T,optional:t}],_[d.DI_TARGET]=_)}function b(C){if(d.serviceIds.has(C))return d.serviceIds.get(C);const _=function(T,t,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(_,T,E,!1)};return _.toString=()=>C,d.serviceIds.set(C,_),_}e.createDecorator=b;function R(C){return C}e.refineServiceDecorator=R;function F(C){return function(_,T,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(C,_,t,!0)}}e.optional=F}),define(we[140],be([0,1,4]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,d.createDecorator)("modelService");function M(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(we[141],be([0,1,3,58,6,20,75,55,140]),function(ne,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(a){return typeof a=="string"?!1:Array.isArray(a)?a.every(T):!!a.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new d.Emitter}get onDidChange(){return this._onDidChange.event}register(w,I){let S={selector:w,provider:I,_score:-1,_time:this._clock++};return this._entries.push(S),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,b.toDisposable)(()=>{if(S){let o=this._entries.indexOf(S);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),S=void 0)}})}has(w){return this.all(w).length>0}all(w){if(!w)return[];this._updateScores(w);const I=[];for(let S of this._entries)S._score>0&&I.push(S.provider);return I}ordered(w){const I=[];return this._orderedForEach(w,S=>I.push(S.provider)),I}orderedGroups(w){const I=[];let S,o;return this._orderedForEach(w,m=>{S&&o===m._score?S.push(m.provider):(o=m._score,S=[m.provider],I.push(S))}),I}_orderedForEach(w,I){if(!!w){this._updateScores(w);for(const S of this._entries)S._score>0&&I(S)}}_updateScores(w){let I={uri:w.uri.toString(),language:w.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===I.language&&this._lastCandidate.uri===I.uri)){this._lastCandidate=I;for(let S of this._entries)if(S._score=(0,C.score)(S.selector,w.uri,w.getLanguageIdentifier().language,(0,_.shouldSynchronizeModel)(w)),T(S.selector)&&S._score>0){for(let o of this._entries)o._score=0;S._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(w,I){return w._score<I._score?1:w._score>I._score?-1:w._time<I._time?1:w._time>I._time?-1:0}}e.LanguageFeatureRegistry=t;const E=new WeakMap;let n=0;function u(a){let w=E.get(a);return w===void 0&&(w=++n,E.set(a,w)),w}class l{constructor(w,I,S=Number.MAX_SAFE_INTEGER){this._registry=w,this.min=I,this.max=S,this._cache=new R.LRUCache(50,.7)}_key(w){return w.id+this._registry.all(w).reduce((I,S)=>(0,M.doHash)(u(S),I),0)}_clamp(w){return w===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(w*1.3)))}get(w){const I=this._key(w),S=this._cache.get(I);return this._clamp(S?.value)}update(w,I){const S=this._key(w);let o=this._cache.get(S);return o||(o=new F.MovingAverage,this._cache.set(S,o)),o.update(I),this.get(w)}}e.LanguageFeatureRequestDelays=l}),define(we[59],be([0,1,2,44,141,114,34]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class _{constructor(D,f){this.language=D,this.id=f}}e.LanguageIdentifier=_;var T;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline"})(T=e.FontStyle||(e.FontStyle={}));var t;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var E;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=4]="RegEx"})(E=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",p[p.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class u{static getLanguageId(D){return(D&255)>>>0}static getTokenType(D){return(D&1792)>>>8}static getFontStyle(D){return(D&14336)>>>11}static getForeground(D){return(D&8372224)>>>14}static getBackground(D){return(D&4286578688)>>>23}static getClassNameFromMetadata(D){let f=this.getForeground(D),A="mtk"+f,L=this.getFontStyle(D);return L&1&&(A+=" mtki"),L&2&&(A+=" mtkb"),L&4&&(A+=" mtku"),A}static getInlineStyleFromMetadata(D,f){const A=this.getForeground(D),L=this.getFontStyle(D);let V=`color: ${f[A]};`;return L&1&&(V+="font-style: italic;"),L&2&&(V+="font-weight: bold;"),L&4&&(V+="text-decoration: underline;"),V}}e.TokenMetadata=u;var l;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let p=Object.create(null);return p[0]="symbol-method",p[1]="symbol-function",p[2]="symbol-constructor",p[3]="symbol-field",p[4]="symbol-variable",p[5]="symbol-class",p[6]="symbol-struct",p[7]="symbol-interface",p[8]="symbol-module",p[9]="symbol-property",p[10]="symbol-event",p[11]="symbol-operator",p[12]="symbol-unit",p[13]="symbol-value",p[14]="symbol-constant",p[15]="symbol-enum",p[16]="symbol-enum-member",p[17]="symbol-keyword",p[27]="symbol-snippet",p[18]="symbol-text",p[19]="symbol-color",p[20]="symbol-file",p[21]="symbol-reference",p[22]="symbol-customcolor",p[23]="symbol-folder",p[24]="symbol-type-parameter",p[25]="account",p[26]="issues",function(D){const f=p[D];let A=f&&F.iconRegistry.get(f);return A||(console.info("No codicon found for CompletionItemKind "+D),A=F.Codicon.symbolProperty),A.classNames}}(),e.completionKindFromString=function(){let p=Object.create(null);return p.method=0,p.function=1,p.constructor=2,p.field=3,p.variable=4,p.class=5,p.struct=6,p.interface=7,p.module=8,p.property=9,p.event=10,p.operator=11,p.unit=12,p.value=13,p.constant=14,p.enum=15,p["enum-member"]=16,p.enumMember=16,p.keyword=17,p.snippet=27,p.text=18,p.color=19,p.file=20,p.reference=21,p.customcolor=22,p.folder=23,p["type-parameter"]=24,p.typeParameter=24,p.account=25,p.issue=26,function(D,f){let A=p[D];return typeof A=="undefined"&&!f&&(A=9),A}}();var a;(function(p){p[p.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(p){p[p.Automatic=0]="Automatic",p[p.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var o;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(o=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var y;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(y=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(p){return p&&d.URI.isUri(p.uri)&&M.Range.isIRange(p.range)&&(M.Range.isIRange(p.originSelectionRange)||M.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=i;var v;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(v=e.SymbolKind||(e.SymbolKind={}));var r;(function(p){p[p.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var s;(function(p){const D=new Map;D.set("file",0),D.set("module",1),D.set("namespace",2),D.set("package",3),D.set("class",4),D.set("method",5),D.set("property",6),D.set("field",7),D.set("constructor",8),D.set("enum",9),D.set("interface",10),D.set("function",11),D.set("variable",12),D.set("constant",13),D.set("string",14),D.set("number",15),D.set("boolean",16),D.set("array",17),D.set("object",18),D.set("key",19),D.set("null",20),D.set("enum-member",21),D.set("struct",22),D.set("event",23),D.set("operator",24),D.set("type-parameter",25);const f=new Map;f.set(0,"file"),f.set(1,"module"),f.set(2,"namespace"),f.set(3,"package"),f.set(4,"class"),f.set(5,"method"),f.set(6,"property"),f.set(7,"field"),f.set(8,"constructor"),f.set(9,"enum"),f.set(10,"interface"),f.set(11,"function"),f.set(12,"variable"),f.set(13,"constant"),f.set(14,"string"),f.set(15,"number"),f.set(16,"boolean"),f.set(17,"array"),f.set(18,"object"),f.set(19,"key"),f.set(20,"null"),f.set(21,"enum-member"),f.set(22,"struct"),f.set(23,"event"),f.set(24,"operator"),f.set(25,"type-parameter");function A(G){return D.get(G)}p.fromString=A;function L(G){return f.get(G)}p.toString=L;function V(G,$){const K=f.get(G);let W=K&&F.iconRegistry.get("symbol-"+K);return W||(console.info("No codicon found for SymbolKind "+G),W=F.Codicon.symbolProperty),`${$?"inline":"block"} ${W.classNames}`}p.toCssClassName=V})(s=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(D){this.value=D}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var h;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(h=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var g;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(g=e.CommentMode||(e.CommentMode={}));var k;(function(p){p[p.Other=0]="Other",p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(k=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new b.LanguageFeatureRegistry,e.RenameProviderRegistry=new b.LanguageFeatureRegistry,e.CompletionProviderRegistry=new b.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new b.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new b.LanguageFeatureRegistry,e.HoverProviderRegistry=new b.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new b.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new b.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new b.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new b.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new b.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new b.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new b.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new b.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new b.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.LinkProviderRegistry=new b.LanguageFeatureRegistry,e.ColorProviderRegistry=new b.LanguageFeatureRegistry,e.SelectionRangeRegistry=new b.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new b.LanguageFeatureRegistry,e.TokenizationRegistry=new R.TokenizationRegistryImpl;var P;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(P=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[45],be([0,1,26,9,4]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let R=d.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",d.isMacintosh),F.set("isLinux",d.isLinux),F.set("isWindows",d.isWindows),F.set("isWeb",d.isWeb),F.set("isMacNative",d.isMacintosh&&!d.isWeb),F.set("isEdge",R.indexOf("Edg/")>=0),F.set("isFirefox",R.indexOf("Firefox")>=0),F.set("isChrome",R.indexOf("Chrome")>=0),F.set("isSafari",R.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var _;(function(D){D[D.False=0]="False",D[D.True=1]="True",D[D.Defined=2]="Defined",D[D.Not=3]="Not",D[D.Equals=4]="Equals",D[D.NotEquals=5]="NotEquals",D[D.And=6]="And",D[D.Regex=7]="Regex",D[D.NotRegex=8]="NotRegex",D[D.Or=9]="Or",D[D.In=10]="In",D[D.NotIn=11]="NotIn",D[D.Greater=12]="Greater",D[D.GreaterEquals=13]="GreaterEquals",D[D.Smaller=14]="Smaller",D[D.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return E.INSTANCE}static true(){return n.INSTANCE}static has(f){return u.create(f)}static equals(f,A){return l.create(f,A)}static notEquals(f,A){return I.create(f,A)}static regex(f,A){return v.create(f,A)}static in(f,A){return a.create(f,A)}static not(f){return S.create(f)}static and(...f){return s.create(f,null)}static or(...f){return c.create(f,null,!0)}static greater(f,A){return o.create(f,A)}static less(f,A){return y.create(f,A)}static deserialize(f,A=!1){if(!!f)return this._deserializeOrExpression(f,A)}static _deserializeOrExpression(f,A){let L=f.split("||");return c.create(L.map(V=>this._deserializeAndExpression(V,A)),null,!0)}static _deserializeAndExpression(f,A){let L=f.split("&&");return s.create(L.map(V=>this._deserializeOne(V,A)),null)}static _deserializeOne(f,A){if(f=f.trim(),f.indexOf("!=")>=0){let L=f.split("!=");return I.create(L[0].trim(),this._deserializeValue(L[1],A))}if(f.indexOf("==")>=0){let L=f.split("==");return l.create(L[0].trim(),this._deserializeValue(L[1],A))}if(f.indexOf("=~")>=0){let L=f.split("=~");return v.create(L[0].trim(),this._deserializeRegexValue(L[1],A))}if(f.indexOf(" in ")>=0){let L=f.split(" in ");return a.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(f)){const L=f.split(">=");return m.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(f)){const L=f.split(">");return o.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(f)){const L=f.split("<=");return i.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(f)){const L=f.split("<");return y.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(f)?S.create(f.substr(1).trim()):u.create(f)}static _deserializeValue(f,A){if(f=f.trim(),f==="true")return!0;if(f==="false")return!1;let L=/^'([^']*)'$/.exec(f);return L?L[1].trim():f}static _deserializeRegexValue(f,A){if((0,M.isFalsyOrWhitespace)(f)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=f.indexOf("/"),V=f.lastIndexOf("/");if(L===V||L<0){if(A)throw new Error(`bad regexp-value '${f}', missing /-enclosure`);return console.warn(`bad regexp-value '${f}', missing /-enclosure`),null}let G=f.slice(L+1,V),$=f[V+1]==="i"?"i":"";try{return new RegExp(G,$)}catch(K){if(A)throw new Error(`bad regexp-value '${f}', parse error: ${K}`);return console.warn(`bad regexp-value '${f}', parse error: ${K}`),null}}}e.ContextKeyExpr=T;function t(D,f){return D.cmp(f)}class E{constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return n.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class n{constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=n,n.INSTANCE=new n;class u{constructor(f,A){this.key=f,this.negated=A,this.type=2}static create(f,A=null){const L=F.get(f);return typeof L=="boolean"?L?n.INSTANCE:E.INSTANCE:new u(f,A)}cmp(f){return f.type!==this.type?this.type-f.type:g(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=u;class l{constructor(f,A,L){this.key=f,this.value=A,this.negated=L,this.type=4}static create(f,A,L=null){if(typeof A=="boolean")return A?u.create(f,L):S.create(f,L);const V=F.get(f);return typeof V=="boolean"?A===(V?"true":"false")?n.INSTANCE:E.INSTANCE:new l(f,A,L)}cmp(f){return f.type!==this.type?this.type-f.type:k(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(f){return f.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=l;class a{constructor(f,A){this.key=f,this.valueKey=A,this.type=10,this.negated=null}static create(f,A){return new a(f,A)}cmp(f){return f.type!==this.type?this.type-f.type:k(this.key,this.valueKey,f.key,f.valueKey)}equals(f){return f.type===this.type?this.key===f.key&&this.valueKey===f.valueKey:!1}evaluate(f){const A=f.getValue(this.valueKey),L=f.getValue(this.key);return Array.isArray(A)?A.indexOf(L)>=0:typeof L=="string"&&typeof A=="object"&&A!==null?C.call(A,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(f){return f.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this)),this.negated}}e.ContextKeyInExpr=a;class w{constructor(f){this._actual=f,this.type=11}static create(f){return new w(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new w(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class I{constructor(f,A,L){this.key=f,this.value=A,this.negated=L,this.type=5}static create(f,A,L=null){if(typeof A=="boolean")return A?S.create(f,L):u.create(f,L);const V=F.get(f);return typeof V=="boolean"?A===(V?"true":"false")?E.INSTANCE:n.INSTANCE:new I(f,A,L)}cmp(f){return f.type!==this.type?this.type-f.type:k(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(f){return f.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=I;class S{constructor(f,A){this.key=f,this.negated=A,this.type=3}static create(f,A=null){const L=F.get(f);return typeof L=="boolean"?L?E.INSTANCE:n.INSTANCE:new S(f,A)}cmp(f){return f.type!==this.type?this.type-f.type:g(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!f.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(f){return f.mapNot(this.key)}negate(){return this.negated||(this.negated=u.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=S;class o{constructor(f,A,L){this.key=f,this.value=A,this.negated=L,this.type=12}static create(f,A,L=null){return new o(f,A,L)}cmp(f){return f.type!==this.type?this.type-f.type:k(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class m{constructor(f,A,L){this.key=f,this.value=A,this.negated=L,this.type=13}static create(f,A,L=null){return new m(f,A,L)}cmp(f){return f.type!==this.type?this.type-f.type:k(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=m;class y{constructor(f,A,L){this.key=f,this.value=A,this.negated=L,this.type=14}static create(f,A,L=null){return new y(f,A,L)}cmp(f){return f.type!==this.type?this.type-f.type:k(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=y;class i{constructor(f,A,L){this.key=f,this.value=A,this.negated=L,this.type=15}static create(f,A,L=null){return new i(f,A,L)}cmp(f){return f.type!==this.type?this.type-f.type:k(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class v{constructor(f,A){this.key=f,this.regexp=A,this.type=7,this.negated=null}static create(f,A){return new v(f,A)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.key<f.key)return-1;if(this.key>f.key)return 1;const A=this.regexp?this.regexp.source:"",L=f.regexp?f.regexp.source:"";return A<L?-1:A>L?1:0}equals(f){if(f.type===this.type){const A=this.regexp?this.regexp.source:"",L=f.regexp?f.regexp.source:"";return this.key===f.key&&A===L}return!1}evaluate(f){let A=f.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const f=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${f}`}keys(){return[this.key]}map(f){return f.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=v;class r{constructor(f){this._actual=f,this.type=8}static create(f){return new r(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new r(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class s{constructor(f,A){this.expr=f,this.negated=A,this.type=6}static create(f,A){return s._normalizeArr(f,A)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const V=t(this.expr[A],f.expr[A]);if(V!==0)return V}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(f.expr[A]))return!1;return!0}return!1}evaluate(f){for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].evaluate(f))return!1;return!0}static _normalizeArr(f,A){const L=[];let V=!1;for(const G of f)if(!!G){if(G.type===1){V=!0;continue}if(G.type===0)return E.INSTANCE;if(G.type===6){L.push(...G.expr);continue}L.push(G)}if(L.length===0&&V)return n.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(t);for(let G=1;G<L.length;G++)L[G-1].equals(L[G])&&(L.splice(G,1),G--);if(L.length===1)return L[0];for(;L.length>1;){const G=L[L.length-1];if(G.type!==9)break;L.pop();const $=L.pop(),K=L.length===0,W=c.create(G.expr.map(U=>s.create([U,$],null)),null,K);W&&(L.push(W),L.sort(t))}return L.length===1?L[0]:new s(L,A)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(let A of this.expr)f.push(...A.keys());return f}map(f){return new s(this.expr.map(A=>A.map(f)),null)}negate(){if(!this.negated){const f=[];for(let A of this.expr)f.push(A.negate());this.negated=c.create(f,this,!0)}return this.negated}}class c{constructor(f,A){this.expr=f,this.negated=A,this.type=9}static create(f,A,L){return c._normalizeArr(f,A,L)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const V=t(this.expr[A],f.expr[A]);if(V!==0)return V}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(f.expr[A]))return!1;return!0}return!1}evaluate(f){for(let A=0,L=this.expr.length;A<L;A++)if(this.expr[A].evaluate(f))return!0;return!1}static _normalizeArr(f,A,L){let V=[],G=!1;if(f){for(let $=0,K=f.length;$<K;$++){const W=f[$];if(!!W){if(W.type===0){G=!0;continue}if(W.type===1)return n.INSTANCE;if(W.type===9){V=V.concat(W.expr);continue}V.push(W)}}if(V.length===0&&G)return E.INSTANCE;V.sort(t)}if(V.length!==0){if(V.length===1)return V[0];for(let $=1;$<V.length;$++)V[$-1].equals(V[$])&&(V.splice($,1),$--);if(V.length===1)return V[0];if(L){for(let $=0;$<V.length;$++)for(let K=$+1;K<V.length;K++)P(V[$],V[K])&&(V.splice(K,1),K--);if(V.length===1)return V[0]}return new c(V,A)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(let A of this.expr)f.push(...A.keys());return f}map(f){return new c(this.expr.map(A=>A.map(f)),null)}negate(){if(!this.negated){let f=[];for(let A of this.expr)f.push(A.negate());for(;f.length>1;){const A=f.shift(),L=f.shift(),V=[];for(const $ of p(A))for(const K of p(L))V.push(s.create([$,K],null));const G=f.length===0;f.unshift(c.create(V,null,G))}this.negated=f[0]}return this.negated}}class h extends u{constructor(f,A,L){super(f,null);this._defaultValue=A,typeof L=="object"?h._info.push({...L,key:f}):L!==!0&&h._info.push({key:f,description:L,type:A!=null?typeof A:void 0})}static all(){return h._info.values()}bindTo(f){return f.createKey(this.key,this._defaultValue)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return l.create(this.key,f)}notEqualsTo(f){return I.create(this.key,f)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(D,f){return D<f?-1:D>f?1:0}function k(D,f,A,L){return D<A?-1:D>A?1:f<L?-1:f>L?1:0}function P(D,f){if(f.type===6&&D.type!==9&&D.type!==6){for(const V of f.expr)if(D.equals(V))return!0}const A=D.negate(),L=p(A).concat(p(f));L.sort(t);for(let V=0;V<L.length;V++){const $=L[V].negate();for(let K=V+1;K<L.length;K++){const W=L[K];if($.equals(W))return!0}}return!1}e.implies=P;function p(D){return D.type===9?D.expr:[D]}}),define(we[142],be([0,1,4]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(we[25],be([0,1,9,4]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function b(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=b;function R(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(F=e.ExtensionType||(e.ExtensionType={}));class C{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,n){if(typeof E=="undefined"||E===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof E=="string"||typeof n=="string"){let u=typeof E=="string"?E:E.value,l=typeof n=="string"?n:n.value;return d.equalsIgnoreCase(u,l)}return E._lower===n._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=C;function _(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function T(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=T,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[143],be([0,1,9,25]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function b(l,a){return l.uuid&&a.uuid?l.uuid===a.uuid:l.id===a.id?!0:(0,d.compareIgnoreCase)(l.id,a.id)===0}e.areSameExtensions=b;class R{constructor(a,w){this.version=w,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof R?b(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=R;function F(l,a){return`${l}.${a}`}e.getExtensionId=F;function C(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function _(l,a){return C(F(l,a))}e.getGalleryExtensionId=_;function T(l,a){const w=[],I=S=>{for(const o of w)if(o.some(m=>b(a(m),a(S))))return o;return null};for(const S of l){const o=I(S);o?o.push(S):w.push([S])}return w}e.groupByExtension=T;function t(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function E(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(l){const a=new Set;for(const w of l)w.malicious&&a.add(w.id.id);return a}e.getMaliciousExtensionsSet=n;function u(l,a){const w=[],I=a.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const S=I.shift();if(S&&w.every(o=>!b(o.identifier,{id:S}))){const o=l.filter(m=>b(m.identifier,{id:S}));o.length===1&&(w.push(o[0]),I.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=u}),define(we[60],be([0,1,20,17,9,10,2,121,4]),function(ne,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function T($){return $.create===!0}e.isFileOpenForWriteOptions=T;var t;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var E;(function($){$[$.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var n;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u($){return!!($.capabilities&2)}e.hasReadWriteCapability=u;function l($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=l;function a($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function w($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=w;var I;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(K,W){super(K);this.code=W}}e.FileSystemProviderError=S;function o($,K){const W=new S($.toString(),K);return y(W,K),W}e.createFileSystemProviderError=o;function m($){return $||o((0,C.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=m;function y($,K){return $.name=K?`${K} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=y;function i($){if(!$)return I.Unknown;if($ instanceof S)return $.code;const K=/^(.+) \(FileSystemError\)$/.exec($.name);if(!K)return I.Unknown;switch(K[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=i;function v($){if($ instanceof k)return $.fileOperationResult;switch(i($)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=v;var r;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(K,W,U){this.resource=K,this.operation=W,this.target=U}isOperation(K){return this.operation===K}}e.FileOperationEvent=s;var c;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class h{constructor(K,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const U of K)switch(U.type){case 1:this.added||(this.added=d.TernarySearchTree.forUris(()=>W)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=d.TernarySearchTree.forUris(()=>W)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=d.TernarySearchTree.forUris(()=>W)),this.deleted.set(U.resource,U);break}}contains(K,...W){return this.doContains(K,{includeChildren:!1},...W)}affects(K,...W){return this.doContains(K,{includeChildren:!0},...W)}doContains(K,W,...U){if(!K)return!1;const z=U.length>0;return!!((!z||U.includes(1))&&(this.added?.get(K)||W.includeChildren&&this.added?.findSuperstr(K))||(!z||U.includes(0))&&(this.updated?.get(K)||W.includeChildren&&this.updated?.findSuperstr(K))||(!z||U.includes(2))&&(this.deleted?.findSubstr(K)||W.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function g($,K,W){return!$||!K||$===K||K.length>$.length?!1:(K.charAt(K.length-1)!==M.sep&&(K+=M.sep),W?(0,b.startsWithIgnoreCase)($,K):$.indexOf(K)===0)}e.isParent=g;class k extends Error{constructor(K,W,U){super(K);this.fileOperationResult=W,this.options=U}}e.FileOperationError=k;class P extends k{constructor(K,W,U){super(K,2,U);this.stat=W}}e.NotModifiedSinceFileOperationError=P;var p;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(p=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var D;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(D=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function f($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=f;async function A($,K){if(!K.canHandleResource(F.URI.from({scheme:$.scheme})))return new Promise(W=>{const U=K.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===$.scheme&&z.added&&(U.dispose(),W())})})}e.whenProviderRegistered=A,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(K){return(0,R.isNumber)(K)||(K=0),K<L.KB?(0,C.localize)(1,null,K.toFixed(0)):K<L.MB?(0,C.localize)(2,null,(K/L.KB).toFixed(2)):K<L.GB?(0,C.localize)(3,null,(K/L.MB).toFixed(2)):K<L.TB?(0,C.localize)(4,null,(K/L.GB).toFixed(2)):(0,C.localize)(5,null,(K/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var V;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function G($){return{maxFileSize:$===0?300*L.MB:16*L.GB,maxHeapSize:$===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=G}),define(we[61],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(...b){this._entries=new Map;for(let[R,F]of b)this.set(R,F)}set(b,R){const F=this._entries.get(b);return this._entries.set(b,R),F}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=d}),define(we[144],be([0,1,14,16,81,139,4,61]),function(ne,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class T extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class t{constructor(l=new C.ServiceCollection,a=!1,w){this._activeInstantiations=new Set,this._services=l,this._strict=a,this._parent=w,this._services.set(F.IInstantiationService,this)}createChild(l){return new t(l,this._strict,this)}invokeFunction(l,...a){let w=n.traceInvocation(l),I=!1;try{return l({get:(o,m)=>{if(I)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const y=this._getOrCreateServiceInstance(o,w);if(!y&&m!==F.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return y}},...a)}finally{I=!0,w.stop()}}createInstance(l,...a){let w,I;return l instanceof b.SyncDescriptor?(w=n.traceCreation(l.ctor),I=this._createInstance(l.ctor,l.staticArguments.concat(a),w)):(w=n.traceCreation(l),I=this._createInstance(l,a,w)),w.stop(),I}_createInstance(l,a=[],w){let I=F._util.getServiceDependencies(l).sort((m,y)=>m.index-y.index),S=[];for(const m of I){let y=this._getOrCreateServiceInstance(m.id,w);if(!y&&this._strict&&!m.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${m.id}.`);S.push(y)}let o=I.length>0?I[0].index:a.length;if(a.length!==o){console.warn(`[createInstance] First service dependency of ${l.name} at position ${o+1} conflicts with ${a.length} static arguments`);let m=o-a.length;m>0?a=a.concat(new Array(m)):a=a.slice(0,o)}return new l(...[...a,...S])}_setServiceInstance(l,a){if(this._services.get(l)instanceof b.SyncDescriptor)this._services.set(l,a);else if(this._parent)this._parent._setServiceInstance(l,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let a=this._services.get(l);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):a}_getOrCreateServiceInstance(l,a){let w=this._getServiceInstanceOrDescriptor(l);return w instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,w,a.branch(l,!0)):(a.branch(l,!1),w)}_safeCreateAndCacheServiceInstance(l,a,w){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,a,w)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,a,w){const I=new R.Graph(m=>m.id.toString());let S=0;const o=[{id:l,desc:a,_trace:w}];for(;o.length;){const m=o.pop();if(I.lookupOrInsertNode(m),S++>1e3)throw new T(I);for(let y of F._util.getServiceDependencies(m.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(y.id);if(!i&&!y.optional&&console.warn(`[createInstance] ${l} depends on ${y.id} which is NOT registered.`),i instanceof b.SyncDescriptor){const v={id:y.id,desc:i,_trace:m._trace.branch(y.id,!0)};I.insertEdge(m,v),o.push(v)}}}for(;;){const m=I.roots();if(m.length===0){if(!I.isEmpty())throw new T(I);break}for(const{data:y}of m){if(this._getServiceInstanceOrDescriptor(y.id)instanceof b.SyncDescriptor){const v=this._createServiceInstanceWithOwner(y.id,y.desc.ctor,y.desc.staticArguments,y.desc.supportsDelayedInstantiation,y._trace);this._setServiceInstance(y.id,v)}I.removeNode(y)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,a,w=[],I,S){if(this._services.get(l)instanceof b.SyncDescriptor)return this._createServiceInstance(a,w,I,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,a,w,I,S);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(l,a=[],w,I){if(w){const S=new d.IdleValue(()=>this._createInstance(l,a,I));return new Proxy(Object.create(null),{get(o,m){if(m in o)return o[m];let y=S.value,i=y[m];return typeof i!="function"||(i=i.bind(y),o[m]=i),i},set(o,m,y){return S.value[m]=y,!0}})}else return this._createInstance(l,a,I)}}e.InstantiationService=t;var E;(function(u){u[u.Creation=0]="Creation",u[u.Invocation=1]="Invocation",u[u.Branch=2]="Branch"})(E||(E={}));class n{constructor(l,a){this.type=l,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return _?new n(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(l){return _?new n(0,l.name):n._None}branch(l,a){let w=new n(2,l.toString());return this._dep.push([l,a,w]),w}stop(){let l=Date.now()-this._start;n._totals+=l;let a=!1;function w(S,o){let m=[],y=new Array(S+1).join("	");for(const[i,v,r]of o._dep)if(v&&r){a=!0,m.push(`${y}CREATES -> ${i}`);let s=w(S+1,r);s&&m.push(s)}else m.push(`${y}uses -> ${i}`);return m.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(l>2||a)&&console.log(I.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(we[15],be([0,1,56,3,6,26,4]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function C(){return new Date().toISOString()}var _;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class T extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class t extends T{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...v){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([i,...v]))}debug(i,...v){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([i,...v]))}info(i,...v){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([i,...v]))}warn(i,...v){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([i,...v]))}error(i,...v){if(this.checkLogLevel(_.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(_.Error,this.format(r))}else this.log(_.Error,this.format([i,...v]))}critical(i,...v){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([i,...v]))}flush(){}format(i){let v="";for(let r=0;r<i.length;r++){let s=i[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(c){}v+=(r>0?" ":"")+s}return v}}e.AbstractMessageLogger=t;class E extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!R.isWindows}trace(i,...v){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...v):console.log(`[main ${C()}]`,i,...v))}debug(i,...v){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...v):console.log(`[main ${C()}]`,i,...v))}info(i,...v){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...v):console.log(`[main ${C()}]`,i,...v))}warn(i,...v){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,i,...v):console.warn(`[main ${C()}]`,i,...v))}error(i,...v){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,i,...v):console.error(`[main ${C()}]`,i,...v))}critical(i,...v){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,i,...v):console.error(`[main ${C()}]`,i,...v))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class n extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...v){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",i,...v)}debug(i,...v){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...v)}info(i,...v){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",i,...v)}warn(i,...v){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",i,...v)}error(i,...v){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",i,...v)}critical(i,...v){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...v)}dispose(){}flush(){}}e.ConsoleLogger=n;class u extends T{constructor(i,v=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(v)}trace(i,...v){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(i),...v])}debug(i,...v){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(i),...v])}info(i,...v){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(i),...v])}warn(i,...v){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(i),...v])}error(i,...v){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(i),...v])}critical(i,...v){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(i),...v])}extractMessage(i){return typeof i=="string"?i:(0,d.toErrorMessage)(i,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class l extends T{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const v of this.logServices)v.setLevel(i);super.setLevel(i)}trace(i,...v){for(const r of this.logServices)r.trace(i,...v)}debug(i,...v){for(const r of this.logServices)r.debug(i,...v)}info(i,...v){for(const r of this.logServices)r.info(i,...v)}warn(i,...v){for(const r of this.logServices)r.warn(i,...v)}error(i,...v){for(const r of this.logServices)r.error(i,...v)}critical(i,...v){for(const r of this.logServices)r.critical(i,...v)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=l;class a extends b.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...v){this.logger.trace(i,...v)}debug(i,...v){this.logger.debug(i,...v)}info(i,...v){this.logger.info(i,...v)}warn(i,...v){this.logger.warn(i,...v)}error(i,...v){this.logger.error(i,...v)}critical(i,...v){this.logger.critical(i,...v)}flush(){this.logger.flush()}}e.LogService=a;class w extends b.Disposable{constructor(i,v){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(v(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,v){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,v?.always?_.Trace:this.logLevel,v),this.loggers.set(i.toString(),r),v?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class I{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return _.Info}trace(i,...v){}debug(i,...v){}info(i,...v){}warn(i,...v){}error(i,...v){}critical(i,...v){}dispose(){}flush(){}}e.NullLogService=I;function S(y){if(y.verbose)return _.Trace;if(typeof y.logLevel=="string"){const i=o(y.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function o(y){switch(y){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=o;function m(y){switch(y){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=m}),define(we[82],be([0,1,35,122,4]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var F;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function T(l,a){return a-l}_.compare=T;const t=Object.create(null);t[_.Error]=(0,M.localize)(0,null),t[_.Warning]=(0,M.localize)(1,null),t[_.Info]=(0,M.localize)(2,null);function E(l){return t[l]||""}_.toString=E;function n(l){switch(l){case d.default.Error:return _.Error;case d.default.Warning:return _.Warning;case d.default.Info:return _.Info;case d.default.Ignore:return _.Hint}}_.fromSeverity=n;function u(l){switch(l){case _.Error:return d.default.Error;case _.Warning:return d.default.Warning;case _.Info:return d.default.Info;case _.Hint:return d.default.Ignore}}_.toSeverity=u}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(_){const T="";function t(n){return E(n,!0)}_.makeKey=t;function E(n,u){let l=[T];return n.source?l.push(n.source.replace("\xA6","\\\xA6")):l.push(T),n.code?typeof n.code=="string"?l.push(n.code.replace("\xA6","\\\xA6")):l.push(n.code.value.replace("\xA6","\\\xA6")):l.push(T),n.severity!==void 0&&n.severity!==null?l.push(F.toString(n.severity)):l.push(T),n.message&&u?l.push(n.message.replace("\xA6","\\\xA6")):l.push(T),n.startLineNumber!==void 0&&n.startLineNumber!==null?l.push(n.startLineNumber.toString()):l.push(T),n.startColumn!==void 0&&n.startColumn!==null?l.push(n.startColumn.toString()):l.push(T),n.endLineNumber!==void 0&&n.endLineNumber!==null?l.push(n.endLineNumber.toString()):l.push(T),n.endColumn!==void 0&&n.endColumn!==null?l.push(n.endColumn.toString()):l.push(T),l.push(T),l.join("\xA6")}_.makeKeyOptionalMessage=E})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(we[145],be([0,1,3,35,4]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,b.createDecorator)("notificationService");var R;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new _,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=C;class _{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=_}),define(we[146],be([0,1,6,9,2,4]),function(ne,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,R.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function F(C,_){return b.URI.isUri(C)?(0,M.equalsIgnoreCase)(C.scheme,_):(0,M.startsWithIgnoreCase)(C,_+":")}e.matchesScheme=F});var Ue=this&&this.__decorate||function(ne,e,d,M){var b=arguments.length,R=b<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,d):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ne,e,d,M);else for(var C=ne.length-1;C>=0;C--)(F=ne[C])&&(R=(b<3?F(R):b>3?F(e,d,R):F(e,d))||R);return b>3&&R&&Object.defineProperty(e,d,R),R},He=this&&this.__param||function(ne,e){return function(d,M){e(d,M,ne)}};define(we[147],be([0,1,14,21,6,4]),function(ne,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(E){this.callback=E}get value(){return this._value}report(E){this._value=E,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let _=class extends b.Disposable{constructor(E,n){super();this.deferred=new d.DeferredPromise,n.withProgress(E,u=>(this.reporter=u,this.lastStep&&u.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(E){this.reporter?this.reporter.report(E):this.lastStep=E}};_=Ue([He(1,e.IProgressService)],_),e.UnmanagedProgress=_;class T extends b.Disposable{constructor(E){super();this.progressIndicator=E,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(E){this.stop();const n=++this.currentOperationId,u=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},E),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>u.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:u.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(E){this.currentOperationId===E&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(we[28],be([0,1,42,10]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(F,C){d.ok(M.isString(F)),d.ok(M.isObject(C)),d.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,C)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new b}),define(we[83],be([0,1,3,28]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class R{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,T){this.schemasById[b(_)]=T,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new R;M.Registry.add(e.Extensions.JSONContribution,F)}),define(we[62],be([0,1,3,10,119,83,28]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var _;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(_=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const T=F.Registry.as(R.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new d.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new d.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(S,o=!0){this.registerConfigurations([S],o)}registerConfigurations(S,o=!0){const m=[];S.forEach(y=>{m.push(...this.validateAndRegisterProperties(y,o,y.extensionInfo)),this.configurationContributors.push(y),this.registerJSONConfiguration(y)}),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(S){const o=[],m=y=>{if(y.properties)for(const i in y.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,y.properties[i]);y.allOf&&y.allOf.forEach(i=>m(i))};for(const y of S){m(y);const i=this.configurationContributors.indexOf(y);i!==-1&&this.configurationContributors.splice(i,1)}T.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(S){const o=[],m=[];for(const y of S)for(const i in y)if(o.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...y[i]};const v={type:"object",default:this.defaultValues[i],description:b.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};m.push(n(i)),this.configurationProperties[i]=v,this.defaultLanguageConfigurationOverridesNode.properties[i]=v}else{this.defaultValues[i]=y[i];const v=this.configurationProperties[i];v&&(this.updatePropertyDefaultValue(i,v),this.updateSchema(i,v))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(S){const o=[];for(const m of S)for(const y in m)if(o.push(y),delete this.defaultValues[y],e.OVERRIDE_PROPERTY_PATTERN.test(y))delete this.configurationProperties[y],delete this.defaultLanguageConfigurationOverridesNode.properties[y];else{const i=this.configurationProperties[y];i&&(this.updatePropertyDefaultValue(y,i),this.updateSchema(y,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...S){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(S){for(const o of S)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(S,o=!0,m,y=3){y=M.isUndefinedOrNull(S.scope)?y:S.scope;let i=[],v=S.properties;if(v)for(let s in v){if(o&&a(s)){delete v[s];continue}const c=v[s];if(this.updatePropertyDefaultValue(s,c),e.OVERRIDE_PROPERTY_PATTERN.test(s)?c.scope=void 0:(c.scope=M.isUndefinedOrNull(c.scope)?y:c.scope,c.restricted=M.isUndefinedOrNull(c.restricted)?!!m?.restrictedConfigurations?.includes(s):c.restricted),v[s].hasOwnProperty("included")&&!v[s].included){this.excludedConfigurationProperties[s]=v[s],delete v[s];continue}else this.configurationProperties[s]=v[s];!v[s].deprecationMessage&&v[s].markdownDeprecationMessage&&(v[s].deprecationMessage=v[s].markdownDeprecationMessage),i.push(s)}let r=S.allOf;if(r)for(let s of r)i.push(...this.validateAndRegisterProperties(s,o,m,y));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(S){const o=m=>{let y=m.properties;if(y)for(const v in y)this.updateSchema(v,y[v]);let i=m.allOf;i&&i.forEach(o)};o(S)}updateSchema(S,o){switch(e.allSettings.properties[S]=o,o.scope){case 1:e.applicationSettings.properties[S]=o;break;case 2:e.machineSettings.properties[S]=o;break;case 6:e.machineOverridableSettings.properties[S]=o;break;case 3:e.windowSettings.properties[S]=o;break;case 4:e.resourceSettings.properties[S]=o;break;case 5:e.resourceSettings.properties[S]=o,this.resourceLanguageSettingsSchema.properties[S]=o;break}}removeFromSchema(S,o){switch(delete e.allSettings.properties[S],o.scope){case 1:delete e.applicationSettings.properties[S];break;case 2:delete e.machineSettings.properties[S];break;case 6:delete e.machineOverridableSettings.properties[S];break;case 3:delete e.windowSettings.properties[S];break;case 4:case 5:delete e.resourceSettings.properties[S];break}}updateOverridePropertyPatternKey(){for(const S of this.overrideIdentifiers.values()){const o=`[${S}]`,m={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,m),e.allSettings.properties[o]=m,e.applicationSettings.properties[o]=m,e.machineSettings.properties[o]=m,e.machineOverridableSettings.properties[o]=m,e.windowSettings.properties[o]=m,e.resourceSettings.properties[o]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(S,o){let m=this.defaultValues[S];M.isUndefined(m)&&(m=o.default),M.isUndefined(m)&&(m=u(o.type)),o.default=m}}const E="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(E);function n(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=n;function u(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const l=new t;F.Registry.add(e.Extensions.Configuration,l);function a(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?b.localize(5,null,I):l.getConfigurationProperties()[I]!==void 0?b.localize(6,null,I):null:b.localize(4,null)}e.validateProperty=a;function w(){const I=[],S=l.getConfigurationProperties();for(const o of Object.keys(S))I.push([o,S[o].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=w}),define(we[84],be([0,1,23,10,2,62,4,28]),function(ne,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function _(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof b.URI)}e.isConfigurationOverrides=_;var T;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function E(v,r){const s=r?v?r.keys.filter(D=>v.keys.indexOf(D)===-1):[...r.keys]:[],c=v?r?v.keys.filter(D=>r.keys.indexOf(D)===-1):[...v.keys]:[],h=[];if(r&&v){for(const D of v.keys)if(r.keys.indexOf(D)!==-1){const f=I(v.contents,D),A=I(r.contents,D);d.equals(f,A)||h.push(D)}}const g=[],k=D=>{const f={};for(const A of D)for(const L of A.identifiers)f[y(L)]=A;return f},P=r?k(r.overrides):{},p=v?k(v.overrides):{};if(Object.keys(P).length)for(const D of s){const f=P[D];f&&g.push([(0,R.overrideIdentifierFromKey)(D),f.keys])}if(Object.keys(p).length)for(const D of c){const f=p[D];f&&g.push([(0,R.overrideIdentifierFromKey)(D),f.keys])}if(Object.keys(P).length&&Object.keys(p).length)for(const D of h){const f=p[D],A=P[D];if(f&&A){const L=E({contents:f.contents,keys:f.keys,overrides:[]},{contents:A.contents,keys:A.keys,overrides:[]});g.push([(0,R.overrideIdentifierFromKey)(D),[...L.added,...L.removed,...L.updated]])}}return{added:s,removed:c,updated:h,overrides:g}}e.compare=E;function n(v,r){const s=[];for(const c of Object.keys(v))if(R.OVERRIDE_PROPERTY_PATTERN.test(c)){const h={};for(const g in v[c])h[g]=v[c][g];s.push({identifiers:[(0,R.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(h),contents:u(h,r)})}return s}e.toOverrides=n;function u(v,r){const s=Object.create(null);for(let c in v)l(s,c,v[c],r);return s}e.toValuesTree=u;function l(v,r,s,c){const h=r.split("."),g=h.pop();let k=v;for(let P=0;P<h.length;P++){let p=h[P],D=k[p];switch(typeof D){case"undefined":D=k[p]=Object.create(null);break;case"object":break;default:c(`Ignoring ${r} as ${h.slice(0,P+1).join(".")} is ${JSON.stringify(D)}`);return}k=D}if(typeof k=="object"&&k!==null)try{k[g]=s}catch(P){c(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(k)}`)}else c(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=l;function a(v,r){const s=r.split(".");w(v,s)}e.removeFromValueTree=a;function w(v,r){const s=r.shift();if(r.length===0){delete v[s];return}if(Object.keys(v).indexOf(s)!==-1){const c=v[s];typeof c=="object"&&!Array.isArray(c)&&(w(c,r),Object.keys(c).length===0&&delete v[s])}}function I(v,r,s){function c(k,P){let p=k;for(const D of P){if(typeof p!="object"||p===null)return;p=p[D]}return p}const h=r.split("."),g=c(v,h);return typeof g=="undefined"?s:g}e.getConfigurationValue=I;function S(v,r,s){Object.keys(r).forEach(c=>{c!=="__proto__"&&(c in v?M.isObject(v[c])&&M.isObject(r[c])?S(v[c],r[c],s):s&&(v[c]=r[c]):v[c]=r[c])})}e.merge=S;function o(){const v=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(v)}e.getConfigurationKeys=o;function m(){const v=Object.create(null),r=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let s in r){let c=r[s].default;l(v,s,c,h=>console.error(`Conflict in default settings: ${h}`))}return v}e.getDefaultValues=m;function y(v){return`[${v}]`}e.keyFromOverrideIdentifier=y;function i(v,r,s){const c=v.inspect(r),h=v.inspect(s);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:c.defaultValue}e.getMigratedSettingValue=i}),define(we[148],be([0,1,13,3,102,6,20,23,10,2,84,62,28]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class u{constructor(i={},v=[],r=[]){this._contents=i,this._keys=v,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,v){const r=this.getContentsForOverrideIdentifer(v);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const v of this.overrides)if(v.identifiers.indexOf(i)!==-1)return v.keys;return[]}override(i){const v=this.getContentsForOverrideIdentifer(i);if(!v||typeof v!="object"||!Object.keys(v).length)return this;let r={};for(const s of d.distinct([...Object.keys(this.contents),...Object.keys(v)])){let c=this.contents[s],h=v[s];h&&(typeof c=="object"&&typeof h=="object"?(c=C.deepClone(c),this.mergeContents(c,h)):c=h),r[s]=c}return new u(r,this.keys,this.overrides)}merge(...i){const v=C.deepClone(this.contents),r=C.deepClone(this.overrides),s=[...this.keys];for(const c of i){this.mergeContents(v,c.contents);for(const h of c.overrides){const[g]=r.filter(k=>d.equals(k.identifiers,h.identifiers));g?this.mergeContents(g.contents,h.contents):r.push(C.deepClone(h))}for(const h of c.keys)s.indexOf(h)===-1&&s.push(h)}return new u(v,s,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,v){for(const r of Object.keys(v)){if(r in i&&_.isObject(i[r])&&_.isObject(v[r])){this.mergeContents(i[r],v[r]);continue}i[r]=C.deepClone(v[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?C.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const v of this.overrides)if(v.identifiers.indexOf(i)!==-1)return v.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,v){this.addKey(i),(0,t.addToValueTree)(this.contents,i,v,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let v=this.keys.length;for(let r=0;r<v;r++)i.indexOf(this.keys[r])===0&&(v=r);this.keys.splice(v,1,i)}removeKey(i){let v=this.keys.indexOf(i);return v!==-1?(this.keys.splice(v,1),!0):!1}}e.ConfigurationModel=u;class l extends u{constructor(){const i=(0,t.getDefaultValues)(),v=(0,t.getConfigurationKeys)(),r=[];for(const s of Object.keys(i))E.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,E.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(i[s]),contents:(0,t.toValuesTree)(i[s],c=>console.error(`Conflict in default settings file: ${c}`))});super(i,v,r)}}e.DefaultConfigurationModel=l;class a{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new u}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,v){if(!_.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,v)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,v){this._raw=i;const{contents:r,keys:s,overrides:c,restricted:h}=this.doParseRaw(i,v);this._configurationModel=new u(r,s,c),this._restrictedConfigurations=h||[]}doParseContent(i){let v={},r=null,s=[],c=[],h=[];function g(P){Array.isArray(s)?s.push(P):r!==null&&(s[r]=P)}let k={onObjectBegin:()=>{let P={};g(P),c.push(s),s=P,r=null},onObjectProperty:P=>{r=P},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{let P=[];g(P),c.push(s),s=P,r=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:g,onError:(P,p,D)=>{h.push({error:P,offset:p,length:D})}};if(i)try{b.visit(i,k),v=s[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return v}doParseRaw(i,v){const r=n.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,r,!0,v);i=s.raw;const c=(0,t.toValuesTree)(i,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),h=Object.keys(i),g=(0,t.toOverrides)(i,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:c,keys:h,overrides:g,restricted:s.restricted}}filter(i,v,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const c={},h=[];for(let g in i)if(E.OVERRIDE_PROPERTY_PATTERN.test(g)&&r){const k=this.filter(i[g],v,!1,s);c[g]=k.raw,h.push(...k.restricted)}else{const k=v[g],P=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&h.push(g),(P===void 0||s.scopes===void 0||s.scopes.includes(P))&&(s.skipRestricted&&k?.restricted||(c[g]=i[g]))}return{raw:c,restricted:h}}}e.ConfigurationModelParser=a;class w extends R.Disposable{constructor(i,v,r,s){super();this.userSettingsResource=i,this.scopes=v,this.fileService=s,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new u}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class I{constructor(i,v,r=new u,s=new u,c=new F.ResourceMap,h=new u,g=new F.ResourceMap,k=!0){this._defaultConfiguration=i,this._localUserConfiguration=v,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=g,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(i,v,r){return this.getConsolidateConfigurationModel(v,r).getValue(i)}updateValue(i,v,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new u,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,v===void 0?s.removeValue(i):s.setValue(i,v),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,v,r){const s=this.getConsolidateConfigurationModel(v,r),c=this.getFolderConfigurationModelForResource(v.resource,r),h=v.resource?this._memoryConfigurationByResource.get(v.resource)||this._memoryConfiguration:this._memoryConfiguration,g=v.overrideIdentifier?this._defaultConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),k=v.overrideIdentifier?this.userConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),P=v.overrideIdentifier?this.localUserConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),p=v.overrideIdentifier?this.remoteUserConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),D=r?v.overrideIdentifier?this._workspaceConfiguration.freeze().override(v.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,f=c?v.overrideIdentifier?c.freeze().override(v.overrideIdentifier).getValue(i):c.freeze().getValue(i):void 0,A=v.overrideIdentifier?h.override(v.overrideIdentifier).getValue(i):h.getValue(i),L=s.getValue(i),V=d.distinct(d.flatten(s.overrides.map(G=>G.identifiers))).filter(G=>s.getOverrideValue(i,G)!==void 0);return{defaultValue:g,userValue:k,userLocalValue:P,userRemoteValue:p,workspaceValue:D,workspaceFolderValue:f,memoryValue:A,value:L,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,userRemote:p!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,workspace:D!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:v.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,workspaceFolder:f!==void 0?{value:c?.freeze().getValue(i),override:v.overrideIdentifier?c?.freeze().getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,memory:A!==void 0?{value:h.getValue(i),override:v.overrideIdentifier?h.getOverrideValue(i,v.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(i){const v=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:v?v.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,v){this._folderConfigurations.set(i,v),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,v){const r=v.filter(s=>E.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const c=(0,E.overrideIdentifierFromKey)(s),h=this._defaultConfiguration.getKeysForOverrideIdentifier(c),g=i.getKeysForOverrideIdentifier(c),k=[...g.filter(P=>h.indexOf(P)===-1),...h.filter(P=>g.indexOf(P)===-1),...h.filter(P=>!C.equals(this._defaultConfiguration.override(c).getValue(P),i.override(c).getValue(P)))];return[c,k]});return this.updateDefaultConfiguration(i),{keys:v,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:v,updated:r,removed:s,overrides:c}=(0,t.compare)(this.localUserConfiguration,i),h=[...v,...r,...s];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:v,updated:r,removed:s,overrides:c}=(0,t.compare)(this.remoteUserConfiguration,i);let h=[...v,...r,...s];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:v,updated:r,removed:s,overrides:c}=(0,t.compare)(this.workspaceConfiguration,i);let h=[...v,...r,...s];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:c}}compareAndUpdateFolderConfiguration(i,v){const r=this.folderConfigurations.get(i),{added:s,updated:c,removed:h,overrides:g}=(0,t.compare)(r,v);let k=[...s,...c,...h];return(k.length||!r)&&this.updateFolderConfiguration(i,v),{keys:k,overrides:g}}compareAndDeleteFolderConfiguration(i){const v=this.folderConfigurations.get(i);if(!v)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:c,overrides:h}=(0,t.compare)(v,void 0);return{keys:[...r,...s,...c],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,v){let r=this.getConsolidatedConfigurationModelForResource(i,v);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},v){let r=this.getWorkspaceConsolidatedConfiguration();if(v&&i){const s=v.getFolder(i);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const c=this._memoryConfigurationByResource.get(i);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let v=this._foldersConsolidatedConfigurations.get(i);if(!v){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(v=r.merge(s),this._freeze&&(v=v.freeze()),this._foldersConsolidatedConfigurations.set(i,v)):v=r}return v}getFolderConfigurationModelForResource(i,v){if(v&&i){const r=v.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,v)=>{const{contents:r,overrides:s,keys:c}=this._folderConfigurations.get(v);return i.push([v,{contents:r,overrides:s,keys:c}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(v=>i.add(v)),this.userConfiguration.freeze().keys.forEach(v=>i.add(v)),this._workspaceConfiguration.freeze().keys.forEach(v=>i.add(v)),this._folderConfigurations.forEach(v=>v.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const v=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>v.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>v.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>v.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>v.add(s))),[...v.values()]}static parse(i){const v=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((h,g)=>(h.set(T.URI.revive(g[0]),this.parseConfigurationModel(g[1])),h),new F.ResourceMap);return new I(v,r,new u,s,c,new u,new F.ResourceMap,!1)}static parseConfigurationModel(i){return new u(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=I;function S(...y){if(y.length===0)return{keys:[],overrides:[]};if(y.length===1)return y[0];const i=new Set,v=new Map;for(const s of y)s.keys.forEach(c=>i.add(c)),s.overrides.forEach(([c,h])=>{const g=(0,F.getOrSet)(v,c,new Set);h.forEach(k=>g.add(k))});const r=[];return v.forEach((s,c)=>r.push([c,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=S;class o{constructor(i,v,r,s){this.change=i,this.previous=v,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const c=new Set;i.keys.forEach(g=>c.add(g)),i.overrides.forEach(([,g])=>g.forEach(k=>c.add(k))),this.affectedKeys=[...c.values()];const h=new u;this.affectedKeys.forEach(g=>h.setValue(g,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,v){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(v){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,v,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,v,this.currentWorkspace);return!C.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(i,v){let r=(0,t.toValuesTree)({[v]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(i=i[s],!i)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=o;class m extends o{constructor(i,v,r,s){super({keys:i.allKeys(),overrides:[]},void 0,i,v);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=m}),define(we[85],be([0,1,4]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var M;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class b extends Error{constructor(F,C=M.Unknown,_){super(F);this._message=F,this._code=C,this._detail=_,this.isHandled=C===M.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype)}static isTemporarilyNotAvailable(F){return F instanceof b&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof b&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof b&&F.isHandled}}e.RemoteAuthorityResolverError=b}),define(we[86],be([0,1,11]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(T){return T.scheme===d.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=M;function b(T){if(!T)return;const t=T.indexOf("+");return t<0?T:T.substr(0,t)}e.getRemoteName=b;function R(T){return T.scheme!==d.Schemas.file&&T.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=R;function F(T){if(T.folders.length)return T.folders.every(t=>R(t.uri))?T.folders[0].uri:void 0;if(T.configuration&&R(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=F;function C(T){return F(T)?.scheme}e.getVirtualWorkspaceScheme=C;function _(T){return F(T)!==void 0}e.isVirtualWorkspace=_}),define(we[149],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,R,F=5){let C;return C=R(_=>{const T=typeof _=="string"?_:_.data;let t=this._terminalBufferMap.get(b);if(t){t.data.push(T);return}const E=setTimeout(()=>this.flushBuffer(b),F);t={data:[T],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(b),C.dispose()}},this._terminalBufferMap.set(b,t)}),C}stopBuffering(b){const R=this._terminalBufferMap.get(b);R&&R.dispose()}flushBuffer(b){const R=this._terminalBufferMap.get(b);R&&(this._terminalBufferMap.delete(b),this._callback(b,R.data.join("")))}}e.TerminalDataBufferer=d}),define(we[150],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(we[46],be([0,1,34,3,6,4,28,150]),function(ne,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var _;(function(w){function I(S){return S&&typeof S=="object"&&typeof S.id=="string"}w.isThemeColor=I})(_=e.ThemeColor||(e.ThemeColor={}));function T(w){return{id:w}}e.themeColorFromId=T;var t;(function(w){function I(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(typeof v.color=="undefined"||_.isThemeColor(v.color))}w.isThemeIcon=I;const S=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function o(v){const r=S.exec(v);if(!r)return;let[,s]=r;return{id:s}}w.fromString=o;function m(v,r){let s=v.id;const c=s.lastIndexOf("~");return c!==-1&&(s=s.substring(0,c)),r&&(s=`${s}~${r}`),{id:s}}w.modify=m;function y(v,r){return v.id===r.id&&v.color?.id===r.color?.id}w.isEqual=y;function i(v,r){return{id:v.id,color:r?T(r):void 0}}w.asThemeIcon=i,w.asClassNameArray=d.CSSIcon.asClassNameArray,w.asClassName=d.CSSIcon.asClassName,w.asCSSSelector=d.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function E(w){switch(w){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,b.toDisposable)(()=>{const S=this.themingParticipants.indexOf(I);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let u=new n;F.Registry.add(e.Extensions.ThemingContribution,u);function l(w){return u.onColorThemeChange(w)}e.registerThemingParticipant=l;class a extends b.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,S){let o=this.theme.getColor(I);return o&&S&&(o=S(o,this.theme)),o?o.toString():null}}e.Themable=a}),define(we[151],be([0,1,14,34,3,123,83,28,46]),function(ne,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,R.localize)(0,null)},fontCharacter:{type:"string",description:(0,R.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(I,S,o,m){const y=this.iconsById[I];if(y){if(o&&!y.description){y.description=o,this.iconSchema.properties[I].markdownDescription=`${o} $(${I})`;const r=this.iconReferenceSchema.enum.indexOf(I);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=o),this._onDidChange.fire()}return y}let i={id:I,description:o,defaults:S,deprecationMessage:m};this.iconsById[I]=i;let v={$ref:"#/definitions/icons"};return m&&(v.deprecationMessage=m),o&&(v.markdownDescription=`${o}: $(${I})`),this.iconSchema.properties[I]=v,this.iconReferenceSchema.enum.push(I),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:I}}deregisterIcon(I){delete this.iconsById[I],delete this.iconSchema.properties[I];const S=this.iconReferenceSchema.enum.indexOf(I);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(I=>this.iconsById[I])}getIcon(I){return this.iconsById[I]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(I,S){const o=this.iconFontsById[I];if(o)return o;let m={id:I,definition:S};return this.iconFontsById[I]=m,this._onDidChange.fire(),m}deregisterIconFont(I){delete this.iconFontsById[I]}getIconFonts(){return Object.keys(this.iconFontsById).map(I=>this.iconFontsById[I])}getIconFont(I){return this.iconFontsById[I]}toString(){const I=(y,i)=>y.id.localeCompare(i.id),S=y=>{for(;_.ThemeIcon.isThemeIcon(y.defaults);)y=this.iconsById[y.defaults.id];return`codicon codicon-${y?y.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.iconsById).map(y=>this.iconsById[y]);for(const y of m.filter(i=>!!i.description).sort(I))o.push(`|<i class="${S(y)}"></i>|${y.id}|${_.ThemeIcon.isThemeIcon(y.defaults)?y.defaults.id:y.id}|${y.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const y of m.filter(i=>!_.ThemeIcon.isThemeIcon(i.defaults)).sort(I))o.push(`|<i class="${S(y)}"></i>|${y.id}|`);return o.join(`
`)}}const t=new T;C.Registry.add(e.Extensions.IconContribution,t);function E(w,I,S,o){return t.registerIcon(w,I,S,o)}e.registerIcon=E;function n(){return t}e.getIconRegistry=n;function u(){for(const w of M.iconRegistry.all)t.registerIcon(w.id,w.definition,w.description);M.iconRegistry.onDidRegister(w=>t.registerIcon(w.id,w.definition,w.description))}u(),e.iconsSchemaId="vscode://schemas/icons";let l=C.Registry.as(F.Extensions.JSONContribution);l.registerSchema(e.iconsSchemaId,t.getIconSchema());const a=new d.RunOnceScheduler(()=>l.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=E("widget-close",M.Codicon.close,(0,R.localize)(2,null)),e.gotoPreviousLocation=E("goto-previous-location",M.Codicon.arrowUp,(0,R.localize)(3,null)),e.gotoNextLocation=E("goto-next-location",M.Codicon.arrowDown,(0,R.localize)(4,null)),e.syncing=_.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(we[47],be([0,1,20,24,2,4]),function(ne,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");var F;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function C(n){const u=n;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=C;function _(n){const u=n;return!!(u&&typeof u=="object"&&b.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=_;class T{constructor(u,l,a,w){this._id=u,this._configuration=a,this._ignorePathCasing=w,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(u){this._id=u.id,this._configuration=u.configuration,this._ignorePathCasing=u._ignorePathCasing,this.folders=u.folders}get folders(){return this._folders}set folders(u){this._folders=u,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(u){this._configuration=u}getFolder(u){return u&&this._foldersMap.findSubstr(u.with({scheme:u.scheme,authority:u.authority,path:u.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const u of this.folders)this._foldersMap.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=T;class t{constructor(u,l){this.raw=l,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,M.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function E(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=E}),define(we[63],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const R=this._idPool++;return this._data.set(R,b),this.logDebugInfo(),R}get(b,R){return this._data.has(b)?this._data.get(b)[R]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(we[37],be([0,1,11,24,4]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(C=>{const _=this._providerInfo.get(C.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(C,_){_===null?this._providerInfo.delete(C):this._providerInfo.set(C,_)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(we[29],be([0,1,4]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(we[152],be([0,1,14]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,C,_){this._deferredPromises=new Map,this._id=F,this._shared=C,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of T.values())t.complete()}catch(t){for(const E of T.values())E.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,C){let _=this._value[F];return typeof _=="undefined"&&(_=C),_}update(F,C){this._value[F]=C;let _=this._deferredPromises.get(F);if(_!==void 0)return _.p;const T=new d.DeferredPromise;return this._deferredPromises.set(F,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class b extends M{constructor(F,C){super(F.identifier.value,!0,C);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=b}),define(we[153],be([0,1,3,2,15]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let R=class{constructor(C,_){this._logService=C,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,_,T){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptModelChanged(_.value,T)}$acceptDirtyStateChanged(C,_){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptDirty(_)}$acceptModelSaved(C){const _=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(C,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,_);const T=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));T.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};R=Ue([He(0,b.ILogService)],R),e.ExtHostNotebookDocuments=R}),define(we[12],be([0,1,4]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class M{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=M});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,d):b?b.value=d:e.set(ne,d),d},Ae=this&&this.__classPrivateFieldGet||function(ne,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[154],be([0,1,25,3]),function(ne,e,d,M){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(C,_){b.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(C.identifier),Xe(this,b,_,"f"),Ae(this,b,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(C){return Ae(this,b,"f").get(this._id,C)}store(C,_){return Ae(this,b,"f").store(this._id,C,_)}delete(C){return Ae(this,b,"f").delete(this._id,C)}}e.ExtensionSecrets=R,b=new WeakMap}),define(we[87],be([0,1,4,3]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(we[48],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(S){S[S.Upsert=0]="Upsert",S[S.RemoveChild=1]="RemoveChild",S[S.Invalidated=2]="Invalidated",S[S.SetProp=3]="SetProp",S[S.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,b=(S,o)=>{const m={controllerId:o};return M.set(S,m),m};e.createPrivateApiFor=b;const R=S=>M.get(S);e.getPrivateApiFor=R;const F=(S,o,m,y)=>{let i=m;return{enumerable:!0,configurable:!1,get(){return i},set(v){if(!y(i,v)){const r=i;i=v,S.listener?.({op:3,key:o,value:v,previous:r})}}}},C=(S,o)=>S===o,_={range:(S,o)=>S===o?!0:!S||!o?!1:S.isEqual(o),label:C,description:C,busy:C,error:C,canResolveChildren:C,tags:(S,o)=>!(S.length!==o.length||S.some(m=>!o.find(y=>m.id===y.id)))},T=Object.keys(_),t=(S,o)=>({range:F(S,"range",void 0,_.range),label:F(S,"label",o,_.label),description:F(S,"description",void 0,_.description),canResolveChildren:F(S,"canResolveChildren",!1,_.canResolveChildren),busy:F(S,"busy",!1,_.busy),error:F(S,"error",void 0,_.error),tags:F(S,"tags",[],_.tags)}),E=(S,o)=>{const m=new Map;for(const y of T)_[y](S[y],o[y])||m.set(y,o[y]);return m};e.diffTestItems=E;class n extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=n;class u extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=u;class l extends Error{constructor(o,m,y){super(`TestItem with ID "${o}" is from controller "${m}" and cannot be added as a child of an item from controller "${y}".`)}}e.MixedTestItemController=l;const a=S=>{const o=(0,e.getPrivateApiFor)(S);let m=new Map;return{get size(){return m.size},forEach(y,i){for(const v of m.values())y.call(i,v,this)},replace(y){const i=new Map,v=new Set(m.keys()),r={op:4,ops:[]};for(const s of y){if(!(s instanceof w))throw new u(s.id);const c=(0,e.getPrivateApiFor)(s).controllerId;if(c!==o.controllerId)throw new l(s.id,c,o.controllerId);if(i.has(s.id))throw new n(s.id);i.set(s.id,s),v.delete(s.id),r.ops.push({op:0,item:s})}for(const s of v.keys())r.ops.push({op:1,id:s});o.listener?.(r),m=i},add(y){if(!(y instanceof w))throw new u(y.id);m.set(y.id,y),o.listener?.({op:0,item:y})},delete(y){m.delete(y)&&o.listener?.({op:1,id:y})},get(y){return m.get(y)},toJSON(){return Array.from(m.values())},[Symbol.iterator](){return m.values()}}};class w{constructor(o,m,y,i){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const v=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return v.parent instanceof I?void 0:v.parent}},children:{value:a(this),enumerable:!0,writable:!1},...t(v,y)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=w;class I extends w{constructor(o,m){super(o,o,m,void 0)}}e.TestItemRootImpl=I}),define(we[64],be([0,1,4,3,12]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var R;(function(C){function _(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,protocol:t.protocol}}C.fromApiTunnel=_;function T(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.public,protocol:t.protocol}}C.fromServiceTunnel=T})(R=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let F=class{constructor(_){this.onDidChangeTunnels=new M.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,T){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,T){return{dispose:()=>{}}}async $providePortAttributes(_,T,t,E,n){return[]}async $forwardPort(_,T){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};F=Ue([He(0,b.IExtHostRpcService)],F),e.ExtHostTunnelService=F});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,d):b?b.value=d:e.set(ne,d),d},Ae=this&&this.__classPrivateFieldGet||function(ne,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[7],be([0,1,13,16,76,20,78,10,2,36,60,85]),function(ne,e,d,M,b,R,F,C,_,T,t,E){"use strict";var n,u,l,a,w,I,S,o,m,y,i,v,r,s,c,h,g,k,P,p;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let f=w=class{constructor(O){n.set(this,void 0),Xe(this,n,O,"f")}static from(...O){let te=O;return new w(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}dispose(){typeof Ae(this,n,"f")=="function"&&(Ae(this,n,"f").call(this),Xe(this,n,void 0,"f"))}};n=new WeakMap,f=w=Ue([D],f),e.Disposable=f;let A=I=class{constructor(O,te){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(te<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=te}static Min(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let Ee=1;Ee<O.length;Ee++){const Ge=O[Ee];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let Ee=1;Ee<O.length;Ee++){const Ge=O[Ee];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(O){if(!O)return!1;if(O instanceof I)return!0;let{line:te,character:Ee}=O;return typeof te=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,te=0){if(O===null||te===null)throw(0,M.illegalArgument)();let Ee;return typeof O=="undefined"?Ee=0:typeof O=="number"?Ee=O:(Ee=typeof O.lineDelta=="number"?O.lineDelta:0,te=typeof O.characterDelta=="number"?O.characterDelta:0),Ee===0&&te===0?this:new I(this.line+Ee,this.character+te)}with(O,te=this.character){if(O===null||te===null)throw(0,M.illegalArgument)();let Ee;return typeof O=="undefined"?Ee=this.line:typeof O=="number"?Ee=O:(Ee=typeof O.line=="number"?O.line:this.line,te=typeof O.character=="number"?O.character:this.character),Ee===this.line&&te===this.character?this:new I(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};A=I=Ue([D],A),e.Position=A;let L=S=class{constructor(O,te,Ee,Ge){let et,st;if(typeof O=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(et=new A(O,te),st=new A(Ee,Ge)):O instanceof A&&te instanceof A&&(et=O,st=te),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(O){return O instanceof S?!0:O?A.isPosition(O.start)&&A.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof S?this.contains(O._start)&&this.contains(O._end):O instanceof A?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const te=A.Max(O.start,this._start),Ee=A.Min(O.end,this._end);if(!te.isAfter(Ee))return new S(te,Ee)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const te=A.Min(O.start,this._start),Ee=A.Max(O.end,this.end);return new S(te,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,te=this.end){if(O===null||te===null)throw(0,M.illegalArgument)();let Ee;return O?A.isPosition(O)?Ee=O:(Ee=O.start||this.start,te=O.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&te.isEqual(this.end)?this:new S(Ee,te)}toJSON(){return[this.start,this.end]}};L=S=Ue([D],L),e.Range=L;let V=o=class extends L{constructor(O,te,Ee,Ge){let et,st;if(typeof O=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(et=new A(O,te),st=new A(Ee,Ge)):O instanceof A&&te instanceof A&&(et=O,st=te),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(O){return O instanceof o?!0:O?L.isRange(O)&&A.isPosition(O.anchor)&&A.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};V=o=Ue([D],V),e.Selection=V;class G{constructor(O,te,Ee){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,M.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(te),this.connectionToken=Ee}}e.ResolvedAuthority=G;class $ extends Error{constructor(O,te=E.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(O);this._message=O,this._code=te,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(O,te){return new $(O,E.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(O){return new $(O,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var K;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var W;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let U=m=class{constructor(O,te){this._range=O,this._newText=te}static isTextEdit(O){return O instanceof m?!0:O?L.isRange(O)&&typeof O.newText=="string":!1}static replace(O,te){return new m(O,te)}static insert(O,te){return m.replace(new L(O,O),te)}static delete(O){return m.replace(O,"")}static setEndOfLine(O){const te=new m(new L(new A(0,0),new A(0,0)),"");return te.newEol=O,te}get range(){return this._range}set range(O){if(O&&!L.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};U=m=Ue([D],U),e.TextEdit=U;var z;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(z=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,te,Ee,Ge){this._edits.push({_type:1,from:O,to:te,options:Ee,metadata:Ge})}createFile(O,te,Ee){this._edits.push({_type:1,from:void 0,to:O,options:te,metadata:Ee})}deleteFile(O,te,Ee){this._edits.push({_type:1,from:O,to:void 0,options:te,metadata:Ee})}replaceNotebookMetadata(O,te,Ee){this._edits.push({_type:3,metadata:Ee,uri:O,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(O,te,Ee,Ge,et){let st,ut,St=[],At;if(Vt.isNotebookRange(te)&&Mt.isNotebookCellDataArray(Ee)&&!Mt.isNotebookCellDataArray(Ge)?(st=te.start,ut=te.end,St=Ee,At=Ge):typeof te=="number"&&typeof Ee=="number"&&Mt.isNotebookCellDataArray(Ge)&&(st=te,ut=Ee,St=Ge,At=et),st===void 0||ut===void 0)throw new Error("Invalid arguments");(st!==ut||St.length>0)&&this._edits.push({_type:5,uri:O,index:st,count:ut-st,cells:St,metadata:At})}replaceNotebookCellMetadata(O,te,Ee,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:te,metadata:Ee}})}replace(O,te,Ee,Ge){this._edits.push({_type:2,uri:O,edit:new U(te,Ee),metadata:Ge})}insert(O,te,Ee,Ge){this.replace(O,new L(te,te),Ee,Ge)}delete(O,te,Ee){this.replace(O,te,"",Ee)}has(O){return this._edits.some(te=>te._type===2&&te.uri.toString()===O.toString())}set(O,te){if(te)for(const Ee of te)Ee&&this._edits.push({_type:2,uri:O,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const Ge=this._edits[Ee];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[Ee]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(O){const te=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===O.toString()&&te.push(Ee.edit);return te}entries(){const O=new R.ResourceMap;for(let te of this._edits)if(te._type===2){let Ee=O.get(te.uri);Ee||(Ee=[te.uri,[]],O.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=Ue([D],Y),e.WorkspaceEdit=Y;let re=y=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof y?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=y._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,te=this._tabstop++){if(typeof O=="function"){const Ee=new y;Ee._tabstop=this._tabstop,O(Ee),this._tabstop=Ee._tabstop,O=Ee.value}else O=y._escape(O);return this.value+="${",this.value+=te,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,te=this._tabstop++){const Ee=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(O,te){if(typeof te=="function"){const Ee=new y;Ee._tabstop=this._tabstop,te(Ee),this._tabstop=Ee._tabstop,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,te&&(this.value+=":",this.value+=te),this.value+="}",this}};re=y=Ue([D],re),e.SnippetString=re;var j;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(j=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=i=class{constructor(O,te){if(this.uri=O,te)if(te instanceof L)this.range=te;else if(te instanceof A)this.range=new L(te,te);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof i?!0:O?L.isRange(O.range)&&_.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=i=Ue([D],oe),e.Location=oe;let ve=class{constructor(O,te){this.location=O,this.message=te}static is(O){return O?typeof O.message=="string"&&O.location&&L.isRange(O.location.range)&&_.URI.isUri(O.location.uri):!1}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.location.range.isEqual(te.location.range)&&O.location.uri.toString()===te.location.uri.toString()}};ve=Ue([D],ve),e.DiagnosticRelatedInformation=ve;let Fe=class{constructor(O,te,Ee=ue.Error){if(!L.isRange(O))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=O,this.message=te,this.severity=Ee}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.severity===te.severity&&O.code===te.code&&O.severity===te.severity&&O.source===te.source&&O.range.isEqual(te.range)&&(0,d.equals)(O.tags,te.tags)&&(0,d.equals)(O.relatedInformation,te.relatedInformation,ve.isEqual)}};Fe=Ue([D],Fe),e.Diagnostic=Fe;let Me=class{constructor(O,te){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=te}};Me=Ue([D],Me),e.Hover=Me;var Oe;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Oe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ye=class{constructor(O,te=Oe.Text){this.range=O,this.kind=te}toJSON(){return{range:this.range,kind:Oe[this.kind]}}};Ye=Ue([D],Ye),e.DocumentHighlight=Ye;var ze;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(ze=e.SymbolKind||(e.SymbolKind={}));var je;(function(N){N[N.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let x=v=class{constructor(O,te,Ee,Ge,et){this.name=O,this.kind=te,this.containerName=et,typeof Ee=="string"&&(this.containerName=Ee),Ge instanceof oe?this.location=Ge:Ee instanceof L&&(this.location=new oe(Ge,Ee)),v.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ze[this.kind],location:this.location,containerName:this.containerName}}};x=v=Ue([D],x),e.SymbolInformation=x;let Q=r=class{constructor(O,te,Ee,Ge,et){this.name=O,this.detail=te,this.kind=Ee,this.range=Ge,this.selectionRange=et,this.children=[],r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(r.validate)}};Q=r=Ue([D],Q),e.DocumentSymbol=Q;var ee;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(O,te){this.title=O,this.kind=te}};le=Ue([D],le),e.CodeAction=le;let q=s=class{constructor(O){this.value=O}append(O){return new s(this.value?this.value+s.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+s.sep)}};q.sep=".",q=s=Ue([D],q),e.CodeActionKind=q,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll");let ae=class{constructor(O,te){if(this.range=O,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=Ue([D],ae),e.SelectionRange=ae;class he{constructor(O,te,Ee,Ge,et,st){this.kind=O,this.name=te,this.detail=Ee,this.uri=Ge,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=he;class Te{constructor(O,te){this.fromRanges=te,this.from=O}}e.CallHierarchyIncomingCall=Te;class Be{constructor(O,te){this.fromRanges=te,this.to=O}}e.CallHierarchyOutgoingCall=Be;var $e;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})($e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Qe=class{constructor(O,te){this.range=O,this.command=te}get isResolved(){return!!this.command}};Qe=Ue([D],Qe),e.CodeLens=Qe;let _e=c=class{constructor(O,te=!1){u.set(this,void 0),Xe(this,u,new b.MarkdownString(O,{supportThemeIcons:te}),"f")}static isMarkdownString(O){return O instanceof c?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ae(this,u,"f").value}set value(O){Ae(this,u,"f").value=O}get isTrusted(){return Ae(this,u,"f").isTrusted}set isTrusted(O){Ae(this,u,"f").isTrusted=O}get supportThemeIcons(){return Ae(this,u,"f").supportThemeIcons}set supportThemeIcons(O){Ae(this,u,"f").supportThemeIcons=O}get supportHtml(){return Ae(this,u,"f").supportHtml}set supportHtml(O){Ae(this,u,"f").supportHtml=O}appendText(O){return Ae(this,u,"f").appendText(O),this}appendMarkdown(O){return Ae(this,u,"f").appendMarkdown(O),this}appendCodeblock(O,te){return Ae(this,u,"f").appendCodeblock(te??"",O),this}};u=new WeakMap,_e=c=Ue([D],_e),e.MarkdownString=_e;let rt=class{constructor(O,te){this.label=O,this.documentation=te}};rt=Ue([D],rt),e.ParameterInformation=rt;let H=class{constructor(O,te){this.label=O,this.documentation=te,this.parameters=[]}};H=Ue([D],H),e.SignatureInformation=H;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=Ue([D],J),e.SignatureHelp=J;var me;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(me=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ne;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Ne=e.InlayHintKind||(e.InlayHintKind={}));let Ke=class{constructor(O,te,Ee){this.text=O,this.position=te,this.kind=Ee}};Ke=Ue([D],Ke),e.InlayHint=Ke;var ot;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ot=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var at;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(at=e.CompletionItemKind||(e.CompletionItemKind={}));var vt;(function(N){N[N.Deprecated=1]="Deprecated"})(vt=e.CompletionItemTag||(e.CompletionItemTag={}));let kt=class{constructor(O,te){this.label=O,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&at[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};kt=Ue([D],kt),e.CompletionItem=kt;let ht=class{constructor(O=[],te=!1){this.items=O,this.isIncomplete=te}};ht=Ue([D],ht),e.CompletionList=ht;let yt=class{constructor(O,te,Ee){this.text=O,this.range=te,this.command=Ee}};yt=Ue([D],yt),e.InlineSuggestion=yt;let It=class{constructor(O){this.items=O}};It=Ue([D],It),e.InlineSuggestions=It;var ft;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(ft=e.ViewColumn||(e.ViewColumn={}));var Je;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Je=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Et;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ce;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Z;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(Z=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ce;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ce=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(te){switch(te){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(O,te){if(te&&!_.URI.isUri(te))throw(0,M.illegalArgument)("target");if(!L.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=te}};ge=Ue([D],ge),e.DocumentLink=ge;let fe=class{constructor(O,te,Ee,Ge){this.red=O,this.green=te,this.blue=Ee,this.alpha=Ge}};fe=Ue([D],fe),e.Color=fe;let Ie=class{constructor(O,te){if(te&&!(te instanceof fe))throw(0,M.illegalArgument)("color");if(!L.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=te}};Ie=Ue([D],Ie),e.ColorInformation=Ie;let xe=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};xe=Ue([D],xe),e.ColorPresentation=xe;var Le;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Le=e.ColorFormat||(e.ColorFormat={}));var Ve;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Ve=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ze{constructor(O,te,Ee){if(this.startIndex=O,this.length=te,this.tooltip=Ee,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,M.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Ze;var ie;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(ie=e.TerminalLocation||(e.TerminalLocation={}));class pe{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=pe;var se;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(se=e.TaskRevealKind||(e.TaskRevealKind={}));var B;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(B=e.TaskPanelKind||(e.TaskPanelKind={}));let De=h=class{constructor(O,te){if(this.label=te,typeof O!="string"||typeof te!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};De.Clean=new h("clean","Clean"),De.Build=new h("build","Build"),De.Rebuild=new h("rebuild","Rebuild"),De.Test=new h("test","Test"),De=h=Ue([D],De),e.TaskGroup=De;function Se(N){let O="";for(let te=0;te<N.length;te++)O+=N[te].replace(/,/g,",,")+",";return O}let qe=class{constructor(O,te,Ee){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Ee):this._options=te)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let te of this._args)O.push(te);return Se(O)}};qe=Ue([D],qe),e.ProcessExecution=qe;let We=class{constructor(O,te,Ee){if(this._args=[],Array.isArray(te)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=te,this._options=Ee}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=te}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)O.push(typeof te=="string"?te:te.value);return Se(O)}};We=Ue([D],We),e.ShellExecution=We;var tt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(tt=e.ShellQuoting||(e.ShellQuoting={}));var mt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(mt=e.TaskScope||(e.TaskScope={}));class wt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=wt;let nt=g=class{constructor(O,te,Ee,Ge,et,st){this.__deprecated=!1,this._definition=this.definition=O;let ut;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Ee,this.execution=Ge,ut=et,this.__deprecated=!0):te===mt.Global||te===mt.Workspace?(this.target=te,this._name=this.name=Ee,this._source=this.source=Ge,this.execution=et,ut=st):(this.target=te,this._name=this.name=Ee,this._source=this.source=Ge,this.execution=et,ut=st),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof qe?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof wt?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const te=this._definition.type;(g.EmptyType===te||g.ProcessType===te||g.ShellType===te||g.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};nt.ExtensionCallbackType="customExecution",nt.ProcessType="process",nt.ShellType="shell",nt.EmptyType="$empty",nt=g=Ue([D],nt),e.Task=nt;var ct;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ct=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(O,te=Tt.None){this.collapsibleState=te,_.URI.isUri(O)?this.resourceUri=O:this.label=O}};lt=Ue([D],lt),e.TreeItem=lt;var Tt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let _t=class{constructor(O,te){this.id=O,this.color=te}};_t=Ue([D],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let Ut=class{constructor(O){this.id=O}};Ut=Ue([D],Ut),e.ThemeColor=Ut;var $t;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})($t=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(O,te){if(typeof O!="string"&&(!O||!_.URI.isUri(O)&&!_.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof te!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=_.URI.file(O),this.base=O):_.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=te}};Ct=Ue([D],Ct),e.RelativePattern=Ct;let Wt=class{constructor(O,te,Ee,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};Wt=Ue([D],Wt),e.Breakpoint=Wt;let ei=class extends Wt{constructor(O,te,Ee,Ge,et){super(te,Ee,Ge,et);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};ei=Ue([D],ei),e.SourceBreakpoint=ei;let gt=class extends Wt{constructor(O,te,Ee,Ge,et){super(te,Ee,Ge,et);this.functionName=O}};gt=Ue([D],gt),e.FunctionBreakpoint=gt;let Qt=class extends Wt{constructor(O,te,Ee,Ge,et,st,ut){super(Ge,et,st,ut);if(!te)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=te,this.canPersist=Ee}};Qt=Ue([D],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(O,te,Ee){this.command=O,this.args=te||[],this.options=Ee}};jt=Ue([D],jt),e.DebugAdapterExecutable=jt;let ti=class{constructor(O,te){this.port=O,this.host=te}};ti=Ue([D],ti),e.DebugAdapterServer=ti;let ii=class{constructor(O){this.path=O}};ii=Ue([D],ii),e.DebugAdapterNamedPipeServer=ii;let Pt=class{constructor(O){this.implementation=O}};Pt=Ue([D],Pt),e.DebugAdapterInlineImplementation=Pt;let Yt=class{constructor(O,te){this.range=O,this.expression=te}};Yt=Ue([D],Yt),e.EvaluatableExpression=Yt;var wi;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ht=class{constructor(O,te){this.range=O,this.text=te}};Ht=Ue([D],Ht),e.InlineValueText=Ht;let zt=class{constructor(O,te,Ee=!0){this.range=O,this.variableName=te,this.caseSensitiveLookup=Ee}};zt=Ue([D],zt),e.InlineValueVariableLookup=zt;let dt=class{constructor(O,te){this.range=O,this.expression=te}};dt=Ue([D],dt),e.InlineValueEvaluatableExpression=dt;let ni=class{constructor(O,te){this.frameId=O,this.stoppedLocation=te}};ni=Ue([D],ni),e.InlineValueContext=ni;var Ot;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=k=class extends Error{constructor(O,te=t.FileSystemProviderErrorCode.Unknown,Ee){super(_.URI.isUri(O)?O.toString(!0):O);this.code=Ee?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(O){return new k(O,t.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(O){return new k(O,t.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(O){return new k(O,t.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(O){return new k(O,t.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(O){return new k(O,t.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(O){return new k(O,t.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}};Nt=k=Ue([D],Nt),e.FileSystemError=Nt;let Jt=class{constructor(O,te,Ee){this.start=O,this.end=te,this.kind=Ee}};Jt=Ue([D],Jt),e.FoldingRange=Jt;var bi;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class fi{constructor(O,te=[]){this.tokenTypes=O,this.tokenModifiers=te}}e.SemanticTokensLegend=fi;function ri(N){return typeof N=="undefined"||(0,C.isStringArray)(N)}class si{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let te=0,Ee=O.tokenTypes.length;te<Ee;te++)this._tokenTypeStrToInt.set(O.tokenTypes[te],te);for(let te=0,Ee=O.tokenModifiers.length;te<Ee;te++)this._tokenModifierStrToInt.set(O.tokenModifiers[te],te)}}push(O,te,Ee,Ge,et){if(typeof O=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(O,te,Ee,Ge,et);if(L.isRange(O)&&typeof te=="string"&&ri(Ee))return this._push(O,te,Ee);throw(0,M.illegalArgument)()}_push(O,te,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,et=O.start.character,st=O.end.character-O.start.character,ut=this._tokenTypeStrToInt.get(te);let St=0;if(Ee)for(const At of Ee){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(At);St|=1<<Ft>>>0}this._pushEncoded(Ge,et,st,ut,St)}_pushEncoded(O,te,Ee,Ge,et){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let At=0,Ft=0;for(let Lt=0;Lt<St;Lt++){let xt=this._data[5*Lt],ci=this._data[5*Lt+1];xt===0?(xt=At,ci+=Ft):xt+=At,this._data[5*Lt]=xt,this._data[5*Lt+1]=ci,At=xt,Ft=ci}}let st=O,ut=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=et,this._prevLine=O,this._prevChar=te}static _sortAndDeltaEncode(O){let te=[];const Ee=O.length/5|0;for(let ut=0;ut<Ee;ut++)te[ut]=ut;te.sort((ut,St)=>{const At=O[5*ut],Ft=O[5*St];if(At===Ft){const Lt=O[5*ut+1],xt=O[5*St+1];return Lt-xt}return At-Ft});const Ge=new Uint32Array(O.length);let et=0,st=0;for(let ut=0;ut<Ee;ut++){const St=5*te[ut],At=O[St+0],Ft=O[St+1],Lt=O[St+2],xt=O[St+3],ci=O[St+4],xi=At-et,qi=xi===0?Ft-st:Ft,di=5*ut;Ge[di+0]=xi,Ge[di+1]=qi,Ge[di+2]=Lt,Ge[di+3]=xt,Ge[di+4]=ci,et=At,st=Ft}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(si._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=si;class qt{constructor(O,te){this.resultId=te,this.data=O}}e.SemanticTokens=qt;class oi{constructor(O,te,Ee){this.start=O,this.deleteCount=te,this.data=Ee}}e.SemanticTokensEdit=oi;class _i{constructor(O,te){this.resultId=te,this.edits=O}}e.SemanticTokensEdits=_i;var yi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new _t("arrow-left")},Xt=Ue([D],Xt),e.QuickInputButtons=Xt;var Si;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(O,te,Ee){this.badge=O,this.tooltip=te,this.color=Ee}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let ai=class{constructor(O){this.kind=O}};ai=Ue([D],ai),e.ColorTheme=ai;var li;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(li=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(O,te){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(te<0)throw(0,M.illegalArgument)("end must be positive");O<=te?(this._start=O,this._end=te):(this._start=te,this._end=O)}static isNotebookRange(O){return O instanceof Vt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let te=this._start,Ee=this._end;return O.start!==void 0&&(te=O.start),O.end!==void 0&&(Ee=O.end),te===this._start&&Ee===this._end?this:new Vt(te,Ee)}}e.NotebookRange=Vt;class Mt{constructor(O,te,Ee,Ge,et,st,ut){this.kind=O,this.value=te,this.languageId=Ee,this.mime=Ge,this.outputs=et??[],this.metadata=st,this.executionSummary=ut,Mt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(te=>Mt.isNotebookCellData(te))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Mt;class Re{constructor(O){this.cells=O}}e.NotebookData=Re;class Rt{constructor(O,te){this.data=O,this.mime=te;const Ee=(0,F.normalizeMimeType)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}static isNotebookCellOutputItem(O){return O instanceof Rt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const te={name:O.name,message:O.message,stack:O.stack};return Rt.json(te,"application/vnd.code.notebook.error")}static stdout(O){return Rt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Rt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,te="application/octet-stream"){return new Rt(O,te)}static text(O,te=F.Mimes.text){const Ee=Ae(Rt,l,"f",a).encode(String(O));return new Rt(Ee,te)}static json(O,te="application/json"){const Ee=JSON.stringify(O,void 0,"	");return Rt.text(Ee,te)}}e.NotebookCellOutputItem=Rt,l=Rt,a={value:new TextEncoder};class Kt{constructor(O,te,Ee){this.items=Kt.ensureUniqueMimeTypes(O,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,T.generateUuid)(),this.metadata=te??Ee)}static isNotebookCellOutput(O){return O instanceof Kt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,C.isArray)(O.items)}static ensureUniqueMimeTypes(O,te=!1){const Ee=new Set,Ge=new Set;for(let et=0;et<O.length;et++){const st=O[et],ut=(0,F.normalizeMimeType)(st.mime);if(!Ee.has(ut)){Ee.add(ut);continue}Ge.add(et),te&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ge.size===0?O:O.filter((et,st)=>!Ge.has(st))}}e.NotebookCellOutput=Kt;var pt;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(pt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gi{constructor(O,te){this.text=O,this.alignment=te}}e.NotebookCellStatusBarItem=gi;var Ii;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(O,te=[]){this.uri=O,this.provides=(0,d.asArray)(te)}}e.NotebookRendererScript=Pi;let ui=class{constructor(O,te){this.label=O,this.timestamp=te}};ui=Ue([D],ui),e.TimelineItem=ui;var Ti;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Ti=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ai;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ai=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(O,te){this.ranges=O,this.wordPattern=te}}e.LinkedEditingRanges=Ri;class Fi{constructor(O,te){this._port=O,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let X=class{constructor(O,te,Ee){this.include=O,this.exclude=te,this.profile=Ee}};X=Ue([D],X),e.TestRunRequest=X;let de=P=class{constructor(O){this.message=O}static diff(O,te,Ee){const Ge=new P(O);return Ge.expectedOutput=te,Ge.actualOutput=Ee,Ge}};de=P=Ue([D],de),e.TestMessage=de;let ke=class{constructor(O){this.id=O}};ke=Ue([D],ke),e.TestTag=ke;let it=class{constructor(O,te){this.covered=O,this.total=te}};it=Ue([D],it),e.CoveredCount=it;let bt=p=class{constructor(O,te,Ee,Ge){this.uri=O,this.statementCoverage=te,this.branchCoverage=Ee,this.functionCoverage=Ge}static fromDetails(O,te){const Ee=new it(0,0),Ge=new it(0,0),et=new it(0,0);for(const ut of te)if("branches"in ut){Ee.total+=1,Ee.covered+=ut.executionCount>0?1:0;for(const St of ut.branches)Ge.total+=1,Ge.covered+=St.executionCount>0?1:0}else et.total+=1,et.covered+=ut.executionCount>0?1:0;const st=new p(O,Ee,Ge.total>0?Ge:void 0,et.total>0?et:void 0);return st.detailedCoverage=te,st}};bt=p=Ue([D],bt),e.FileCoverage=bt;let Dt=class{constructor(O,te,Ee=[]){this.executionCount=O,this.location=te,this.branches=Ee}};Dt=Ue([D],Dt),e.StatementCoverage=Dt;let Oi=class{constructor(O,te){this.executionCount=O,this.location=te}};Oi=Ue([D],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(O,te){this.executionCount=O,this.location=te}};Ni=Ue([D],Ni),e.FunctionCoverage=Ni;var Hi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(O,te,Ee,Ge,et,st){this.kind=O,this.name=te,this.detail=Ee,this.uri=Ge,this.range=et,this.selectionRange=st}}e.TypeHierarchyItem=ji}),define(we[88],be([0,1,42,11,9,227,118,7,13]),function(ne,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function t(l,a){a?T.set(l,a):T.delete(l)}e.setWordDefinitionFor=t;function E(l){return T.get(l)}e.getWordDefinitionFor=E;class n extends R.MirrorTextModel{constructor(a,w,I,S,o,m,y,i){super(w,I,S,o);this._proxy=a,this._languageId=m,this._isDirty=y,this._notebook=i,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,_.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===M.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},get notebook(){return a._notebook},save(){return a._save()},getText(w){return w?a._getTextInRange(w):a.getText()},get eol(){return a._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(w){return a._lineAt(w)},offsetAt(w){return a._offsetAt(w)},positionAt(w){return a._positionAt(w)},validateRange(w){return a._validateRange(w)},validatePosition(w){return a._validatePosition(w)},getWordRangeAtPosition(w,I){return a._getWordRangeAtPosition(w,I)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,d.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,d.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const w=this._validateRange(a);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const I=this._eol,S=w.start.line,o=w.end.line,m=[];m.push(this._lines[S].substring(w.start.character));for(let y=S+1;y<o;y++)m.push(this._lines[y]);return m.push(this._lines[o].substring(0,w.end.character)),m.join(I)}_lineAt(a){let w;if(a instanceof C.Position?w=a.line:typeof a=="number"&&(w=a),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new u(w,this._lines[w],w===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(a),I=this._lines[w.index].length;return new C.Position(w.index,Math.min(w.remainder,I))}_validateRange(a){if(!(a instanceof C.Range))throw new Error("Invalid argument");const w=this._validatePosition(a.start),I=this._validatePosition(a.end);return w===a.start&&I===a.end?a:new C.Range(w.line,w.character,I.line,I.character)}_validatePosition(a){if(!(a instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:w,character:I}=a,S=!1;if(w<0)w=0,I=0,S=!0;else if(w>=this._lines.length)w=this._lines.length-1,I=this._lines[w].length,S=!0;else{const o=this._lines[w].length;I<0?(I=0,S=!0):I>o&&(I=o,S=!0)}return S?new C.Position(w,I):a}_getWordRangeAtPosition(a,w){const I=this._validatePosition(a);if(!w)w=E(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const S=(0,F.getWordAtText)(I.character+1,(0,F.ensureValidWordDefinition)(w),this._lines[I.line],0);if(S)return new C.Range(I.line,S.startColumn-1,I.line,S.endColumn-1)}}e.ExtHostDocumentData=n;class u{constructor(a,w,I){this._line=a,this._text=w,this._isLastLine=I}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=u}),define(we[155],be([0,1,7,3,228,6,55,20,2,36]),function(ne,e,d,M,b,R,F,C,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,u,l,a){this._notebook=l,this._selector=a,this._disposables=new R.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(u.onDidChangeDocument(I=>{const S=this._cellUris.get(I.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=I=>{I===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(I=>w(I.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const n=[],u=[];for(const l of this._notebook.getCells())l.kind===d.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),n.push(l.document.getText().length+1),u.push(l.document.lineCount));this._cellLengths=new b.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new b.PrefixSumComputer(new Uint32Array(u))}get version(){return this._versionId}getText(n){if(!n){let S="";for(const o of this._cells)S+=o.document.getText()+`
`;return S=S.slice(0,-1),S}if(n.isEmpty)return"";const u=this.locationAt(n.start),l=this.locationAt(n.end),a=this._cellUris.get(u.uri),w=this._cellUris.get(l.uri);if(a===void 0||w===void 0)return"";if(a===w)return this._cells[a].document.getText(new d.Range(u.range.start,l.range.end));const I=[this._cells[a].document.getText(new d.Range(u.range.start,new d.Position(this._cells[a].document.lineCount,0)))];for(let S=a+1;S<w;S++)I.push(this._cells[S].document.getText());return I.push(this._cells[w].document.getText(new d.Range(new d.Position(0,0),l.range.end))),I.join(`
`)}offsetAt(n){const u=this._cellLines.getIndexOf(n.line),l=this._cellLengths.getPrefixSum(u.index-1),a=this._cells[u.index].document.offsetAt(n.with(u.remainder));return l+a}positionAt(n){if(typeof n=="number"){const l=this._cellLengths.getIndexOf(n),a=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(a)}const u=this._cellUris.get(n.uri);if(u!==void 0){const l=this._cellLines.getPrefixSum(u-1);return new d.Position(l+n.range.start.line,n.range.start.character)}return new d.Position(0,0)}locationAt(n){d.Range.isRange(n)||(n=new d.Range(n,n));const u=this._cellLines.getIndexOf(n.start.line);let l=u;n.isEmpty||(l=this._cellLines.getIndexOf(n.end.line));const a=new d.Position(u.remainder,n.start.character),w=new d.Position(l.remainder,n.end.character),I=new d.Range(a,w),S=this._cells[u.index];return new d.Location(S.document.uri,S.document.validateRange(I))}contains(n){return this._cellUris.has(n)}validateRange(n){const u=this.validatePosition(n.start),l=this.validatePosition(n.end);return n.with(u,l)}validatePosition(n){const u=this._cellLines.getIndexOf(n.line),l=new d.Position(u.remainder,n.character),a=this._cells[u.index].document.validatePosition(l),w=this._cellLines.getPrefixSum(u.index-1);return new d.Position(w+a.line,a.character)}}e.ExtHostNotebookConcatDocument=t}),define(we[156],be([0,1,7,12,3]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(C){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let _=C==="light"?d.ColorThemeKind.Light:C==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};R=Ue([He(0,M.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(we[65],be([0,1,4]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class M{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(we[157],be([0,1,22]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(_){let T=this.buffers.indexOf(_);return T<0&&(T=this.buffers.length,this.buffers.push(_)),T}}function b(C,_){if(_.serializeBuffersForPostMessage){const T=new M,t=(u,l)=>{if(l instanceof ArrayBuffer){const a=T.add(l);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(l)){const a=R(l);if(a){const w=T.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:a,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},E=JSON.stringify(C,t),n=T.buffers.map(u=>{const l=new Uint8Array(u);return d.VSBuffer.wrap(l)});return{message:E,buffers:n}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=b;function R(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(C,_){const T=_.map(n=>{const u=new ArrayBuffer(n.byteLength);return new Uint8Array(u).set(n.buffer),u}),t=_.length?(n,u)=>{if(typeof u=="object"&&u.$$vscode_array_buffer_reference$$){const l=u,{index:a}=l,w=T[a];if(l.view)switch(l.view.type){case 1:return new Int8Array(w,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return u}:void 0;return{message:JSON.parse(C,t),arrayBuffers:T}}e.deserializeWebviewMessage=F}),define(we[158],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(M){function b(F){const C={items:new Map};return F.types.forEach((_,T)=>{C.items.set(_,{asString:async()=>F.items[T].asString})}),C}M.toITreeDataTransfer=b;async function R(F){const C={types:[],items:[]},_=Array.from(F.items.entries());for(const T of _)C.types.push(T[0]),C.items.push({asString:await T[1].asString()});return C}M.toTreeDataTransferDTO=R})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[66],be([0,1,11,2]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function b(C,_){return C.scheme===d.Schemas.http||C.scheme===d.Schemas.https?C:(_&&_.authority&&_.isRemote&&C.scheme===d.Schemas.file&&(C=M.URI.from({scheme:d.Schemas.vscodeRemote,authority:_.authority,path:C.path})),M.URI.from({scheme:d.Schemas.https,authority:`${C.scheme}+${R(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=b;function R(C){return C.replace(/./g,_=>{const T=_.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?_:"-"+T.toString(16).padStart(4,"0")})}function F(C){return C.replace(/-([0-9a-f]{4})/g,(_,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=F}),define(we[159],be([0,1,3,6,66]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(C,_,T){this._proxy=C,this._editors=_,this._initData=T,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const t=_.getVisibleTextEditors();for(const E of this._insets.values())t.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,_,T,t,E){let n;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===C){n=o;break}if(!n)throw new Error("not a visible editor");const u=this,l=this._handlePool++,a=new d.Emitter,w=new d.Emitter,I=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,b.asWebviewUri)(o,u._initData.remote)}get cspSource(){return b.webviewGenericCspSource}set options(o){this._options=o,u._proxy.$setOptions(l,o)}get options(){return this._options}set html(o){this._html=o,u._proxy.$setHtml(l,o)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(o){return u._proxy.$postMessage(l,o)}},S=new class{constructor(){this.editor=C,this.line=_,this.height=T,this.webview=I,this.onDidDispose=w.event}dispose(){u._insets.has(l)&&(u._insets.delete(l),u._proxy.$disposeEditorInset(l),w.fire(),w.dispose(),a.dispose())}};return this._proxy.$createEditorInset(l,n.id,n.value.document.uri,_+1,T,t||{},E.identifier,E.extensionLocation),this._insets.set(l,{editor:C,inset:S,onDidReceiveMessage:a}),S}$onDidDispose(C){const _=this._insets.get(C);_&&_.inset.dispose()}$onDidReceiveMessage(C,_){const T=this._insets.get(C);T&&T.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=R}),define(we[160],be([0,1,131,10,2,6,4,45,28,13,11]),function(ne,e,d,M,b,R,F,C,_,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,d.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,d.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,d.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,d.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,d.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new C.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,d.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,d.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,d.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,d.localize)(10,null)),e.SideBySideEditorActiveContext=new C.RawContextKey("sideBySideEditorActive",!1,(0,d.localize)(11,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,d.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,d.localize)(13,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,d.localize)(14,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,d.localize)(15,null)),e.ActiveEditorGroupLockedContext=new C.RawContextKey("activeEditorGroupLocked",!1,(0,d.localize)(16,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,d.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,d.localize)(18,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,d.localize)(19,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,d.localize)(20,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,d.localize)(21,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,d.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function E(A,L,V){for(const G of V.visibleEditorPanes)if(G.group.id===L&&A.matches(G.input))return G.getViewState()}e.findViewStateForEditor=E;function n(A){if(m(A))return!1;const L=A;return b.URI.isUri(L?.resource)}e.isResourceEditorInput=n;function u(A){if(m(A))return!1;const L=A;return L?.original!==void 0&&L.modified!==void 0}e.isResourceDiffEditorInput=u;function l(A){if(m(A)||u(A))return!1;const L=A;return L?.primary!==void 0&&L.secondary!==void 0}e.isResourceSideBySideEditorInput=l;function a(A){if(m(A))return!1;const L=A;return L?L.resource===void 0||L.resource.scheme===t.Schemas.untitled||L.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;var w;(function(A){A[A.SHORT=0]="SHORT",A[A.MEDIUM=1]="MEDIUM",A[A.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var I;(function(A){A[A.EXPLICIT=1]="EXPLICIT",A[A.AUTO=2]="AUTO",A[A.FOCUS_CHANGE=3]="FOCUS_CHANGE",A[A.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(I=e.SaveReason||(e.SaveReason={}));var S;(function(A){A[A.None=0]="None",A[A.Readonly=2]="Readonly",A[A.Untitled=4]="Untitled",A[A.Singleton=8]="Singleton",A[A.RequiresTrust=16]="RequiresTrust",A[A.CanSplitInGroup=32]="CanSplitInGroup"})(S=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends R.Disposable{}e.AbstractEditorInput=o;function m(A){return A instanceof o}e.isEditorInput=m;function y(A){const L=A;return b.URI.isUri(L?.preferredResource)}function i(A){const L=A;return m(L?.primary)&&m(L?.secondary)}e.isSideBySideEditorInput=i;function v(A){const L=A;return m(L?.modified)&&m(L?.original)}e.isDiffEditorInput=v;function r(A){return m(A?.editor)}e.isEditorInputWithOptions=r;function s(A){const L=A;return r(A)&&L?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function c(A){const L=A;return typeof L?.groupId=="number"&&m(L.editor)}e.isEditorIdentifier=c;var h;(function(A){A[A.UNKNOWN=0]="UNKNOWN",A[A.REPLACE=1]="REPLACE",A[A.MOVE=2]="MOVE",A[A.UNPIN=3]="UNPIN"})(h=e.EditorCloseContext||(e.EditorCloseContext={}));var g;(function(A){A[A.PRIMARY=1]="PRIMARY",A[A.SECONDARY=2]="SECONDARY",A[A.BOTH=3]="BOTH",A[A.ANY=4]="ANY"})(g=e.SideBySideEditor||(e.SideBySideEditor={}));class k{getOriginalUri(L,V){if(!L)return;if(V?.supportSideBySide){const{primary:$,secondary:K}=this.getSideEditors(L);if($&&K){if(V?.supportSideBySide===g.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===g.ANY)return this.getOriginalUri($,{filterByScheme:V.filterByScheme})??this.getOriginalUri(K,{filterByScheme:V.filterByScheme});L=V.supportSideBySide===g.PRIMARY?$:K}}if(u(L)||l(L))return;const G=y(L)?L.preferredResource:L.resource;return!G||!V||!V.filterByScheme?G:this.filterUri(G,V.filterByScheme)}getSideEditors(L){return i(L)||l(L)?{primary:L.primary,secondary:L.secondary}:v(L)||u(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,V){if(!L)return;if(V?.supportSideBySide){const{primary:$,secondary:K}=this.getSideEditors(L);if($&&K){if(V?.supportSideBySide===g.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===g.ANY)return this.getCanonicalUri($,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(K,{filterByScheme:V.filterByScheme});L=V.supportSideBySide===g.PRIMARY?$:K}}if(u(L)||l(L))return;const G=L.resource;return!G||!V||!V.filterByScheme?G:this.filterUri(G,V.filterByScheme)}filterUri(L,V){if(Array.isArray(V)){if(V.some(G=>L.scheme===G))return L}else if(V===L.scheme)return L}}e.EditorResourceAccessor=new k;var P;(function(A){A[A.LEFT=0]="LEFT",A[A.RIGHT=1]="RIGHT"})(P=e.CloseDirection||(e.CloseDirection={}));class p{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(L){const V=this.instantiationService=L.get(F.IInstantiationService);for(const[G,$]of this.editorSerializerConstructors)this.createEditorSerializer(G,$,V);this.editorSerializerConstructors.clear()}createEditorSerializer(L,V,G){const $=G.createInstance(V);this.editorSerializerInstances.set(L,$)}registerFileEditorFactory(L){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=L}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(L,V){if(this.editorSerializerConstructors.has(L)||this.editorSerializerInstances.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.instantiationService?this.createEditorSerializer(L,V,this.instantiationService):this.editorSerializerConstructors.set(L,V),(0,R.toDisposable)(()=>{this.editorSerializerConstructors.delete(L),this.editorSerializerInstances.delete(L)})}getEditorSerializer(L){return this.editorSerializerInstances.get(typeof L=="string"?L:L.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new p);async function D(A,L){if(!A||!A.length)return[];const V=await Promise.all(A.map(async G=>{const $=b.URI.revive(G.fileUri);if(!$||(await L.activateProvider($.scheme),!L.canHandleResource($)))return;const K=typeof G.exists=="boolean"?G.exists:await L.exists($);if(!K&&G.openOnlyIfExists)return;const W={selection:K?G.selection:void 0,pinned:!0,override:G.editorOverrideId};let U;return K?U={resource:$,options:W}:U={resource:$,options:W,forceUntitled:!0},U}));return(0,T.coalesce)(V)}e.pathsToEditors=D;var f;(function(A){A[A.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",A[A.SEQUENTIAL=1]="SEQUENTIAL"})(f=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[161],be([0,1,3,45,132,4,6,20,28,13,51,23,34,151]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,u.registerIcon)("default-view-icon",n.Codicon.window,(0,b.localize)(0,null));var l;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(l=e.Extensions||(e.Extensions={}));var a;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel"})(a=e.ViewContainerLocation||(e.ViewContainerLocation={}));function w(c){switch(c){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=w;function I(c){return`viewContainer.${c}.enabled`}e.getEnabledViewContainerContextKey=I;class S extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new d.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new d.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(h,g,k){const P=this.get(h.id);if(P)return P;const p=h;return p.openCommandActionDescriptor=k?.donotRegisterOpenCommand?void 0:p.openCommandActionDescriptor??{id:p.id},(0,C.getOrSet)(this.viewContainers,g,[]).push(p),k?.isDefault&&this.defaultViewContainers.push(p),this._onDidRegister.fire({viewContainer:p,viewContainerLocation:g}),p}deregisterViewContainer(h){for(const g of this.viewContainers.keys()){const k=this.viewContainers.get(g),P=k?.indexOf(h);if(P!==-1){k?.splice(P,1),k.length===0&&this.viewContainers.delete(g),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:g});return}}}get(h){return this.all.filter(g=>g.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(g=>this.getViewContainers(g).filter(k=>k?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(g=>this.getViewContainerLocation(g)===h)}}_.Registry.add(l.ViewContainersRegistry,new S);var o;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function m(c,h){const g=c.group??o.More,k=h.group??o.More;return g!==k?g.localeCompare(k):(c.order??5)-(h.order??5)}class y extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new d.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new d.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new d.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new d.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(h,g){this.registerViews2([{views:h,viewContainer:g}])}registerViews2(h){h.forEach(({views:g,viewContainer:k})=>this.addViews(g,k)),this._onViewsRegistered.fire(h)}deregisterViews(h,g){const k=this.removeViews(h,g);k.length&&this._onViewsDeregistered.fire({views:k,viewContainer:g})}moveViews(h,g){for(const k of this._views.keys())if(k!==g){const P=this.removeViews(h,k);P.length&&(this.addViews(P,g),this._onDidChangeContainer.fire({views:P,from:k,to:g}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const g of this._viewContainers){const k=(this._views.get(g)||[]).filter(P=>P.id===h)[0];if(k)return k}return null}getViewContainer(h){for(const g of this._viewContainers)if((this._views.get(g)||[]).filter(P=>P.id===h)[0])return g;return null}registerViewWelcomeContent(h,g){return this._viewWelcomeContents.add(h,g),this._onDidChangeViewWelcomeContent.fire(h),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(h,g),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,g){const k=new Map;for(const[P,p]of g)this._viewWelcomeContents.add(h,p),k.set(P,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(h,p),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),k}getViewWelcomeContent(h){const g=[];return this._viewWelcomeContents.forEach(h,k=>g.push(k)),g.sort(m)}addViews(h,g){let k=this._views.get(g);k||(k=[],this._views.set(g,k),this._viewContainers.push(g));for(const P of h){if(this.getView(P.id)!==null)throw new Error((0,b.localize)(1,null,P.id));k.push(P)}}removeViews(h,g){const k=this._views.get(g);if(!k)return[];const P=[],p=[];for(const D of k)h.includes(D)?P.push(D):p.push(D);return P.length&&(p.length?this._views.set(g,p):(this._views.delete(g),this._viewContainers.splice(this._viewContainers.indexOf(g),1))),P}}_.Registry.add(l.ViewsRegistry,new y),e.IViewsService=(0,R.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,b.localize)(2,null));function i(c){return`view.${c}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,R.createDecorator)("viewDescriptorService");var v;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(v=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(h,g){this.resolved=!1,this._hasResolve=!1,(0,E.mixin)(this,h),this._hasResolve=!!g,this.resolve=async k=>{if(g&&!this.resolved){const P=await g(k);P&&(this.tooltip=this.tooltip??P.tooltip,this.command=this.command??P.command)}k.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(we[162],be([0,1,3,14,133]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,_,T,t){const E={command:C};if(_&&Object.keys(_).length>0&&(E.arguments=_),this.internalSend("request",E),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const u=this.pendingRequests.get(E.seq);if(u){this.pendingRequests.delete(E.seq);const l={type:"response",seq:0,request_seq:E.seq,success:!1,command:C,message:(0,b.localize)(0,null,t,C)};u(l)}},t)}return T&&this.pendingRequests.set(E.seq,T),E.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,_){return C.type!=="event"||_.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,M.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const _=C,T=this.pendingRequests.get(_.request_seq);T&&(this.pendingRequests.delete(_.request_seq),T(_));break}}}internalSend(C,_){_.type=C,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((_,T)=>C.set(T,_)),await(0,M.timeout)(500),C.forEach((_,T)=>{_({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=R}),define(we[163],be([0,1,9,2,17,23,11]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function _(r,s,c){return r.replace(C,function(h,g){return s&&g.length>0&&g[0]!=="_"?h:c&&c.hasOwnProperty(g)?c[g]:h})}e.formatPII=_;function T(r){const s={};for(const c of Object.keys(r))c.startsWith("!")||(s[c]=r[c]);return s}e.filterExceptionsFromTelemetry=T;function t(r){return r.configuration.request==="attach"&&!E(r)&&(!r.parentSession||t(r.parentSession))}e.isSessionAttach=t;function E(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(s,"extensionhost")||(0,d.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?E(r.parentSession):void 0}e.getExtensionHostDebugSession=E;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function u(r,s,c){let h,g=0,k=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=k.exec(r);){let p=P.index+1,D=p+P[0].length;if(p<=s&&D>=c){h=P[0],g=p;break}}if(h){let p=/\w+/g,D=null;for(;(D=p.exec(h))&&!(D.index+1+g+D[0].length>=c););D&&(h=h.substring(0,p.lastIndex))}return h?{start:g,end:g+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=u;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(r){return!!(r&&r.match(l))}e.isUri=a;function w(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(a(r.path))return M.URI.parse(r.path);if((0,b.isAbsolute)(r.path))return M.URI.file(r.path)}return r.path}function I(r){if(typeof r.path=="object"){const s=M.URI.revive(r.path);if(s)return s.scheme===F.Schemas.file?s.fsPath:s.toString()}return r.path}function S(r,s){const c=s?w:I,h=(0,R.deepClone)(r);return m(h,(g,k)=>{g&&k&&(k.path=c(k))}),h}e.convertToDAPaths=S;function o(r,s){const c=s?w:I,h=(0,R.deepClone)(r);return m(h,(g,k)=>{!g&&k&&(k.path=c(k))}),h}e.convertToVSCPaths=o;function m(r,s){switch(r.type){case"event":const c=r;switch(c.event){case"output":s(!1,c.body.source);break;case"loadedSource":s(!1,c.body.source);break;case"breakpoint":s(!1,c.body.breakpoint.source);break;default:break}break;case"request":const h=r;switch(h.command){case"setBreakpoints":s(!0,h.arguments.source);break;case"breakpointLocations":s(!0,h.arguments.source);break;case"source":s(!0,h.arguments.source);break;case"gotoTargets":s(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(k=>s(!1,k));break;default:break}break;case"response":const g=r;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(k=>s(!1,k.source));break;case"loadedSources":g.body.sources.forEach(k=>s(!1,k));break;case"scopes":g.body.scopes.forEach(k=>s(!1,k.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(k=>s(!1,k.source));break;case"setBreakpoints":g.body.breakpoints.forEach(k=>s(!1,k.source));break;default:break}break}}function y(r){return r.filter(s=>!s.presentation?.hidden).sort((s,c)=>s.presentation?c.presentation?s.presentation.group?c.presentation.group?s.presentation.group!==c.presentation.group?s.presentation.group.localeCompare(c.presentation.group):i(s.presentation.order,c.presentation.order):-1:c.presentation.group?1:i(s.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=y;function i(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}async function v(r,s){const c=r.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorMode});if(c!=="none"&&(await s.saveAll(),c==="allEditorsInActiveGroup")){const h=s.activeEditorPane;h&&await s.save({editor:h.input,groupId:h.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=v}),define(we[89],be([0,1,27,78,11,17,26,45]),function(ne,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(p){p[p.Markup=1]="Markup",p[p.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(p){p[p.Running=1]="Running",p[p.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(p){p[p.Pending=2]="Pending",p[p.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(p){p[p.WithHardKernelDependency=0]="WithHardKernelDependency",p[p.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",p[p.Pure=2]="Pure",p[p.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(p){p.Always="always",p.Never="never",p.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var u;(function(p){p[p.ModelChange=1]="ModelChange",p[p.Move=2]="Move",p[p.ChangeLanguage=5]="ChangeLanguage",p[p.Initialize=6]="Initialize",p[p.ChangeCellMetadata=7]="ChangeCellMetadata",p[p.Output=8]="Output",p[p.OutputItem=9]="OutputItem",p[p.ChangeCellContent=10]="ChangeCellContent",p[p.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",p[p.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",p[p.ChangeCellMime=13]="ChangeCellMime",p[p.Unknown=100]="Unknown"})(u=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var l;(function(p){p[p.Handle=0]="Handle",p[p.Index=1]="Index"})(l=e.SelectionStateType||(e.SelectionStateType={}));var a;(function(p){p[p.Replace=1]="Replace",p[p.Output=2]="Output",p[p.Metadata=3]="Metadata",p[p.CellLanguage=4]="CellLanguage",p[p.DocumentMetadata=5]="DocumentMetadata",p[p.Move=6]="Move",p[p.OutputItems=7]="OutputItems",p[p.PartialMetadata=8]="PartialMetadata",p[p.PartialInternalMetadata=9]="PartialInternalMetadata"})(a=e.CellEditType||(e.CellEditType={}));var w;(function(p){p.scheme=b.Schemas.vscodeNotebookCell;const D=/^ch(\d{7,})/;function f($,K){return $.with({scheme:p.scheme,fragment:`ch${K.toString().padStart(7,"0")}${$.scheme!==b.Schemas.file?$.scheme:""}`})}p.generate=f;function A($){if($.scheme!==p.scheme)return;const K=D.exec($.fragment);return K?{handle:Number(K[1]),notebook:$.with({scheme:$.fragment.substr(K[0].length)||b.Schemas.file,fragment:null})}:void 0}p.parse=A;function L($){if($.scheme!==b.Schemas.vscodeNotebookCellMetadata)return;const K=D.exec($.fragment);return K?{handle:Number(K[1]),notebook:$.with({scheme:$.fragment.substr(K[0].length)||b.Schemas.file,fragment:null})}:void 0}p.parseCellMetadataUri=L;function V($,K,W){return $.with({scheme:W,fragment:`ch${K.toString().padStart(7,"0")}${$.scheme!==b.Schemas.file?$.scheme:""}`})}p.generateCellUri=V;function G($,K){if($.scheme!==K)return;const W=D.exec($.fragment);return W?{handle:Number(W[1]),notebook:$.with({scheme:$.fragment.substr(W[0].length)||b.Schemas.file,fragment:null})}:void 0}p.parseCellUri=G})(w=e.CellUri||(e.CellUri={}));const I=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function S(p){return I.get(p)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=S;function o(p){return I.get(p)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function m(p){return I.get(p)?.mergeable??!1}e.mimeTypeIsMergeable=m;function y(p,D){return F.isWindows&&(p=p.replace(/\//g,"\\"),D=D.replace(/\//g,"\\")),d.match(p,D)}function i(p,D,f){let A=0;for(let L=0;L<D.length;L++){if(y(D[L],p))return A;A++}for(let L=0;L<f.length;L++){if(y(f[L],p))return A;A++}return A}function v(p,D,f){return p.sort((A,L)=>i(A,D,f)-i(L,D,f))}e.sortMimeTypes=v;function r(p,D,f,A=(L,V)=>L===V){const L=[];function V(K,W,U){if(W===0&&U.length===0)return;const z=L[L.length-1];z&&z.start+z.deleteCount===K?(z.deleteCount+=W,z.toInsert.push(...U)):L.push({start:K,deleteCount:W,toInsert:U})}let G=0,$=0;for(;;){if(G===p.length){V(G,0,D.slice($));break}if($===D.length){V(G,p.length-G,[]);break}const K=p[G],W=D[$];if(A(K,W)){G+=1,$+=1;continue}f(W)?(V(G,1,[]),G+=1):(V(G,0,[W]),$+=1)}return L}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(p){p.default="default",p.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(p){const D=p;return!!((typeof D.include=="string"||d.isRelativePattern(D.include))&&(typeof D.exclude=="string"||d.isRelativePattern(D.exclude)))}e.isDocumentExcludePattern=c;function h(p,D,f){if(Array.isArray(p.viewType)&&p.viewType.indexOf(D)>=0||p.viewType===D)return!0;if(p.filenamePattern){let A=c(p.filenamePattern)?p.filenamePattern.include:p.filenamePattern,L=c(p.filenamePattern)?p.filenamePattern.exclude:void 0;if(d.match(A,(0,R.basename)(f.fsPath).toLowerCase()))return!(L&&d.match(L,(0,R.basename)(f.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h;class g{constructor(D){this.textModel=D}getElements(){const D=new Int32Array(this.textModel.cells.length);for(let f=0;f<this.textModel.cells.length;f++)D[f]=this.textModel.cells[f].getHashValue();return D}}e.CellSequence=g,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var k;(function(p){p[p.Left=1]="Left",p[p.Right=2]="Right"})(k=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class P{static create(D){return`${P._prefix}${D}`}static parse(D){if(D.startsWith(P._prefix))return D.substr(P._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=P,P._prefix="notebook/"}),define(we[164],be([0,1,4]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState",b[b.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(we[165],be([0,1,135,4,45]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new b.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new b.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new b.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[166],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=d;function M(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=M}),define(we[90],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(E){E[E.Unset=0]="Unset",E[E.Queued=1]="Queued",E[E.Running=2]="Running",E[E.Passed=3]="Passed",E[E.Failed=4]="Failed",E[E.Skipped=5]="Skipped",E[E.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var M;(function(E){E[E.Run=2]="Run",E[E.Debug=4]="Debug",E[E.Coverage=8]="Coverage",E[E.HasNonDefaultProfile=16]="HasNonDefaultProfile",E[E.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var b;(function(E){E[E.Error=0]="Error",E[E.Info=1]="Info"})(b=e.TestMessageType||(e.TestMessageType={}));var R;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})(R=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(E,n)=>{n.expand!==void 0&&(E.expand=n.expand),n.item!==void 0&&(E.item=E.item?Object.assign(E.item,n.item):n.item)};e.applyTestItemUpdate=F;var C;(function(E){E[E.Function=0]="Function",E[E.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var _;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.Remove=2]="Remove",E[E.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",E[E.Retire=4]="Retire",E[E.AddTag=5]="AddTag",E[E.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(n){}update(n){}remove(n,u){}complete(){}}e.IncrementalChangeCollector=T;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const u=this.createChangeCollector();for(const l of n)switch(l[0]){case 0:{const a=l[1];if(a.parent){if(this.items.has(a.parent)){const w=this.items.get(a.parent);w.children.add(a.item.extId);const I=this.createItem(a,w);this.items.set(a.item.extId,I),u.add(I)}}else{const w=this.createItem(a);this.roots.add(w),this.items.set(a.item.extId,w),u.add(w)}a.expand===2&&this.busyControllerCount++;break}case 1:{const a=l[1],w=this.items.get(a.extId);if(!w)break;a.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,a.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,a),u.update(w);break}case 2:{const a=this.items.get(l[1]);if(!a)break;a.parent?this.items.get(a.parent).children.delete(a.item.extId):this.roots.delete(a);const w=[[l[1]]];for(;w.length;)for(const I of w.pop()){const S=this.items.get(I);S&&(w.push(S.children),this.items.delete(I),u.remove(S,S!==a),S.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l[1]);break;case 3:this.updatePendingRoots(l[1]);break;case 5:this._tags.set(l[1].id,l[1]);break;case 6:this._tags.delete(l[1]);break}u.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=t}),define(we[67],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(R){R.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class b{constructor(F,C=F.length){if(this.path=F,this.viewEnd=C,F.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,C,_=F.parent){if(F.id===C)return new b([C]);let T=[F.id];for(let t=_;t&&t.id!==C;t=t.parent)T.push(t.id);return T.push(C),new b(T.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new b(F.split("\0"))}static join(F,C){return new b([...F.path,C])}static joinToString(F,C){return F.toString()+"\0"+C}static compare(F,C){return F===C?0:C.startsWith(F+"\0")?2:F.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new b(this.path,F)}compare(F){if(typeof F=="string")return b.compare(this.toString(),F);for(let C=0;C<F.viewEnd&&C<this.viewEnd;C++)if(F.path[C]!==this.path[C])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=b}),define(we[167],be([0,1,17,91,10,23,26,77,136]),function(ne,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(E,n,u){this._contributedVariables=new Map,this._context=E,this._labelService=n,u&&(this._envVariablesPromise=u.then(l=>this.prepareEnv(l)))}prepareEnv(E){if(F.isWindows){const n=Object.create(null);return Object.keys(E).forEach(u=>{n[u.toLowerCase()]=E[u]}),n}return E}resolveWithEnvironment(E,n,u){return this.recursiveResolve(this.prepareEnv(E),n?n.uri:void 0,u)}async resolveAsync(E,n){return this.recursiveResolve(await this._envVariablesPromise,E?E.uri:void 0,n)}async resolveAnyBase(E,n,u,l){const a=R.deepClone(n);return F.isWindows&&a.windows?Object.keys(a.windows).forEach(w=>a[w]=a.windows[w]):F.isMacintosh&&a.osx?Object.keys(a.osx).forEach(w=>a[w]=a.osx[w]):F.isLinux&&a.linux&&Object.keys(a.linux).forEach(w=>a[w]=a.linux[w]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(await this._envVariablesPromise,E?E.uri:void 0,a,u,l)}async resolveAnyAsync(E,n,u){return this.resolveAnyBase(E,n,u)}async resolveAnyMap(E,n,u){const l=new Map;return{newConfig:await this.resolveAnyBase(E,n,u,l),resolvedVariables:l}}resolveWithInteractionReplace(E,n,u,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,n,u,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,n){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,n)}recursiveResolve(E,n,u,l,a){if(b.isString(u))return this.resolveString(E,n,u,l,a);if(b.isArray(u))return u.map(w=>this.recursiveResolve(E,n,w,l,a));if(b.isObject(u)){let w=Object.create(null);return Object.keys(u).forEach(I=>{const S=this.resolveString(E,n,I,l,a);w[S]=this.recursiveResolve(E,n,u[I],l,a)}),w}return u}resolveString(E,n,u,l,a){return u.replace(T.VARIABLE_REGEXP,(I,S)=>{if(S.includes(T.VARIABLE_LHS))return I;let o=this.evaluateSingleVariable(E,I,S,n,l);return a&&a.set(S,o),o!==I&&b.isString(o)&&o.match(T.VARIABLE_REGEXP)&&(o=this.resolveString(E,n,o,l,a)),o})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}evaluateSingleVariable(E,n,u,l,a){let w;const I=u.split(":");I.length>1&&(u=I[0],w=I[1]);const S=()=>{const y=this._context.getFilePath();if(y)return y;throw new Error((0,_.localize)(0,null,n))},o=()=>{const y=S();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,_.localize)(1,null,n,d.basename(y)))},m=()=>{if(w){const y=this._context.getFolderUri(w);if(y)return y;throw new Error((0,_.localize)(2,null,n,w))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,n)):new Error((0,_.localize)(4,null,n))};switch(u){case"env":if(w){if(E){const y=E[F.isWindows?w.toLowerCase():w];if(b.isString(y))return y}return""}throw new Error((0,_.localize)(5,null,n));case"config":if(w){const y=this._context.getConfigurationValue(l,w);if(b.isUndefinedOrNull(y))throw new Error((0,_.localize)(6,null,n,w));if(b.isObject(y))throw new Error((0,_.localize)(7,null,n,w));return y}throw new Error((0,_.localize)(8,null,n));case"command":return this.resolveFromMap(n,w,a,"command");case"input":return this.resolveFromMap(n,w,a,"input");default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(m()));case"cwd":return l||w?(0,C.normalizeDriveLetter)(this.fsPath(m())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(m()));case"lineNumber":const y=this._context.getLineNumber();if(y)return y;throw new Error((0,_.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,_.localize)(10,null,n));case"file":return S();case"fileWorkspaceFolder":return o();case"relativeFile":return l||w?d.relative(this.fsPath(m()),S()):S();case"relativeFileDirname":const v=d.dirname(S());if(l||w){const h=d.relative(this.fsPath(m()),v);return h.length===0?".":h}return v;case"fileDirname":return d.dirname(S());case"fileExtname":return d.extname(S());case"fileBasename":return d.basename(S());case"fileBasenameNoExtension":const r=d.basename(S());return r.slice(0,r.length-d.extname(r).length);case"fileDirnameBasename":return d.basename(d.dirname(S()));case"execPath":const s=this._context.getExecPath();return s||n;case"execInstallFolder":const c=this._context.getAppRoot();return c||n;case"pathSeparator":return d.sep;default:try{const h=w?`${u}:${w}`:u;return this.resolveFromMap(n,h,a,void 0)}catch(h){return n}}}}resolveFromMap(E,n,u,l){if(n&&u){const a=l===void 0?u[n]:u[l+":"+n];if(typeof a=="string")return a;throw new Error((0,_.localize)(11,null,E))}return E}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[92],be([0,1,4,160]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var b;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var R;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var C;(function(a){a[a.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",a[a.EVEN=1]="EVEN",a[a.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function T(a){const w=a;return(0,M.isEditorInput)(w?.editor)&&(0,M.isEditorInput)(w?.replacement)}e.isEditorReplacement=T;var t;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var E;(function(a){a[a.GROUP_ACTIVE=0]="GROUP_ACTIVE",a[a.GROUP_INDEX=1]="GROUP_INDEX",a[a.GROUP_LOCKED=2]="GROUP_LOCKED",a[a.EDITOR_OPEN=3]="EDITOR_OPEN",a[a.EDITOR_CLOSE=4]="EDITOR_CLOSE",a[a.EDITOR_MOVE=5]="EDITOR_MOVE",a[a.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",a[a.EDITOR_LABEL=7]="EDITOR_LABEL",a[a.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",a[a.EDITOR_PIN=9]="EDITOR_PIN",a[a.EDITOR_STICKY=10]="EDITOR_STICKY",a[a.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(E=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function u(a){const w=a;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=u;function l(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=l}),define(we[168],be([0,1,4,92]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(R){const F=R;return typeof R=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=b}),define(we[8],be([0,1,13,22,76,229,54,23,10,2,44,59,137,82,48,89,67,168,7]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ie){function pe(B){const{selectionStartLineNumber:De,selectionStartColumn:Se,positionLineNumber:qe,positionColumn:We}=B,tt=new S.Position(De-1,Se-1),mt=new S.Position(qe-1,We-1);return new S.Selection(tt,mt)}ie.to=pe;function se(B){const{anchor:De,active:Se}=B;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Se.line+1,positionColumn:Se.character+1}}ie.from=se})(o=e.Selection||(e.Selection={}));var m;(function(ie){function pe(B){if(!B)return;const{start:De,end:Se}=B;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Se.line+1,endColumn:Se.character+1}}ie.from=pe;function se(B){if(!B)return;const{startLineNumber:De,startColumn:Se,endLineNumber:qe,endColumn:We}=B;return new S.Range(De-1,Se-1,qe-1,We-1)}ie.to=se})(m=e.Range||(e.Range={}));var y;(function(ie){function pe(se){switch(se){case 1:return S.StandardTokenType.Comment;case 0:return S.StandardTokenType.Other;case 4:return S.StandardTokenType.RegEx;case 2:return S.StandardTokenType.String}}ie.to=pe})(y=e.TokenType||(e.TokenType={}));var i;(function(ie){function pe(B){return new S.Position(B.lineNumber-1,B.column-1)}ie.to=pe;function se(B){return{lineNumber:B.line+1,column:B.character+1}}ie.from=se})(i=e.Position||(e.Position={}));var v;(function(ie){function pe(B){switch(B){case S.DiagnosticTag.Unnecessary:return 1;case S.DiagnosticTag.Deprecated:return 2}}ie.from=pe;function se(B){switch(B){case 1:return S.DiagnosticTag.Unnecessary;case 2:return S.DiagnosticTag.Deprecated;default:return}}ie.to=se})(v=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(ie){function pe(B){let De;return B.code&&((0,_.isString)(B.code)||(0,_.isNumber)(B.code)?De=String(B.code):De={value:String(B.code.value),target:B.code.target}),{...m.from(B.range),message:B.message,source:B.source,code:De,severity:c.from(B.severity),relatedInformation:B.relatedInformation&&B.relatedInformation.map(s.from),tags:Array.isArray(B.tags)?(0,d.coalesce)(B.tags.map(v.from)):void 0}}ie.from=pe;function se(B){const De=new S.Diagnostic(m.to(B),B.message,c.to(B.severity));return De.source=B.source,De.code=(0,_.isString)(B.code)?B.code:B.code?.value,De.relatedInformation=B.relatedInformation&&B.relatedInformation.map(s.to),De.tags=B.tags&&(0,d.coalesce)(B.tags.map(v.to)),De}ie.to=se})(r=e.Diagnostic||(e.Diagnostic={}));var s;(function(ie){function pe(B){return{...m.from(B.location.range),message:B.message,resource:B.location.uri}}ie.from=pe;function se(B){return new S.DiagnosticRelatedInformation(new S.Location(B.resource,m.to(B)),B.message)}ie.to=se})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var c;(function(ie){function pe(B){switch(B){case S.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}ie.from=pe;function se(B){switch(B){case u.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}ie.to=se})(c=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var h;(function(ie){function pe(B){return typeof B=="number"&&B>=S.ViewColumn.One?B-1:B===S.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}ie.from=pe;function se(B){if(typeof B=="number"&&B>=0)return B+1;throw new Error("invalid 'EditorGroupColumn'")}ie.to=se})(h=e.ViewColumn||(e.ViewColumn={}));function g(ie){return typeof ie.range!="undefined"}function k(ie){return ie.length===0?!0:!!g(ie[0])}e.isDecorationOptionsArr=k;var P;(function(ie){function pe(We){return We.map(ie.from)}ie.fromMany=pe;function se(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function B(We){let tt;if(se(We)){const{language:ct,value:lt}=We;tt={value:"```"+ct+`
`+lt+"\n```\n"}}else S.MarkdownString.isMarkdownString(We)?tt={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml}:typeof We=="string"?tt={value:We}:tt={value:""};const mt=Object.create(null);tt.uris=mt;const wt=ct=>{try{let lt=T.URI.parse(ct,!0);lt=lt.with({query:De(lt.query,mt)}),mt[ct]=lt}catch(lt){}return""},nt=new R.Renderer;return nt.link=wt,nt.image=ct=>wt(b.parseHrefAndDimensions(ct).href),R(tt.value,{renderer:nt}),tt}ie.from=B;function De(We,tt){if(!We)return We;let mt;try{mt=(0,F.parse)(We)}catch(nt){}if(!mt)return We;let wt=!1;return mt=(0,C.cloneAndChange)(mt,nt=>{if(T.URI.isUri(nt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[ct]=nt,wt=!0,ct}else return}),wt?JSON.stringify(mt):We}function Se(We){const tt=new S.MarkdownString(We.value,We.supportThemeIcons);return tt.isTrusted=We.isTrusted,tt.supportHtml=We.supportHtml,tt}ie.to=Se;function qe(We){if(!!We)return typeof We=="string"?We:ie.from(We)}ie.fromStrict=qe})(P=e.MarkdownString||(e.MarkdownString={}));function p(ie){return k(ie)?ie.map(pe=>({range:m.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?P.fromMany(pe.hoverMessage):pe.hoverMessage?P.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):ie.map(pe=>({range:m.from(pe)}))}e.fromRangeOrRangeWithMessage=p;function D(ie){return typeof ie=="undefined"?ie:typeof ie=="string"?T.URI.file(ie):ie}e.pathOrURIToURI=D;var f;(function(ie){function pe(se){return typeof se=="undefined"?se:{contentText:se.contentText,contentIconPath:se.contentIconPath?D(se.contentIconPath):void 0,border:se.border,borderColor:se.borderColor,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,color:se.color,backgroundColor:se.backgroundColor,margin:se.margin,width:se.width,height:se.height}}ie.from=pe})(f=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var A;(function(ie){function pe(se){return typeof se=="undefined"?se:{backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?D(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?f.from(se.before):void 0,after:se.after?f.from(se.after):void 0}}ie.from=pe})(A=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(ie){function pe(se){if(typeof se=="undefined")return se;switch(se){case S.DecorationRangeBehavior.OpenOpen:return 0;case S.DecorationRangeBehavior.ClosedClosed:return 1;case S.DecorationRangeBehavior.OpenClosed:return 2;case S.DecorationRangeBehavior.ClosedOpen:return 3}}ie.from=pe})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(ie){function pe(se){return{isWholeLine:se.isWholeLine,rangeBehavior:se.rangeBehavior?L.from(se.rangeBehavior):void 0,overviewRulerLane:se.overviewRulerLane,light:se.light?A.from(se.light):void 0,dark:se.dark?A.from(se.dark):void 0,backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?D(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?f.from(se.before):void 0,after:se.after?f.from(se.after):void 0}}ie.from=pe})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var G;(function(ie){function pe(B){return{text:B.newText,eol:B.newEol&&J.from(B.newEol),range:m.from(B.range)}}ie.from=pe;function se(B){const De=new S.TextEdit(m.to(B.range),B.text);return De.newEol=typeof B.eol=="undefined"?void 0:J.to(B.eol),De}ie.to=se})(G=e.TextEdit||(e.TextEdit={}));var $;(function(ie){function pe(B,De,Se){const qe={edits:[]};if(B instanceof S.WorkspaceEdit)for(let We of B._allEntries())if(We._type===1)qe.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata});else if(We._type===2){const tt=De?.getDocument(We.uri);qe.edits.push({_type:2,resource:We.uri,edit:G.from(We.edit),modelVersionId:tt?.version,metadata:We.metadata})}else We._type===3?qe.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version}):We._type===5&&qe.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version,edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(ft.from)}});return qe}ie.from=pe;function se(B){const De=new S.WorkspaceEdit;for(const Se of B.edits)Se.edit?De.replace(T.URI.revive(Se.resource),m.to(Se.edit.range),Se.edit.text):De.renameFile(T.URI.revive(Se.oldUri),T.URI.revive(Se.newUri),Se.options);return De}ie.to=se})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var K;(function(ie){const pe=Object.create(null);pe[S.SymbolKind.File]=0,pe[S.SymbolKind.Module]=1,pe[S.SymbolKind.Namespace]=2,pe[S.SymbolKind.Package]=3,pe[S.SymbolKind.Class]=4,pe[S.SymbolKind.Method]=5,pe[S.SymbolKind.Property]=6,pe[S.SymbolKind.Field]=7,pe[S.SymbolKind.Constructor]=8,pe[S.SymbolKind.Enum]=9,pe[S.SymbolKind.Interface]=10,pe[S.SymbolKind.Function]=11,pe[S.SymbolKind.Variable]=12,pe[S.SymbolKind.Constant]=13,pe[S.SymbolKind.String]=14,pe[S.SymbolKind.Number]=15,pe[S.SymbolKind.Boolean]=16,pe[S.SymbolKind.Array]=17,pe[S.SymbolKind.Object]=18,pe[S.SymbolKind.Key]=19,pe[S.SymbolKind.Null]=20,pe[S.SymbolKind.EnumMember]=21,pe[S.SymbolKind.Struct]=22,pe[S.SymbolKind.Event]=23,pe[S.SymbolKind.Operator]=24,pe[S.SymbolKind.TypeParameter]=25;function se(De){return typeof pe[De]=="number"?pe[De]:6}ie.from=se;function B(De){for(const Se in pe)if(pe[Se]===De)return Number(Se);return S.SymbolKind.Property}ie.to=B})(K=e.SymbolKind||(e.SymbolKind={}));var W;(function(ie){function pe(B){switch(B){case S.SymbolTag.Deprecated:return 1}}ie.from=pe;function se(B){switch(B){case 1:return S.SymbolTag.Deprecated}}ie.to=se})(W=e.SymbolTag||(e.SymbolTag={}));var U;(function(ie){function pe(B){return{name:B.name,kind:K.from(B.kind),tags:B.tags&&B.tags.map(W.from),containerName:B.containerName,location:ue.from(B.location)}}ie.from=pe;function se(B){const De=new S.SymbolInformation(B.name,K.to(B.kind),B.containerName,ue.to(B.location));return De.tags=B.tags&&B.tags.map(W.to),De}ie.to=se})(U=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var z;(function(ie){function pe(B){const De={name:B.name||"!!MISSING: name!!",detail:B.detail,range:m.from(B.range),selectionRange:m.from(B.selectionRange),kind:K.from(B.kind),tags:B.tags?.map(W.from)??[]};return B.children&&(De.children=B.children.map(pe)),De}ie.from=pe;function se(B){const De=new S.DocumentSymbol(B.name,B.detail,K.to(B.kind),m.to(B.range),m.to(B.selectionRange));return(0,d.isNonEmptyArray)(B.tags)&&(De.tags=B.tags.map(W.to)),B.children&&(De.children=B.children.map(se)),De}ie.to=se})(z=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(ie){function pe(B){const De=new S.CallHierarchyItem(K.to(B.kind),B.name,B.detail||"",T.URI.revive(B.uri),m.to(B.range),m.to(B.selectionRange));return De._sessionId=B._sessionId,De._itemId=B._itemId,De}ie.to=pe;function se(B,De,Se){if(De=De??B._sessionId,Se=Se??B._itemId,De===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Se,name:B.name,detail:B.detail,kind:K.from(B.kind),uri:B.uri,range:m.from(B.range),selectionRange:m.from(B.selectionRange),tags:B.tags?.map(W.from)}}ie.from=se})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var re;(function(ie){function pe(se){return new S.CallHierarchyIncomingCall(Y.to(se.from),se.fromRanges.map(B=>m.to(B)))}ie.to=pe})(re=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var j;(function(ie){function pe(se){return new S.CallHierarchyOutgoingCall(Y.to(se.to),se.fromRanges.map(B=>m.to(B)))}ie.to=pe})(j=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ue;(function(ie){function pe(B){return{range:B.range&&m.from(B.range),uri:B.uri}}ie.from=pe;function se(B){return new S.Location(T.URI.revive(B.uri),m.to(B.range))}ie.to=se})(ue=e.location||(e.location={}));var oe;(function(ie){function pe(B){const De=B,Se=B;return{originSelectionRange:De.originSelectionRange?m.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Se.uri,range:m.from(De.targetRange?De.targetRange:Se.range),targetSelectionRange:De.targetSelectionRange?m.from(De.targetSelectionRange):void 0}}ie.from=pe;function se(B){return{targetUri:T.URI.revive(B.uri),targetRange:m.to(B.range),targetSelectionRange:B.targetSelectionRange?m.to(B.targetSelectionRange):void 0,originSelectionRange:B.originSelectionRange?m.to(B.originSelectionRange):void 0}}ie.to=se})(oe=e.DefinitionLink||(e.DefinitionLink={}));var ve;(function(ie){function pe(B){return{range:m.from(B.range),contents:P.fromMany(B.contents)}}ie.from=pe;function se(B){return new S.Hover(B.contents.map(P.to),m.to(B.range))}ie.to=se})(ve=e.Hover||(e.Hover={}));var Fe;(function(ie){function pe(B){return{range:m.from(B.range),expression:B.expression}}ie.from=pe;function se(B){return new S.EvaluatableExpression(m.to(B.range),B.expression)}ie.to=se})(Fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Me;(function(ie){function pe(B){if(B instanceof S.InlineValueText)return{type:"text",range:m.from(B.range),text:B.text};if(B instanceof S.InlineValueVariableLookup)return{type:"variable",range:m.from(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};if(B instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(B.range),expression:B.expression};throw new Error("Unknown 'InlineValue' type")}ie.from=pe;function se(B){switch(B.type){case"text":return{range:m.to(B.range),text:B.text};case"variable":return{range:m.to(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};case"expression":return{range:m.to(B.range),expression:B.expression}}}ie.to=se})(Me=e.InlineValue||(e.InlineValue={}));var Oe;(function(ie){function pe(B){return{frameId:B.frameId,stoppedLocation:m.from(B.stoppedLocation)}}ie.from=pe;function se(B){return new S.InlineValueContext(B.frameId,m.to(B.stoppedLocation))}ie.to=se})(Oe=e.InlineValueContext||(e.InlineValueContext={}));var Ye;(function(ie){function pe(B){return{range:m.from(B.range),kind:B.kind}}ie.from=pe;function se(B){return new S.DocumentHighlight(m.to(B.range),B.kind)}ie.to=se})(Ye=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(ie){function pe(se){switch(se){case 1:return S.CompletionTriggerKind.TriggerCharacter;case 2:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return S.CompletionTriggerKind.Invoke}}ie.to=pe})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(ie){function pe(se){return{triggerKind:ze.to(se.triggerKind),triggerCharacter:se.triggerCharacter}}ie.to=pe})(je=e.CompletionContext||(e.CompletionContext={}));var x;(function(ie){function pe(B){switch(B){case S.CompletionItemTag.Deprecated:return 1}}ie.from=pe;function se(B){switch(B){case 1:return S.CompletionItemTag.Deprecated}}ie.to=se})(x=e.CompletionItemTag||(e.CompletionItemTag={}));var Q;(function(ie){const pe=new Map([[S.CompletionItemKind.Method,0],[S.CompletionItemKind.Function,1],[S.CompletionItemKind.Constructor,2],[S.CompletionItemKind.Field,3],[S.CompletionItemKind.Variable,4],[S.CompletionItemKind.Class,5],[S.CompletionItemKind.Interface,7],[S.CompletionItemKind.Struct,6],[S.CompletionItemKind.Module,8],[S.CompletionItemKind.Property,9],[S.CompletionItemKind.Unit,12],[S.CompletionItemKind.Value,13],[S.CompletionItemKind.Constant,14],[S.CompletionItemKind.Enum,15],[S.CompletionItemKind.EnumMember,16],[S.CompletionItemKind.Keyword,17],[S.CompletionItemKind.Snippet,27],[S.CompletionItemKind.Text,18],[S.CompletionItemKind.Color,19],[S.CompletionItemKind.File,20],[S.CompletionItemKind.Reference,21],[S.CompletionItemKind.Folder,23],[S.CompletionItemKind.Event,10],[S.CompletionItemKind.Operator,11],[S.CompletionItemKind.TypeParameter,24],[S.CompletionItemKind.Issue,26],[S.CompletionItemKind.User,25]]);function se(Se){return pe.get(Se)??9}ie.from=se;const B=new Map([[0,S.CompletionItemKind.Method],[1,S.CompletionItemKind.Function],[2,S.CompletionItemKind.Constructor],[3,S.CompletionItemKind.Field],[4,S.CompletionItemKind.Variable],[5,S.CompletionItemKind.Class],[7,S.CompletionItemKind.Interface],[6,S.CompletionItemKind.Struct],[8,S.CompletionItemKind.Module],[9,S.CompletionItemKind.Property],[12,S.CompletionItemKind.Unit],[13,S.CompletionItemKind.Value],[14,S.CompletionItemKind.Constant],[15,S.CompletionItemKind.Enum],[16,S.CompletionItemKind.EnumMember],[17,S.CompletionItemKind.Keyword],[27,S.CompletionItemKind.Snippet],[18,S.CompletionItemKind.Text],[19,S.CompletionItemKind.Color],[20,S.CompletionItemKind.File],[21,S.CompletionItemKind.Reference],[23,S.CompletionItemKind.Folder],[10,S.CompletionItemKind.Event],[11,S.CompletionItemKind.Operator],[24,S.CompletionItemKind.TypeParameter],[25,S.CompletionItemKind.User],[26,S.CompletionItemKind.Issue]]);function De(Se){return B.get(Se)??S.CompletionItemKind.Property}ie.to=De})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ie){function pe(se,B){const De=new S.CompletionItem(se.label);return De.insertText=se.insertText,De.kind=Q.to(se.kind),De.tags=se.tags?.map(x.to),De.detail=se.detail,De.documentation=b.isMarkdownString(se.documentation)?P.to(se.documentation):se.documentation,De.sortText=se.sortText,De.filterText=se.filterText,De.preselect=se.preselect,De.commitCharacters=se.commitCharacters,t.Range.isIRange(se.range)?De.range=m.to(se.range):typeof se.range=="object"&&(De.range={inserting:m.to(se.range.insert),replacing:m.to(se.range.replace)}),De.keepWhitespace=typeof se.insertTextRules=="undefined"?!1:Boolean(se.insertTextRules&1),typeof se.insertTextRules!="undefined"&&se.insertTextRules&4?De.insertText=new S.SnippetString(se.insertText):(De.insertText=se.insertText,De.textEdit=De.range instanceof S.Range?new S.TextEdit(De.range,De.insertText):void 0),se.additionalTextEdits&&se.additionalTextEdits.length>0&&(De.additionalTextEdits=se.additionalTextEdits.map(Se=>G.to(Se))),De.command=B&&se.command?B.fromInternal(se.command):void 0,De}ie.to=pe})(ee=e.CompletionItem||(e.CompletionItem={}));var le;(function(ie){function pe(B){return{label:B.label,documentation:B.documentation?P.fromStrict(B.documentation):void 0}}ie.from=pe;function se(B){return{label:B.label,documentation:b.isMarkdownString(B.documentation)?P.to(B.documentation):B.documentation}}ie.to=se})(le=e.ParameterInformation||(e.ParameterInformation={}));var q;(function(ie){function pe(B){return{label:B.label,documentation:B.documentation?P.fromStrict(B.documentation):void 0,parameters:Array.isArray(B.parameters)?B.parameters.map(le.from):[],activeParameter:B.activeParameter}}ie.from=pe;function se(B){return{label:B.label,documentation:b.isMarkdownString(B.documentation)?P.to(B.documentation):B.documentation,parameters:Array.isArray(B.parameters)?B.parameters.map(le.to):[],activeParameter:B.activeParameter}}ie.to=se})(q=e.SignatureInformation||(e.SignatureInformation={}));var ae;(function(ie){function pe(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(q.from):[]}}ie.from=pe;function se(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(q.to):[]}}ie.to=se})(ae=e.SignatureHelp||(e.SignatureHelp={}));var he;(function(ie){function pe(B){return{text:B.text,position:i.from(B.position),kind:Te.from(B.kind??S.InlayHintKind.Other),whitespaceBefore:B.whitespaceBefore,whitespaceAfter:B.whitespaceAfter}}ie.from=pe;function se(B){const De=new S.InlayHint(B.text,i.to(B.position),Te.to(B.kind));return De.whitespaceAfter=B.whitespaceAfter,De.whitespaceBefore=B.whitespaceBefore,De}ie.to=se})(he=e.InlayHint||(e.InlayHint={}));var Te;(function(ie){function pe(B){return B}ie.from=pe;function se(B){return B}ie.to=se})(Te=e.InlayHintKind||(e.InlayHintKind={}));var Be;(function(ie){function pe(B){return{range:m.from(B.range),url:B.target,tooltip:B.tooltip}}ie.from=pe;function se(B){let De;if(B.url)try{De=typeof B.url=="string"?T.URI.parse(B.url,!0):T.URI.revive(B.url)}catch(Se){}return new S.DocumentLink(m.to(B.range),De)}ie.to=se})(Be=e.DocumentLink||(e.DocumentLink={}));var $e;(function(ie){function pe(B){const De=new S.ColorPresentation(B.label);return B.textEdit&&(De.textEdit=G.to(B.textEdit)),B.additionalTextEdits&&(De.additionalTextEdits=B.additionalTextEdits.map(Se=>G.to(Se))),De}ie.to=pe;function se(B){return{label:B.label,textEdit:B.textEdit?G.from(B.textEdit):void 0,additionalTextEdits:B.additionalTextEdits?B.additionalTextEdits.map(De=>G.from(De)):void 0}}ie.from=se})($e=e.ColorPresentation||(e.ColorPresentation={}));var Qe;(function(ie){function pe(B){return new S.Color(B[0],B[1],B[2],B[3])}ie.to=pe;function se(B){return[B.red,B.green,B.blue,B.alpha]}ie.from=se})(Qe=e.Color||(e.Color={}));var _e;(function(ie){function pe(B){return{range:m.from(B.range)}}ie.from=pe;function se(B){return new S.SelectionRange(m.to(B.range))}ie.to=se})(_e=e.SelectionRange||(e.SelectionRange={}));var rt;(function(ie){function pe(se){switch(se){case 2:return S.TextDocumentSaveReason.AfterDelay;case 1:return S.TextDocumentSaveReason.Manual;case 3:case 4:return S.TextDocumentSaveReason.FocusOut}}ie.to=pe})(rt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var H;(function(ie){function pe(B){switch(B){case S.TextEditorLineNumbersStyle.Off:return 0;case S.TextEditorLineNumbersStyle.Relative:return 2;case S.TextEditorLineNumbersStyle.On:default:return 1}}ie.from=pe;function se(B){switch(B){case 0:return S.TextEditorLineNumbersStyle.Off;case 2:return S.TextEditorLineNumbersStyle.Relative;case 1:default:return S.TextEditorLineNumbersStyle.On}}ie.to=se})(H=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(ie){function pe(B){if(B===S.EndOfLine.CRLF)return 1;if(B===S.EndOfLine.LF)return 0}ie.from=pe;function se(B){if(B===1)return S.EndOfLine.CRLF;if(B===0)return S.EndOfLine.LF}ie.to=se})(J=e.EndOfLine||(e.EndOfLine={}));var me;(function(ie){function pe(se){if(typeof se=="object")return se.viewId;switch(se){case S.ProgressLocation.SourceControl:return 3;case S.ProgressLocation.Window:return 10;case S.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ie.from=pe})(me=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(ie){function pe(se){const B={start:se.start+1,end:se.end+1};return se.kind&&(B.kind=Ke.from(se.kind)),B}ie.from=pe})(Ne=e.FoldingRange||(e.FoldingRange={}));var Ke;(function(ie){function pe(se){if(se)switch(se){case S.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}ie.from=pe})(Ke=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ot;(function(ie){function pe(se){if(se)return{pinned:typeof se.preview=="boolean"?!se.preview:void 0,inactive:se.background,preserveFocus:se.preserveFocus,selection:typeof se.selection=="object"?m.from(se.selection):void 0,override:typeof se.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ie.from=pe})(ot=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var at;(function(ie){function pe(B){return B instanceof S.RelativePattern||typeof B=="string"?B:se(B)?new S.RelativePattern(B.base,B.pattern):B}ie.from=pe;function se(B){const De=B;return De&&typeof De.base=="string"&&typeof De.pattern=="string"}})(at=e.GlobPattern||(e.GlobPattern={}));var vt;(function(ie){function pe(se){if(se){if(Array.isArray(se))return se.map(pe);if(typeof se=="string")return se;{const B=se;return{language:B.language,scheme:B.scheme,pattern:typeof B.pattern=="undefined"?void 0:at.from(B.pattern),exclusive:B.exclusive}}}else return}ie.from=pe})(vt=e.LanguageSelector||(e.LanguageSelector={}));var kt;(function(ie){function pe(B){return{start:B.start,end:B.end}}ie.from=pe;function se(B){return new S.NotebookRange(B.start,B.end)}ie.to=se})(kt=e.NotebookRange||(e.NotebookRange={}));var ht;(function(ie){function pe(B){return{timing:typeof B.runStartTime=="number"&&typeof B.runEndTime=="number"?{startTime:B.runStartTime,endTime:B.runEndTime}:void 0,executionOrder:B.executionOrder,success:B.lastRunSuccess}}ie.to=pe;function se(B){return{lastRunSuccess:B.success,runStartTime:B.timing?.startTime,runEndTime:B.timing?.endTime,executionOrder:B.executionOrder}}ie.from=se})(ht=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var yt;(function(ie){function pe(B){switch(B){case S.NotebookCellKind.Markup:return a.CellKind.Markup;case S.NotebookCellKind.Code:default:return a.CellKind.Code}}ie.from=pe;function se(B){switch(B){case a.CellKind.Markup:return S.NotebookCellKind.Markup;case a.CellKind.Code:default:return S.NotebookCellKind.Code}}ie.to=se})(yt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(ie){function pe(B){const De={metadata:B.metadata??Object.create(null),cells:[]};for(let Se of B.cells)S.NotebookCellData.validate(Se),De.cells.push(ft.from(Se));return De}ie.from=pe;function se(B){const De=new S.NotebookData(B.cells.map(ft.to));return(0,_.isEmptyObject)(B.metadata)||(De.metadata=B.metadata),De}ie.to=se})(It=e.NotebookData||(e.NotebookData={}));var ft;(function(ie){function pe(B){return{cellKind:yt.from(B.kind),language:B.languageId,mime:B.mime,source:B.value,metadata:B.metadata,internalMetadata:ht.from(B.executionSummary??{}),outputs:B.outputs?B.outputs.map(Et.from):[]}}ie.from=pe;function se(B){return new S.NotebookCellData(yt.to(B.cellKind),B.source,B.language,B.mime,B.outputs?B.outputs.map(Et.to):void 0,B.metadata,B.internalMetadata?ht.to(B.internalMetadata):void 0)}ie.to=se})(ft=e.NotebookCellData||(e.NotebookCellData={}));var Je;(function(ie){function pe(B){return{mime:B.mime,valueBytes:M.VSBuffer.wrap(B.data)}}ie.from=pe;function se(B){return new S.NotebookCellOutputItem(B.valueBytes.buffer,B.mime)}ie.to=se})(Je=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Et;(function(ie){function pe(B){return{outputId:B.id,items:B.items.map(Je.from),metadata:B.metadata}}ie.from=pe;function se(B){const De=B.items.map(Je.to);return new S.NotebookCellOutput(De,B.outputId,B.metadata)}ie.to=se})(Et=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(ie){function pe(Se){if(Se!=null){if(Se instanceof S.RelativePattern||typeof Se=="string")return Se;if(De(Se))return new S.RelativePattern(Se.base,Se.pattern);if(B(Se))return{include:at.from(Se.include)||void 0,exclude:at.from(Se.exclude)||void 0}}}ie.from=pe;function se(Se){return typeof Se=="string"?Se:De(Se)?{base:Se.base,pattern:Se.pattern}:{include:Se.include,exclude:Se.exclude}}ie.to=se;function B(Se){const qe=Se,We=at.from(qe.include);if(!(We&&We instanceof S.RelativePattern||typeof We=="string"))return!1;const tt=at.from(qe.exclude);return!!(tt&&tt instanceof S.RelativePattern||typeof tt=="string")}function De(Se){const qe=Se;return qe&&typeof qe.base=="string"&&typeof qe.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(ie){function pe(se){return{backgroundColor:se.backgroundColor,borderColor:se.borderColor,top:se.top?f.from(se.top):void 0}}ie.from=pe})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ce;(function(ie){function pe(se,B,De){const Se=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{alignment:se.alignment===S.NotebookCellStatusBarAlignment.Left?1:2,command:B.toInternal(Se,De),text:se.text,tooltip:se.tooltip,accessibilityInformation:se.accessibilityInformation,priority:se.priority}}ie.from=pe})(Ce=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Z;(function(ie){function pe(se){return{transientOutputs:se?.transientOutputs??!1,transientCellMetadata:se?.transientCellMetadata??{},transientDocumentMetadata:se?.transientDocumentMetadata??{}}}ie.from=pe})(Z=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ce;(function(ie){function pe(B){return{uri:B.uri,provides:B.provides}}ie.from=pe;function se(B){return new S.NotebookRendererScript(T.URI.revive(B.uri),B.provides)}ie.to=se})(ce=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ge;(function(ie){function pe(B){return{message:P.fromStrict(B.message)||"",type:0,expected:B.expectedOutput,actual:B.actualOutput,location:B.location?ue.from(B.location):void 0}}ie.from=pe;function se(B){const De=new S.TestMessage(typeof B.message=="string"?B.message:P.to(B.message));return De.actualOutput=B.actual,De.expectedOutput=B.expected,De.location=B.location?ue.to(B.location):void 0,De}ie.to=se})(ge=e.TestMessage||(e.TestMessage={}));var fe;(function(ie){let pe;(function(se){se.Delimiter="\0"})(pe||(pe={})),ie.namespace=(se,B)=>se+"\0"+B,ie.denamespace=se=>{const B=se.indexOf("\0");return{ctrlId:se.slice(0,B),tagId:se.slice(B+1)}}})(fe=e.TestTag||(e.TestTag={}));var Ie;(function(ie){function pe(Se){const qe=(0,l.getPrivateApiFor)(Se).controllerId;return{extId:w.TestId.fromExtHostTestItem(Se,qe).toString(),label:Se.label,uri:Se.uri,tags:Se.tags.map(We=>fe.namespace(qe,We.id)),range:m.from(Se.range)||null,description:Se.description||null,error:Se.error&&P.fromStrict(Se.error)||null}}ie.from=pe;function se(Se){return{id:w.TestId.fromString(Se.extId).localId,label:Se.label,uri:T.URI.revive(Se.uri),tags:(Se.tags||[]).map(qe=>{const{tagId:We}=fe.denamespace(qe);return new S.TestTag(We)}),range:m.to(Se.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Se.description||void 0}}ie.toPlain=se;function B(Se){const qe=w.TestId.fromString(Se.extId),We=new l.TestItemImpl(qe.controllerId,qe.localId,Se.label,T.URI.revive(Se.uri));return We.range=m.to(Se.range||void 0),We.description=Se.description||void 0,We}function De(Se){let qe;for(const We of Se.tests){const tt=B(We.item);(0,l.getPrivateApiFor)(tt).parent=qe,qe=tt}return qe}ie.toItemFromContext=De})(Ie=e.TestItem||(e.TestItem={})),function(ie){function pe(B){return{id:B.id}}ie.from=pe;function se(B){return new S.TestTag(B.id)}ie.to=se}(fe=e.TestTag||(e.TestTag={}));var xe;(function(ie){const pe=(B,De)=>{const Se={...Ie.toPlain(B.item),parent:void 0,taskStates:B.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(We=>We.type===0).map(ge.to)})),children:B.children.map(qe=>De.get(qe)).filter(_.isDefined).map(qe=>pe(qe,De))};for(const qe of Se.children)qe.parent=Se;return Se};function se(B){const De=[],Se=new Map;for(const qe of B.items)Se.set(qe.item.extId,qe),B.request.targets.some(We=>We.controllerId===qe.controllerId&&We.testIds.includes(qe.item.extId))&&De.push(qe);return{completedAt:B.completedAt,results:De.map(qe=>pe(qe,Se))}}ie.to=se})(xe=e.TestResults||(e.TestResults={}));var Le;(function(ie){function pe(Se){return{covered:Se.covered,total:Se.covered}}function se(Se){return"line"in Se?i.from(Se):m.from(Se)}function B(Se){return"branches"in Se?{count:Se.executionCount,location:se(Se.location),type:1,branches:Se.branches.length?Se.branches.map(qe=>({count:qe.executionCount,location:qe.location&&se(qe.location)})):void 0}:{type:0,count:Se.executionCount,location:se(Se.location)}}ie.fromDetailed=B;function De(Se){return{uri:Se.uri,statement:pe(Se.statementCoverage),branch:Se.branchCoverage&&pe(Se.branchCoverage),function:Se.functionCoverage&&pe(Se.functionCoverage),details:Se.detailedCoverage?.map(B)}}ie.fromFile=De})(Le=e.TestCoverage||(e.TestCoverage={}));var Ve;(function(ie){function pe(se){switch(se){case 1:return S.CodeActionTriggerKind.Invoke;case 2:return S.CodeActionTriggerKind.Automatic}}ie.to=pe})(Ve=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ze;(function(ie){function pe(B){const De=new S.TypeHierarchyItem(K.to(B.kind),B.name,B.detail||"",T.URI.revive(B.uri),m.to(B.range),m.to(B.selectionRange));return De._sessionId=B._sessionId,De._itemId=B._itemId,De}ie.to=pe;function se(B,De,Se){if(De=De??B._sessionId,Se=Se??B._itemId,De===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Se,kind:K.from(B.kind),name:B.name,detail:B.detail??"",uri:B.uri,range:m.from(B.range),selectionRange:m.from(B.selectionRange),tags:B.tags?.map(W.from)}}ie.from=se})(Ze=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[169],be([0,1,2,16,7,8,230]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(T,t,E,n={timeout:1500,errors:3}){this._logService=T,this._documents=t,this._mainThreadBulkEdits=E,this._thresholds=n,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(t,E,n)=>{const l={dispose:this._callbacks.push([t,E,T])};return Array.isArray(n)&&n.push(l),l}}async $participateInSave(T,t){const E=d.URI.revive(T);let n=!1;const u=setTimeout(()=>n=!0,this._thresholds.timeout),l=[];try{for(let a of[...this._callbacks]){if(n)break;const w=this._documents.getDocument(E),I=await this._deliverEventAsyncAndBlameBadListeners(a,{document:w,reason:R.TextDocumentSaveReason.to(t)});l.push(I)}}finally{clearTimeout(u)}return l}_deliverEventAsyncAndBlameBadListeners([T,t,E],n){const u=this._badListeners.get(T);return typeof u=="number"&&u>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(E,T,t,n).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const a=this._badListeners.get(T);this._badListeners.set(T,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,t,E,n){const u=[],l=Date.now(),{document:a,reason:w}=n,{version:I}=a,S=Object.freeze({document:a,reason:w,waitUntil(o){if(Object.isFrozen(u))throw(0,M.illegalState)("waitUntil can not be called async");u.push(Promise.resolve(o))}});try{t.apply(E,[S])}catch(o){return Promise.reject(o)}return Object.freeze(u),new Promise((o,m)=>{const y=setTimeout(()=>m(new Error("timeout")),this._thresholds.timeout);return Promise.all(u).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(y),o(i)}).catch(i=>{clearTimeout(y),m(i)})}).then(o=>{const m={edits:[]};for(const y of o)if(Array.isArray(y)&&y.every(i=>i instanceof b.TextEdit))for(const{newText:i,newEol:v,range:r}of y)m.edits.push({_type:2,resource:a.uri,edit:{range:r&&R.Range.from(r),text:i,eol:v&&R.EndOfLine.from(v)}});if(m.edits.length!==0)return I===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(we[68],be([0,1,8,2,3,4]),function(ne,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");class F{constructor(){this._onDidChangeTabs=new b.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new b.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let T=-1;this._tabs=_.map((E,n)=>(E.isActive&&(T=n),Object.freeze({label:E.label,viewColumn:d.ViewColumn.to(E.viewColumn),resource:M.URI.revive(E.resource),viewId:E.editorId,isActive:E.isActive})));const t=this._activeTab;this._activeTab=T===-1?void 0:this._tabs[T],this._activeTab!==t&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=F}),define(we[170],be([0,1,3,27,2,8,7]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(t,E,n,u,l){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter,this._config=0,n&&(this._config+=1),u&&(this._config+=2),l&&(this._config+=4);const a=(0,M.parse)(E),w=t(I=>{if(!n)for(let S of I.created){const o=b.URI.revive(S);a(o.fsPath)&&this._onDidCreate.fire(o)}if(!u)for(let S of I.changed){const o=b.URI.revive(S);a(o.fsPath)&&this._onDidChange.fire(o)}if(!l)for(let S of I.deleted){const o=b.URI.revive(S);a(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(t,E,n){this._logService=E,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,E,n,u){return new C(this._onFileSystemEvent.event,t,E,n,u)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,E){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(n=>({oldUri:b.URI.revive(n.source),newUri:b.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(n=>b.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:E.map(n=>b.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,E){return(n,u,l)=>{const a=function(I){n.call(u,I)};return a.extension=t,E.event(a,void 0,l)}}async $onWillRunFileOperation(t,E,n,u){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(l=>({oldUri:b.URI.revive(l.source),newUri:b.URI.revive(l.target)}))},n,u);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(l=>b.URI.revive(l.target))},n,u);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(l=>b.URI.revive(l.target))},n,u)}}async _fireWillEvent(t,E,n,u){const l=new Set,a=[];if(await t.fireAsync(E,u,async(I,S)=>{const o=Date.now(),m=await Promise.resolve(I);m instanceof F.WorkspaceEdit&&(a.push(m),l.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-o>n&&this._logService.warn("SLOW file-participant",S.extension.identifier)}),u.isCancellationRequested||a.length===0)return;const w={edits:[]};for(let I of a){let{edits:S}=R.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(S)}return{edit:w,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=_}),define(we[171],be([0,1,11,23,2,8,7,89]),function(ne,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(n,u,l,a){this.start=n,this.deletedCount=u,this.deletedItems=l,this.items=a}static asApiEvents(n){return n.map(u=>({start:u.start,deletedCount:u.deletedCount,deletedItems:u.deletedItems,items:u.items.map(l=>l.apiCell)}))}}class T{constructor(n,u,l){this.notebook=n,this._extHostDocument=u,this._cellData=l,this.handle=l.handle,this.uri=b.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(R.NotebookCellOutput.to),this._internalMetadata=l.internalMetadata??{},this._metadata=Object.freeze(l.metadata??{}),this._previousResult=Object.freeze(R.NotebookCellExecutionSummary.to(l.internalMetadata??{}))}static asModelAddData(n,u){return{EOL:u.eol,lines:u.source,modeId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,u=this._extHostDocument.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:R.NotebookCellKind.to(this._cellData.cellKind),document:u.document,get mime(){return n._mime},set mime(l){n._mime=l},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(R.NotebookCellOutput.to)}setOutputItems(n,u,l){const a=l.map(R.NotebookCellOutputItem.to),w=this._outputs.find(I=>I.id===n);w&&(u||(w.items.length=0),w.items.push(...a))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(R.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=T;class t{constructor(n,u,l,a,w,I){this._proxy=n,this._textDocumentsAndEditors=u,this._textDocuments=l,this._emitter=a,this.uri=w,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=I.viewType,this._metadata=Object.freeze(I.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,I.cells]],!0),this._versionId=I.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===d.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(u){return u=n._validateIndex(u),n._cells[u].apiCell},getCells(u){return(u?n._getCells(u):n._cells).map(a=>a.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,u){this._versionId=n.versionId,this._isDirty=u;for(const l of n.rawEvents)l.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===C.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(l.index,l.metadata):l.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(l.index,l.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let u=n.start|0,l=n.end|0;return u<0&&(u=0),l>this._cells.length&&(l=this._cells.length),n.with({start:u,end:l})}_getCells(n){n=this._validateRange(n);const u=[];for(let l=n.start;l<n.end;l++)u.push(this._cells[l]);return u}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,u){if(this._disposed)return;const l=[],a=[],w=[];n.reverse().forEach(I=>{const o=I[2].map(i=>{const v=new T(this,this._textDocumentsAndEditors,i);return u||a.push(T.asModelAddData(this.apiNotebook,i)),v}),m=new _(I[0],I[1],[],o),y=this._cells.splice(I[0],I[1],...o);for(const i of y)w.push(i.uri),m.deletedItems.push(i.apiCell);l.push(m)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:w}),u||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(l)}))}_moveCell(n,u){const l=this._cells.splice(n,1);this._cells.splice(u,0,...l);const a=[new _(n,1,l.map(w=>w.apiCell),[]),new _(u,0,[],l)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(a)}))}_setCellOutputs(n,u){const l=this._cells[n];l.setOutputs(u),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[l.apiCell]}))}_setCellOutputItems(n,u,l,a){const w=this._cells[n];w.setOutputItems(u,l,a),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(n,u){const l=this._cells[n];l.apiCell.document.languageId!==u&&this._textDocuments.$acceptModelModeChanged(l.uri,u)}_changeCellMime(n,u){const l=this._cells[n];l.apiCell.mime=u}_changeCellMetadata(n,u){const l=this._cells[n],a=l.apiCell.metadata;l.setMetadata(u);const w=l.apiCell.metadata;(0,M.equals)(a,w)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:l.apiCell}))}_changeCellInternalMetadata(n,u){const l=this._cells[n],a=l.internalMetadata;if(l.setInternalMetadata(u),a.runState!==u.runState){const w=u.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:l.apiCell,state:w}))}}getCellFromApiCell(n){return this._cells.find(u=>u.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(u=>u.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(we[93],be([0,1,7,8,16]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:T})}replaceCells(_,T,t){this._throwIfFinalized(),!(_===T&&t.length===0)&&this._collectedEdits.push({editType:1,index:_,count:T-_,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(_,T,t,E,n,u){this.id=_,this._proxy=T,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=E,this._viewColumn=u}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(T){if(!Array.isArray(T)||!T.every(d.NotebookRange.isNotebookRange))throw(0,b.illegalArgument)("selections");_._selections=T,_._trySetSelections(T)},get visibleRanges(){return _._visibleRanges},revealRange(T,t){_._proxy.$tryRevealRange(_.id,M.NotebookRange.from(T),t??d.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(T){const t=new R(this.document.version);return T(t),_._applyEdit(t.finalize())},setDecorations(T,t){return _.setDecorations(T,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(M.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const T=[];let t=-1;for(let E=0;E<_.cellEdits.length;E++){if(t<0){T.push(_.cellEdits[E]),t++;continue}const u=T[t],l=_.cellEdits[E];if(u.editType===1&&l.editType===1&&u.index===l.index){u.cells.push(..._.cellEdits[E].cells),u.count+=_.cellEdits[E].count;continue}T.push(_.cellEdits[E]),t++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,T)}setDecorations(_,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return T.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(T),_.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(we[172],be([0,1,8,147,126,21,52]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(E){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=E}withProgress(E,n,u){const l=this._handles++,{title:a,location:w,cancellable:I}=n,S={label:(0,b.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this._proxy.$startProgress(l,{location:d.ProgressLocation.from(w),title:a,source:S,cancellable:I},E),this._withProgress(l,u,!!I)}_withProgress(E,n,u){let l;u&&(l=new R.CancellationTokenSource,this._mapHandleToCancellationSource.set(E,l));const a=I=>{this._proxy.$progressEnd(I),this._mapHandleToCancellationSource.delete(I),l&&l.dispose()};let w;try{w=n(new T(this._proxy,E),u&&l?l.token:R.CancellationToken.None)}catch(I){throw a(E),I}return w.then(I=>a(E),I=>a(E)),w}$acceptProgressCanceled(E){const n=this._mapHandleToCancellationSource.get(E);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(E))}}e.ExtHostProgress=C;function _(t,E){return t.message=E.message,typeof E.increment=="number"&&(typeof t.increment=="number"?t.increment+=E.increment:t.increment=E.increment),t}class T extends M.Progress{constructor(E,n){super(u=>this.throttledReport(u));this._proxy=E,this._handle=n}throttledReport(E){this._proxy.$progressReport(this._handle,E)}}Ue([(0,F.throttle)(100,(t,E)=>_(t,E),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(we[94],be([0,1,42,16,53,8,7]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(n,u,l){const a=C._Keys.nextId();n.$registerTextEditorDecorationType(u.identifier,a,R.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:a,dispose(){n.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=C,C._Keys=new b.IdGenerator("TextEditorDecorationType");class _{constructor(n,u){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=u.undoStopBefore,this._undoStopAfter=u.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,u){this._throwIfFinalized();let l=null;if(n instanceof F.Position)l=new F.Range(n,n);else if(n instanceof F.Range)l=n;else throw new Error("Unrecognized location");this._pushEdit(l,u,!1)}insert(n,u){this._throwIfFinalized(),this._pushEdit(new F.Range(n,n),u,!0)}delete(n){this._throwIfFinalized();let u=null;if(n instanceof F.Range)u=n;else throw new Error("Unrecognized location");this._pushEdit(u,null,!0)}_pushEdit(n,u,l){const a=this._document.validateRange(n);this._collectedEdits.push({range:a,text:u,forceMoveMarkers:l})}setEndOfLine(n){if(this._throwIfFinalized(),n!==F.EndOfLine.LF&&n!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=_;class T{constructor(n,u,l,a){this._proxy=n,this._id=u,this._accept(l),this._logService=a;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(I){w._setTabSize(I)},get insertSpaces(){return w._insertSpaces},set insertSpaces(I){w._setInsertSpaces(I)},get cursorStyle(){return w._cursorStyle},set cursorStyle(I){w._setCursorStyle(I)},get lineNumbers(){return w._lineNumbers},set lineNumbers(I){w._setLineNumbers(I)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=R.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const u=Math.floor(n);return u>0?u:null}if(typeof n=="string"){const u=parseInt(n,10);return isNaN(u)?null:u>0?u:null}return null}_setTabSize(n){const u=this._validateTabSize(n);if(u!==null){if(typeof u=="number"){if(this._tabSize===u)return;this._tabSize=u}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:u}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const u=this._validateInsertSpaces(n);if(typeof u=="boolean"){if(this._insertSpaces===u)return;this._insertSpaces=u}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:u}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:R.TextEditorLineNumbersStyle.from(n)})))}assign(n){const u={};let l=!1;if(typeof n.tabSize!="undefined"){const a=this._validateTabSize(n.tabSize);a==="auto"?(l=!0,u.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,l=!0,u.tabSize=a)}if(typeof n.insertSpaces!="undefined"){const a=this._validateInsertSpaces(n.insertSpaces);a==="auto"?(l=!0,u.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,l=!0,u.insertSpaces=a)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,l=!0,u.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,l=!0,u.lineNumbers=R.TextEditorLineNumbersStyle.from(n.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,u))}_warnOnError(n){n.catch(u=>this._logService.warn(u))}}e.ExtHostTextEditorOptions=T;class t{constructor(n,u,l,a,w,I,S,o){this.id=n,this._proxy=u,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new T(this._proxy,this.id,I,l),this._visibleRanges=S,this._viewColumn=o;const m=this;this.value=Object.freeze({get document(){return a.getValue()},set document(y){throw(0,M.readonly)("document")},get selection(){return m._selections&&m._selections[0]},set selection(y){if(!(y instanceof F.Selection))throw(0,M.illegalArgument)("selection");m._selections=[y],m._trySetSelection()},get selections(){return m._selections},set selections(y){if(!Array.isArray(y)||y.some(i=>!(i instanceof F.Selection)))throw(0,M.illegalArgument)("selections");m._selections=y,m._trySetSelection()},get visibleRanges(){return m._visibleRanges},set visibleRanges(y){throw(0,M.readonly)("visibleRanges")},get options(){return m._options.value},set options(y){m._disposed||m._options.assign(y)},get viewColumn(){return m._viewColumn},set viewColumn(y){throw(0,M.readonly)("viewColumn")},edit(y,i={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new _(a.getValue(),i);return y(v),m._applyEdit(v)},insertSnippet(y,i,v={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=m._selections.map(s=>R.Range.from(s));else if(i instanceof F.Position){const{lineNumber:s,column:c}=R.Position.from(i);r=[{startLineNumber:s,startColumn:c,endLineNumber:s,endColumn:c}]}else if(i instanceof F.Range)r=[R.Range.from(i)];else{r=[];for(const s of i)if(s instanceof F.Range)r.push(R.Range.from(s));else{const{lineNumber:c,column:h}=R.Position.from(s);r.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return u.$tryInsertSnippet(n,y.value,r,v)},setDecorations(y,i){const v=i.length===0;v&&!m._hasDecorationsForKey.has(y.key)||(v?m._hasDecorationsForKey.delete(y.key):m._hasDecorationsForKey.add(y.key),m._runOnProxy(()=>{if(R.isDecorationOptionsArr(i))return u.$trySetDecorations(n,y.key,R.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let s=0,c=i.length;s<c;s++){const h=i[s];r[4*s]=h.start.line+1,r[4*s+1]=h.start.character+1,r[4*s+2]=h.end.line+1,r[4*s+3]=h.end.character+1}return u.$trySetDecorationsFast(n,y.key,r)}}))},revealRange(y,i){m._runOnProxy(()=>u.$tryRevealRange(n,R.Range.from(y),i||F.TextEditorRevealType.Default))},show(y){u.$tryShowEditor(n,R.ViewColumn.from(y))},hide(){u.$tryHideEditor(n)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,d.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,d.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,d.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,d.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(R.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const u=n.finalize();if(u.edits.length===0&&!u.setEndOfLine)return Promise.resolve(!0);const l=u.edits.map(w=>w.range);l.sort((w,I)=>w.end.line===I.end.line?w.end.character===I.end.character?w.start.line===I.start.line?w.start.character-I.start.character:w.start.line-I.start.line:w.end.character-I.end.character:w.end.line-I.end.line);for(let w=0,I=l.length-1;w<I;w++){const S=l[w].end;if(l[w+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=u.edits.map(w=>({range:R.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,u.documentVersionId,a,{setEndOfLine:typeof u.setEndOfLine=="number"?R.EndOfLine.from(u.setEndOfLine):void 0,undoStopBefore:u.undoStopBefore,undoStopAfter:u.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,u=>(u instanceof Error&&u.name==="DISPOSED"||this._logService.warn(u),null))}}e.ExtHostTextEditor=t}),define(we[173],be([0,1,129,24,2,3,6,161,14,7,10,13,8,21,158]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(S,o){if((0,t.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let m;return Array.isArray(S.highlights)&&(m=S.highlights.filter(y=>y.length===2&&typeof y[0]=="number"&&typeof y[1]=="number"),m=m.length?m:void 0),{label:S.label,highlights:m}}}class w{constructor(o,m,y){this._proxy=o,this.commands=m,this.logService=y,this.treeViews=new Map;function i(v){return v&&v.$treeViewId&&v.$treeItemHandle}m.registerArgumentProcessor({processArgument:v=>i(v)?this.convertArgument(v):Array.isArray(v)&&v.length>0?v.map(r=>i(r)?this.convertArgument(r):r):v})}registerTreeDataProvider(o,m,y){const i=this.createTreeView(o,{treeDataProvider:m},y);return{dispose:()=>i.dispose()}}createTreeView(o,m,y){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=m.dragAndDropController!==void 0,v=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,canDragAndDrop:i}),r=this.createExtHostTreeView(o,m,y);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(s){r.message=s},get title(){return r.title},set title(s){r.title=s},get description(){return r.description},set description(s){r.description=s},reveal:(s,c)=>r.reveal(s,c),dispose:async()=>{await v,this.treeViews.delete(o),r.dispose()}}}$getChildren(o,m){const y=this.treeViews.get(o);return y?y.getChildren(m):Promise.reject(new Error((0,d.localize)(0,null,o)))}async $onDrop(o,m,y){const i=this.treeViews.get(o);if(!i)return Promise.reject(new Error((0,d.localize)(1,null,o)));const v=l.TreeDataTransferConverter.toITreeDataTransfer(m);if(v.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const s=JSON.parse(await v.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(c=>i.getExtensionElement(c)).filter(c=>!!c);s.length>0?v.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(s)}):v.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(v,y)}async $hasResolve(o){const m=this.treeViews.get(o);if(!m)throw new Error((0,d.localize)(2,null,o));return m.hasResolve}$resolve(o,m,y){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(3,null,o));return i.resolveTreeItem(m,y)}$setExpanded(o,m,y){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(4,null,o));i.setExpanded(m,y)}$setSelection(o,m){const y=this.treeViews.get(o);if(!y)throw new Error((0,d.localize)(5,null,o));y.setSelection(m)}$setVisible(o,m){const y=this.treeViews.get(o);if(!y)throw new Error((0,d.localize)(6,null,o));y.setVisible(m)}createExtHostTreeView(o,m,y){const i=new I(o,m,this._proxy,this.commands.converter,this.logService,y);return this.treeViews.set(o,i),i}convertArgument(o){const m=this.treeViews.get(o.$treeViewId);return m?m.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=w;class I extends F.Disposable{constructor(o,m,y,i,v,r){super();if(this.viewId=o,this.proxy=y,this.commands=i,this.logService=v,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new R.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new R.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new R.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new R.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new R.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new u.CancellationTokenSource,r.contributes&&r.contributes.views)for(const h in r.contributes.views)for(const g of r.contributes.views[h])g.id===o&&(this._title=g.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(h=>this._onDidChangeData.fire({message:!1,element:h}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let s,c;this._register(R.Event.debounce(this._onDidChangeData.event,(h,g)=>(h||(h={message:!1,elements:[]}),g.element!==!1&&(s||(s=new Promise(k=>c=k),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(g.element)?h.elements.push(...g.element):h.elements.push(g.element)),g.message&&(h.message=!0),h),200,!0)(({message:h,elements:g})=>{g.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const k=c;return s=null,this.refresh(g).then(()=>k())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,t.isUndefinedOrNull)(o))}async getChildren(o){const m=o?this.getExtensionElement(o):void 0;if(o&&!m)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let y=this.getChildrenNodes(o);return y||(y=await this.fetchChildrenNodes(m)),y?y.map(i=>i.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,m){m=m||{select:!0,focus:!1};const y=(0,t.isUndefinedOrNull)(m.select)?!0:m.select,i=(0,t.isUndefinedOrNull)(m.focus)?!1:m.focus,v=(0,t.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(r=>this.resolveTreeNode(o,r[r.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:r.map(c=>c.item)},{select:y,focus:i,expand:v})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:y,focus:i,expand:v})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,m){const y=this.getExtensionElement(o);y&&(m?this._onDidExpandElement.fire(Object.freeze({element:y})):this._onDidCollapseElement.fire(Object.freeze({element:y})))}setSelection(o){(0,E.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,m){const y=this.getExtensionElement(m);if(!!y)return(0,_.asPromise)(()=>this.dndController?.onDrop(o,y))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,m){if(!this.dataProvider.resolveTreeItem)return;const y=this.elements.get(o);if(y){const i=this.nodes.get(y);if(i){const v=await this.dataProvider.resolveTreeItem(i.extensionItem,y,m)??i.extensionItem;return i.item.tooltip=this.getTooltip(v.tooltip),i.item.command=this.getCommand(i.disposableStore,v.command),i.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(m=>m?this.resolveUnknownParentChain(m).then(y=>this.resolveTreeNode(m,y[y.length-1]).then(i=>(y.push(i),y))):Promise.resolve([]))}resolveParent(o){const m=this.nodes.get(o);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,_.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,m){const y=this.nodes.get(o);return y?Promise.resolve(y):(0,_.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(i=>this.createHandle(o,i,m,!0)).then(i=>this.getChildren(m?m.item.handle:void 0).then(()=>{const v=this.getExtensionElement(i);if(v){const r=this.nodes.get(v);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(o){if(o){let m;if(typeof o=="string"){const y=this.getExtensionElement(o);m=y?this.nodes.get(y):void 0}else m=o;return m&&m.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const m=new u.CancellationTokenSource(this._refreshCancellationSource.token);try{const y=o?this.nodes.get(o):void 0,i=await this.dataProvider.getChildren(o);if(m.token.isCancellationRequested)return;const v=await Promise.all((0,E.coalesce)(i||[]).map(async r=>{const s=await this.dataProvider.getTreeItem(r);return s&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(r,s,y):null}));return m.token.isCancellationRequested?void 0:(0,E.coalesce)(v)}finally{m.dispose()}}refresh(o){if(o.some(y=>!y))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new u.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const y=this.getHandlesToRefresh(o);if(y.length)return this.refreshHandles(y)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const m=new Set,y=o.map(v=>this.nodes.get(v));for(const v of y)if(v&&!m.has(v.item.handle)){let r=v;for(;r&&r.parent&&y.findIndex(s=>r&&r.parent&&s&&s.item.handle===r.parent.item.handle)===-1;){const s=this.elements.get(r.parent.item.handle);r=s?this.nodes.get(s):void 0}r&&!r.parent&&m.add(v.item.handle)}const i=[];return m.forEach(v=>{const r=this.elements.get(v);if(r){const s=this.nodes.get(r);s&&(!s.parent||!m.has(s.parent.item.handle))&&i.push(v)}}),i}refreshHandles(o){const m={};return Promise.all(o.map(y=>this.refreshNode(y).then(i=>{i&&(m[y]=i.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(o){const m=this.getExtensionElement(o);if(m){const y=this.nodes.get(m);if(y)return this.clearChildren(m),(0,_.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(i=>{if(i){const v=this.createTreeNode(m,i,y.parent);return this.updateNodeCache(m,v,y,y.parent),y.dispose(),v}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,m,y){const i=this.createTreeNode(o,m,y);if(m.id&&this.elements.has(i.item.handle))throw new Error((0,d.localize)(7,null,m.id));return this.addNodeToCache(o,i),this.addNodeToParentCache(i,y),i}getTooltip(o){return T.MarkdownString.isMarkdownString(o)?n.MarkdownString.from(o):o}getCommand(o,m){return m?this.commands.toInternal(m,o):void 0}createTreeNode(o,m,y){const i=new F.DisposableStore,v=this.createHandle(o,m,y),r=this.getLightIconPath(m);return{item:{handle:v,parentHandle:y?y.item.handle:void 0,label:a(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(i,m.command),contextValue:m.contextValue,icon:r,iconDark:this.getDarkIconPath(m)||r,themeIcon:this.getThemeIcon(m),collapsibleState:(0,t.isUndefinedOrNull)(m.collapsibleState)?T.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:y,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(o){return o.iconPath instanceof T.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:m,label:y,resourceUri:i},v,r){if(m)return`${I.ID_HANDLE_PREFIX}/${m}`;const s=a(y,this.extension),c=v?v.item.handle:I.LABEL_HANDLE_PREFIX;let h=s?s.label:i?(0,M.basename)(i):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const g=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,k=this.getChildrenNodes(v)||[];let P,p=0;do{if(P=`${c}/${p}:${h}`,r||!this.elements.has(P)||g===P)break;p++}while(p<=k.length);return P}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon))return typeof o.iconPath=="string"||b.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return b.URI.isUri(o)?o:b.URI.file(o)}addNodeToCache(o,m){this.elements.set(m.item.handle,o),this.nodes.set(o,m)}updateNodeCache(o,m,y,i){this.elements.delete(m.item.handle),this.nodes.delete(o),m.item.handle!==y.item.handle&&this.elements.delete(y.item.handle),this.addNodeToCache(o,m);const v=this.getChildrenNodes(i)||[],r=v.filter(s=>s.item.handle===y.item.handle)[0];r&&v.splice(v.indexOf(r),1,m)}addNodeToParentCache(o,m){m?(m.children||(m.children=[]),m.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const m=this.nodes.get(o);if(m){if(m.children)for(const y of m.children){const i=this.elements.get(y.item.handle);i&&this.clear(i)}m.children=void 0}}else this.clearAll()}clear(o){const m=this.nodes.get(o);if(m){if(m.children)for(const y of m.children){const i=this.elements.get(y.item.handle);i&&this.clear(i)}this.nodes.delete(o),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}I.LABEL_HANDLE_PREFIX="0",I.ID_HANDLE_PREFIX="1"}),define(we[174],be([0,1,14,3,6,10,48,8,90,67]),function(ne,e,d,M,b,R,F,C,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends b.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const u of this.tree.values())this.updateExpandability(u)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const u=this.diff[this.diff.length-1];if(u&&n[0]===1){if(u[0]===1&&u[1].extId===n[1].extId){(0,_.applyTestItemUpdate)(u[1],n[1]);return}if(u[0]===0&&u[1].item.extId===n[1].extId){(0,_.applyTestItemUpdate)(u[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,u){const l=this.tree.get(n);if(!!l){if((l.expandLevels===void 0||u>l.expandLevels)&&(l.expandLevels=u),l.expand===1){const a=this.resolveChildren(l);return a.isOpen()?this.expandChildren(l,u-1):a.wait().then(()=>this.expandChildren(l,u-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,u-1)):this.expandChildren(l,u-1)}}dispose(){for(const n of this.tree.values())(0,F.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,u){switch(u.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(n.fullId,u.id));break;case 0:this.upsertItem(u.item,n);break;case 4:for(const S of u.ops)this.onTestItemEvent(n,S);break;case 3:const{key:l,value:a,previous:w}=u,I=n.fullId.toString();switch(l){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(a,w,I);break;case"range":this.pushDiff([1,{extId:I,item:{range:C.Range.from(a)}}]);break;case"error":this.pushDiff([1,{extId:I,item:{error:C.MarkdownString.fromStrict(a)||null}}]);break;default:this.pushDiff([1,{extId:I,item:{[l]:a??null}}]);break}break;default:(0,R.assertNever)(u)}}upsertItem(n,u){if(!(n instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const l=T.TestId.fromExtHostTestItem(n,this.root.id,u?.actual),a=(0,F.getPrivateApiFor)(n);a.parent&&a.parent!==u?.actual&&a.parent.children.delete(n.id);let w=this.tree.get(l.toString());if(!w){w={fullId:l,actual:n,parent:u?l.parentId:null,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(w.fullId.toString(),w),this.setItemParent(n,u),this.pushDiff([0,{parent:w.parent&&w.parent.toString(),controllerId:this.controllerId,expand:w.expand,item:C.TestItem.from(n)}]),this.connectItemAndChildren(n,w,u);return}if(w.actual===n){this.connectItem(n,w,u);return}const I=w.actual.children,S=w.actual,o=(0,F.diffTestItems)(S,n);(0,F.getPrivateApiFor)(S).listener=void 0,w.actual=n,w.expand=0;for(const[m,y]of o)this.onTestItemEvent(w,{op:3,key:m,value:y,previous:S[m]});this.connectItemAndChildren(n,w,u);for(const m of I)n.children.get(m.id)||this.removeItem(T.TestId.joinToString(l,m.id))}diffTagRefs(n,u,l){const a=new Set(u.map(w=>w.id));for(const w of n)a.delete(w.id)||this.incrementTagRefs(w);this.pushDiff([1,{extId:l,item:{tags:n.map(w=>C.TestTag.namespace(this.controllerId,w.id))}}]),a.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const u=this.tags.get(n.id);u?u.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:C.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const u=this.tags.get(n);u&&!--u.refCount&&(this.tags.delete(n),this.pushDiff([6,C.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,u){(0,F.getPrivateApiFor)(n).parent=u&&u.actual!==this.root?u.actual:void 0}connectItem(n,u,l){this.setItemParent(n,l);const a=(0,F.getPrivateApiFor)(n);a.parent=l?.actual,a.listener=w=>this.onTestItemEvent(u,w),this.updateExpandability(u)}connectItemAndChildren(n,u,l){this.connectItem(n,u,l);for(const a of n.children)this.upsertItem(a,u)}updateExpandability(n){let u;this._resolveHandler?n.resolveBarrier?u=n.resolveBarrier.isOpen()?3:2:u=n.actual.canResolveChildren?1:0:u=0,u!==n.expand&&(n.expand=u,this.pushDiff([1,{extId:n.fullId.toString(),expand:u}]),u===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,u){if(u<0)return;const l=[];for(const a of n.actual.children){const w=this.expand(T.TestId.joinToString(n.fullId,a.id),u);(0,d.isThenable)(w)&&l.push(w)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const w=new d.Barrier;return w.open(),w}n.expand=2,this.pushExpandStateUpdate(n);const u=n.resolveBarrier=new d.Barrier,l=w=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=w.stack||w.message||String(w))};let a;try{a=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(w){l(w)}return(0,d.isThenable)(a)?a.catch(l).then(()=>{u.open(),this.updateExpandability(n)}):(u.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const u=this.tree.get(n);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const l=[u];for(;l.length;){const a=l.pop();if(!!a){(0,F.getPrivateApiFor)(a.actual).listener=void 0;for(const w of a.actual.tags)this.decrementTagRefs(w.id);this.tree.delete(a.fullId.toString());for(const w of a.actual.children)l.push(this.tree.get(T.TestId.joinToString(a.fullId,w.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(we[175],be([0,1,4,142]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(M.IEnvironmentService)}),define(we[176],be([0,1,25,3,17]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=R;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let E of t.activationEvents)E==="onUri"&&(E=`onUri:${d.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(E)||this._activationMap.set(E,[]),this._activationMap.get(E).push(t)}}keepOnly(t){const E=new Set;t.forEach(n=>E.add(d.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>E.has(d.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,E){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=F._findLoopingExtensions(this._extensionDescriptions);if(E=E.concat(n.map(u=>u.identifier)),E.length>0){const u=new Set;E.forEach(l=>u.add(d.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!u.has(d.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new R(n)}static _findLoopingExtensions(t){const E=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,I){this.addNode(w),this.addNode(I),this._arcs.has(w)?this._arcs.get(w).push(I):this._arcs.set(w,[I])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,I){const S=E.getArcs(w);for(let o=0;o<S.length;o++)if(!I.has(S[o]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let w of t){const I=d.ExtensionIdentifier.toKey(w.identifier);if(n.set(I,w),w.extensionDependencies)for(let S of w.extensionDependencies){const o=d.ExtensionIdentifier.toKey(S);E.addArc(I,o)}}let u=new Set;E.getNodes().filter(w=>E.getArcs(w).length===0).forEach(w=>u.add(w));let l=E.getNodes().filter(w=>!u.has(w)),a;do{a=!1;for(let w=0;w<l.length;w++){const I=l[w];E.hasOnlyGoodArcs(I,u)&&(l.splice(w,1),w--,u.add(I),a=!0)}}while(a);return l.map(w=>n.get(w))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const E=this._activationMap.get(t);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const E=this._extensionsMap.get(d.ExtensionIdentifier.toKey(t));return E||void 0}}e.ExtensionDescriptionRegistry=F;var C;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(C||(C={}));function _(T,t){const E=T.isBuiltin?0:T.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(E!==n)return E-n;const u=b.posix.basename(T.extensionLocation.path),l=b.posix.basename(t.extensionLocation.path);return u<l?-1:u>l?1:0}}),define(we[177],be([0,1,22]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var b;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(b=e.MessageType||(e.MessageType={}));function R(C){const _=d.VSBuffer.alloc(1);switch(C){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=R;function F(C,_){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=F}),define(we[30],be([0,1,3,2,4,25,143]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");var C;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(C=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class _{constructor(m){this.dependency=m}}e.MissingExtensionDependency=_;var T;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(T=e.ExtensionHostKind||(e.ExtensionHostKind={}));function t(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=t;class E{constructor(m,y,i,v){this.codeLoadingTime=m,this.activateCallTime=y,this.activateResolvedTime=i,this.activationReason=v}}e.ActivationTimes=E;class n{constructor(m,y){this.description=m,this.value=y}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var u;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(u=e.ActivationKind||(e.ActivationKind={}));function l(o){o.enableProposedApi||a(o)}e.checkProposedApiEnabled=l;function a(o){throw new Error(`[${o.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.throwProposedApiError=a;function w(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=w;function I(o,m){return{identifier:new R.ExtensionIdentifier(o.identifier.id),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!m,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=I;class S{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(m){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(m,y){return Promise.resolve()}_onWillActivateExtension(m){}_onDidActivateExtension(m,y,i,v,r){}_onDidActivateExtensionError(m,y){}_onExtensionRuntimeError(m,y){}_onExtensionHostExit(m){}}e.NullExtensionService=S}),define(we[178],be([0,1,25,30,15]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const R=Promise.resolve(void 0);class F{constructor(l,a,w,I){this.startup=l,this.codeLoadingTime=a,this.activateCallTime=w,this.activateResolvedTime=I}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class C{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,a){return l===-1||a===-1?-1:a-l}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class _{constructor(l,a,w,I,S,o){this.activationFailed=l,this.activationFailedError=a,this.activationTimes=w,this.module=I,this.exports=S,this.subscriptions=o}}e.ActivatedExtension=_;class T extends _{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class t extends _{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class E extends _{constructor(l){super(!0,l,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=E;let n=class{constructor(l,a,w,I,S){this._logService=S,this._registry=l,this._resolvedExtensionsSet=new Set,a.forEach(o=>this._resolvedExtensionsSet.add(d.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,w.forEach(o=>this._hostExtensionsMap.set(d.ExtensionIdentifier.toKey(o),o)),this._host=I,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const a=d.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(a)}getActivatedExtension(l){const a=d.ExtensionIdentifier.toKey(l),w=this._activatedExtensions.get(a);if(!w)throw new Error("Extension `"+l.value+"` is not known or not activated");return w}activateByEvent(l,a){if(this._alreadyActivatedEvents[l])return R;const w=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(w.map(I=>({id:I.identifier,reason:{startup:a,extensionId:I.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,a){const w=this._registry.getExtensionDescription(l);if(!w)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:w.identifier,reason:a}])}_handleActivateRequest(l,a,w){if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(l.id))){a[d.ExtensionIdentifier.toKey(l.id)]=l;return}const I=this._registry.getExtensionDescription(l.id);if(!I){const m=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,m,new M.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(l.id),new E(m));return}const S=typeof I.extensionDependencies=="undefined"?[]:I.extensionDependencies;let o=!0;for(let m=0,y=S.length;m<y;m++){const i=S[m];if(this._resolvedExtensionsSet.has(d.ExtensionIdentifier.toKey(i)))continue;const v=this._activatedExtensions.get(d.ExtensionIdentifier.toKey(i));if(v&&!v.activationFailed)continue;if(v&&v.activationFailed){const h=I.displayName||I.identifier.value,g=this._registry.getExtensionDescription(i),k=g&&g.displayName||i,P=new Error(`Cannot activate the '${h}' extension because its dependency '${k}' failed to activate`);P.detail=v.activationFailedError,this._host.onExtensionActivationError(I.identifier,P,null),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(I.identifier),new E(P));return}if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(i))){o=!1,a[d.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(d.ExtensionIdentifier.toKey(i)),reason:l.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){o=!1,a[d.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:l.reason};continue}const s=I.displayName||I.identifier.value,c=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(I.identifier,c,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(I.identifier),new E(c));return}o?a[d.ExtensionIdentifier.toKey(I.identifier)]=l:w.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(S=>!this._activatedExtensions.has(d.ExtensionIdentifier.toKey(S.id))),l.length===0))return Promise.resolve(void 0);const a=Object.create(null),w=[];for(let S=0,o=l.length;S<o;S++)this._handleActivateRequest(l[S],a,w);for(let S=0,o=w.length;S<o;S++){const m=d.ExtensionIdentifier.toKey(w[S].id);a[m]&&delete a[m]}const I=Object.keys(a).map(S=>a[S]);return w.length===0?Promise.all(I.map(S=>this._activateExtension(S.id,S.reason))).then(S=>{}):this._activateExtensions(I).then(S=>this._activateExtensions(w))}_activateExtension(l,a){const w=d.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const I=this._activatingExtensions.get(w);if(I)return I;const S=this._host.actualActivateExtension(l,a).then(void 0,o=>{const m=new Error;return o&&o.name&&(m.name=o.name),o&&o.message?m.message=`Activating extension '${l.value}' failed: ${o.message}.`:m.message=`Activating extension '${l.value}' failed: ${o}.`,o&&o.stack&&(m.stack=o.stack),this._host.onExtensionActivationError(l,m,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(o),new E(o)}).then(o=>{this._activatedExtensions.set(w,o),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,S),S}};n=Ue([He(4,b.ILogService)],n),e.ExtensionsActivator=n}),define(we[179],be([0,1,16]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((R,F)=>{this._actualOk=R,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(R){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=R,this._actual&&this._actualOk(R))}resolveErr(R){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=R,this._actual?this._actualErr(R):(0,d.onUnexpectedError)(R))}then(R,F){return this._ensureActual().then(R,F)}catch(R){return this._ensureActual().then(void 0,R)}finally(R){return this._ensureActual().finally(R)}}e.LazyPromise=M}),define(we[38],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(T,t){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=t,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const M=[];function b(_){const T=new d(!0,_);return M[T.nid]=T,T}e.createMainContextProxyIdentifier=b;function R(_){const T=new d(!1,_);return M[T.nid]=T,T}e.createExtHostContextProxyIdentifier=R;function F(_){return M[_].sid}e.getStringIdentifierForProxy=F;class C{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=C}),define(we[5],be([0,1,54,2,38]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var R;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(R=e.UIKind||(e.UIKind={}));var F;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var E;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(E=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(o){o.name="$ident";function m(i,v){return Object.defineProperty(i,o.name,{value:v,enumerable:!0}),i}o.mixin=m;function y(i){return i[o.name]}o.of=y})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class u{static mixin(m){return m._id=u._n++,m}}e.IdObject=u,u._n=0;var l;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var a;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(a=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function I(o){if(o&&o.edits)for(const m of o.edits)typeof m.resource=="object"?m.resource=M.URI.revive(m.resource):(m.newUri=M.URI.revive(m.newUri),m.oldUri=M.URI.revive(m.oldUri)),m.metadata&&m.metadata.iconPath&&(m.metadata=(0,d.revive)(m.metadata));return o}e.reviveWorkspaceEditDto=I;var S;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,b.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,b.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,b.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,b.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,b.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,b.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,b.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,b.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,b.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,b.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,b.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,b.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,b.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,b.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,b.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,b.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,b.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,b.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,b.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,b.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,b.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,b.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,b.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,b.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,b.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,b.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,b.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,b.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,b.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,b.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,b.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,b.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,b.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,b.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,b.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,b.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,b.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,b.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,b.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,b.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,b.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,b.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,b.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,b.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,b.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,b.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,b.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,b.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,b.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,b.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,b.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,b.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,b.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,b.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,b.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,b.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,b.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,b.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[69],be([0,1,5,3,4]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(C){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,_){return this._proxy.$getPassword(C,_)}store(C,_,T){return this._proxy.$setPassword(C,_,T)}delete(C,_){return this._proxy.$deletePassword(C,_)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")}),define(we[70],be([0,1,4,15,5,12]),function(ne,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(_,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(b.MainContext.MainThreadTelemetry)}report(_,T,t){const E=this.getUsageKey(_,T);this._reportedUsages.has(E)||(this._reportedUsages.add(E),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:_}))}getUsageKey(_,T){return`${_}-${T.identifier.value}`}};F=Ue([He(0,R.IExtHostRpcService),He(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(C,_,T){}})}),define(we[180],be([0,1,3,5,7,25]),function(ne,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,T,t,E={}){const n=R.ExtensionIdentifier.toKey(_.identifier),u=this._inFlightRequests.get(n)||[],l=[...t].sort().join(" ");let a=u.find(w=>w.scopes===l);if(a)return a.result;{const w=this._getSession(_,n,T,t,E);a={scopes:l,result:w},u.push(a),this._inFlightRequests.set(n,u);try{await w}finally{const I=u.findIndex(S=>S.scopes===l);I>-1&&(u.splice(I),this._inFlightRequests.set(n,u))}return w}}async _getSession(_,T,t,E,n={}){await this._proxy.$ensureProvider(t);const u=_.displayName||_.name;return this._proxy.$getSession(t,E,T,u,n)}async removeSession(_,T){const t=this._authenticationProviders.get(_);return t?t.provider.removeSession(T):this._proxy.$removeSession(_,T)}registerAuthenticationProvider(_,T,t,E){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:T,provider:t,options:E??{supportsMultipleAccounts:!1}}),this._providers.find(u=>u.id===_)||this._providers.push({id:_,label:T});const n=t.onDidChangeSessions(u=>{this._proxy.$sendDidChangeSessions(_,{added:u.added??[],changed:u.changed??[],removed:u.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,T,E?.supportsMultipleAccounts??!1),new b.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(_);const u=this._providers.findIndex(l=>l.id===_);u>-1&&this._providers.splice(u),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,T){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,T){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,T){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,T){return this._onDidChangeSessions.fire({provider:{id:_,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(we[181],be([0,1,5,12,8]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(C,_){this._extHostDocumentsAndEditors=_,this._proxy=C.getProxy(d.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const _=b.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};R=Ue([He(0,M.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(we[182],be([0,1,5]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(R){const F=R.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(C){return F.$writeText(C)}})}}e.ExtHostClipboard=M}),define(we[39],be([0,1,10,7,8,23,5,13,15,54,44,112,2,6,4,12,48,22,38]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(s,c){this._commands=new Map,this._apiCommands=new Map,this._proxy=s.getProxy(F.MainContext.MainThreadCommands),this._logService=c,this.converter=new m(this,h=>{const g=this._apiCommands.get(h);return g?.result===i.Void?g:void 0},c),this._argumentProcessors=[{processArgument(h){return(0,T.revive)(h)}},{processArgument(h){return(0,R.cloneAndChange)(h,function(g){if(t.Range.isIRange(g))return b.Range.to(g);if(E.Position.isIPosition(g))return b.Position.to(g);if(t.Range.isIRange(g.range)&&n.URI.isUri(g.uri))return b.location.to(g);if(g instanceof I.VSBuffer)return g.buffer.buffer;if(!Array.isArray(g))return g})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const c=this.registerCommand(!1,s.id,async(...h)=>{const g=s.args.map((P,p)=>{if(!P.validate(h[p]))throw new Error(`Invalid argument '${P.name}' when running '${s.id}', received: ${h[p]}`);return P.convert(h[p])}),k=await this.executeCommand(s.internalId,...g);return s.result.convert(k,h,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new M.Disposable(()=>{c.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,c,h,g,k){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:h,thisArg:g,description:k}),s&&this._proxy.$registerCommand(c),new M.Disposable(()=>{this._commands.delete(c)&&s&&this._proxy.$unregisterCommand(c)})}executeCommand(s,...c){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,c,!0)}async _doExecuteCommand(s,c,h){if(this._commands.has(s))return this._executeContributedCommand(s,c);{let g=!1;const k=(0,R.cloneAndChange)(c,function(P){if(P instanceof M.Position)return b.Position.from(P);if(P instanceof M.Range)return b.Range.from(P);if(P instanceof M.Location)return b.location.from(P);if(M.NotebookRange.isNotebookRange(P))return b.NotebookRange.from(P);if(P instanceof ArrayBuffer)return g=!0,I.VSBuffer.wrap(new Uint8Array(P));if(P instanceof Uint8Array)return g=!0,I.VSBuffer.wrap(P);if(!Array.isArray(P))return P});try{const P=await this._proxy.$executeCommand(s,g?new S.SerializableObjectWithBuffers(k):k,h);return(0,T.revive)(P)}catch(P){if(P instanceof Error&&P.message==="$executeCommand:retry")return this._doExecuteCommand(s,c,!1);throw P}}}async _executeContributedCommand(s,c){const h=this._commands.get(s);if(!h)throw new Error("Unknown command");let{callback:g,thisArg:k,description:P}=h;if(P)for(let p=0;p<P.args.length;p++)try{(0,d.validateConstraint)(c[p],P.args[p].constraint)}catch(D){throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${P.args[p].name}' - ${P.args[p].description}`)}try{return await g.apply(k,c)}catch(p){if(s===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...c);D&&(s=D.command)}throw this._logService.error(p,s),new Error(`Running the contributed command: '${s}' failed.`)}}$executeContributedCommand(s,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(c=c.map(h=>this._argumentProcessors.reduce((g,k)=>k.processArgument(g),h)),this._executeContributedCommand(s,c)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),this._proxy.$getCommands().then(c=>(s&&(c=c.filter(h=>h[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[c,h]of this._commands){let{description:g}=h;g&&(s[c]=g)}return Promise.resolve(s)}};o=Ue([He(0,a.IExtHostRpcService),He(1,_.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class m{constructor(s,c,h){this._commands=s,this._lookupApiCommand=c,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,c){if(!s)return;const h={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return h;const g=this._lookupApiCommand(s.command);if(g)h.id=g.internalId,h.arguments=g.args.map((k,P)=>k.convert(s.arguments&&s.arguments[P]));else if((0,C.isNonEmptyArray)(s.arguments)){const k=++this._cachIdPool;this._cache.set(k,s),c.add((0,u.toDisposable)(()=>{this._cache.delete(k),this._logService.trace("CommandsConverter#DISPOSE",k)})),h.$ident=k,h.id=this.delegatingCommandId,h.arguments=[k],this._logService.trace("CommandsConverter#CREATE",s.command,k)}return h}fromInternal(s){const c=F.ObjectIdentifier.of(s);return typeof c=="number"?this._cache.get(c):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const c=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class y{constructor(s,c,h,g){this.name=s,this.description=c,this.validate=h,this.convert=g}optional(){return new y(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,c){return new y(s??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=y,y.Uri=new y("uri","Uri of a text document",r=>n.URI.isUri(r),r=>r),y.Position=new y("position","A position in a text document",r=>M.Position.isPosition(r),b.Position.from),y.Range=new y("range","A range in a text document",r=>M.Range.isRange(r),b.Range.from),y.Selection=new y("selection","A selection in a text document",r=>M.Selection.isSelection(r),b.Selection.from),y.Number=new y("number","",r=>typeof r=="number",r=>r),y.String=new y("string","",r=>typeof r=="string",r=>r),y.CallHierarchyItem=new y("item","A call hierarchy item",r=>r instanceof M.CallHierarchyItem,b.CallHierarchyItem.from),y.TypeHierarchyItem=new y("item","A type hierarchy item",r=>r instanceof M.TypeHierarchyItem,b.TypeHierarchyItem.from),y.TestItem=new y("testItem","A VS Code TestItem",r=>r instanceof w.TestItemImpl,b.TestItem.from);class i{constructor(s,c){this.description=s,this.convert=c}}e.ApiCommandResult=i,i.Void=new i("no result",r=>r);class v{constructor(s,c,h,g,k){this.id=s,this.internalId=c,this.description=h,this.args=g,this.result=k}}e.ApiCommand=v}),define(we[183],be([0,1,8,7,59,39,13,80]),function(ne,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new R.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(d.DocumentHighlight.to))),new R.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,u)=>{if((0,F.isFalsyOrEmpty)(n))return;class l extends M.SymbolInformation{static to(w){const I=new l(w.name,d.SymbolKind.to(w.kind),w.containerName||"",new M.Location(u[0],d.Range.to(w.range)));return I.detail=w.detail,I.range=I.location.range,I.selectionRange=d.Range.to(w.selectionRange),I.children=w.children?w.children.map(l.to):[],I}}return n.map(l.to)})),new R.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[R.ApiCommandArgument.Uri,new R.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new R.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new R.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Range,new R.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new R.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new R.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position,new R.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new R.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new R.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new R.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new R.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new R.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new R.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new R.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(d.location.to))),new R.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(d.Hover.to))),new R.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[R.ApiCommandArgument.Uri,new R.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(u=>M.Position.isPosition(u)),n=>n.map(d.Position.from))],new R.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(u=>{let l;for(const a of u.reverse())l=new M.SelectionRange(d.Range.to(a),l);return l}))),new R.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[R.ApiCommandArgument.String.with("query","Search string")],new R.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const u=[];if(Array.isArray(n))for(let l of n)u.push(...l[1].map(d.WorkspaceSymbol.to));return u})),new R.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyItem.to))),new R.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[R.ApiCommandArgument.CallHierarchyItem],new R.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyIncomingCall.to))),new R.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[R.ApiCommandArgument.CallHierarchyItem],new R.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyOutgoingCall.to))),new R.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position,R.ApiCommandArgument.String.with("newName","The new symbol name")],new R.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return d.WorkspaceEdit.to(n)}})),new R.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new R.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(d.DocumentLink.to))),new R.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new R.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const u=(0,C.decodeSemanticTokensDto)(n);if(u.type==="full")return new M.SemanticTokens(u.data,void 0)})),new R.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new R.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Range],new R.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const u=(0,C.decodeSemanticTokensDto)(n);if(u.type==="full")return new M.SemanticTokens(u.data,void 0)})),new R.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position,R.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),R.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new R.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,u,l)=>{if(!n)return new M.CompletionList([]);const a=n.suggestions.map(w=>d.CompletionItem.to(w,l));return new M.CompletionList(a,n.incomplete)})),new R.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position,R.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new R.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return d.SignatureHelp.to(n)})),new R.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new R.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,u,l)=>t(a=>new M.CodeLens(d.Range.to(a.range),a.command&&l.fromInternal(a.command)))(n))),new R.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[R.ApiCommandArgument.Uri,new R.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?d.Selection.from(n):d.Range.from(n)),R.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),R.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new R.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,u,l)=>t(a=>{if(a._isSynthetic){if(!a.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(a.command)}else{const w=new M.CodeAction(a.title,a.kind?new M.CodeActionKind(a.kind):void 0);return a.edit&&(w.edit=d.WorkspaceEdit.to(a.edit)),a.command&&(w.command=l.fromInternal(a.command)),w.isPreferred=a.isPreferred,w}})(n))),new R.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[R.ApiCommandArgument.Uri],new R.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(u=>new M.ColorInformation(d.Range.to(u.range),d.Color.to(u.color))):[])),new R.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new R.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,d.Color.from),new R.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:d.Range.from(n.range)}))],new R.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(d.ColorPresentation.to):[])),new R.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Range],new R.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(d.InlayHint.to))),new R.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new R.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(u=>d.NotebookExclusiveDocumentPattern.to(u))})))),new R.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Range],new R.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(d.InlineValue.to))),new R.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[R.ApiCommandArgument.Uri,new R.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional(),R.ApiCommandArgument.String.with("label","").optional()],R.ApiCommandResult.Void),new R.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[R.ApiCommandArgument.Uri.with("resource","Resource to open"),R.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new R.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional()],R.ApiCommandResult.Void),new R.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[R.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),R.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),R.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new R.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)]).optional()],R.ApiCommandResult.Void),new R.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[R.ApiCommandArgument.Uri,R.ApiCommandArgument.Position],new R.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new R.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[R.ApiCommandArgument.TypeHierarchyItem],new R.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new R.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[R.ApiCommandArgument.TypeHierarchyItem],new R.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new R.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[R.ApiCommandArgument.TestItem],R.ApiCommandResult.Void)];class T{static register(u){_.forEach(u.registerApiCommand,u)}}e.ExtHostApiCommands=T;function t(n){return u=>{if(Array.isArray(u))return u.map(n)}}function E(n){if(!Array.isArray(n))return;const u=[];for(const l of n)b.isLocationLink(l)?u.push(d.DefinitionLink.to(l)):u.push(d.location.to(l));return u}}),define(we[184],be([0,1,14,52,3,6,2,59,25,8,7,5]),function(ne,e,d,M,b,R,F,C,_,T,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(u,l,a){const w=u.getProxy(E.MainContext.MainThreadComments);class I{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,l.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const c=this._commentControllers.get(s.handle);return c||s}else if(s&&s.$mid===7){const c=this._commentControllers.get(s.commentControlHandle);if(!c)return s;const h=c.getCommentThread(s.commentThreadHandle);return h||s}else if(s&&s.$mid===8){const c=this._commentControllers.get(s.thread.commentControlHandle);if(!c)return s;const h=c.getCommentThread(s.thread.commentThreadHandle);return h?{thread:h,text:s.text}:s}else if(s&&s.$mid===9){const c=this._commentControllers.get(s.thread.commentControlHandle);if(!c)return s;const h=c.getCommentThread(s.thread.commentThreadHandle);if(!h)return s;let g=s.commentUniqueId,k=h.getCommentByUniqueId(g);return k||s}else if(s&&s.$mid===10){const c=this._commentControllers.get(s.thread.commentControlHandle);if(!c)return s;const h=c.getCommentThread(s.thread.commentThreadHandle);if(!h)return s;let g=s.text,k=s.commentUniqueId,P=h.getCommentByUniqueId(k);return P?(P.body=g,P):s}return s}})}createCommentController(s,c,h){const g=I.handlePool++,k=new o(s,g,c,h);this._commentControllers.set(k.handle,k);const P=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(s.identifier))||[];return P.push(k),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(s.identifier),P),k.value}$createCommentThreadTemplate(s,c,h){const g=this._commentControllers.get(s);!g||g.$createCommentThreadTemplate(c,h)}async $updateCommentThreadTemplate(s,c,h){const g=this._commentControllers.get(s);!g||g.$updateCommentThreadTemplate(c,h)}$deleteCommentThread(s,c){const h=this._commentControllers.get(s);h&&h.$deleteCommentThread(c)}$provideCommentingRanges(s,c,h){const g=this._commentControllers.get(s);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const k=a.getDocument(F.URI.revive(c));return(0,d.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(k,h)).then(P=>P?P.map(p=>T.Range.from(p)):void 0)}$toggleReaction(s,c,h,g,k){const P=this._commentControllers.get(s);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const p=P.getCommentThread(c);if(p){const D=p.getCommentByUniqueId(g.uniqueIdInThread);if(P!==void 0&&D&&P.reactionHandler)return P.reactionHandler(D,i(k))}return Promise.resolve(void 0)})}dispose(){}}I.handlePool=0;class S{constructor(s,c,h,g,k,P,p){this._commentControllerHandle=c,this._id=h,this._uri=g,this._range=k,this._comments=P,this.handle=S._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputDisposables.value=new R.DisposableStore,this._id===void 0&&(this._id=`${s}.${this.handle}`),w.$createCommentThread(c,this.handle,this._id,this._uri,T.Range.from(this._range),p),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{w.$deleteCommentThread(c,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(f){D.range=f},get comments(){return D.comments},set comments(f){D.comments=f},get collapsibleState(){return D.collapsibleState},set collapsibleState(f){D.collapsibleState=f},get canReply(){return D.canReply},set canReply(f){D.canReply=f},get contextValue(){return D.contextValue},set contextValue(f){D.contextValue=f},get label(){return D.label},set label(f){D.label=f},dispose:()=>{D.dispose()}}}set threadId(s){this._id=s}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(s){s.isEqual(this._range)||(this._range=s,this.modifications.range=s,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(s){this._canReply!==s&&(this._canReply=s,this.modifications.canReply=s,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(s){this._label=s,this.modifications.label=s,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(s){this._contextValue=s,this.modifications.contextValue=s,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(s){this._comments=s,this.modifications.comments=s,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(s){this._collapseState=s,this.modifications.collapsibleState=s,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new R.DisposableStore);const s=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),c={};s("range")&&(c.range=T.Range.from(this._range)),s("label")&&(c.label=this.label),s("contextValue")&&(c.contextValue=this.contextValue),s("comments")&&(c.comments=this._comments.map(h=>m(this,h,this._commentsMap))),s("collapsibleState")&&(c.collapseState=v(this._collapseState)),s("canReply")&&(c.canReply=this.canReply),this.modifications={},w.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(s){for(let c of this._commentsMap){let h=c[0],g=c[1];if(s===g)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(s=>s.dispose())}}S._handlePool=0,Ue([(0,M.debounce)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(s,c,h,g){this._extension=s,this._handle=c,this._id=h,this._label=g,this._threads=new Map,w.$registerCommentController(this.handle,h,g);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(P){k.options=P},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(P){k.commentingRangeProvider=P},get reactionHandler(){return k.reactionHandler},set reactionHandler(P){k.reactionHandler=P},createCommentThread(P,p,D){return k.createCommentThread(P,p,D).value},dispose:()=>{k.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{w.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(s){this._reactionHandler=s,w.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!s})}get options(){return this._options}set options(s){this._options=s,w.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(s,c,h,g){if(typeof s=="string"){const k=new S(this.id,this.handle,s,c,h,g,this._extension.identifier);return this._threads.set(k.handle,k),k}else{const k=new S(this.id,this.handle,void 0,s,c,h,this._extension.identifier);return this._threads.set(k.handle,k),k}}$createCommentThreadTemplate(s,c){const h=new S(this.id,this.handle,void 0,F.URI.revive(s),T.Range.to(c),[],this._extension.identifier);return h.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(s,c){let h=this._threads.get(s);h&&(h.range=T.Range.to(c))}$deleteCommentThread(s){let c=this._threads.get(s);c&&c.dispose(),this._threads.delete(s)}getCommentThread(s){return this._threads.get(s)}dispose(){this._threads.forEach(s=>{s.dispose()}),this._localDisposables.forEach(s=>s.dispose())}}function m(r,s,c){let h=c.get(s);h||(h=++r.commentHandle,c.set(s,h));const g=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:h,body:T.MarkdownString.from(s.body),userName:s.author.name,userIconPath:g,label:s.label,commentReactions:s.reactions?s.reactions.map(k=>y(k)):void 0}}function y(r){return{label:r.label,iconPath:r.iconPath?T.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?F.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function v(r){if(r!==void 0)switch(r){case t.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new I}e.createExtHostComments=n}),define(we[95],be([0,1,2,5,7,4,12,15,13,9,17]),function(ne,e,d,M,b,R,F,C,_,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class vi{constructor(u,l){this._logService=l,this._provider=new Map,this._proxy=u.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(u,l){const a=vi._handlePool++;this._provider.set(a,{provider:u,extensionId:l}),this._proxy.$registerDecorationProvider(a,l.value);const w=u.onDidChangeFileDecorations&&u.onDidChangeFileDecorations(I=>{if(!I){this._proxy.$onDidChange(a,null);return}let S=(0,_.asArray)(I);if(S.length<=vi._maxEventSize){this._proxy.$onDidChange(a,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,S.length);const o=S.map(i=>({uri:i,rank:(0,T.count)(i.path,"/")})),m=(0,_.groupBy)(o,(i,v)=>i.rank-v.rank||(0,T.compare)(i.uri.path,v.uri.path));let y=[];e:for(let i of m){let v;for(let r of i){let s=(0,t.dirname)(r.uri.path);if(v!==s&&(v=s,y.push(r.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(a,y)});return new b.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(u,l,a){if(!this._provider.has(u))return Object.create(null);const w=Object.create(null),{provider:I,extensionId:S}=this._provider.get(u);return await Promise.all(l.map(async o=>{try{const{uri:m,id:y}=o,i=await Promise.resolve(I.provideFileDecoration(d.URI.revive(m),a));if(!i)return;try{b.FileDecoration.validate(i),w[y]=[i.propagate,i.tooltip,i.badge,i.color]}catch(v){this._logService.warn(`INVALID decoration from extension '${S.value}': ${v}`)}}catch(m){this._logService.error(m)}})),w}};E._handlePool=0,E._maxEventSize=250,E=Ue([He(0,F.IExtHostRpcService),He(1,C.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,d):b?b.value=d:e.set(ne,d),d},Ae=this&&this.__classPrivateFieldGet||function(ne,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[185],be([0,1,124,82,2,5,7,8,3,15,20,37,104]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n){"use strict";var u,l,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(o,m,y,i,v,r){this._name=o,this._owner=m,this._maxDiagnosticsPerFile=y,u.set(this,void 0),l.set(this,void 0),a.set(this,void 0),this._isDisposed=!1,Xe(this,a,new n.SkipList((s,c)=>i.compare(s,c)),"f"),Xe(this,u,v,"f"),Xe(this,l,r,"f")}dispose(){this._isDisposed||(Ae(this,l,"f").fire([...Ae(this,a,"f").keys()]),Ae(this,u,"f")&&Ae(this,u,"f").$clear(this._owner),Ae(this,a,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,m){if(!o){this.clear();return}this._checkDisposed();let y=[];if(b.URI.isUri(o)){if(!m){this.delete(o);return}Ae(this,a,"f").set(o,m.slice()),y=[o]}else if(Array.isArray(o)){y=[];let v;o=[...o].sort(w._compareIndexedTuplesByUri);for(const r of o){const[s,c]=r;if((!v||s.toString()!==v.toString())&&(v&&Ae(this,a,"f").get(v).length===0&&Ae(this,a,"f").delete(v),v=s,y.push(s),Ae(this,a,"f").set(s,[])),c){const h=Ae(this,a,"f").get(s);h&&h.push(...c)}else{const h=Ae(this,a,"f").get(s);h&&(h.length=0)}}}if(Ae(this,l,"f").fire(y),!Ae(this,u,"f"))return;const i=[];for(let v of y){let r=[];const s=Ae(this,a,"f").get(v);if(s)if(s.length>this._maxDiagnosticsPerFile){r=[];const c=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(let g of s)if(g.severity===c[h]&&r.push(C.Diagnostic.from(g))===this._maxDiagnosticsPerFile)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,d.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(c=>C.Diagnostic.from(c));i.push([v,r])}Ae(this,u,"f").$changeMany(this._owner,i)}delete(o){this._checkDisposed(),Ae(this,l,"f").fire([o]),Ae(this,a,"f").delete(o),Ae(this,u,"f")&&Ae(this,u,"f").$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),Ae(this,l,"f").fire([...Ae(this,a,"f").keys()]),Ae(this,a,"f").clear(),Ae(this,u,"f")&&Ae(this,u,"f").$clear(this._owner)}forEach(o,m){this._checkDisposed();for(let y of Ae(this,a,"f").keys())o.apply(m,[y,this.get(y),this])}get(o){this._checkDisposed();const m=Ae(this,a,"f").get(o);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(Ae(this,a,"f").get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,m){return o[0].toString()<m[0].toString()?-1:o[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=w,u=new WeakMap,l=new WeakMap,a=new WeakMap;let I=class Zt{constructor(o,m,y){this._logService=m,this._fileSystemInfoService=y,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=o.getProxy(R.MainContext.MainThreadDiagnostics)}static _mapper(o){const m=new t.ResourceMap;for(const y of o)m.set(y,y);return{uris:Object.freeze(Array.from(m.values()))}}createDiagnosticCollection(o,m){const{_collections:y,_proxy:i,_onDidChangeDiagnostics:v,_logService:r,_fileSystemInfoService:s}=this,c=new class{$changeMany(k,P){i.$changeMany(k,P),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,k,P.length===0?"CLEARING":P)}$clear(k){i.$clear(k),r.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,k)}dispose(){i.dispose()}};let h;if(!m)m="_generated_diagnostic_collection_name_#"+Zt._idPool++,h=m;else if(!y.has(m))h=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do h=m+Zt._idPool++;while(y.has(h))}return new class extends w{constructor(){super(m,h,Zt._maxDiagnosticsPerFile,s.extUri,c,v);y.set(h,this)}dispose(){super.dispose(),y.delete(h)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const m=new Map,y=[];for(const i of this._collections.values())i.forEach((v,r)=>{let s=m.get(v.toString());typeof s=="undefined"&&(s=y.length,m.set(v.toString(),s),y.push([v,[]])),y[s][1]=y[s][1].concat(...r)});return y}}_getDiagnostics(o){let m=[];for(let y of this._collections.values())y.has(o)&&(m=m.concat(y.get(o)));return m}$acceptMarkersChange(o){if(!this._mirrorCollection){const m="_generated_mirror",y=new w(m,m,Zt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(m,y),this._mirrorCollection=y}for(const[m,y]of o)this._mirrorCollection.set(b.URI.revive(m),y.map(C.Diagnostic.to))}};I._idPool=0,I._maxDiagnosticsPerFile=1e3,I=Ue([He(1,T.ILogService),He(2,E.IExtHostFileSystemInfo)],I),e.ExtHostDiagnostics=I}),define(we[186],be([0,1,2,5]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(C=>C?C.map(_=>d.URI.revive(_)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(C=>C?d.URI.revive(C):void 0)}}e.ExtHostDialogs=b}),define(we[187],be([0,1,16,2,7,5,11,21,9]),function(ne,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(E,n,u){this._documentsAndEditors=n,this._logService=u,this._documentContentProviders=new Map,this._proxy=E.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,n){if(Object.keys(F.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const u=T._handlePool++;this._documentContentProviders.set(u,n),this._proxy.$registerTextContentProvider(u,E);let l;return typeof n.onDidChange=="function"&&(l=n.onDidChange(a=>{if(a.scheme!==E){this._logService.warn(`Provider for scheme '${E}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(u,a).then(w=>{if(!w&&typeof w!="string")return;const I=this._documentsAndEditors.getDocument(a);if(!I)return;const S=(0,_.splitLines)(w);if(!I.equalLines(S))return this._proxy.$onVirtualDocumentChange(a,w)},d.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(u)&&this._proxy.$unregisterTextContentProvider(u),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(E,n){const u=this._documentContentProviders.get(E);return u?Promise.resolve(u.provideTextDocumentContent(M.URI.revive(n),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(we[188],be([0,1,3,6,2,5,88,8,10,23,7]),function(ne,e,d,M,b,R,F,C,_,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class E{constructor(u,l){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=u.getProxy(R.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const w of a)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const w of a)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(u){if(!u)return;const l=this._documentsAndEditors.getDocument(u);if(l)return l}getDocument(u){const l=this.getDocumentData(u);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${u}'`);return l.document}ensureDocumentData(u){const l=this._documentsAndEditors.getDocument(u);if(l)return Promise.resolve(l);let a=this._documentLoader.get(u.toString());return a||(a=this._proxy.$tryOpenDocument(u).then(w=>{this._documentLoader.delete(u.toString());const I=b.URI.revive(w);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(I))},w=>(this._documentLoader.delete(u.toString()),Promise.reject(w))),this._documentLoader.set(u.toString(),a)),a}createDocumentData(u){return this._proxy.$tryCreateDocument(u).then(l=>b.URI.revive(l))}$acceptModelModeChanged(u,l){const a=b.URI.revive(u),w=this._documentsAndEditors.getDocument(a);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(l),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(u){const l=b.URI.revive(u),a=this._documentsAndEditors.getDocument(l);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(u,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(u,l){const a=b.URI.revive(u),w=this._documentsAndEditors.getDocument(a);if(!w)throw new Error("unknown document");w._acceptIsDirty(l),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(u,l,a){const w=b.URI.revive(u),I=this._documentsAndEditors.getDocument(w);if(!I)throw new Error("unknown document");I._acceptIsDirty(a),I.onEvents(l);let S;l.isUndoing?S=t.TextDocumentChangeReason.Undo:l.isRedoing&&(S=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:I.document,contentChanges:l.changes.map(o=>({range:C.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:S}))}setWordDefinitionFor(u,l){(0,F.setWordDefinitionFor)(u,l)}}e.ExtHostDocuments=E}),define(we[49],be([0,1,42,3,6,2,4,5,88,12,94,8,15,20,11,231,103]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class I{constructor(m){this.value=m,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(m,y){this._extHostRpc=m,this._logService=y,this._activeEditorId=null,this._editors=new Map,this._documents=new u.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const y=[],i=[],v=[];if(m.removedDocuments)for(const r of m.removedDocuments){const s=R.URI.revive(r),c=this._documents.get(s);c?.unref()&&(this._documents.delete(s),y.push(c.value))}if(m.addedDocuments)for(const r of m.addedDocuments){const s=R.URI.revive(r.uri);let c=this._documents.get(s);if(c&&s.scheme!==l.Schemas.vscodeNotebookCell&&s.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);c||(c=new I(new _.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(s,c),i.push(c.value)),c.ref()}if(m.removedEditors)for(const r of m.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&v.push(s)}if(m.addedEditors)for(const r of m.addedEditors){const s=R.URI.revive(r.documentUri);d.ok(this._documents.has(s),`document '${s}' does not exist`),d.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const c=this._documents.get(s).value,h=new t.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>c.document),r.selections.map(E.Selection.to),r.options,r.visibleRanges.map(g=>E.Range.to(g)),typeof r.editorPosition=="number"?E.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,h)}m.newActiveEditor!==void 0&&(d.ok(m.newActiveEditor===null||this._editors.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this._activeEditorId=m.newActiveEditor),(0,b.dispose)(y),(0,b.dispose)(v),m.removedDocuments&&this._onDidRemoveDocuments.fire(y),m.addedDocuments&&this._onDidAddDocuments.fire(i),(m.removedEditors||m.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),m.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(m){return this._documents.get(m)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),m=>m.value)}getEditor(m){return this._editors.get(m)}activeEditor(m){if(!this._activeEditorId)return;const y=this._editors.get(this._activeEditorId);return m?y:y?.value}allEditors(){return[...this._editors.values()]}};S=Ue([He(0,T.IExtHostRpcService),He(1,n.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[189],be([0,1,2,5,6,7,8,232,9,22]),function(ne,e,d,M,b,R,F,C,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(u){this._stateMachine=void 0,this._schemes.push(u)}delete(u){const l=this._schemes.indexOf(u);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const u=this._schemes.sort(),l=[];let a,w,I=14,S=14;for(const o of u){let m=a?(0,_.commonPrefixLength)(a,o):0;for(m===0?w=1:w=S;m<o.length;m++)m+1===o.length?(I=S,S=9):S+=1,l.push([w,o.toUpperCase().charCodeAt(m),S]),l.push([w,o.toLowerCase().charCodeAt(m),S]),w=S;a=o,S=I}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new C.StateMachine(l)}}provideDocumentLinks(u){this._initStateMachine();const l=[],a=C.LinkComputer.computeLinks({getLineContent(w){return u.lineAt(w-1).text},getLineCount(){return u.lineCount}},this._stateMachine);for(const w of a){const I=F.DocumentLink.to(w);I.target&&l.push(I)}return l}}class E{constructor(u,l){this._extHostLanguageFeatures=l,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=u.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(u,l,a,w={}){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const I=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(I,a);let S=2;w.isCaseSensitive&&(S+=1024),w.isReadonly&&(S+=2048),typeof a.copy=="function"&&(S+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&(S+=4),this._proxy.$registerFileSystemProvider(I,l,S).catch(m=>{console.error(`FAILED to register filesystem provider of ${u.value}-extension for the scheme ${l}`),console.error(m)});const o=a.onDidChangeFile(m=>{const y=[];for(const i of m){let{uri:v,type:r}=i;if(v.scheme!==l)continue;let s;switch(r){case R.FileChangeType.Changed:s=0;break;case R.FileChangeType.Created:s=1;break;case R.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}y.push({resource:v,type:s})}this._proxy.$onFileSystemChange(I,y)});return(0,b.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(I),this._proxy.$unregisterProvider(I)})}static _asIStat(u){const{type:l,ctime:a,mtime:w,size:I,permissions:S}=u;return{type:l,ctime:a,mtime:w,size:I,permissions:S}}$stat(u,l){return Promise.resolve(this._getFsProvider(u).stat(d.URI.revive(l))).then(a=>E._asIStat(a))}$readdir(u,l){return Promise.resolve(this._getFsProvider(u).readDirectory(d.URI.revive(l)))}$readFile(u,l){return Promise.resolve(this._getFsProvider(u).readFile(d.URI.revive(l))).then(a=>T.VSBuffer.wrap(a))}$writeFile(u,l,a,w){return Promise.resolve(this._getFsProvider(u).writeFile(d.URI.revive(l),a.buffer,w))}$delete(u,l,a){return Promise.resolve(this._getFsProvider(u).delete(d.URI.revive(l),a))}$rename(u,l,a,w){return Promise.resolve(this._getFsProvider(u).rename(d.URI.revive(l),d.URI.revive(a),w))}$copy(u,l,a,w){const I=this._getFsProvider(u);if(!I.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(I.copy(d.URI.revive(l),d.URI.revive(a),w))}$mkdir(u,l){return Promise.resolve(this._getFsProvider(u).createDirectory(d.URI.revive(l)))}$watch(u,l,a,w){const I=this._getFsProvider(u).watch(d.URI.revive(a),w);this._watches.set(l,I)}$unwatch(u,l){const a=this._watches.get(l);a&&(a.dispose(),this._watches.delete(l))}$open(u,l,a){const w=this._getFsProvider(u);if(!w.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(w.open(d.URI.revive(l),a))}$close(u,l){const a=this._getFsProvider(u);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(l))}$read(u,l,a,w){const I=this._getFsProvider(u);if(!I.read)throw new Error('FileSystemProvider does not implement "read"');const S=T.VSBuffer.alloc(w);return Promise.resolve(I.read(l,a,S.buffer,0,w)).then(o=>S.slice(0,o))}$write(u,l,a,w){const I=this._getFsProvider(u);if(!I.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(I.write(l,a,w.buffer,0,w.byteLength))}_getFsProvider(u){const l=this._fsProvider.get(u);if(!l){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return l}}e.ExtHostFileSystem=E}),define(we[71],be([0,1,5,60,7,22,4,12,37]),function(ne,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class Bt{constructor(E,n){const u=E.getProxy(d.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return u.$stat(l).catch(Bt._handleError)},readDirectory(l){return u.$readdir(l).catch(Bt._handleError)},createDirectory(l){return u.$mkdir(l).catch(Bt._handleError)},async readFile(l){return u.$readFile(l).then(a=>a.buffer).catch(Bt._handleError)},writeFile(l,a){return u.$writeFile(l,R.VSBuffer.wrap(a)).catch(Bt._handleError)},delete(l,a){return u.$delete(l,{recursive:!1,useTrash:!1,...a}).catch(Bt._handleError)},rename(l,a,w){return u.$rename(l,a,{overwrite:!1,...w}).catch(Bt._handleError)},copy(l,a,w){return u.$copy(l,a,{overwrite:!1,...w}).catch(Bt._handleError)},isWritableFileSystem(l){const a=n.getCapabilities(l);if(typeof a=="number")return!(a&2048)}})}static _handleError(E){if(!(E instanceof Error))throw new b.FileSystemError(String(E));if(E.name==="ENOPRO")throw b.FileSystemError.Unavailable(E.message);switch(E.name){case M.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(E.message);case M.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(E.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(E.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(E.message);case M.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(E.message);case M.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(E.message);default:throw new b.FileSystemError(E.message,E.name)}}};T=Ue([He(0,C.IExtHostRpcService),He(1,_.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(we[190],be([0,1,2,39]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(F,C,_,T){this._extHostNotebooks=C,this._textDocumentsAndEditors=_,this._commands=T;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new M.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new M.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new M.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new M.ApiCommandResult("Notebook and input URI",E=>{if(E.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(E.notebookEditorId);return{notebookUri:d.URI.revive(E.notebookUri),inputUri:d.URI.revive(E.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:d.URI.revive(E.notebookUri),inputUri:d.URI.revive(E.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,C,_,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:_,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=b}),define(we[191],be([0,1,6,5]),function(ne,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,F),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=b}),define(we[192],be([0,1,2,23,8,7,5,9,44,13,10,233,6,80,53,63,193,16,3]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentSymbols(x,Q){const ee=this._documents.getDocument(x),le=await this._provider.provideDocumentSymbols(ee,Q);if(!(0,T.isFalsyOrEmpty)(le))return le[0]instanceof R.DocumentSymbol?le.map(b.DocumentSymbol.from):o._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(x){x=x.slice(0).sort((le,q)=>{let ae=le.location.range.start.compareTo(q.location.range.start);return ae===0&&(ae=q.location.range.end.compareTo(le.location.range.end)),ae});const Q=[],ee=[];for(const le of x){const q={name:le.name||"!!MISSING: name!!",kind:b.SymbolKind.from(le.kind),tags:le.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:b.Range.from(le.location.range),selectionRange:b.Range.from(le.location.range),children:[]};for(;;){if(ee.length===0){ee.push(q),Q.push(q);break}const ae=ee[ee.length-1];if(_.Range.containsRange(ae.range,q.range)&&!_.Range.equalsRange(ae.range,q.range)){ae.children&&ae.children.push(q),ee.push(q);break}ee.pop()}}return Q}}class m{constructor(x,Q,ee){this._documents=x,this._commands=Q,this._provider=ee,this._cache=new a.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,Q){const ee=this._documents.getDocument(x),le=await this._provider.provideCodeLenses(ee,Q);if(!le||Q.isCancellationRequested)return;const q=this._cache.add(le),ae=new n.DisposableStore;this._disposables.set(q,ae);const he={cacheId:q,lenses:[]};for(let Te=0;Te<le.length;Te++)he.lenses.push({cacheId:[q,Te],range:b.Range.from(le[Te].range),command:this._commands.toInternal(le[Te].command,ae)});return he}async resolveCodeLens(x,Q){const ee=x.cacheId&&this._cache.get(...x.cacheId);if(!ee)return;let le;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?le=ee:le=await this._provider.resolveCodeLens(ee,Q),le||(le=ee),Q.isCancellationRequested)return;const q=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!q)return x.command=this._commands.toInternal(le.command??m._badCmd,q),x}releaseCodeLenses(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}}m._badCmd={command:"missing",title:"!!MISSING: command!!"};function y(je){return Array.isArray(je)?je.map(b.DefinitionLink.from):je?[b.DefinitionLink.from(je)]:[]}class i{constructor(x,Q){this._documents=x,this._provider=Q}async provideDefinition(x,Q,ee){const le=this._documents.getDocument(x),q=b.Position.to(Q),ae=await this._provider.provideDefinition(le,q,ee);return y(ae)}}class v{constructor(x,Q){this._documents=x,this._provider=Q}async provideDeclaration(x,Q,ee){const le=this._documents.getDocument(x),q=b.Position.to(Q),ae=await this._provider.provideDeclaration(le,q,ee);return y(ae)}}class r{constructor(x,Q){this._documents=x,this._provider=Q}async provideImplementation(x,Q,ee){const le=this._documents.getDocument(x),q=b.Position.to(Q),ae=await this._provider.provideImplementation(le,q,ee);return y(ae)}}class s{constructor(x,Q){this._documents=x,this._provider=Q}async provideTypeDefinition(x,Q,ee){const le=this._documents.getDocument(x),q=b.Position.to(Q),ae=await this._provider.provideTypeDefinition(le,q,ee);return y(ae)}}class c{constructor(x,Q){this._documents=x,this._provider=Q}async provideHover(x,Q,ee){const le=this._documents.getDocument(x),q=b.Position.to(Q),ae=await this._provider.provideHover(le,q,ee);if(!(!ae||(0,T.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=le.getWordRangeAtPosition(q)),ae.range||(ae.range=new R.Range(q,q)),b.Hover.from(ae)}}class h{constructor(x,Q){this._documents=x,this._provider=Q}async provideEvaluatableExpression(x,Q,ee){const le=this._documents.getDocument(x),q=b.Position.to(Q),ae=await this._provider.provideEvaluatableExpression(le,q,ee);if(ae)return b.EvaluatableExpression.from(ae)}}class g{constructor(x,Q){this._documents=x,this._provider=Q}async provideInlineValues(x,Q,ee,le){const q=this._documents.getDocument(x),ae=await this._provider.provideInlineValues(q,b.Range.to(Q),b.InlineValueContext.to(ee),le);if(Array.isArray(ae))return ae.map(he=>b.InlineValue.from(he))}}class k{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentHighlights(x,Q,ee){const le=this._documents.getDocument(x),q=b.Position.to(Q),ae=await this._provider.provideDocumentHighlights(le,q,ee);if(Array.isArray(ae))return ae.map(b.DocumentHighlight.from)}}class P{constructor(x,Q){this._documents=x,this._provider=Q}async provideLinkedEditingRanges(x,Q,ee){const le=this._documents.getDocument(x),q=b.Position.to(Q),ae=await this._provider.provideLinkedEditingRanges(le,q,ee);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,T.coalesce)(ae.ranges.map(b.Range.from)),wordPattern:ae.wordPattern}}}class p{constructor(x,Q){this._documents=x,this._provider=Q}async provideReferences(x,Q,ee,le){const q=this._documents.getDocument(x),ae=b.Position.to(Q),he=await this._provider.provideReferences(q,ae,ee,le);if(Array.isArray(he))return he.map(b.location.from)}}class D{constructor(x,Q,ee,le,q,ae,he){this._documents=x,this._commands=Q,this._diagnostics=ee,this._provider=le,this._logService=q,this._extension=ae,this._apiDeprecation=he,this._cache=new a.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(x,Q,ee,le){const q=this._documents.getDocument(x),ae=E.Selection.isISelection(Q)?b.Selection.to(Q):b.Range.to(Q),he=[];for(const rt of this._diagnostics.getDiagnostics(x))if(ae.intersection(rt.range)&&he.push(rt)>D._maxCodeActionsPerFile)break;const Te={diagnostics:he,only:ee.only?new R.CodeActionKind(ee.only):void 0,triggerKind:b.CodeActionTriggerKind.to(ee.trigger)},Be=await this._provider.provideCodeActions(q,ae,Te,le);if(!(0,T.isNonEmptyArray)(Be)||le.isCancellationRequested)return;const $e=this._cache.add(Be),Qe=new n.DisposableStore;this._disposables.set($e,Qe);const _e=[];for(let rt=0;rt<Be.length;rt++){const H=Be[rt];!H||(D._isCommand(H)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:H.title,command:this._commands.toInternal(H,Qe)})):(Te.only&&(H.kind?Te.only.contains(H.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${H.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[$e,rt],title:H.title,command:H.command&&this._commands.toInternal(H.command,Qe),diagnostics:H.diagnostics&&H.diagnostics.map(b.Diagnostic.from),edit:H.edit&&b.WorkspaceEdit.from(H.edit),kind:H.kind&&H.kind.value,isPreferred:H.isPreferred,disabled:H.disabled?.reason})))}return{cacheId:$e,actions:_e}}async resolveCodeAction(x,Q){const[ee,le]=x,q=this._cache.get(ee,le);if(!q||D._isCommand(q)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(q,Q)??q;return ae?.edit?b.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}D._maxCodeActionsPerFile=1e3;class f{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentFormattingEdits(x,Q,ee){const le=this._documents.getDocument(x),q=await this._provider.provideDocumentFormattingEdits(le,Q,ee);if(Array.isArray(q))return q.map(b.TextEdit.from)}}class A{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentRangeFormattingEdits(x,Q,ee,le){const q=this._documents.getDocument(x),ae=b.Range.to(Q),he=await this._provider.provideDocumentRangeFormattingEdits(q,ae,ee,le);if(Array.isArray(he))return he.map(b.TextEdit.from)}}class L{constructor(x,Q){this._documents=x,this._provider=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(x,Q,ee,le,q){const ae=this._documents.getDocument(x),he=b.Position.to(Q),Te=await this._provider.provideOnTypeFormattingEdits(ae,he,ee,le,q);if(Array.isArray(Te))return Te.map(b.TextEdit.from)}}class V{constructor(x,Q){this._provider=x,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(x,Q){const ee=F.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(x,Q);if((0,T.isNonEmptyArray)(le))for(const q of le){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const ae=F.IdObject.mixin(b.WorkspaceSymbol.from(q));this._symbolCache.set(ae._id,q),ee.symbols.push(ae)}return ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee}async resolveWorkspaceSymbol(x,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const ee=this._symbolCache.get(x._id);if(ee){const le=await this._provider.resolveWorkspaceSymbol(ee,Q);return le&&(0,M.mixin)(x,b.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(x){const Q=this._resultCache.get(x);if(Q){for(let[ee,le]=Q;ee<=le;ee++)this._symbolCache.delete(ee);this._resultCache.delete(x)}}}class G{constructor(x,Q,ee){this._documents=x,this._provider=Q,this._logService=ee}static supportsResolving(x){return typeof x.prepareRename=="function"}async provideRenameEdits(x,Q,ee,le){const q=this._documents.getDocument(x),ae=b.Position.to(Q);try{const he=await this._provider.provideRenameEdits(q,ae,ee,le);return he?b.WorkspaceEdit.from(he):void 0}catch(he){const Te=G._asMessage(he);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(x,Q,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(x),q=b.Position.to(Q);try{const ae=await this._provider.prepareRename(le,q,ee);let he,Te;if(R.Range.isRange(ae)?(he=ae,Te=le.getText(ae)):(0,t.isObject)(ae)&&(he=ae.range,Te=ae.placeholder),!he||!Te)return;if(he.start.line>q.line||he.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(he),text:Te}}catch(ae){const he=G._asMessage(ae);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class ${constructor(x,Q){this.resultId=x,this.tokens=Q}}class K{constructor(x,Q){this._documents=x,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(x,Q,ee){const le=this._documents.getDocument(x),q=Q!==0?this._previousResults.get(Q):null;let ae=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,q.resultId,ee):await this._provider.provideDocumentSemanticTokens(le,ee);return q&&this._previousResults.delete(Q),ae?(ae=K._fixProvidedSemanticTokens(ae),this._send(K._convertToEdits(q,ae),ae)):null}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return K._isSemanticTokens(x)?K._isCorrectSemanticTokens(x)?x:new R.SemanticTokens(new Uint32Array(x.data),x.resultId):K._isSemanticTokensEdits(x)?K._isCorrectSemanticTokensEdits(x)?x:new R.SemanticTokensEdits(x.edits.map(Q=>new R.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const Q of x.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,Q){if(!K._isSemanticTokens(Q)||!x||!x.tokens)return Q;const ee=x.tokens,le=ee.length,q=Q.data,ae=q.length;let he=0;const Te=Math.min(le,ae);for(;he<Te&&ee[he]===q[he];)he++;if(he===le&&he===ae)return new R.SemanticTokensEdits([],Q.resultId);let Be=0;const $e=Te-he;for(;Be<$e&&ee[le-Be-1]===q[ae-Be-1];)Be++;return new R.SemanticTokensEdits([{start:he,deleteCount:le-he-Be,data:q.subarray(he,ae-Be)}],Q.resultId)}_send(x,Q){if(K._isSemanticTokens(x)){const ee=this._nextResultId++;return this._previousResults.set(ee,new $(x.resultId,x.data)),(0,u.encodeSemanticTokensDto)({id:ee,type:"full",data:x.data})}if(K._isSemanticTokensEdits(x)){const ee=this._nextResultId++;return K._isSemanticTokens(Q)?this._previousResults.set(ee,new $(Q.resultId,Q.data)):this._previousResults.set(ee,new $(x.resultId)),(0,u.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(x.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=K;class W{constructor(x,Q){this._documents=x,this._provider=Q}async provideDocumentRangeSemanticTokens(x,Q,ee){const le=this._documents.getDocument(x),q=await this._provider.provideDocumentRangeSemanticTokens(le,b.Range.to(Q),ee);return q?this._send(q):null}_send(x){return(0,u.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=W;class U{constructor(x,Q,ee,le,q){this._documents=x,this._commands=Q,this._provider=ee,this._apiDeprecation=le,this._extension=q,this._cache=new a.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,Q,ee,le){const q=this._documents.getDocument(x),ae=b.Position.to(Q),he=q.getWordRangeAtPosition(ae)||new R.Range(ae,ae),Te=he.with({end:ae}),Be=new w.StopWatch(!0),$e=await this._provider.provideCompletionItems(q,ae,le,b.CompletionContext.to(ee));if(!$e||le.isCancellationRequested)return;const Qe=Array.isArray($e)?new R.CompletionList($e):$e,_e=U.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),rt=new n.DisposableStore;this._disposables.set(_e,rt);const H=[],J={x:_e,b:H,a:{replace:b.Range.from(he),insert:b.Range.from(Te)},c:Qe.isIncomplete||void 0,d:Be.elapsed()};for(let me=0;me<Qe.items.length;me++){const Ne=Qe.items[me],Ke=this._convertCompletionItem(Ne,[_e,me],Te,he);H.push(Ke)}return J}async resolveCompletionItem(x,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...x);if(!ee)return;const le=await this._provider.resolveCompletionItem(ee,Q);if(!!le)return this._convertCompletionItem(le,x)}releaseCompletionItems(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,Q,ee,le){const q=this._disposables.get(Q[0]);if(!q)throw Error("DisposableStore is missing...");const ae={x:Q,a:x.label,b:x.kind!==void 0?b.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(b.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:b.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(x.command,q)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=x.textEdit.newText):typeof x.insertText=="string"?ae.h=x.insertText:x.insertText instanceof R.SnippetString&&(ae.h=x.insertText.value,ae.i|=4);let he;return x.textEdit?he=x.textEdit.range:x.range&&(he=x.range),R.Range.isRange(he)?ae.j=b.Range.from(he):he&&(!ee?.isEqual(he.inserting)||!le?.isEqual(he.replacing))&&(ae.j={insert:b.Range.from(he.inserting),replace:b.Range.from(he.replacing)}),ae}}class z{constructor(x,Q,ee){this._documents=x,this._provider=Q,this._commands=ee,this._cache=new a.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(x,Q,ee,le){const q=this._documents.getDocument(x),ae=b.Position.to(Q),he=await this._provider.provideInlineCompletionItems(q,ae,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:b.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:ee.triggerKind},le);if(!he||le.isCancellationRequested)return;const Te=(0,t.isArray)(he)?{items:he}:he,Be=this._cache.add(Te.items);let $e;return{pid:Be,items:Te.items.map((Qe,_e)=>{let rt;return Qe.command&&($e||($e=new n.DisposableStore,this._disposables.set(Be,$e)),rt=this._commands.toInternal(Qe.command,$e)),{text:Qe.text,range:Qe.range?b.Range.from(Qe.range):void 0,command:rt,idx:_e}})}}disposeCompletions(x){this._cache.delete(x);const Q=this._disposables.get(x);Q&&Q.clear(),this._disposables.delete(x)}handleDidShowCompletionItem(x,Q){const ee=this._cache.get(x,Q);ee&&Y.get(this._provider).fireOnDidShowCompletionItem({completionItem:ee})}}class Y{constructor(){this._onDidShowCompletionItemEmitter=new S.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(x){let Q=Y.map.get(x);return Q||(Q=new Y,Y.map.set(x,Q)),Q}fireOnDidShowCompletionItem(x){this._onDidShowCompletionItemEmitter.fire(x)}}e.InlineCompletionController=Y,Y.map=new WeakMap;class re{constructor(x,Q){this._documents=x,this._provider=Q,this._cache=new a.Cache("SignatureHelp")}async provideSignatureHelp(x,Q,ee,le){const q=this._documents.getDocument(x),ae=b.Position.to(Q),he=this.reviveContext(ee),Te=await this._provider.provideSignatureHelp(q,ae,le,he);if(Te){const Be=this._cache.add([Te]);return{...b.SignatureHelp.from(Te),id:Be}}}reviveContext(x){let Q;if(x.activeSignatureHelp){const ee=b.SignatureHelp.to(x.activeSignatureHelp),le=this._cache.get(x.activeSignatureHelp.id,0);le?(Q=le,Q.activeSignature=ee.activeSignature,Q.activeParameter=ee.activeParameter):Q=ee}return{...x,activeSignatureHelp:Q}}releaseSignatureHelp(x){this._cache.delete(x)}}class j{constructor(x,Q){this._documents=x,this._provider=Q}async provideInlayHints(x,Q,ee){const le=this._documents.getDocument(x),q=await this._provider.provideInlayHints(le,b.Range.to(Q),ee);return q?{hints:q.map(b.InlayHint.from)}:void 0}}class ue{constructor(x,Q){this._documents=x,this._provider=Q,this._cache=new a.Cache("DocumentLink")}async provideLinks(x,Q){const ee=this._documents.getDocument(x),le=await this._provider.provideDocumentLinks(ee,Q);if(!(!Array.isArray(le)||le.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(ue._validateLink).map(b.DocumentLink.from)};{const q=this._cache.add(le),ae={links:[],id:q};for(let he=0;he<le.length;he++){if(!ue._validateLink(le[he]))continue;const Te=b.DocumentLink.from(le[he]);Te.cacheId=[q,he],ae.links.push(Te)}return ae}}}static _validateLink(x){return x.target&&x.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(x,Q){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...x);if(!ee)return;const le=await this._provider.resolveDocumentLink(ee,Q);if(!(!le||!ue._validateLink(le)))return b.DocumentLink.from(le)}releaseLinks(x){this._cache.delete(x)}}class oe{constructor(x,Q){this._documents=x,this._provider=Q}async provideColors(x,Q){const ee=this._documents.getDocument(x),le=await this._provider.provideDocumentColors(ee,Q);return Array.isArray(le)?le.map(ae=>({color:b.Color.from(ae.color),range:b.Range.from(ae.range)})):[]}async provideColorPresentations(x,Q,ee){const le=this._documents.getDocument(x),q=b.Range.to(Q.range),ae=b.Color.to(Q.color),he=await this._provider.provideColorPresentations(ae,{document:le,range:q},ee);if(!!Array.isArray(he))return he.map(b.ColorPresentation.from)}}class ve{constructor(x,Q){this._documents=x,this._provider=Q}async provideFoldingRanges(x,Q,ee){const le=this._documents.getDocument(x),q=await this._provider.provideFoldingRanges(le,Q,ee);if(!!Array.isArray(q))return q.map(b.FoldingRange.from)}}class Fe{constructor(x,Q,ee){this._documents=x,this._provider=Q,this._logService=ee}async provideSelectionRanges(x,Q,ee){const le=this._documents.getDocument(x),q=Q.map(b.Position.to),ae=await this._provider.provideSelectionRanges(le,q,ee);if(!(0,T.isNonEmptyArray)(ae))return[];if(ae.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Te=0;Te<q.length;Te++){const Be=[];he.push(Be);let $e=q[Te],Qe=ae[Te];for(;;){if(!Qe.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(b.SelectionRange.from(Qe)),!Qe.parent)break;$e=Qe.range,Qe=Qe.parent}}return he}}class Me{constructor(x,Q){this._documents=x,this._provider=Q,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(x,Q,ee){const le=this._documents.getDocument(x),q=b.Position.to(Q),ae=await this._provider.prepareCallHierarchy(le,q,ee);if(!ae)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(ae)?ae.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,ae)]}async provideCallsTo(x,Q,ee){const le=this._itemFromCache(x,Q);if(!le)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(le,ee);if(!!q)return q.map(ae=>({from:this._cacheAndConvertItem(x,ae.from),fromRanges:ae.fromRanges.map(he=>b.Range.from(he))}))}async provideCallsFrom(x,Q,ee){const le=this._itemFromCache(x,Q);if(!le)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(le,ee);if(!!q)return q.map(ae=>({to:this._cacheAndConvertItem(x,ae.to),fromRanges:ae.fromRanges.map(he=>b.Range.from(he))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Q){const ee=this._cache.get(x),le=b.CallHierarchyItem.from(Q,x,ee.size.toString(36));return ee.set(le._itemId,Q),le}_itemFromCache(x,Q){return this._cache.get(x)?.get(Q)}}class Oe{constructor(x,Q){this._documents=x,this._provider=Q,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(x,Q,ee){const le=this._documents.getDocument(x),q=b.Position.to(Q),ae=await this._provider.prepareTypeHierarchy(le,q,ee);if(!ae)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(ae)?ae.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,ae)]}async provideSupertypes(x,Q,ee){const le=this._itemFromCache(x,Q);if(!le)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(le,ee);if(!!q)return q.map(ae=>this._cacheAndConvertItem(x,ae))}async provideSubtypes(x,Q,ee){const le=this._itemFromCache(x,Q);if(!le)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(le,ee);if(!!q)return q.map(ae=>this._cacheAndConvertItem(x,ae))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Q){const ee=this._cache.get(x),le=b.TypeHierarchyItem.from(Q,x,ee.size.toString(36));return ee.set(le._itemId,Q),le}_itemFromCache(x,Q){return this._cache.get(x)?.get(Q)}}class Ye{constructor(x,Q){this.adapter=x,this.extension=Q}}class ze{constructor(x,Q,ee,le,q,ae,he){this._adapter=new Map,this._uriTransformer=Q,this._proxy=x.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=le,this._diagnostics=q,this._logService=ae,this._apiDeprecation=he}_transformDocumentSelector(x){return(0,T.coalesce)((0,T.asArray)(x).map(Q=>this._doTransformDocumentSelector(Q)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:b.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new R.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return ze._handlePool++}_withAdapter(x,Q,ee,le,q=!1){const ae=this._adapter.get(x);if(!ae)return Promise.resolve(le);if(ae.adapter instanceof Q){let he;ae.extension&&(he=Date.now(),this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Te=ee(ae.adapter,ae.extension),Be=ae.extension;return Be&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Be.identifier.value}] provider DONE after ${Date.now()-he}ms`),$e=>{q&&$e instanceof I.CancellationError||(this._logService.error(`[${Be.identifier.value}] provider FAILED`),this._logService.error($e))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,Q){const ee=this._nextHandle();return this._adapter.set(ee,new Ye(x,Q)),ee}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,Q,ee,le){const q=this._addNewAdapter(new o(this._documents,ee),x),ae=le&&le.label||ze._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(Q),ae),this._createDisposable(q)}$provideDocumentSymbols(x,Q,ee){return this._withAdapter(x,o,le=>le.provideDocumentSymbols(d.URI.revive(Q),ee),void 0)}registerCodeLensProvider(x,Q,ee){const le=this._nextHandle(),q=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new Ye(new m(this._documents,this._commands.converter,ee),x)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(Q),q);let ae=this._createDisposable(le);if(q!==void 0){const he=ee.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(q));ae=R.Disposable.from(ae,he)}return ae}$provideCodeLenses(x,Q,ee){return this._withAdapter(x,m,le=>le.provideCodeLenses(d.URI.revive(Q),ee),void 0)}$resolveCodeLens(x,Q,ee){return this._withAdapter(x,m,le=>le.resolveCodeLens(Q,ee),void 0)}$releaseCodeLenses(x,Q){this._withAdapter(x,m,ee=>Promise.resolve(ee.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(x,Q,ee){const le=this._addNewAdapter(new i(this._documents,ee),x);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(Q)),this._createDisposable(le)}$provideDefinition(x,Q,ee,le){return this._withAdapter(x,i,q=>q.provideDefinition(d.URI.revive(Q),ee,le),[])}registerDeclarationProvider(x,Q,ee){const le=this._addNewAdapter(new v(this._documents,ee),x);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(Q)),this._createDisposable(le)}$provideDeclaration(x,Q,ee,le){return this._withAdapter(x,v,q=>q.provideDeclaration(d.URI.revive(Q),ee,le),[])}registerImplementationProvider(x,Q,ee){const le=this._addNewAdapter(new r(this._documents,ee),x);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(Q)),this._createDisposable(le)}$provideImplementation(x,Q,ee,le){return this._withAdapter(x,r,q=>q.provideImplementation(d.URI.revive(Q),ee,le),[])}registerTypeDefinitionProvider(x,Q,ee){const le=this._addNewAdapter(new s(this._documents,ee),x);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(Q)),this._createDisposable(le)}$provideTypeDefinition(x,Q,ee,le){return this._withAdapter(x,s,q=>q.provideTypeDefinition(d.URI.revive(Q),ee,le),[])}registerHoverProvider(x,Q,ee,le){const q=this._addNewAdapter(new c(this._documents,ee),x);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(Q)),this._createDisposable(q)}$provideHover(x,Q,ee,le){return this._withAdapter(x,c,q=>q.provideHover(d.URI.revive(Q),ee,le),void 0)}registerEvaluatableExpressionProvider(x,Q,ee,le){const q=this._addNewAdapter(new h(this._documents,ee),x);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(Q)),this._createDisposable(q)}$provideEvaluatableExpression(x,Q,ee,le){return this._withAdapter(x,h,q=>q.provideEvaluatableExpression(d.URI.revive(Q),ee,le),void 0)}registerInlineValuesProvider(x,Q,ee,le){const q=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new g(this._documents,ee),x);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(Q),q);let he=this._createDisposable(ae);if(q!==void 0){const Te=ee.onDidChangeInlineValues(Be=>this._proxy.$emitInlineValuesEvent(q));he=R.Disposable.from(he,Te)}return he}$provideInlineValues(x,Q,ee,le,q){return this._withAdapter(x,g,ae=>ae.provideInlineValues(d.URI.revive(Q),ee,le,q),void 0)}registerDocumentHighlightProvider(x,Q,ee){const le=this._addNewAdapter(new k(this._documents,ee),x);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(Q)),this._createDisposable(le)}$provideDocumentHighlights(x,Q,ee,le){return this._withAdapter(x,k,q=>q.provideDocumentHighlights(d.URI.revive(Q),ee,le),void 0)}registerLinkedEditingRangeProvider(x,Q,ee){const le=this._addNewAdapter(new P(this._documents,ee),x);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(Q)),this._createDisposable(le)}$provideLinkedEditingRanges(x,Q,ee,le){return this._withAdapter(x,P,async q=>{const ae=await q.provideLinkedEditingRanges(d.URI.revive(Q),ee,le);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?ze._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(x,Q,ee){const le=this._addNewAdapter(new p(this._documents,ee),x);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(Q)),this._createDisposable(le)}$provideReferences(x,Q,ee,le,q){return this._withAdapter(x,p,ae=>ae.provideReferences(d.URI.revive(Q),ee,le,q),void 0)}registerCodeActionProvider(x,Q,ee,le){const q=new n.DisposableStore,ae=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(Q),{providedKinds:le?.providedCodeActionKinds?.map(he=>he.value),documentation:le?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,q)}))},ze._extLabel(x),Boolean(ee.resolveCodeAction)),q.add(this._createDisposable(ae)),q}$provideCodeActions(x,Q,ee,le,q){return this._withAdapter(x,D,ae=>ae.provideCodeActions(d.URI.revive(Q),ee,le,q),void 0)}$resolveCodeAction(x,Q,ee){return this._withAdapter(x,D,le=>le.resolveCodeAction(Q,ee),void 0)}$releaseCodeActions(x,Q){this._withAdapter(x,D,ee=>Promise.resolve(ee.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(x,Q,ee){const le=this._addNewAdapter(new f(this._documents,ee),x);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(Q),x.identifier,x.displayName||x.name),this._createDisposable(le)}$provideDocumentFormattingEdits(x,Q,ee,le){return this._withAdapter(x,f,q=>q.provideDocumentFormattingEdits(d.URI.revive(Q),ee,le),void 0)}registerDocumentRangeFormattingEditProvider(x,Q,ee){const le=this._addNewAdapter(new A(this._documents,ee),x);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(Q),x.identifier,x.displayName||x.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(x,Q,ee,le,q){return this._withAdapter(x,A,ae=>ae.provideDocumentRangeFormattingEdits(d.URI.revive(Q),ee,le,q),void 0)}registerOnTypeFormattingEditProvider(x,Q,ee,le){const q=this._addNewAdapter(new L(this._documents,ee),x);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(Q),le,x.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(x,Q,ee,le,q,ae){return this._withAdapter(x,L,he=>he.provideOnTypeFormattingEdits(d.URI.revive(Q),ee,le,q,ae),void 0)}registerWorkspaceSymbolProvider(x,Q){const ee=this._addNewAdapter(new V(Q,this._logService),x);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(x,Q,ee){return this._withAdapter(x,V,le=>le.provideWorkspaceSymbols(Q,ee),{symbols:[]})}$resolveWorkspaceSymbol(x,Q,ee){return this._withAdapter(x,V,le=>le.resolveWorkspaceSymbol(Q,ee),void 0)}$releaseWorkspaceSymbols(x,Q){this._withAdapter(x,V,ee=>ee.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(x,Q,ee){const le=this._addNewAdapter(new G(this._documents,ee,this._logService),x);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(Q),G.supportsResolving(ee)),this._createDisposable(le)}$provideRenameEdits(x,Q,ee,le,q){return this._withAdapter(x,G,ae=>ae.provideRenameEdits(d.URI.revive(Q),ee,le,q),void 0)}$resolveRenameLocation(x,Q,ee,le){return this._withAdapter(x,G,q=>q.resolveRenameLocation(d.URI.revive(Q),ee,le),void 0)}registerDocumentSemanticTokensProvider(x,Q,ee,le){const q=this._nextHandle(),ae=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new Ye(new K(this._documents,ee),x)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(Q),le,ae);let he=this._createDisposable(q);if(ae){const Te=ee.onDidChangeSemanticTokens(Be=>this._proxy.$emitDocumentSemanticTokensEvent(ae));he=R.Disposable.from(he,Te)}return he}$provideDocumentSemanticTokens(x,Q,ee,le){return this._withAdapter(x,K,q=>q.provideDocumentSemanticTokens(d.URI.revive(Q),ee,le),null,!0)}$releaseDocumentSemanticTokens(x,Q){this._withAdapter(x,K,ee=>ee.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(x,Q,ee,le){const q=this._addNewAdapter(new W(this._documents,ee),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(Q),le),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(x,Q,ee,le){return this._withAdapter(x,W,q=>q.provideDocumentRangeSemanticTokens(d.URI.revive(Q),ee,le),null,!0)}registerCompletionItemProvider(x,Q,ee,le){const q=this._addNewAdapter(new U(this._documents,this._commands.converter,ee,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(Q),le,U.supportsResolving(ee),`${x.identifier.value}(${le.join("")})`),this._createDisposable(q)}$provideCompletionItems(x,Q,ee,le,q){return this._withAdapter(x,U,ae=>ae.provideCompletionItems(d.URI.revive(Q),ee,le,q),void 0)}$resolveCompletionItem(x,Q,ee){return this._withAdapter(x,U,le=>le.resolveCompletionItem(Q,ee),void 0)}$releaseCompletionItems(x,Q){this._withAdapter(x,U,ee=>ee.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider(x,Q,ee){const le=this._addNewAdapter(new z(this._documents,ee,this._commands.converter),x);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(Q)),this._createDisposable(le)}$provideInlineCompletions(x,Q,ee,le,q){return this._withAdapter(x,z,ae=>ae.provideInlineCompletions(d.URI.revive(Q),ee,le,q),void 0)}$handleInlineCompletionDidShow(x,Q,ee){this._withAdapter(x,z,async le=>{le.handleDidShowCompletionItem(Q,ee)},void 0)}$freeInlineCompletionsList(x,Q){this._withAdapter(x,z,async ee=>{ee.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider(x,Q,ee,le){const q=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,ae=this._addNewAdapter(new re(this._documents,ee),x);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(Q),q),this._createDisposable(ae)}$provideSignatureHelp(x,Q,ee,le,q){return this._withAdapter(x,re,ae=>ae.provideSignatureHelp(d.URI.revive(Q),ee,le,q),void 0)}$releaseSignatureHelp(x,Q){this._withAdapter(x,re,ee=>ee.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider(x,Q,ee){const le=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new j(this._documents,ee),x);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(Q),le);let ae=this._createDisposable(q);if(le!==void 0){const he=ee.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(le));ae=R.Disposable.from(ae,he)}return ae}$provideInlayHints(x,Q,ee,le){return this._withAdapter(x,j,q=>q.provideInlayHints(d.URI.revive(Q),ee,le),void 0)}registerDocumentLinkProvider(x,Q,ee){const le=this._addNewAdapter(new ue(this._documents,ee),x);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(Q),typeof ee.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(x,Q,ee){return this._withAdapter(x,ue,le=>le.provideLinks(d.URI.revive(Q),ee),void 0)}$resolveDocumentLink(x,Q,ee){return this._withAdapter(x,ue,le=>le.resolveLink(Q,ee),void 0)}$releaseDocumentLinks(x,Q){this._withAdapter(x,ue,ee=>ee.releaseLinks(Q),void 0)}registerColorProvider(x,Q,ee){const le=this._addNewAdapter(new oe(this._documents,ee),x);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(Q)),this._createDisposable(le)}$provideDocumentColors(x,Q,ee){return this._withAdapter(x,oe,le=>le.provideColors(d.URI.revive(Q),ee),[])}$provideColorPresentations(x,Q,ee,le){return this._withAdapter(x,oe,q=>q.provideColorPresentations(d.URI.revive(Q),ee,le),void 0)}registerFoldingRangeProvider(x,Q,ee){const le=this._nextHandle(),q=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new Ye(new ve(this._documents,ee),x)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(Q),q);let ae=this._createDisposable(le);if(q!==void 0){const he=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));ae=R.Disposable.from(ae,he)}return ae}$provideFoldingRanges(x,Q,ee,le){return this._withAdapter(x,ve,q=>q.provideFoldingRanges(d.URI.revive(Q),ee,le),void 0)}registerSelectionRangeProvider(x,Q,ee){const le=this._addNewAdapter(new Fe(this._documents,ee,this._logService),x);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(Q)),this._createDisposable(le)}$provideSelectionRanges(x,Q,ee,le){return this._withAdapter(x,Fe,q=>q.provideSelectionRanges(d.URI.revive(Q),ee,le),[])}registerCallHierarchyProvider(x,Q,ee){const le=this._addNewAdapter(new Me(this._documents,ee),x);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(Q)),this._createDisposable(le)}$prepareCallHierarchy(x,Q,ee,le){return this._withAdapter(x,Me,q=>Promise.resolve(q.prepareSession(d.URI.revive(Q),ee,le)),void 0)}$provideCallHierarchyIncomingCalls(x,Q,ee,le){return this._withAdapter(x,Me,q=>q.provideCallsTo(Q,ee,le),void 0)}$provideCallHierarchyOutgoingCalls(x,Q,ee,le){return this._withAdapter(x,Me,q=>q.provideCallsFrom(Q,ee,le),void 0)}$releaseCallHierarchy(x,Q){this._withAdapter(x,Me,ee=>Promise.resolve(ee.releaseSession(Q)),void 0)}registerTypeHierarchyProvider(x,Q,ee){const le=this._addNewAdapter(new Oe(this._documents,ee),x);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(Q)),this._createDisposable(le)}$prepareTypeHierarchy(x,Q,ee,le){return this._withAdapter(x,Oe,q=>Promise.resolve(q.prepareSession(d.URI.revive(Q),ee,le)),void 0)}$provideTypeHierarchySupertypes(x,Q,ee,le){return this._withAdapter(x,Oe,q=>q.provideSupertypes(Q,ee,le),void 0)}$provideTypeHierarchySubtypes(x,Q,ee,le){return this._withAdapter(x,Oe,q=>q.provideSubtypes(Q,ee,le),void 0)}$releaseTypeHierarchy(x,Q){this._withAdapter(x,Oe,ee=>Promise.resolve(ee.releaseSession(Q)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,C.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:ze._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?ze._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?ze._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:ze._serializeRegExp(x.beforeText),afterText:x.afterText?ze._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?ze._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(ze._serializeOnEnterRule)}setLanguageConfiguration(x,Q,ee){let{wordPattern:le}=ee;if(le&&(0,C.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(Q,le):this._documents.setWordDefinitionFor(Q,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const q=this._nextHandle(),ae={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?ze._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?ze._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?ze._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,Q,ae),this._createDisposable(q)}$setWordDefinitions(x){for(const Q of x)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(we[194],be([0,1,5,8,7,35,14,6]),function(ne,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(t,E,n){this._documents=E,this._commands=n,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,E){await this._proxy.$changeLanguage(t,E);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,E){const n=t.version,u=M.Position.from(E),l=await this._proxy.$tokensAtPosition(t.uri,u),a={type:b.StandardTokenType.Other,range:t.getWordRangeAtPosition(E)??new b.Range(E.line,E.character,E.line,E.character)};if(!l)return a;const w={range:M.Range.to(l.range),type:M.TokenType.to(l.type)};return!w.range.contains(E)||n!==t.version?a:w}createLanguageStatusItem(t,E,n){const u=this._handlePool++,l=this._proxy,a=this._ids,w=`${t.identifier.value}/${E}`;if(a.has(w))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);a.add(w);const I={selector:n,id:E,name:t.displayName??t.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let S,o=new C.DisposableStore;const m=()=>{S?.dispose(),S=(0,F.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(u,{id:w,name:I.name??t.displayName??t.name,source:t.displayName??t.name,selector:I.selector,label:I.text,detail:I.detail??"",severity:I.severity===b.LanguageStatusSeverity.Error?R.default.Error:I.severity===b.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:I.command&&this._commands.toInternal(I.command,o),accessibilityInfo:I.accessibilityInformation})},0)},y={dispose(){o.dispose(),S?.dispose(),l.$removeLanguageStatus(u),a.delete(w)},get id(){return I.id},get name(){return I.name},set name(i){I.name=i,m()},get selector(){return I.selector},set selector(i){I.selector=i,m()},get text(){return I.text},set text(i){I.text=i,m()},get detail(){return I.detail},set detail(i){I.detail=i,m()},get severity(){return I.severity},set severity(i){I.severity=i,m()},get accessibilityInformation(){return I.accessibilityInformation},set accessibilityInformation(i){I.accessibilityInformation=i,m()},get command(){return I.command},set command(i){I.command=i,m()}};return m(),y}}e.ExtHostLanguages=_}),define(we[195],be([0,1,5,15,30]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(C){return C&&C.title}let F=class{constructor(_,T){this._logService=T,this._proxy=_.getProxy(d.MainContext.MainThreadMessageService)}showMessage(_,T,t,E,n){const u={extension:_};let l;typeof E=="string"||R(E)?l=[E,...n]:(u.modal=E?.modal,u.useCustom=E?.useCustom,u.detail=E?.detail,l=n),u.useCustom&&(0,b.checkProposedApiEnabled)(_);const a=[];for(let w=0;w<l.length;w++){const I=l[w];if(typeof I=="string")a.push({title:I,handle:w,isCloseAffordance:!1});else if(typeof I=="object"){let{title:S,isCloseAffordance:o}=I;a.push({title:S,isCloseAffordance:!!o,handle:w})}else this._logService.warn("Invalid message item:",I)}return this._proxy.$showMessage(T,t,u,a).then(w=>{if(typeof w=="number")return l[w]})}};F=Ue([He(1,M.ILogService)],F),e.ExtHostMessageService=F}),define(we[196],be([0,1,22,3,58,6,20,9,10,2,63,5,8,7,38,171,93]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(o,m,y,i,v){this._textDocumentsAndEditors=y,this._textDocuments=i,this._extensionStoragePaths=v,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(E.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(E.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(E.MainContext.MainThreadNotebookEditors),this._commandsConverter=m.converter,m.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,c=r.cell.handle,g=this._documents.get(s)?.getCell(c);if(g)return g.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const m=this._editors.get(o);if(!m)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return m}getIdByEditor(o){for(const[m,y]of this._editors)if(y.apiEditor===o)return m}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,m){const y=this._documents.get(o);if(!y&&!m)throw new Error(`NO notebook document for '${o}'`);return y}_getProviderData(o){const m=this._notebookContentProviders.get(o);if(!m)throw new Error(`NO provider for '${o}'`);return m}registerNotebookContentProvider(o,m,y,i,v){if((0,C.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(m))throw new Error(`Notebook provider for '${m}' already registered`);this._notebookContentProviders.set(m,{extension:o,provider:y});let r;return y.onDidChangeNotebookContentOptions&&(r=y.onDidChangeNotebookContentOptions(()=>{const s=n.NotebookDocumentContentOptions.from(y.options);this._notebookProxy.$updateNotebookProviderOptions(m,s)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},m,n.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(o,v)),new u.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(m),this._notebookProxy.$unregisterNotebookProvider(m)})}static _convertNotebookRegistrationData(o,m){if(!m)return;const y=m.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(m.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${m.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:m.displayName,filenamePattern:y,exclusive:m.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,m,y){const i=I._notebookStatusBarItemProviderHandlePool++,v=typeof y.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,y),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,v,m);let r;return v!==void 0&&(r=y.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(v))),new u.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,v),r&&r.dispose()})}async createNotebookDocument(o){const m=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&n.NotebookData.from(o.content)});return T.URI.revive(m)}async openNotebookDocument(o){const m=this._documents.get(o);if(m)return m.apiNotebook;const y=await this._notebookDocumentsProxy.$tryOpenNotebook(o),i=this._documents.get(T.URI.revive(y));return(0,_.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(o,m){T.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let y;typeof m=="object"?y={position:n.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selections:m.selections&&m.selections.map(n.NotebookRange.from),pinned:typeof m.preview=="boolean"?!m.preview:void 0}:y={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,y),v=i&&this._editors.get(i)?.apiEditor;if(v)return v;throw i?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,m,y,i){const v=this._notebookStatusBarItemProviders.get(o),r=T.URI.revive(m),s=this._documents.get(r);if(!s||!v)return;const c=s.getCellFromIndex(y);if(!c)return;const h=await v.provideCellStatusBarItems(c.apiCell,i);if(!h)return;const g=new R.DisposableStore,k=this._statusBarCache.add([g]),p=(Array.isArray(h)?h:[h]).map(D=>n.NotebookStatusBarItem.from(D,this._commandsConverter,g));return{cacheId:k,items:p}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,m,y,i,v){if((0,C.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,y),this._notebookProxy.$registerNotebookSerializer(r,{id:o.identifier,location:o.extensionLocation},m,n.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(o,v)),(0,R.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(o,m,y){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const v=await i.deserializeNotebook(m.buffer,y);return new l.SerializableObjectWithBuffers(n.NotebookData.from(v))}async $notebookToData(o,m,y){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const v=await i.serializeNotebook(n.NotebookData.to(m.value),y);return d.VSBuffer.wrap(v)}async $openNotebook(o,m,y,i,v){const{provider:r}=this._getProviderData(o),s=await r.openNotebook(T.URI.revive(m),{backupId:y,untitledDocumentData:i?.buffer},v);return new l.SerializableObjectWithBuffers({metadata:s.metadata??Object.create(null),cells:s.cells.map(n.NotebookCellData.from)})}async $saveNotebook(o,m,y){const i=this.getNotebookDocument(T.URI.revive(m)),{provider:v}=this._getProviderData(o);return await v.saveNotebook(i.apiNotebook,y),!0}async $saveNotebookAs(o,m,y,i){const v=this.getNotebookDocument(T.URI.revive(m)),{provider:r}=this._getProviderData(o);return await r.saveNotebookAs(T.URI.revive(y),v.apiNotebook,i),!0}async $backupNotebook(o,m,y){const i=this.getNotebookDocument(T.URI.revive(m)),v=this._getProviderData(o),r=this._extensionStoragePaths.workspaceValue(v.extension)??this._extensionStoragePaths.globalValue(v.extension),s=String((0,b.hash)([i.uri.toString(),this._backupIdPool++])),c=T.URI.joinPath(r,s),h=await v.provider.backupNotebook(i.apiNotebook,{destination:c},y);return i.updateBackup(h),h.id}_createExtHostEditor(o,m,y){if(this._editors.has(m))throw new Error(`editor with id ALREADY EXSIST: ${m}`);const i=new w.ExtHostNotebookEditor(m,this._notebookEditorsProxy,o,y.visibleRanges.map(n.NotebookRange.to),y.selections.map(n.NotebookRange.to),typeof y.viewColumn=="number"?n.ViewColumn.to(y.viewColumn):void 0);this._editors.set(m,i)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const y of o.value.removedDocuments){const i=T.URI.revive(y),v=this._documents.get(i);v&&(v.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(v.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===i.toString()&&this._editors.delete(r.id)}if(o.value.addedDocuments){const y=[];for(const i of o.value.addedDocuments){const v=T.URI.revive(i.uri);if(this._documents.has(v))throw new Error(`adding EXISTING notebook ${v} `);const r=this,s=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(c){r._onDidChangeNotebookCells.fire(c)},emitCellOutputsChange(c){r._onDidChangeCellOutputs.fire(c)},emitCellMetadataChange(c){r._onDidChangeCellMetadata.fire(c)},emitCellExecutionStateChange(c){r._onDidChangeCellExecutionState.fire(c)}},v,i);y.push(...i.cells.map(c=>a.ExtHostCell.asModelAddData(s.apiNotebook,c))),this._documents.get(v)?.dispose(),this._documents.set(v,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(o.value.addedEditors)for(const y of o.value.addedEditors){if(this._editors.has(y.id))return;const i=T.URI.revive(y.documentUri),v=this._documents.get(i);v&&this._createExtHostEditor(v,y.id,y)}const m=[];if(o.value.removedEditors)for(const y of o.value.removedEditors){const i=this._editors.get(y);i&&(this._editors.delete(y),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),m.push(i))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const y=new Set;this._visibleNotebookEditors.forEach(i=>y.add(i.id));for(const i of this._editors.values()){const v=y.has(i.id);i._acceptVisibility(v)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(we[197],be([0,1,3,53,15,5,12,8]),function(ne,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(E,n){const u=_._Keys.nextId();E.$registerNotebookEditorDecorationType(u,C.NotebookDecorationRenderOptions.from(n)),this.value={key:u,dispose(){E.$removeNotebookEditorDecorationType(u)}}}}_._Keys=new M.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(E,n,u){this._logService=E,this._extHostRpc=n,this._notebooksAndEditors=u,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(E){return new _(this._extHostRpc.getProxy(R.MainContext.MainThreadNotebookEditors),E).value}$acceptEditorPropertiesChanged(E,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,n);const u=this._notebooksAndEditors.getEditorById(E);n.visibleRanges&&u._acceptVisibleRanges(n.visibleRanges.ranges.map(C.NotebookRange.to)),n.selections&&u._acceptSelections(n.selections.selections.map(C.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:u.apiEditor,visibleRanges:u.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:u.apiEditor,selections:u.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const n in E)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(C.ViewColumn.to(E[n]))}};T=Ue([He(0,b.ILogService),He(1,F.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(we[198],be([0,1,13,14,21,3,6,20,2,25,15,5,39,8,7,66,164,30,38]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(r,s,c,h,g){this._initData=s,this._extHostNotebook=c,this._commands=h,this._logService=g,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(E.MainContext.MainThreadNotebookKernels);const k=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const p=this._extHostNotebook.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:p}}else if(P&&"notebookEditor"in P){const p=this._extHostNotebook.getIdByEditor(P.notebookEditor);if(p===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.document.uri.toString()}`);return{notebookEditorId:p}}return P})],n.ApiCommandResult.Void);this._commands.registerApiCommand(k)}createNotebookController(r,s,c,h,g,k){for(let re of this._kernelData.values())if(re.controller.id===s&&T.ExtensionIdentifier.equals(r.identifier,re.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const P=this._handlePool++,p=this;this._logService.trace(`NotebookController[${P}], CREATED by ${r.identifier.value}, ${s}`);const D=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${r.identifier}'`);let f=!1;const A=new F.DisposableStore,L=new R.Emitter,V=new R.Emitter,G={id:`${r.identifier.value}/${s}`,notebookType:c,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:h||r.identifier.value,preloads:k?k.map(u.NotebookRendererScript.from):[]};let $=g??D,K;this._proxy.$addKernel(P,G).catch(re=>{console.log(re),f=!0});let W=0;const U=()=>{if(f)return;const re=++W;Promise.resolve().then(()=>{re===W&&this._proxy.$updateKernel(P,G)})},z=new C.ResourceMap,Y={get id(){return s},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return G.label},set label(re){G.label=re??r.displayName??r.name,U()},get detail(){return G.detail??""},set detail(re){G.detail=re,U()},get description(){return G.description??""},set description(re){G.description=re,U()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(re){G.supportedLanguages=re,U()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(re){G.supportsExecutionOrder=re,U()},get rendererScripts(){return G.preloads?G.preloads.map(u.NotebookRendererScript.to):[]},get executeHandler(){return $},set executeHandler(re){$=re??D},get interruptHandler(){return K},set interruptHandler(re){K=re,G.supportsInterrupt=Boolean(re),U()},createNotebookCellExecution(re){if(f)throw new Error("notebook controller is DISPOSED");if(!z.has(re.notebook.uri))throw p._logService.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(z.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return p._createNotebookCellExecution(re)},dispose:()=>{f||(this._logService.trace(`NotebookController[${P}], DISPOSED`),f=!0,this._kernelData.delete(P),A.dispose(),L.dispose(),V.dispose(),this._proxy.$removeKernel(P))},updateNotebookAffinity(re,j){p._proxy.$updateNotebookPriority(P,re.uri,j)},onDidReceiveMessage:V.event,postMessage(re,j){return(0,I.checkProposedApiEnabled)(r),p._proxy.$postMessage(P,j&&p._extHostNotebook.getIdByEditor(j),re)},asWebviewUri(re){return(0,I.checkProposedApiEnabled)(r),(0,a.asWebviewUri)(re,p._initData.remote)}};return this._kernelData.set(P,{extensionId:r.identifier,controller:Y,onDidReceiveMessage:V,onDidChangeSelection:L,associatedNotebooks:z}),Y}$acceptNotebookAssociation(r,s,c){const h=this._kernelData.get(r);if(h){const g=this._extHostNotebook.getNotebookDocument(_.URI.revive(s));c?h.associatedNotebooks.set(g.uri,!0):h.associatedNotebooks.delete(g.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,g.uri.toString(),c),h.onDidChangeSelection.fire({selected:c,notebook:g.apiNotebook})}}async $executeCells(r,s,c){const h=this._kernelData.get(r);if(!h)return;const g=this._extHostNotebook.getNotebookDocument(_.URI.revive(s)),k=[];for(let P of c){const p=g.getCell(P);p&&k.push(p.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,g.uri.toString(),k.length),await h.controller.executeHandler.call(h.controller,k,g.apiNotebook,h.controller)}catch(P){this._logService.error(`NotebookController[${r}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(r,s,c){const h=this._kernelData.get(r);if(!h)return;const g=this._extHostNotebook.getNotebookDocument(_.URI.revive(s));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,g.apiNotebook);else for(let k of c){const P=g.getCell(k);P&&this._activeExecutions.get(P.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,s,c){const h=this._kernelData.get(r);if(!h)return;const g=this._extHostNotebook.getEditorById(s);h.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:c}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const h=new y(c.notebook,c,this._proxy);this._activeExecutions.set(c.uri,h);const g=h.onDidChangeState(()=>{h.state===m.Resolved&&(h.dispose(),g.dispose(),this._activeExecutions.delete(c.uri))});return h.asApiObject()}};o=Ue([He(4,t.ILogService)],o),e.ExtHostNotebookKernels=o;var m;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(m||(m={}));class y extends F.Disposable{constructor(r,s,c){super();this._document=r,this._cell=s,this._proxy=c,this._handle=y.HANDLE++,this._onDidChangeState=new R.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=m.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new i(10,h=>this.update(h)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const s=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new S.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===m.Init)throw new Error("Must call start before modifying cell output");if(this._state===m.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let s=this._cell;if(r&&(s=this._document.getCellFromApiCell(r)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(r){return r.map(s=>{const c=l.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return c===s.items?u.NotebookCellOutput.from(s):u.NotebookCellOutput.from({items:c,id:s.id,metadata:s.metadata})})}async updateOutputs(r,s,c){const h=this.cellIndexToHandle(s),g=this.validateAndConvertOutputs((0,d.asArray)(r));return this.updateSoon({editType:w.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:h,append:c,outputs:g})}async updateOutputItems(r,s,c){return r=l.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(r),!0),this.updateSoon({editType:w.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(u.NotebookCellOutputItem.from),outputId:s.id,append:c})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(c){r._executionOrder=c,r.update([{editType:w.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(c){if(r._state===m.Resolved||r._state===m.Started)throw new Error("Cannot call start again");r._state=m.Started,r._onDidChangeState.fire(),r.update({editType:w.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:c})},end(c,h){if(r._state===m.Resolved)throw new Error("Cannot call resolve twice");r._state=m.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:w.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:h,lastRunSuccess:c}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(c){return r.verifyStateForOutput(),r.updateOutputs([],c,!1)},appendOutput(c,h){return r.verifyStateForOutput(),r.updateOutputs(c,h,!0)},replaceOutput(c,h){return r.verifyStateForOutput(),r.updateOutputs(c,h,!1)},appendOutputItems(c,h){return r.verifyStateForOutput(),r.updateOutputItems(c,h,!0)},replaceOutputItems(c,h){return r.verifyStateForOutput(),r.updateOutputItems(c,h,!1)}})}}y.HANDLE=0;class i{constructor(r,s){this.delay=r,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>r.complete())}}}),define(we[199],be([0,1,3,5,93]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(C,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,_,T){const t=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(_)?.fire({editor:t.apiEditor,message:T})}createRendererMessaging(C,_){if(!C.contributes?.notebookRenderer?.some(n=>n.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);const T=!!C.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,u,l)=>{const a=T?n:w=>{const I={};t.set(I,w.editor),n({editor:I,message:w.message})};return this.getOrCreateEmitterFor(_).event(a,u,l)},postMessage:(n,u)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,u]=[u,n]);const l=T?u:t.get(u),a=l&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(l);return this.proxy.$postMessage(a?.id,_,n)}}}getOrCreateEmitterFor(C){let _=this._rendererMessageEmitters.get(C);return _||(_=new d.Emitter({onLastListenerRemove:()=>{_?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,_),_)}}e.ExtHostNotebookRenderers=R}),define(we[96],be([0,1,5,3,6,22,4,12]),function(ne,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends b.Disposable{constructor(l,a,w,I,S){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=S,this._id=S.$register(this.name,a,w,I),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?R.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(a=>this._proxy.$clear(a,l))}show(l,a){this.validate(),this._id.then(w=>this._proxy.$reveal(w,!!(typeof l=="boolean"?l:a)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class T extends _{constructor(l,a,w){super(l,!1,void 0,a,w)}append(l){super.append(l),this._id.then(a=>this._proxy.$append(a,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class t extends _{constructor(l,a,w){super(l,!0,a,void 0,w)}append(l){throw new Error("Not supported")}}class E{constructor(l,a){this.name=l,this._channel=a}append(l){this._channel.then(a=>a.append(l))}appendLine(l){this._channel.then(a=>a.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,a){this._channel.then(w=>w.show(l,a))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=E;let n=class{constructor(l){this._proxy=l.getProxy(d.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l,a){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new T(l,a.identifier.value,this._proxy)}createOutputChannelFromLogFile(l,a){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!a)throw new Error("illegal argument `file`. must not be falsy");return new t(l,a,this._proxy)}};n=Ue([He(0,C.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(we[200],be([0,1,14,21,3,6,5,2,7,16,13,35,46]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function u(l,a,w){const I=l.getProxy(F.MainContext.MainThreadQuickOpen);class S{constructor(h,g){this._sessions=new Map,this._instances=0,this._workspace=h,this._commands=g}showQuickPick(h,g,k,P=M.CancellationToken.None){this._onDidSelectItem=void 0;const p=Promise.resolve(h),D=++this._instances,f=I.$show(D,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},P),A={},L=f.then(()=>A);return Promise.race([L,p]).then(V=>{if(V!==A)return p.then(G=>{const $=[];for(let K=0;K<G.length;K++){const W=G[K];let U,z,Y,re,j;typeof W=="string"?U=W:(U=W.label,z=W.description,Y=W.detail,re=W.picked,j=W.alwaysShow),$.push({label:U,description:z,handle:K,detail:Y,picked:re,alwaysShow:j})}return k&&typeof k.onDidSelectItem=="function"&&(this._onDidSelectItem=K=>{k.onDidSelectItem(G[K])}),I.$setItems(D,$),f.then(K=>{if(typeof K=="number")return G[K];if(Array.isArray(K))return K.map(W=>G[W])})})}).then(void 0,V=>{if(!(0,T.isPromiseCanceledError)(V))return I.$setError(D,V),Promise.reject(V)})}$onItemSelected(h){this._onDidSelectItem&&this._onDidSelectItem(h)}showInput(h,g=M.CancellationToken.None){return this._validateInput=h?h.validateInput:void 0,I.$input(h,typeof this._validateInput=="function",g).then(void 0,k=>{if(!(0,T.isPromiseCanceledError)(k))return Promise.reject(k)})}$validateInput(h){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(h)):Promise.resolve(void 0)}async showWorkspaceFolderPick(h,g=M.CancellationToken.None){const k=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!k)return;const P=await this._workspace.getWorkspaceFolders2();if(!!P)return P.find(p=>p.uri.toString()===k.uri.toString())}createQuickPick(h,g){const k=new r(h,g,()=>this._sessions.delete(k._id));return this._sessions.set(k._id,k),k}createInputBox(h){const g=new s(h,()=>this._sessions.delete(g._id));return this._sessions.set(g._id,g),g}$onDidChangeValue(h,g){const k=this._sessions.get(h);k&&k._fireDidChangeValue(g)}$onDidAccept(h){const g=this._sessions.get(h);g&&g._fireDidAccept()}$onDidChangeActive(h,g){const k=this._sessions.get(h);k instanceof r&&k._fireDidChangeActive(g)}$onDidChangeSelection(h,g){const k=this._sessions.get(h);k instanceof r&&k._fireDidChangeSelection(g)}$onDidTriggerButton(h,g){const k=this._sessions.get(h);k&&k._fireDidTriggerButton(g)}$onDidTriggerItemButton(h,g,k){const P=this._sessions.get(h);P instanceof r&&P._fireDidTriggerItemButton(g,k)}$onDidHide(h){const g=this._sessions.get(h);g&&g._fireDidHide()}}class o{constructor(h,g){this._extensionId=h,this._onDidDispose=g,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new b.Emitter,this._onDidChangeValueEmitter=new b.Emitter,this._onDidTriggerButtonEmitter=new b.Emitter,this._onDidHideEmitter=new b.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(h){this._title=h,this.update({title:h})}get step(){return this._steps}set step(h){this._steps=h,this.update({step:h})}get totalSteps(){return this._totalSteps}set totalSteps(h){this._totalSteps=h,this.update({totalSteps:h})}get enabled(){return this._enabled}set enabled(h){this._enabled=h,this.update({enabled:h})}get busy(){return this._busy}set busy(h){this._busy=h,this.update({busy:h})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(h){this._ignoreFocusOut=h,this.update({ignoreFocusOut:h})}get value(){return this._value}set value(h){this._value=h,this.update({value:h})}get placeholder(){return this._placeholder}set placeholder(h){this._placeholder=h,this.update({placeholder:h})}get buttons(){return this._buttons}set buttons(h){this._buttons=h.slice(),this._handlesToButtons.clear(),h.forEach((g,k)=>{const P=g===_.QuickInputButtons.Back?-1:k;this._handlesToButtons.set(P,g)}),this.update({buttons:h.map((g,k)=>({...v(g),tooltip:g.tooltip,handle:g===_.QuickInputButtons.Back?-1:k}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(h){this._value=h,this._onDidChangeValueEmitter.fire(h)}_fireDidTriggerButton(h){const g=this._handlesToButtons.get(h);g&&this._onDidTriggerButtonEmitter.fire(g)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,R.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),I.$dispose(this._id))}update(h){if(!this._disposed){for(const g of Object.keys(h)){const k=h[g];this._pendingUpdate[g]=k===void 0?null:k}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){I.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function m(c){if(c instanceof _.ThemeIcon)return{id:c.id};const h=i(c),g=y(c);return{dark:typeof h=="string"?C.URI.file(h):h,light:typeof g=="string"?C.URI.file(g):g}}function y(c){return typeof c=="object"&&"light"in c?c.light:c}function i(c){return typeof c=="object"&&"dark"in c?c.dark:c}function v(c){const h=m(c.iconPath);let g,k;return"id"in h?k=n.ThemeIcon.asClassName(h):g=h,{iconPath:g,iconClass:k}}class r extends o{constructor(h,g,k){super(h,k);this.enableProposedApi=g,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new b.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new b.Emitter,this._onDidTriggerItemButtonEmitter=new b.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(h){this._items=h.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),h.forEach((g,k)=>{this._handlesToItems.set(k,g),this._itemsToHandles.set(g,k)}),this.update({items:h.map((g,k)=>({label:g.label,description:g.description,handle:k,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,buttons:g.buttons&&this.enableProposedApi?g.buttons.map((P,p)=>({...v(P),tooltip:P.tooltip,handle:p})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(h){this._canSelectMany=h,this.update({canSelectMany:h})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(h){this._matchOnDescription=h,this.update({matchOnDescription:h})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(h){this._matchOnDetail=h,this.update({matchOnDetail:h})}get sortByLabel(){return this._sortByLabel}set sortByLabel(h){this._sortByLabel=h,this.update({sortByLabel:h})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(h){this._keepScrollPosition=h,this.update({keepScrollPosition:h})}get activeItems(){return this._activeItems}set activeItems(h){this._activeItems=h.filter(g=>this._itemsToHandles.has(g)),this.update({activeItems:this._activeItems.map(g=>this._itemsToHandles.get(g))})}get selectedItems(){return this._selectedItems}set selectedItems(h){this._selectedItems=h.filter(g=>this._itemsToHandles.has(g)),this.update({selectedItems:this._selectedItems.map(g=>this._itemsToHandles.get(g))})}_fireDidChangeActive(h){const g=(0,t.coalesce)(h.map(k=>this._handlesToItems.get(k)));this._activeItems=g,this._onDidChangeActiveEmitter.fire(g)}_fireDidChangeSelection(h){const g=(0,t.coalesce)(h.map(k=>this._handlesToItems.get(k)));this._selectedItems=g,this._onDidChangeSelectionEmitter.fire(g)}_fireDidTriggerItemButton(h,g){const k=this._handlesToItems.get(h);if(!k||!k.buttons||!k.buttons.length)return;const P=k.buttons[g];P&&this._onDidTriggerItemButtonEmitter.fire({button:P,item:k})}}class s extends o{constructor(h,g){super(h,g);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(h){this._password=h,this.update({password:h})}get prompt(){return this._prompt}set prompt(h){this._prompt=h,this.update({prompt:h})}get validationMessage(){return this._validationMessage}set validationMessage(h){this._validationMessage=h,this.update({validationMessage:h,severity:h?E.default.Error:E.default.Ignore})}}return new S(a,w)}e.createExtHostQuickOpen=u}),define(we[201],be([0,1,2,3,52,6,14,5,13,108,15,25,30,46,8]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(h){if(h)return typeof h.iconPath=="string"?d.URI.file(h.iconPath):d.URI.isUri(h.iconPath)||u.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function w(h,g){if(!h.iconPath&&!g.iconPath)return 0;if(h.iconPath){if(!g.iconPath)return 1}else return-1;const k=typeof h.iconPath=="string"?h.iconPath:d.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,P=typeof g.iconPath=="string"?g.iconPath:d.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,T.comparePaths)(k,P)}function I(h,g){let k=0;if(h.strikeThrough!==g.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==g.faded)return h.faded?1:-1;if(h.tooltip!==g.tooltip)return(h.tooltip||"").localeCompare(g.tooltip||"");if(k=w(h,g),k!==0)return k;if(h.light&&g.light)k=w(h.light,g.light);else{if(h.light)return 1;if(g.light)return-1}if(k!==0)return k;if(h.dark&&g.dark)k=w(h.dark,g.dark);else{if(h.dark)return 1;if(g.dark)return-1}return k}function S(h,g){if(h.command!==g.command)return h.command<g.command?-1:1;if(h.title!==g.title)return h.title<g.title?-1:1;if(h.tooltip!==g.tooltip){if(h.tooltip!==void 0&&g.tooltip!==void 0)return h.tooltip<g.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(h.arguments===g.arguments)return 0;if(h.arguments)if(g.arguments){if(h.arguments.length!==g.arguments.length)return h.arguments.length-g.arguments.length}else return 1;else return-1;for(let k=0;k<h.arguments.length;k++){const P=h.arguments[k],p=g.arguments[k];if(P!==p)return P<p?-1:1}return 0}function o(h,g){let k=(0,T.comparePaths)(h.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(k!==0)return k;if(h.command&&g.command)k=S(h.command,g.command);else{if(h.command)return 1;if(g.command)return-1}if(k!==0)return k;if(h.decorations&&g.decorations)k=I(h.decorations,g.decorations);else{if(h.decorations)return 1;if(g.decorations)return-1}return k}function m(h,g){for(let k=0;k<h.length;k++)if(h[k]!==g[k])return!1;return!0}function y(h,g){return h.command===g.command&&h.title===g.title&&h.tooltip===g.tooltip&&(h.arguments&&g.arguments?m(h.arguments,g.arguments):h.arguments===g.arguments)}function i(h,g){return(0,_.equals)(h,g,y)}class v{constructor(g,k,P){this._extension=g,this._proxy=k,this._sourceControlHandle=P,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(g){this._proxy.$setInputBoxValue(this._sourceControlHandle,g),this.updateValue(g)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(g){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,g),this._placeholder=g}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(g){if((0,n.checkProposedApiEnabled)(this._extension),g&&typeof g!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=g,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!g)}get visible(){return this._visible}set visible(g){g=!!g,this._visible!==g&&(this._visible=g,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,g))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(g,k){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,g,k)}$onInputBoxValueChange(g){this.updateValue(g)}updateValue(g){this._value=g,this._onDidChange.fire(g)}}e.ExtHostSCMInputBox=v;class r{constructor(g,k,P,p,D){this._proxy=g,this._commands=k,this._sourceControlHandle=P,this._id=p,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(g){this._label=g,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,g)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(g){this._hideWhenEmpty=g,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(g){this._resourceStates=[...g],this._onDidUpdateResourceStates.fire()}getResourceState(g){return this._resourceStatesMap.get(g)}$executeResourceCommand(g,k){const P=this._resourceStatesCommandsMap.get(g);return P?(0,F.asPromise)(()=>this._commands.executeCommand(P.command,...P.arguments||[],k)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this._resourceStates].sort(o),P=(0,_.sortedDiff)(this._resourceSnapshot,g,o).map(f=>{const A=f.toInsert.map(L=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,L);const G=L.resourceUri;let $;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const ve=new R.DisposableStore;$=this._commands.converter.toInternal(L.command,ve),this._resourceStatesDisposablesMap.set(V,ve)}else this._resourceStatesCommandsMap.set(V,L.command);const K=a(L.decorations),W=L.decorations&&a(L.decorations.light)||K,U=L.decorations&&a(L.decorations.dark)||K,z=[W,U],Y=L.decorations&&L.decorations.tooltip||"",re=L.decorations&&!!L.decorations.strikeThrough,j=L.decorations&&!!L.decorations.faded,ue=L.contextValue||"";return{rawResource:[V,G,z,Y,re,j,ue,$],handle:V}});return{start:f.start,deleteCount:f.deleteCount,toInsert:A}}),p=P.map(({start:f,deleteCount:A,toInsert:L})=>[f,A,L.map(V=>V.rawResource)]),D=P.reverse();for(const{start:f,deleteCount:A,toInsert:L}of D){const V=L.map($=>$.handle),G=this._handlesSnapshot.splice(f,A,...V);for(const $ of G)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=g,p}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class s{constructor(g,k,P,p,D,f){this._proxy=k,this._commands=P,this._id=p,this._label=D,this._rootUri=f,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new R.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new R.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new v(g,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,p,D,f)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(g){this._count!==g&&(this._count=g,this._proxy.$updateSourceControl(this.handle,{count:g}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(g){this._quickDiffProvider=g,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this._commitTemplate}set commitTemplate(g){g!==this._commitTemplate&&(this._commitTemplate=g,this._proxy.$updateSourceControl(this.handle,{commitTemplate:g}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(g){this._acceptInputDisposables.value=new R.DisposableStore,this._acceptInputCommand=g;const k=this._commands.converter.toInternal(g,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:k})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(g){if(this._statusBarCommands&&g&&i(this._statusBarCommands,g))return;this._statusBarDisposables.value=new R.DisposableStore,this._statusBarCommands=g;const k=(g||[]).map(P=>this._commands.converter.toInternal(P,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:k})}get selected(){return this._selected}createResourceGroup(g,k){const P=new r(this._proxy,this._commands,this.handle,g,k),p=M.Event.once(P.onDidDispose)(()=>this.createdResourceGroups.delete(P));return this.createdResourceGroups.set(P,p),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const g=[],k=[];for(const[P,p]of this.createdResourceGroups){p.dispose();const D=P.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(P),this.eventuallyUpdateResourceStates()});M.Event.once(P.onDidDispose)(()=>{this.updatedResourceGroups.delete(P),D.dispose(),this._groups.delete(P.handle),this._proxy.$unregisterGroup(this.handle,P.handle)}),g.push([P.handle,P.id,P.label,P.features]);const f=P._takeResourceStateSnapshot();f.length>0&&k.push([P.handle,f]),this._groups.set(P.handle,P)}this._proxy.$registerGroups(this.handle,g,k),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const g=[];this.updatedResourceGroups.forEach(k=>{const P=k._takeResourceStateSnapshot();P.length!==0&&g.push([k.handle,P])}),g.length>0&&this._proxy.$spliceResourceStates(this.handle,g),this.updatedResourceGroups.clear()}getResourceGroup(g){return this._groups.get(g)}setSelectionState(g){this._selected=g,this._onDidChangeSelection.fire(g)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(g=>g.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,Ue([(0,b.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),Ue([(0,b.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let c=class Bi{constructor(g,k,P){this._commands=k,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=g.getProxy(C.MainContext.MainThreadSCM),this._telemetry=g.getProxy(C.MainContext.MainThreadTelemetry),k.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===3){const D=this._sourceControls.get(p.sourceControlHandle);if(!D)return p;const f=D.getResourceGroup(p.groupHandle);return f?f.getResourceState(p.handle):p}else if(p&&p.$mid===4){const D=this._sourceControls.get(p.sourceControlHandle);return D?D.getResourceGroup(p.groupHandle):p}else if(p&&p.$mid===5){const D=this._sourceControls.get(p.handle);return D||p}return p}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(g,k,P,p){this.logService.trace("ExtHostSCM#createSourceControl",g.identifier.value,k,P,p),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const D=Bi._handlePool++,f=new s(g,this._proxy,this._commands,k,P,p);this._sourceControls.set(D,f);const A=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(g.identifier))||[];return A.push(f),this._sourceControlsByExtension.set(E.ExtensionIdentifier.toKey(g.identifier),A),f}getLastInputBox(g){this.logService.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const k=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(g.identifier)),P=k&&k[k.length-1];return P&&P.inputBox}$provideOriginalResource(g,k,P){const p=d.URI.revive(k);this.logService.trace("ExtHostSCM#$provideOriginalResource",g,p.toString());const D=this._sourceControls.get(g);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>D.quickDiffProvider.provideOriginalResource(p,P)).then(f=>f||null)}$onInputBoxValueChange(g,k){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",g);const P=this._sourceControls.get(g);return P&&P.inputBox.$onInputBoxValueChange(k),Promise.resolve(void 0)}$executeResourceCommand(g,k,P,p){this.logService.trace("ExtHostSCM#$executeResourceCommand",g,k,P);const D=this._sourceControls.get(g);if(!D)return Promise.resolve(void 0);const f=D.getResourceGroup(k);return f?f.$executeResourceCommand(P,p):Promise.resolve(void 0)}$validateInput(g,k,P){this.logService.trace("ExtHostSCM#$validateInput",g);const p=this._sourceControls.get(g);return!p||!p.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>p.inputBox.validateInput(k,P)).then(D=>{if(!D)return Promise.resolve(void 0);const f=l.MarkdownString.fromStrict(D.message);return f?Promise.resolve([f,D.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this._sourceControls.get(g)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=g,Promise.resolve(void 0)}};c._handlePool=0,c=Ue([He(2,t.ILogService)],c),e.ExtHostSCM=c});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,d):b?b.value=d:e.set(ne,d),d},Ae=this&&this.__classPrivateFieldGet||function(ne,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[202],be([0,1,7,5,127,6,8]),function(ne,e,d,M,b,R,F){"use strict";var C,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class T{constructor(u,l,a,w,I=d.StatusBarAlignment.Left,S){C.set(this,void 0),_.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new R.DisposableStore,Xe(this,C,u,"f"),Xe(this,_,l,"f"),this._entryId=T.ID_GEN++,this._extension=a,this._id=w,this._alignment=I,this._priority=S}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(u){this._text=u,this.update()}set name(u){this._name=u,this.update()}set tooltip(u){this._tooltip=u,this.update()}set color(u){this._color=u,this.update()}set backgroundColor(u){u&&!T.ALLOWED_BACKGROUND_COLORS.has(u.id)&&(u=void 0),this._backgroundColor=u,this.update()}set command(u){this._command?.fromApi!==u&&(this._internalCommandRegistration.clear(),typeof u=="string"?this._command={fromApi:u,internal:Ae(this,_,"f").toInternal({title:"",command:u},this._internalCommandRegistration)}:u?this._command={fromApi:u,internal:Ae(this,_,"f").toInternal(u,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(u){this._accessibilityInformation=u,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let u;this._extension?this._id?u=`${this._extension.identifier.value}.${this._id}`:u=this._extension.identifier.value:u=this._id;let l;this._name?l=this._name:l=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let a=this._color;this._backgroundColor&&(a=T.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const w=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Ae(this,C,"f").$setEntry(this._entryId,u,l,this._text,w,this._command?.internal,a,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=T,C=new WeakMap,_=new WeakMap,T.ID_GEN=0,T.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class t{constructor(u){this._messages=[],this._item=u.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(u){const l={message:u};return this._messages.unshift(l),this._update(),new d.Disposable(()=>{const a=this._messages.indexOf(l);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class E{constructor(u,l){this._proxy=u.getProxy(M.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new t(this)}createStatusBarEntry(u,l,a,w){return new T(this._proxy,this._commands,u,l,a,w)}setStatusBarMessage(u,l){const a=this._statusMessage.setMessage(u);let w;return typeof l=="number"?w=setTimeout(()=>a.dispose(),l):typeof l!="undefined"&&l.then(()=>a.dispose(),()=>a.dispose()),new d.Disposable(()=>{a.dispose(),clearTimeout(w)})}}e.ExtHostStatusBar=E}),define(we[72],be([0,1,5,3,4]),function(ne,e,d,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(C){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,_){this._proxy.$registerExtensionStorageKeysToSync(C,_)}getValue(C,_,T){return this._proxy.$getValue(C,_).then(t=>t||T)}setValue(C,_,T){return this._proxy.$setValue(C,_,T)}$acceptValue(C,_,T){this._onDidChangeStorage.fire({shared:C,key:_,value:T})}}e.ExtHostStorage=R,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(we[73],be([0,1,4,29,15,71,2]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let C=class{constructor(T,t,E){this._logService=t,this._extHostFileSystem=E,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(T){return F.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,t=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(E){this._logService.error("[ExtHostStorage]",E);return}}workspaceValue(T){if(this._value)return F.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return F.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=Ue([He(0,M.IExtHostInitDataService),He(1,b.ILogService),He(2,R.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(we[40],be([0,1,3,5,4,2,12,6,7,128,16,166,21,36,149,46,10]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class I{constructor(c,h,g,k){this._proxy=c,this._id=h,this._creationOptions=g,this._name=k,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(p=>this._pidPromiseComplete=p);const P=this;this.value={get name(){return P._name||""},get processId(){return P._pidPromise},get creationOptions(){return P._creationOptions},get exitStatus(){return P._exitStatus},get state(){return P._state},sendText(p,D=!0){P._checkDisposed(),P._proxy.$sendText(P._id,p,D)},show(p){P._checkDisposed(),P._proxy.$show(P._id,p)},hide(){P._checkDisposed(),P._proxy.$hide(P._id)},dispose(){P._disposed||(P._disposed=!0,P._proxy.$dispose(P._id))},get dimensions(){if(!(P._cols===void 0||P._rows===void 0))return{columns:P._cols,rows:P._rows}}}}async create(c,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,w.withNullAsUndefined)(c.shellPath),shellArgs:(0,w.withNullAsUndefined)(c.shellArgs),cwd:(0,w.withNullAsUndefined)(c.cwd),env:(0,w.withNullAsUndefined)(c.env),icon:(0,w.withNullAsUndefined)(v(c.iconPath)),color:a.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,w.withNullAsUndefined)(c.message),strictEnv:(0,w.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,w.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,w.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,w.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this._serializeParentTerminal(c.location,h?.resolvedExtHostIdentifier)})}async createExtensionTerminal(c,h,g,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:g,color:a.ThemeColor.isThemeColor(k)?k.id:void 0,location:this._serializeParentTerminal(c,h)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(c,h){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in c?{viewColumn:c.viewColumn,preserveFocus:c.preserveFocus}:void 0:c}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitCode(c){this._exitStatus=Object.freeze({code:c})}setDimensions(c,h){return c===this._cols&&h===this._rows||c===0||h===0?!1:(this._cols=c,this._rows=h,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=I;class S{constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new d.Emitter,this._onProcessTitleChanged=new d.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new d.Emitter,this._onProcessShellTypeChanged=new d.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(c){return Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput&&this._pty.handleInput(c)}resize(c,h){this._pty.setDimensions&&this._pty.setDimensions({columns:c,rows:h})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose&&this._pty.onDidClose((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(h=>this._onProcessOverrideDimensions.fire(h&&{cols:h.columns,rows:h.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(h=>this._onProcessTitleChanged.fire(h)),this._pty.open(c||void 0),this._pty.setDimensions&&c&&this._pty.setDimensions(c),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=S;let o=1,m=class extends C.Disposable{constructor(c,h){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=h.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[g,k]of this._terminalProcesses)k.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,h){const g=new I(this._proxy,(0,u.generateUuid)(),c,c.name),k=new S(c.pty);return g.createExtensionTerminal(c.location,this._serializeParentTerminal(c,h).resolvedExtHostIdentifier,v(c.iconPath),r(c.color)).then(P=>{const p=this._setupExtHostProcessListeners(P,k);this._terminalProcessDisposables[P]=p}),this._terminals.push(g),g.value}_serializeParentTerminal(c,h){if(h=h||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const g=c.location.parentTerminal;if(g){const k=this._terminals.find(P=>P.value===g);k&&(h.resolvedExtHostIdentifier=k._id)}}else c.location&&typeof c.location!="object"?h.location=c.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(c,h){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const k=new S(h),P=this._setupExtHostProcessListeners(c,k);this._terminalProcessDisposables[c]=P}async $acceptActiveTerminalChanged(c){const h=this._activeTerminal;if(c===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const g=this._getTerminalById(c);g&&(this._activeTerminal=g,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,h){const g=this._getTerminalById(c);g&&this._onDidWriteTerminalData.fire({terminal:g.value,data:h})}async $acceptTerminalDimensions(c,h,g){const k=this._getTerminalById(c);k&&k.setDimensions(h,g)&&this._onDidChangeTerminalDimensions.fire({terminal:k.value,dimensions:k.value.dimensions})}async $acceptTerminalMaximumDimensions(c,h,g){this._terminalProcesses.get(c)?.resize(h,g)}async $acceptTerminalTitleChange(c,h){const g=this._getTerminalById(c);g&&(g.name=h)}async $acceptTerminalClosed(c,h){const g=this._getTerminalObjectIndexById(this._terminals,c);if(g!==null){const k=this._terminals.splice(g,1)[0];k.setExitCode(h),this._onDidCloseTerminal.fire(k.value)}}$acceptTerminalOpened(c,h,g,k){if(h){const D=this._getTerminalObjectIndexById(this._terminals,h);if(D!==null){this._terminals[D]._id=c,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const P={name:k.name,shellPath:k.executable,shellArgs:k.args,cwd:typeof k.cwd=="string"?k.cwd:R.URI.revive(k.cwd),env:k.env,hideFromUser:k.hideFromUser},p=new I(this._proxy,c,P,g);this._terminals.push(p),this._onDidOpenTerminal.fire(p.value),p.isOpen=!0}async $acceptTerminalProcessId(c,h){const g=this._getTerminalById(c);g&&g._setProcessId(h)}async $startExtensionTerminal(c,h){const g=this._getTerminalById(c);if(!g)return{message:(0,T.localize)(0,null,c)};g.isOpen||await new Promise(P=>{const p=this.onDidOpenTerminal(async D=>{D===g.value&&(p.dispose(),P())})});const k=this._terminalProcesses.get(c);k?k.startSendingEvents(h):this._extensionTerminalAwaitingStart[c]={initialDimensions:h}}_setupExtHostProcessListeners(c,h){const g=new C.DisposableStore;g.add(h.onProcessReady(P=>this._proxy.$sendProcessReady(c,P.pid,P.cwd))),g.add(h.onProcessTitleChanged(P=>this._proxy.$sendProcessTitle(c,P))),this._bufferer.startBuffering(c,h.onProcessData),g.add(h.onProcessExit(P=>this._onProcessExit(c,P))),h.onProcessOverrideDimensions&&g.add(h.onProcessOverrideDimensions(P=>this._proxy.$sendOverrideDimensions(c,P))),this._terminalProcesses.set(c,h);const k=this._extensionTerminalAwaitingStart[c];return k&&h instanceof S&&(h.startSendingEvents(k.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),g}$acceptProcessAckDataEvent(c,h){this._terminalProcesses.get(c)?.acknowledgeDataEvent(h)}$acceptProcessInput(c,h){this._terminalProcesses.get(c)?.input(h)}$acceptTerminalInteraction(c){const h=this._getTerminalById(c);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(c,h,g){try{this._terminalProcesses.get(c)?.resize(h,g)}catch(k){if(k.code!=="EPIPE"&&k.code!=="ERR_IPC_CHANNEL_CLOSED")throw k}}$acceptProcessShutdown(c,h){this._terminalProcesses.get(c)?.shutdown(h)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(h=>this._proxy.$sendProcessInitialCwd(c,h))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(h=>this._proxy.$sendProcessCwd(c,h))}$acceptProcessRequestLatency(c){return c}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,h,g){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,g),this._proxy.$registerProfileProvider(h,c.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(c,h){const g=new n.CancellationTokenSource().token,k=await this._profileProviders.get(c)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(!k||!("options"in k))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in k.options){this.createExtensionTerminal(k.options,h);return}this.createTerminalFromOptions(k.options,h)}}async $provideLinks(c,h){const g=this._getTerminalById(c);if(!g)return[];this._terminalLinkCache.delete(c);const k=this._terminalLinkCancellationSource.get(c);k&&k.dispose(!0);const P=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,P);const p=[],D={terminal:g.value,line:h},f=[];for(const V of this._linkProviders)f.push(new Promise(async G=>{P.token.onCancellationRequested(()=>G({provider:V,links:[]}));const $=await V.provideTerminalLinks(D,P.token)||[];P.token.isCancellationRequested||G({provider:V,links:$})}));const A=await Promise.all(f);if(P.token.isCancellationRequested)return[];const L=new Map;for(const V of A)V&&V.links.length>0&&p.push(...V.links.map(G=>{const $={id:o++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return L.set($.id,{provider:V.provider,link:G}),$}));return this._terminalLinkCache.set(c,L),p}$activateLink(c,h){const g=this._terminalLinkCache.get(c)?.get(h);!g||g.provider.handleTerminalLink(g.link)}_onProcessExit(c,h){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const g=this._terminalProcessDisposables[c];g&&(g.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,h)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,h){const g=this._getTerminalObjectIndexById(c,h);return g!==null?c[g]:null}_getTerminalObjectIndexById(c,h){let g=null;return c.some((k,P)=>k._id===h?(g=P,!0):!1),g}getEnvironmentVariableCollection(c){let h=this._environmentVariableCollections.get(c.identifier.value);return h||(h=new y,this._setEnvironmentVariableCollection(c.identifier.value,h)),h}_syncEnvironmentVariableCollection(c,h){const g=(0,E.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(c,h.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(c){c.forEach(h=>{const g=h[0],k=new y(h[1]);this._setEnvironmentVariableCollection(g,k)})}$acceptDefaultProfile(c,h){this._defaultProfile=c,this._defaultAutomationProfile=h}_setEnvironmentVariableCollection(c,h){this._environmentVariableCollections.set(c,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,h)})}};m=Ue([He(1,F.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class y{constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(c)}get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(c,h){this._setIfDiffers(c,{value:h,type:_.EnvironmentVariableMutatorType.Replace})}append(c,h){this._setIfDiffers(c,{value:h,type:_.EnvironmentVariableMutatorType.Append})}prepend(c,h){this._setIfDiffers(c,{value:h,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,h){const g=this.map.get(c);(!g||g.value!==h.value||g.type!==h.type)&&(this.map.set(c,h),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,h){this.map.forEach((g,k)=>c.call(h,k,g,this))}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=y;let i=class extends m{constructor(c){super(!1,c)}createTerminal(c,h,g){throw new t.NotSupportedError}createTerminalFromOptions(c,h){throw new t.NotSupportedError}};i=Ue([He(0,F.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function v(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function r(s){return a.ThemeColor.isThemeColor(s)?s:void 0}});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,d):b?b.value=d:e.set(ne,d),d},Ae=this&&this.__classPrivateFieldGet||function(ne,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[203],be([0,1,13,22,21,3,234,58,6,23,10,36,5,12,48,8,7,174,90,67]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w,I,S,o){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let y=class{constructor(f,A){this.resultsChangedEmitter=new R.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=f.getProxy(n.MainContext.MainThreadTesting),this.observer=new k(this.proxy),this.runTracker=new v(this.proxy),A.registerArgumentProcessor({processArgument:L=>L?.$mid===13?a.TestItem.toItemFromContext(L):L})}createTestController(f,A){if(this.controllers.has(f))throw new Error(`Attempt to insert a duplicate controller with ID "${f}"`);const L=new _.DisposableStore,V=L.add(new I.SingleUseTestCollection(f));V.root.label=A;const G=new Map,$=this.proxy,K={items:V.root.children,get label(){return A},set label(U){A=U,V.root.label=U,$.$updateControllerLabel(f,A)},get id(){return f},createRunProfile:(U,z,Y,re,j)=>{let ue=(0,C.hash)(U);for(;G.has(ue);)ue++;const oe=new P(this.proxy,f,ue,U,z,Y,re,j);return G.set(ue,oe),oe},createTestItem(U,z,Y){return new l.TestItemImpl(f,U,z,Y)},createTestRun:(U,z,Y=!0)=>this.runTracker.createTestRun(f,V,U,z,Y),set resolveHandler(U){V.resolveHandler=U},get resolveHandler(){return V.resolveHandler},dispose:()=>{L.dispose()}};K.createRunConfiguration=K.createRunProfile,$.$registerTestController(f,A),L.add((0,_.toDisposable)(()=>$.$unregisterTestController(f)));const W={controller:K,collection:V,profiles:G};return this.controllers.set(f,W),L.add((0,_.toDisposable)(()=>this.controllers.delete(f))),L.add(V.onDidGenerateDiff(U=>$.$publishDiff(f,U))),K}createTestObserver(){return this.observer.checkout()}async runTests(f,A=b.CancellationToken.None){const L=r(f);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.controllers.get(L.controllerId);if(!V)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:f.include?.map(G=>G.id)??[V.collection.root.id],profileGroup:p[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:f.exclude?.map(G=>G.id)},A)}$provideFileCoverage(f,A,L){return(0,d.mapFind)(this.runTracker.trackers,G=>G.id===f?G.getCoverage(A):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(f,A,L,V){return(0,d.mapFind)(this.runTracker.trackers,$=>$.id===f?$.getCoverage(A):void 0)?.resolveFileCoverage(L,V)??Promise.resolve([])}$configureRunProfile(f,A){this.controllers.get(f)?.profiles.get(A)?.configureHandler?.()}$publishTestResults(f){this.results=Object.freeze(f.map(A=>(0,T.deepFreeze)(a.TestResults.to(A))).concat(this.results).sort((A,L)=>L.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(f,A){const L=this.controllers.get(o.TestId.fromString(f).controllerId)?.collection;L&&(await L.expand(f,A<0?Infinity:A),L.flushDiff())}$acceptDiff(f){this.observer.applyDiff(f)}async $runControllerTests(f,A){const L=this.controllers.get(f.controllerId);if(!L)return;const{collection:V,profiles:G}=L,$=G.get(f.profileId);if(!$)return;const K=f.testIds.map(Y=>V.tree.get(Y)).filter(t.isDefined),W=f.excludeExtIds.map(Y=>L.collection.tree.get(Y)).filter(t.isDefined).filter(Y=>K.some(re=>re.fullId.compare(Y.fullId)===2));if(!K.length)return;const U=new w.TestRunRequest(K.some(Y=>Y.actual instanceof l.TestItemRootImpl)?void 0:K.map(Y=>Y.actual),W.map(Y=>Y.actual),$),z=this.runTracker.prepareForMainThreadTestRun(U,s.fromInternal(f,L.collection),A);try{await $.runHandler(U,A)}finally{z.isRunning&&!A.isCancellationRequested&&await R.Event.toPromise(z.onEnd),z.dispose()}}$cancelExtensionTestRun(f){f===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(f)}};y=Ue([He(0,u.IExtHostRpcService)],y),e.ExtHostTesting=y;class i extends _.Disposable{constructor(f,A,L){super();this.dto=f,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new R.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:V}of this.tasks.values())V.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(f){return this.tasks.get(f)?.coverage}createRun(f){const A=this.dto.id,L=this.dto.controllerId,V=(0,E.generateUuid)(),G=new c(this.proxy,A,V),$=z=>(Y,...re)=>{if(W){console.warn(`Setting the state of test "${Y.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Y)||(this.ensureTestIsKnown(Y),z(Y,...re))},K=(z,Y)=>{const re=Y instanceof Array?Y.map(a.TestMessage.from):[a.TestMessage.from(Y)];if(z.uri&&z.range){const j={range:a.Range.from(z.range),uri:z.uri};for(const ue of re)ue.location=ue.location||j}this.proxy.$appendTestMessagesInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),re)};let W=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:f,get coverageProvider(){return G.coverageProvider},set coverageProvider(z){G.coverageProvider=z},enqueued:$(z=>{this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),1)}),skipped:$(z=>{this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),5)}),started:$(z=>{this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),2)}),errored:$((z,Y,re)=>{K(z,Y),this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),6,re)}),failed:$((z,Y,re)=>{K(z,Y),this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,L).toString(),4,re)}),passed:$((z,Y)=>{this.proxy.$updateTestStateInRun(A,V,o.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,Y)}),appendOutput:(z,Y,re)=>{W||(re&&(this.dto.isIncluded(re)?this.ensureTestIsKnown(re):re=void 0),this.proxy.$appendOutputToRun(A,V,M.VSBuffer.fromString(z),Y&&a.location.from(Y),re&&o.TestId.fromExtHostTestItem(re,L).toString()))},end:()=>{W||(W=!0,this.proxy.$finishedTestRunTask(A,V),this.tasks.delete(V),this.isRunning||this.dispose())}};return this.tasks.set(V,{run:U,coverage:G}),this.proxy.$startedTestRunTask(A,{id:V,name:f,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(f){if(!(f instanceof l.TestItemImpl))throw new l.InvalidTestItemError(f.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(f,this.dto.controllerId).toString()))return;const A=[],L=this.dto.colllection.root;for(;;){const V=a.TestItem.from(f);if(A.unshift(V),this.sharedTestIds.has(V.extId)||(this.sharedTestIds.add(V.extId),f===L))break;f=f.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class v{constructor(f){this.proxy=f,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(f,A,L){return this.getTracker(f,A,L)}cancelRunById(f){for(const A of this.tracked.values())if(A.id===f){A.dispose();return}}cancelAllRuns(){for(const f of this.tracked.values())f.dispose()}createTestRun(f,A,L,V,G){const $=this.tracked.get(L);if($)return $.createRun(V);const K=s.fromPublic(f,A,L,G),W=r(L);this.proxy.$startedExtensionTestRun({controllerId:f,profile:W&&{group:p[W.kind],id:W.profileId},exclude:L.exclude?.map(z=>z.id)??[],id:K.id,include:L.include?.map(z=>z.id)??[A.root.id],persist:G});const U=this.getTracker(L,K);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(K.id)),U.createRun(V)}getTracker(f,A,L){const V=new i(A,this.proxy,L);return this.tracked.set(f,V),V.onEnd(()=>this.tracked.delete(f)),V}}e.TestRunCoordinator=v;const r=D=>{if(!!D.profile){if(!(D.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return D.profile}};class s{constructor(f,A,L,V,G,$){this.controllerId=f,this.id=A,this.isPersisted=G,this.colllection=$,this.includePrefix=L.map(K=>K+"\0"),this.excludePrefix=V.map(K=>K+"\0")}static fromPublic(f,A,L,V){return new s(f,(0,E.generateUuid)(),L.include?.map(G=>o.TestId.fromExtHostTestItem(G,f).toString())??[f],L.exclude?.map(G=>o.TestId.fromExtHostTestItem(G,f).toString())??[],V,A)}static fromInternal(f,A){return new s(f.controllerId,f.runId,f.testIds,f.excludeExtIds,!0,A)}isIncluded(f){const A=o.TestId.fromExtHostTestItem(f,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(A===L||A.startsWith(L))return!1;for(const L of this.includePrefix)if(A===L||A.startsWith(L))return!0;return!1}}e.TestRunDto=s;class c{constructor(f,A,L){this.proxy=f,this.runId=A,this.taskId=L}set coverageProvider(f){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!f||(this._coverageProvider=f,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(f){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(f))());try{return(await this.fileCoverage)?.map(a.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(f,A){const L=await this.fileCoverage;let V=L?.[f];return!this._coverageProvider||!L||!V?[]:(V.detailedCoverage||(V=L[f]=await this._coverageProvider.resolveFileCoverage?.(V,A)??V),V.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class h extends S.IncrementalChangeCollector{constructor(f){super();this.emitter=f,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(f){this.added.add(f)}update(f){Object.assign(f.revived,a.TestItem.toPlain(f.item)),this.added.has(f)||this.updated.add(f)}remove(f){if(this.added.has(f)){this.added.delete(f);return}if(this.updated.delete(f),f.parent&&this.alreadyRemoved.has(f.parent)){this.alreadyRemoved.add(f.item.extId);return}this.removed.add(f)}getChangeEvent(){const{added:f,updated:A,removed:L}=this;return{get added(){return[...f].map(V=>V.revived)},get updated(){return[...A].map(V=>V.revived)},get removed(){return[...L].map(V=>V.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class g extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new R.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(f){return this.items.get(f)}getMirroredTestDataByReference(f){return this.items.get(f.id)}createItem(f,A){return{...f,revived:a.TestItem.toPlain(f.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new h(this.changeEmitter)}}e.MirroredTestCollection=g;class k{constructor(f){this.proxy=f}checkout(){this.current||(this.current=this.createObserverData());const f=this.current;return f.observers++,{onDidChangeTest:f.tests.onDidChangeTests,get tests(){return[...f.tests.rootTests].map(A=>A.revived)},dispose:(0,F.once)(()=>{--f.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(f){return this.current?.tests.getMirroredTestDataByReference(f)}applyDiff(f){this.current?.tests.apply(f)}createObserverData(){const f=new g;return this.proxy.$subscribeToDiffs(),{observers:0,tests:f}}}class P{constructor(f,A,L,V,G,$,K=!1,W=void 0){this.controllerId=A,this.profileId=L,this._label=V,this.kind=G,this.runHandler=$,this._isDefault=K,this._tag=W,m.set(this,void 0),Xe(this,m,f,"f");const U=p[G];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${G}`);Ae(this,m,"f").$publishTestRunProfile({profileId:L,controllerId:A,tag:W?a.TestTag.namespace(this.controllerId,W.id):null,label:V,group:U,isDefault:K,hasConfigurationHandler:!1})}get label(){return this._label}set label(f){f!==this._label&&(this._label=f,Ae(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:f}))}get isDefault(){return this._isDefault}set isDefault(f){f!==this._isDefault&&(this._isDefault=f,Ae(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:f}))}get tag(){return this._tag}set tag(f){f?.id!==this._tag?.id&&(this._tag=f,Ae(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:f?a.TestTag.namespace(this.controllerId,f.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(f){f!==this._configureHandler&&(this._configureHandler=f,Ae(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!f}))}dispose(){Ae(this,m,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=P,m=new WeakMap;const p={[w.TestRunProfileKind.Coverage]:8,[w.TestRunProfileKind.Debug]:4,[w.TestRunProfileKind.Run]:2}}),define(we[204],be([0,1,3,13,5,94,8,7]),function(ne,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(t,E){this._extHostDocumentsAndEditors=E,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const E=this._extHostDocumentsAndEditors.allEditors();return t?E:E.map(n=>n.value)}async showTextDocument(t,E,n){let u;typeof E=="number"?u={position:F.ViewColumn.from(E),preserveFocus:n}:typeof E=="object"?u={position:F.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?F.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:u={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(t.uri,u),a=l&&this._extHostDocumentsAndEditors.getEditor(l);if(a)return a.value;throw l?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,E){return new R.TextEditorDecorationType(this._proxy,t,E).value}$acceptEditorPropertiesChanged(t,E){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(E.options&&n._acceptOptions(E.options),E.selections){const u=E.selections.selections.map(F.Selection.to);n._acceptSelections(u)}if(E.visibleRanges){const u=M.coalesce(E.visibleRanges.map(F.Range.to));n._acceptVisibleRanges(u)}if(E.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...E.options,lineNumbers:F.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const u=C.TextEditorSelectionChangeKind.fromValue(E.selections.source),l=E.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:l,kind:u})}if(E.visibleRanges){const u=M.coalesce(E.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:u})}}$acceptEditorPositionData(t){for(const E in t){const n=this._extHostDocumentsAndEditors.getEditor(E);if(!n)throw new Error("Unknown text editor");const u=F.ViewColumn.to(t[E]);n.value.viewColumn!==u&&(n._acceptViewColumn(u),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:u}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=_}),define(we[205],be([0,1,2,4,5,6,7]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class C{constructor(t,E){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(b.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const u=n.uri===void 0?void 0:d.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(_(u))?.get(n.handle)}return n}})}async $getTimeline(t,E,n,u,l){return this._providers.get(t)?.provideTimeline(d.URI.revive(E),n,u,l)}registerTimelineProvider(t,E,n,u){const l=new R.DisposableStore,a=this.convertTimelineItem(E.id,u,l).bind(this);let w;E.onDidChange&&(w=E.onDidChange(S=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...S,id:E.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...E,scheme:t,onDidChange:void 0,async provideTimeline(S,o,m,y){y?.resetCache&&(l.clear(),I.get(E.id)?.clear());const i=await E.provideTimeline(S,o,m);if(i==null)return;const v=a(S,y);return{...i,source:E.id,items:i.items.map(v)}},dispose(){for(const S of I.values())S.get(E.id)?.clear();w?.dispose(),l.dispose()}})}convertTimelineItem(t,E,n){return(u,l)=>{let a;if(l?.cacheResults){let w=this._itemsBySourceAndUriMap.get(t);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(t,w));const I=_(u);a=w.get(I),a===void 0&&(a=new Map,w.set(I,a))}return w=>{const{iconPath:I,...S}=w,o=`${t}|${w.id??w.timestamp}`;a?.set(o,w);let m,y,i;return w.iconPath&&(I instanceof F.ThemeIcon?i={id:I.id,color:I.color}:d.URI.isUri(I)?(m=I,y=I):{light:m,dark:y}=I),{...S,id:S.id??void 0,handle:o,source:t,command:w.command?E.toInternal(w.command,n):void 0,icon:m,iconDark:y,themeIcon:i,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,R.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=C;function _(T){return T?.toString()}}),define(we[206],be([0,1,6,11,2,5]),function(ne,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(_){this._openers=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,T,t,E){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const n=E.schemes.find(u=>!F.supportedSchemes.has(u));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,t),this._proxy.$registerUriOpener(T,E.schemes,_,E.label),(0,d.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(_,T,t){const E=this._openers.get(_);if(!E)throw new Error(`Unknown opener with id: ${_}`);const n=b.URI.revive(T);return E.canOpenExternalUri(n,t)}async $openUri(_,T,t){const E=this._openers.get(_);if(!E)throw new Error(`Unknown opener id: '${_}'`);return E.openExternalUri(b.URI.revive(T.resolvedUri),{sourceUri:b.URI.revive(T.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(we[207],be([0,1,5,2,6,16,25]),function(ne,e,d,M,b,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(T,t){if(this.handles.has(F.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const E=C.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(T)),this.handlers.set(E,t),this._proxy.$registerUriHandler(E,T),(0,b.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(T)),this.handlers.delete(E),this._proxy.$unregisterUriHandler(E)})}$handleExternalUri(T,t){const E=this.handlers.get(T);if(!E)return Promise.resolve(void 0);try{E.handleUri(M.URI.revive(t))}catch(n){(0,R.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(T){return M.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=C,C.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,d):b?b.value=d:e.set(ne,d),d},Ae=this&&this.__classPrivateFieldGet||function(ne,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[50],be([0,1,3,2,138,157,66,5]),function(ne,e,d,M,b,R,F,C){"use strict";var _,T,t,E,n,u,l,a,w,I,S,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(g,k,P,p,D,f,A){_.set(this,void 0),T.set(this,void 0),t.set(this,void 0),E.set(this,void 0),n.set(this,void 0),u.set(this,void 0),l.set(this,""),a.set(this,void 0),w.set(this,!1),I.set(this,!1),S.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new d.Emitter),this._onDidDispose=Ae(this,o,"f").event,Xe(this,_,g,"f"),Xe(this,T,k,"f"),Xe(this,a,P,"f"),Xe(this,E,p,"f"),Xe(this,n,D,"f"),Xe(this,u,f,"f"),Xe(this,S,y(f),"f"),Xe(this,t,A,"f")}dispose(){Xe(this,w,!0,"f"),Ae(this,o,"f").fire(),Ae(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return Xe(this,I,!0,"f"),(0,F.asWebviewUri)(g,Ae(this,E,"f").remote)}get cspSource(){return F.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,l,"f")}set html(g){this.assertNotDisposed(),Ae(this,l,"f")!==g&&(Xe(this,l,g,"f"),!Ae(this,I,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(Xe(this,I,!0,"f"),Ae(this,t,"f").report("Webview vscode-resource: uris",Ae(this,u,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,T,"f").$setHtml(Ae(this,_,"f"),g))}get options(){return this.assertNotDisposed(),Ae(this,a,"f")}set options(g){this.assertNotDisposed(),Ae(this,T,"f").$setOptions(Ae(this,_,"f"),r(Ae(this,u,"f"),Ae(this,n,"f"),g)),Xe(this,a,g,"f")}async postMessage(g){if(Ae(this,w,"f"))return!1;const k=(0,R.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:Ae(this,S,"f")});return Ae(this,T,"f").$postMessage(Ae(this,_,"f"),k.message,...k.buffers)}assertNotDisposed(){if(Ae(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,_=new WeakMap,T=new WeakMap,t=new WeakMap,E=new WeakMap,n=new WeakMap,u=new WeakMap,l=new WeakMap,a=new WeakMap,w=new WeakMap,I=new WeakMap,S=new WeakMap,o=new WeakMap;function y(h){try{const g=(0,b.normalizeVersion)((0,b.parseVersion)(h.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=y;class i{constructor(g,k,P,p,D){this.initData=k,this.workspace=P,this._logService=p,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=g.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(g,k,...P){const p=this.getWebview(g);if(p){const{message:D}=(0,R.deserializeWebviewMessage)(k,P);p._onMessageEmitter.fire(D)}}$onMissingCsp(g,k){this._logService.warn(`${k} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,k,P){const p=new m(g,this._webviewProxy,s(k),this.initData,this.workspace,P,this._deprecationService);return this._webviews.set(g,p),p._onDidDispose(()=>{this._webviews.delete(g)}),p}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=i;function v(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=v;function r(h,g,k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots||c(h,g)}}e.serializeWebviewOptions=r;function s(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(g=>M.URI.from(g))}}e.reviveOptions=s;function c(h,g){return[...(g?.getWorkspaceFolders()||[]).map(k=>k.uri),h.extensionLocation]}}),define(we[208],be([0,1,21,58,6,11,24,2,8,50,63,5,7]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class u{constructor(i,v){this.document=i,this._storagePath=v,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,v){await this.getEdit(i).undo(),v||this.disposeBackup()}async redo(i,v){await this.getEdit(i).redo(),v||this.disposeBackup()}disposeEdits(i){for(const v of i)this._edits.delete(v)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=m(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const v=this._edits.get(i,0);if(!v)throw new Error("No edit found");return v}}class l{constructor(){this._documents=new Map}get(i,v){return this._documents.get(this.key(i,v))}add(i,v,r){const s=this.key(i,v.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${i} resource:${v.uri}`);const c=new u(v,r);return this._documents.set(s,c),c}delete(i,v){const r=this.key(i,v.uri);this._documents.delete(r)}key(i,v){return`${i}@@@${v}`}}var a;(function(y){y[y.Text=0]="Text",y[y.Custom=1]="Custom"})(a||(a={}));class w{constructor(){this._providers=new Map}addTextProvider(i,v,r){return this.add(0,i,v,r)}addCustomProvider(i,v,r){return this.add(1,i,v,r)}get(i){return this._providers.get(i)}add(i,v,r,s){if(this._providers.has(v))throw new Error(`Provider for viewType:${v} already registered`);return this._providers.set(v,{type:i,extension:r,provider:s}),new n.Disposable(()=>this._providers.delete(v))}}class I{constructor(i,v,r,s,c){this._extHostDocuments=v,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=c,this._editorProviders=new w,this._documents=new l,this._proxy=i.getProxy(E.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,v,r,s){const c=new b.DisposableStore;return S(r)?(c.add(this._editorProviders.addTextProvider(v,i,r)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(i),v,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(i))):(c.add(this._editorProviders.addCustomProvider(v,i,r)),this.supportEditing(r)&&c.add(r.onDidChangeCustomDocument(h=>{const g=this.getCustomDocumentEntry(v,h.document.uri);if(o(h)){const k=g.addEdit(h);this._proxy.$onDidEdit(h.document.uri,v,k,h.label)}else this._proxy.$onContentChange(h.document.uri,v)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(i),v,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(c,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(v)}))}async $createCustomDocument(i,v,r,s,c){const h=this._editorProviders.get(v);if(!h)throw new Error(`No provider found for '${v}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${v}'`);const g=C.URI.revive(i),k=await h.provider.openCustomDocument(g,{backupId:r,untitledDocumentData:s?.buffer},c);let P;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(P=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(v,k,P),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(i,v){const r=this._editorProviders.get(v);if(!r)throw new Error(`No provider found for '${v}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${v}'`);const s=C.URI.revive(i),{document:c}=this.getCustomDocumentEntry(v,s);this._documents.delete(v,c),c.dispose()}async $resolveWebviewEditor(i,v,r,s,c,h){const g=this._editorProviders.get(r);if(!g)throw new Error(`No provider found for '${r}'`);const k=_.ViewColumn.to(c),P=this._extHostWebview.createNewWebview(v,s.webviewOptions,g.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(v,r,s.title,k,s.panelOptions,P),D=C.URI.revive(i);switch(g.type){case 1:{const{document:f}=this.getCustomDocumentEntry(r,D);return g.provider.resolveCustomEditor(f,p,h)}case 0:{const f=this._extHostDocuments.getDocument(D);return g.provider.resolveCustomTextEditor(f,p,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,v,r){this.getCustomDocumentEntry(v,i).disposeEdits(r)}async $onMoveCustomEditor(i,v,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const c=this._extHostWebviewPanels.getWebviewPanel(i);if(!c)throw new Error("No webview found");const h=C.URI.revive(v),g=this._extHostDocuments.getDocument(h);await s.provider.moveCustomTextEditor(g,c,d.CancellationToken.None)}async $undo(i,v,r,s){return this.getCustomDocumentEntry(v,i).undo(r,s)}async $redo(i,v,r,s){return this.getCustomDocumentEntry(v,i).redo(r,s)}async $revert(i,v,r){const s=this.getCustomDocumentEntry(v,i);await this.getCustomEditorProvider(v).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(i,v,r){const s=this.getCustomDocumentEntry(v,i);await this.getCustomEditorProvider(v).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(i,v,r,s){const c=this.getCustomDocumentEntry(v,i);return this.getCustomEditorProvider(v).saveCustomDocumentAs(c.document,C.URI.revive(r),s)}async $backup(i,v,r){const s=this.getCustomDocumentEntry(v,i),h=await this.getCustomEditorProvider(v).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(h),h.id}getCustomDocumentEntry(i,v){const r=this._documents.get(i,C.URI.revive(v));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(i){const r=this._editorProviders.get(i)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=I;function S(y){return typeof y.resolveCustomTextEditor=="function"}function o(y){return typeof y.undo=="function"&&typeof y.redo=="function"}function m(y){const i=y.scheme===R.Schemas.file||y.scheme===R.Schemas.untitled?y.fsPath:y.toString();return(0,M.hash)(i)+""}});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,d):b?b.value=d:e.set(ne,d),d},Ae=this&&this.__classPrivateFieldGet||function(ne,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[209],be([0,1,3,6,2,36,8,50,5,7]),function(ne,e,d,M,b,R,F,C,_,T){"use strict";var t,E,n,u,l,a,w,I,S,o,m,y,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class v extends M.Disposable{constructor(h,g,k,P,p,D,f){super();t.set(this,void 0),E.set(this,void 0),n.set(this,void 0),u.set(this,void 0),l.set(this,void 0),a.set(this,void 0),w.set(this,void 0),I.set(this,void 0),S.set(this,!0),o.set(this,!0),m.set(this,!1),y.set(this,this._register(new d.Emitter)),this.onDidDispose=Ae(this,y,"f").event,i.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Ae(this,i,"f").event,Xe(this,t,h,"f"),Xe(this,E,g,"f"),Xe(this,n,k,"f"),Xe(this,l,D,"f"),Xe(this,I,p,"f"),Xe(this,a,P,"f"),Xe(this,u,f,"f")}dispose(){Ae(this,m,"f")||(Xe(this,m,!0,"f"),Ae(this,y,"f").fire(),Ae(this,E,"f").$disposeWebview(Ae(this,t,"f")),Ae(this,u,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,u,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,n,"f")}get title(){return this.assertNotDisposed(),Ae(this,a,"f")}set title(h){this.assertNotDisposed(),Ae(this,a,"f")!==h&&(Xe(this,a,h,"f"),Ae(this,E,"f").$setTitle(Ae(this,t,"f"),h))}get iconPath(){return this.assertNotDisposed(),Ae(this,w,"f")}set iconPath(h){this.assertNotDisposed(),Ae(this,w,"f")!==h&&(Xe(this,w,h,"f"),Ae(this,E,"f").$setIconPath(Ae(this,t,"f"),b.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Ae(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,I,"f")=="number"&&Ae(this,I,"f")<0))return Ae(this,I,"f")}get active(){return this.assertNotDisposed(),Ae(this,o,"f")}get visible(){return this.assertNotDisposed(),Ae(this,S,"f")}_updateViewState(h){Ae(this,m,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(Xe(this,o,h.active,"f"),Xe(this,S,h.visible,"f"),Xe(this,I,h.viewColumn,"f"),Ae(this,i,"f").fire({webviewPanel:this}))}reveal(h,g){this.assertNotDisposed(),Ae(this,E,"f").$reveal(Ae(this,t,"f"),{viewColumn:h?F.ViewColumn.from(h):void 0,preserveFocus:!!g})}assertNotDisposed(){if(Ae(this,m,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,E=new WeakMap,n=new WeakMap,u=new WeakMap,l=new WeakMap,a=new WeakMap,w=new WeakMap,I=new WeakMap,S=new WeakMap,o=new WeakMap,m=new WeakMap,y=new WeakMap,i=new WeakMap;class r{constructor(h,g,k){this.webviews=g,this.workspace=k,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,R.generateUuid)()}createWebviewPanel(h,g,k,P,p={}){const D=typeof P=="object"?P.viewColumn:P,f={viewColumn:F.ViewColumn.from(D),preserveFocus:typeof P=="object"&&!!P.preserveFocus},A=(0,C.shouldSerializeBuffersForPostMessage)(h),L=r.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(h),L,g,{title:k,panelOptions:s(p),webviewOptions:(0,C.serializeWebviewOptions)(h,this.workspace,p),serializeBuffersForPostMessage:A},f);const V=this.webviews.createNewWebview(L,p,h);return this.createNewWebviewPanel(L,g,k,D,p,V)}$onDidChangeWebviewPanelViewStates(h){const g=Object.keys(h);g.sort((k,P)=>{const p=h[k],D=h[P];return p.active?1:D.active?-1:+p.visible-+D.visible});for(const k of g){const P=this.getWebviewPanel(k);if(!P)continue;const p=h[k];P._updateViewState({active:p.active,visible:p.visible,viewColumn:F.ViewColumn.to(p.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,g,k){if(this._serializers.has(g))throw new Error(`Serializer for '${g}' already registered`);return this._serializers.set(g,{serializer:k,extension:h}),this._proxy.$registerSerializer(g,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(h)}),new T.Disposable(()=>{this._serializers.delete(g),this._proxy.$unregisterSerializer(g)})}async $deserializeWebviewPanel(h,g,k,P){const p=this._serializers.get(g);if(!p)throw new Error(`No serializer found for '${g}'`);const{serializer:D,extension:f}=p,A=this.webviews.createNewWebview(h,k.webviewOptions,f),L=this.createNewWebviewPanel(h,g,k.title,P,k.panelOptions,A);await D.deserializeWebviewPanel(L,k.state)}createNewWebviewPanel(h,g,k,P,p,D){const f=new v(h,this._proxy,g,k,P,p,D);return this._webviewPanels.set(h,f),f}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=r;function s(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,d):b?b.value=d:e.set(ne,d),d},Ae=this&&this.__classPrivateFieldGet||function(ne,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[210],be([0,1,3,6,50,5,7]),function(ne,e,d,M,b,R,F){"use strict";var C,_,T,t,E,n,u,l,a,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends M.Disposable{constructor(m,y,i,v,r,s){super();C.set(this,void 0),_.set(this,void 0),T.set(this,void 0),t.set(this,void 0),E.set(this,!1),n.set(this,void 0),u.set(this,void 0),l.set(this,void 0),a.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Ae(this,a,"f").event,w.set(this,this._register(new d.Emitter)),this.onDidDispose=Ae(this,w,"f").event,Xe(this,T,i,"f"),Xe(this,u,v,"f"),Xe(this,C,m,"f"),Xe(this,_,y,"f"),Xe(this,t,r,"f"),Xe(this,n,s,"f")}dispose(){Ae(this,E,"f")||(Xe(this,E,!0,"f"),Ae(this,w,"f").fire(),Ae(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,u,"f")}set title(m){this.assertNotDisposed(),Ae(this,u,"f")!==m&&(Xe(this,u,m,"f"),Ae(this,_,"f").$setWebviewViewTitle(Ae(this,C,"f"),m))}get description(){return this.assertNotDisposed(),Ae(this,l,"f")}set description(m){this.assertNotDisposed(),Ae(this,l,"f")!==m&&(Xe(this,l,m,"f"),Ae(this,_,"f").$setWebviewViewDescription(Ae(this,C,"f"),m))}get visible(){return Ae(this,n,"f")}get webview(){return Ae(this,t,"f")}get viewType(){return Ae(this,T,"f")}_setVisible(m){m===Ae(this,n,"f")||Ae(this,E,"f")||(Xe(this,n,m,"f"),Ae(this,a,"f").fire())}show(m){this.assertNotDisposed(),Ae(this,_,"f").$show(Ae(this,C,"f"),!!m)}assertNotDisposed(){if(Ae(this,E,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,_=new WeakMap,T=new WeakMap,t=new WeakMap,E=new WeakMap,n=new WeakMap,u=new WeakMap,l=new WeakMap,a=new WeakMap,w=new WeakMap;class S{constructor(m,y){this._extHostWebview=y,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=m.getProxy(R.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(m,y,i,v){if(this._viewProviders.has(y))throw new Error(`View provider for '${y}' already registered`);return this._viewProviders.set(y,{provider:i,extension:m}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(m),y,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(y),this._proxy.$unregisterWebviewViewProvider(y)})}async $resolveWebviewView(m,y,i,v,r){const s=this._viewProviders.get(y);if(!s)throw new Error(`No view provider found for '${y}'`);const{provider:c,extension:h}=s,g=this._extHostWebview.createNewWebview(m,{},h),k=new I(m,this._proxy,y,i,g,!0);this._webviewViews.set(m,k),await c.resolveWebviewView(k,{state:v},r)}async $onDidChangeWebviewViewVisibility(m,y){this.getWebviewView(m)._setVisible(y)}async $disposeWebviewView(m){const y=this.getWebviewView(m);this._webviewViews.delete(m),y.dispose(),this._extHostWebview.deleteWebview(m)}getWebviewView(m){const y=this._webviewViews.get(m);if(!y)throw new Error("No webview found");return y}}e.ExtHostWebviewViews=S}),define(we[97],be([0,1,3,5,2,11,9,4,12]),function(ne,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class Ui{constructor(E){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=E.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(E){E!==this._state.focused&&(this._state={...this._state,focused:E},this._onDidChangeWindowState.fire(this._state))}openUri(E,n){let u;if(typeof E=="string"){u=E;try{E=b.URI.parse(E)}catch(l){return Promise.reject(`Invalid uri - '${E}'`)}}return(0,F.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this._proxy.$openUri(E,u,n)}async asExternalUri(E,n){if((0,F.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const u=await this._proxy.$asExternalUri(E,n);return b.URI.from(u)}};T.InitialState={focused:!0},T=Ue([He(0,_.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(we[211],be([0,1,15,5,29,12]),function(ne,e,d,M,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends d.AbstractLogger{constructor(_,T){super();this._proxy=_.getProxy(M.MainContext.MainThreadLog),this._logFile=T.logFile.toJSON(),this.setLevel(T.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...T){this.getLevel()<=d.LogLevel.Trace&&this._proxy.$log(this._logFile,d.LogLevel.Trace,Array.from(arguments))}debug(_,...T){this.getLevel()<=d.LogLevel.Debug&&this._proxy.$log(this._logFile,d.LogLevel.Debug,Array.from(arguments))}info(_,...T){this.getLevel()<=d.LogLevel.Info&&this._proxy.$log(this._logFile,d.LogLevel.Info,Array.from(arguments))}warn(_,...T){this.getLevel()<=d.LogLevel.Warning&&this._proxy.$log(this._logFile,d.LogLevel.Warning,Array.from(arguments))}error(_,...T){this.getLevel()<=d.LogLevel.Error&&this._proxy.$log(this._logFile,d.LogLevel.Error,Array.from(arguments))}critical(_,...T){this.getLevel()<=d.LogLevel.Critical&&this._proxy.$log(this._logFile,d.LogLevel.Critical,Array.from(arguments))}flush(){}};F=Ue([He(0,R.IExtHostRpcService),He(1,b.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(we[212],be([0,1,14,22,21,16,3,6,109,179,38]),function(ne,e,d,M,b,R,F,C,_,T,t){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(p,D){try{return JSON.stringify(p,D)}catch(f){return"null"}}const u="$$ref$$",l={[u]:-1};class a{constructor(D,f){this.jsonString=D,this.referencedBuffers=f}}function w(p,D=null,f=!1){const A=[];return{jsonString:(f?n:JSON.stringify)(p,(V,G)=>{if(typeof G=="undefined")return l;if(typeof G=="object"){if(G instanceof M.VSBuffer){const $=A.push(G)-1;return{[u]:$}}if(D)return D(V,G)}return G}),referencedBuffers:A}}e.stringifyJsonWithBufferRefs=w;function I(p,D,f){return JSON.parse(p,(A,L)=>{if(L){const V=L[u];if(typeof V=="number")return D[V];if(f&&L.$mid===1)return f.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=I;function S(p,D){return JSON.stringify(p,D)}function o(p){return p?(D,f)=>f&&f.$mid===1?p.transformOutgoing(f):f:null}var m;(function(p){p[p.LocalSide=0]="LocalSide",p[p.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));var y;(function(p){p[p.Responsive=0]="Responsive",p[p.Unresponsive=1]="Unresponsive"})(y=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},v=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends C.Disposable{constructor(D,f=null,A=null){super();this[E]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=D,this._logger=f,this._uriTransformer=A,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,V=t.ProxyIdentifier.count;L<V;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(D=>{this._pendingRPCReplies[D].resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(D){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(D){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(D){this._responsiveState!==D&&(this._responsiveState=D,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(D){return this._uriTransformer?(0,_.transformIncomingURIs)(D,this._uriTransformer):D}getProxy(D){const{nid:f,sid:A}=D;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,A)),this._proxies[f]}_createProxy(D,f){let A={get:(L,V)=>(typeof V=="string"&&!L[V]&&V.charCodeAt(0)===36&&(L[V]=(...G)=>this._remoteCall(D,V,G)),V===r?f:L[V])};return new Proxy(Object.create(null),A)}set(D,f){return this._locals[D.nid]=f,f}assertRegistered(D){for(let f=0,A=D.length;f<A;f++){const L=D[f];if(!this._locals[L.nid])throw new Error(`Missing actor ${L.sid} (isMain: ${L.isMain})`)}}_receiveOneMessage(D){if(this._isDisposed)return;const f=D.byteLength,A=c.read(D,0),L=A.readUInt8(),V=A.readUInt32();switch(L){case 1:case 2:{let{rpcId:G,method:$,args:K}=g.deserializeRequestJSONArgs(A);this._uriTransformer&&(K=(0,_.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(f,V,G,$,K,L===2);break}case 3:case 4:{let{rpcId:G,method:$,args:K}=g.deserializeRequestMixedArgs(A);this._uriTransformer&&(K=(0,_.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(f,V,G,$,K,L===4);break}case 5:{this._logger&&this._logger.logIncoming(f,V,0,"ack"),this._onDidReceiveAcknowledge(V);break}case 6:{this._receiveCancel(f,V);break}case 7:{this._receiveReply(f,V,void 0);break}case 9:{let G=g.deserializeReplyOKJSON(A);this._uriTransformer&&(G=(0,_.transformIncomingURIs)(G,this._uriTransformer)),this._receiveReply(f,V,G);break}case 10:{const G=g.deserializeReplyOKJSONWithBuffers(A,this._uriTransformer);this._receiveReply(f,V,G);break}case 8:{let G=g.deserializeReplyOKVSBuffer(A);this._receiveReply(f,V,G);break}case 11:{let G=g.deserializeReplyErrError(A);this._uriTransformer&&(G=(0,_.transformIncomingURIs)(G,this._uriTransformer)),this._receiveReplyErr(f,V,G);break}case 12:{this._receiveReplyErr(f,V,void 0);break}default:console.error("received unexpected message"),console.error(D)}}_receiveRequest(D,f,A,L,V,G){this._logger&&this._logger.logIncoming(D,f,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(A)}.${L}(`,V);const $=String(f);let K,W;if(G){const z=new b.CancellationTokenSource;V.push(z.token),K=this._invokeHandler(A,L,V),W=()=>z.cancel()}else K=this._invokeHandler(A,L,V),W=i;this._cancelInvokedHandlers[$]=W;const U=g.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(U.byteLength,f,1,"ack"),this._protocol.send(U),K.then(z=>{delete this._cancelInvokedHandlers[$];const Y=g.serializeReplyOK(f,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(Y.byteLength,f,1,"reply:",z),this._protocol.send(Y)},z=>{delete this._cancelInvokedHandlers[$];const Y=g.serializeReplyErr(f,z);this._logger&&this._logger.logOutgoing(Y.byteLength,f,1,"replyErr:",z),this._protocol.send(Y)})}_receiveCancel(D,f){this._logger&&this._logger.logIncoming(D,f,1,"receiveCancel");const A=String(f);this._cancelInvokedHandlers[A]&&this._cancelInvokedHandlers[A]()}_receiveReply(D,f,A){this._logger&&this._logger.logIncoming(D,f,0,"receiveReply:",A);const L=String(f);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const V=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],V.resolveOk(A)}_receiveReplyErr(D,f,A){this._logger&&this._logger.logIncoming(D,f,0,"receiveReplyErr:",A);const L=String(f);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const V=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let G;A&&(A.$isError?(G=new Error,G.name=A.name,G.message=A.message,G.stack=A.stack):G=A),V.resolveErr(G)}_invokeHandler(D,f,A){try{return Promise.resolve(this._doInvokeHandler(D,f,A))}catch(L){return Promise.reject(L)}}_doInvokeHandler(D,f,A){const L=this._locals[D];if(!L)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(D));let V=L[f];if(typeof V!="function")throw new Error("Unknown method "+f+" on actor "+(0,t.getStringIdentifierForProxy)(D));return V.apply(L,A)}_remoteCall(D,f,A){if(this._isDisposed)return Promise.reject(R.canceled());let L=null;if(A.length>0&&b.CancellationToken.isCancellationToken(A[A.length-1])&&(L=A.pop()),L&&L.isCancellationRequested)return Promise.reject(R.canceled());const V=g.serializeRequestArguments(A,this._uriReplacer),G=++this._lastMessageId,$=String(G),K=new T.LazyPromise;L&&L.onCancellationRequested(()=>{const U=g.serializeCancel(G);this._logger&&this._logger.logOutgoing(U.byteLength,G,0,"cancel"),this._protocol.send(g.serializeCancel(G))}),this._pendingRPCReplies[$]=K,this._onWillSendRequest(G);const W=g.serializeRequest(G,D,f,V,!!L);return this._logger&&this._logger.logOutgoing(W.byteLength,G,0,`request: ${(0,t.getStringIdentifierForProxy)(D)}.${f}(`,A),this._protocol.send(W),K}}e.RPCProtocol=s,E=v,s.UNRESPONSIVE_TIME=3*1e3;class c{constructor(D,f){this._buff=D,this._offset=f}static alloc(D,f,A){let L=new c(M.VSBuffer.alloc(A+1+4),0);return L.writeUInt8(D),L.writeUInt32(f),L}static read(D,f){return new c(D,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(D){this._buff.writeUInt8(D,this._offset),this._offset+=1}readUInt8(){const D=this._buff.readUInt8(this._offset);return this._offset+=1,D}writeUInt32(D){this._buff.writeUInt32BE(D,this._offset),this._offset+=4}readUInt32(){const D=this._buff.readUInt32BE(this._offset);return this._offset+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this._buff.writeUInt8(D.byteLength,this._offset),this._offset+=1,this._buff.set(D,this._offset),this._offset+=D.byteLength}readShortString(){const D=this._buff.readUInt8(this._offset);this._offset+=1;const A=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,A}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readLongString(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,A}writeBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readVSBuffer(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+D);return this._offset+=D,f}static sizeMixedArray(D){let f=0;f+=1;for(let A=0,L=D.length;A<L;A++){const V=D[A];switch(f+=1,V.type){case 1:f+=this.sizeLongString(V.value);break;case 2:f+=this.sizeVSBuffer(V.value);break;case 3:f+=this.sizeUInt32,f+=this.sizeLongString(V.value);for(let G=0;G<V.buffers.length;++G)f+=this.sizeVSBuffer(V.buffers[G]);break;case 4:break}}return f}writeMixedArray(D){this._buff.writeUInt8(D.length,this._offset),this._offset+=1;for(let f=0,A=D.length;f<A;f++){const L=D[f];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let V=0;V<L.buffers.length;++V)this.writeBuffer(L.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(D);for(let A=0;A<D;A++)switch(this.readUInt8()){case 1:f[A]=this.readLongString();break;case 2:f[A]=this.readVSBuffer();break;case 3:const V=this.readUInt32(),G=this.readLongString(),$=[];for(let K=0;K<V;++K)$.push(this.readVSBuffer());f[A]=new t.SerializableObjectWithBuffers(I(G,$,null));break;case 4:f[A]=void 0;break}return f}}c.sizeUInt32=4;var h;(function(p){p[p.Simple=0]="Simple",p[p.Mixed=1]="Mixed"})(h||(h={}));class g{static _useMixedArgSerialization(D){for(let f=0,A=D.length;f<A;f++)if(D[f]instanceof M.VSBuffer||D[f]instanceof t.SerializableObjectWithBuffers||typeof D[f]=="undefined")return!0;return!1}static serializeRequestArguments(D,f){if(this._useMixedArgSerialization(D)){const A=[];for(let L=0,V=D.length;L<V;L++){const G=D[L];if(G instanceof M.VSBuffer)A[L]={type:2,value:G};else if(typeof G=="undefined")A[L]={type:4};else if(G instanceof t.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:K}=w(G.value,f);A[L]={type:3,value:M.VSBuffer.fromString($),buffers:K}}else A[L]={type:1,value:M.VSBuffer.fromString(S(G,f))}}return{type:1,args:A}}return{type:0,args:S(D,f)}}static serializeRequest(D,f,A,L,V){switch(L.type){case 0:return this._requestJSONArgs(D,f,A,L.args,V);case 1:return this._requestMixedArgs(D,f,A,L.args,V)}}static _requestJSONArgs(D,f,A,L,V){const G=M.VSBuffer.fromString(A),$=M.VSBuffer.fromString(L);let K=0;K+=c.sizeUInt8(),K+=c.sizeShortString(G),K+=c.sizeLongString($);let W=c.alloc(V?2:1,D,K);return W.writeUInt8(f),W.writeShortString(G),W.writeLongString($),W.buffer}static deserializeRequestJSONArgs(D){const f=D.readUInt8(),A=D.readShortString(),L=D.readLongString();return{rpcId:f,method:A,args:JSON.parse(L)}}static _requestMixedArgs(D,f,A,L,V){const G=M.VSBuffer.fromString(A);let $=0;$+=c.sizeUInt8(),$+=c.sizeShortString(G),$+=c.sizeMixedArray(L);let K=c.alloc(V?4:3,D,$);return K.writeUInt8(f),K.writeShortString(G),K.writeMixedArray(L),K.buffer}static deserializeRequestMixedArgs(D){const f=D.readUInt8(),A=D.readShortString(),L=D.readMixedArray(),V=new Array(L.length);for(let G=0,$=L.length;G<$;G++){const K=L[G];typeof K=="string"?V[G]=JSON.parse(K):V[G]=K}return{rpcId:f,method:A,args:V}}static serializeAcknowledged(D){return c.alloc(5,D,0).buffer}static serializeCancel(D){return c.alloc(6,D,0).buffer}static serializeReplyOK(D,f,A){if(typeof f=="undefined")return this._serializeReplyOKEmpty(D);if(f instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(D,f);if(f instanceof t.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:V}=w(f.value,A,!0);return this._serializeReplyOKJSONWithBuffers(D,L,V)}else return this._serializeReplyOKJSON(D,n(f,A))}static _serializeReplyOKEmpty(D){return c.alloc(7,D,0).buffer}static _serializeReplyOKVSBuffer(D,f){let A=0;A+=c.sizeVSBuffer(f);let L=c.alloc(8,D,A);return L.writeVSBuffer(f),L.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static _serializeReplyOKJSON(D,f){const A=M.VSBuffer.fromString(f);let L=0;L+=c.sizeLongString(A);let V=c.alloc(9,D,L);return V.writeLongString(A),V.buffer}static _serializeReplyOKJSONWithBuffers(D,f,A){const L=M.VSBuffer.fromString(f);let V=0;V+=c.sizeUInt32,V+=c.sizeLongString(L);for(const $ of A)V+=c.sizeVSBuffer($);let G=c.alloc(10,D,V);G.writeUInt32(A.length),G.writeLongString(L);for(const $ of A)G.writeBuffer($);return G.buffer}static deserializeReplyOKJSON(D){const f=D.readLongString();return JSON.parse(f)}static deserializeReplyOKJSONWithBuffers(D,f){const A=D.readUInt32(),L=D.readLongString(),V=[];for(let G=0;G<A;++G)V.push(D.readVSBuffer());return new t.SerializableObjectWithBuffers(I(L,V,f))}static serializeReplyErr(D,f){return f?this._serializeReplyErrEror(D,f):this._serializeReplyErrEmpty(D)}static _serializeReplyErrEror(D,f){const A=M.VSBuffer.fromString(n(R.transformErrorForSerialization(f),null));let L=0;L+=c.sizeLongString(A);let V=c.alloc(11,D,L);return V.writeLongString(A),V.buffer}static deserializeReplyErrError(D){const f=D.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(D){return c.alloc(12,D,0).buffer}}var k;(function(p){p[p.RequestJSONArgs=1]="RequestJSONArgs",p[p.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",p[p.RequestMixedArgs=3]="RequestMixedArgs",p[p.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",p[p.Acknowledged=5]="Acknowledged",p[p.Cancel=6]="Cancel",p[p.ReplyOKEmpty=7]="ReplyOKEmpty",p[p.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",p[p.ReplyOKJSON=9]="ReplyOKJSON",p[p.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",p[p.ReplyErrError=11]="ReplyErrError",p[p.ReplyErrEmpty=12]="ReplyErrEmpty"})(k||(k={}));var P;(function(p){p[p.String=1]="String",p[p.VSBuffer=2]="VSBuffer",p[p.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",p[p.Undefined=4]="Undefined"})(P||(P={}))}),define(we[213],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const d=function(R){const F=C=>{self.removeEventListener("message",F);const _=C.data;Object.defineProperties(self,{postMessage:{value(T,t){_.postMessage(T,t)}},onmessage:{get(){return _.onmessage},set(T){_.onmessage=T}}}),_.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(R)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(R,F,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${d})('${F}'))`,T=new Blob([_],{type:"application/javascript"}),t=URL.createObjectURL(T),E=new MessageChannel,n=t,u={type:"_newWorker",id:n,port:E.port2,url:t,options:C};R(u,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{const l={type:"_terminateWorker",id:n};E.port1.postMessage(l),URL.revokeObjectURL(t),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(l){E.port1.onmessage=l}},onmessageerror:{get(){return E.port1.onmessageerror},set(l){E.port1.onmessageerror=l}}}),E.port1.addEventListener("messageerror",l=>{const a=new MessageEvent("messageerror",{data:l.data});this.dispatchEvent(a)}),E.port1.addEventListener("message",l=>{const a=new MessageEvent("message",{data:l.data});this.dispatchEvent(a)}),E.port1.start()}}e.NestedWorker=M}),define(we[214],be([0,1,4]),function(ne,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(we[215],be([0,1,11,17,26,2,4,86,47,175,214]),function(ne,e,d,M,b,R,F,C,_,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let E=class $i{constructor(u,l,a,w){this.localUserHome=u,this.remoteAgentService=l,this.environmentService=a,this.contextService=w,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||b.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome||u})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(u,l){if(u.remoteAuthority)return d.Schemas.vscodeRemote;const a=(0,C.getVirtualWorkspaceScheme)(l.getWorkspace());if(a)return a;const w=l.getWorkspace().folders[0];if(w)return w.uri.scheme;const I=l.getWorkspace().configuration;return I?I.scheme:d.Schemas.file}async userHome(u){return u?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(u=>u===1?M.win32:M.posix)}async fileURI(u){let l="";if(await this.resolveOS===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const w=u.indexOf("/",2);w===-1?(l=u.substring(2),u="/"):(l=u.substring(2,w),u=u.substring(w)||"/")}return R.URI.from({scheme:d.Schemas.file,authority:l,path:u,query:"",fragment:""})}};E=Ue([He(1,t.IRemoteAgentService),He(2,T.IWorkbenchEnvironmentService),He(3,_.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(we[98],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(F,C){this.line=F,this.character=C}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,C){return new d(0,0)}with(F){return new d(0,0)}}e.Position=d;class M{constructor(F,C,_,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(F,C),this.end=new d(_,T)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var b;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[41],be([0,1,13,27,23,43,9,4,17,16,98,10]),function(ne,e,d,M,b,R,F,C,_,T,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",u=" characters skipped \u27EB",l=(n.length+u.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var a;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var w;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(w=e.QueryType||(e.QueryType={}));function I(U){return!!U.preview}e.resultIsMatch=I;function S(U){return!!U.resource}e.isFileMatch=S;function o(U){return!!U.message}e.isProgressMessage=o;var m;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(m=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class y{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=y;class i{constructor(z,Y,re){this.ranges=Y;const j=Array.isArray(Y)?Y:[Y];if(re&&re.matchLines===1&&v(j)){z=(0,F.getNLines)(z,re.matchLines);let ue="",oe=0,ve=0;const Fe=Math.floor(re.charsPerLine/5),Me=[];for(const Oe of j){const Ye=Math.max(Oe.startColumn-Fe,0),ze=Oe.startColumn+re.charsPerLine;if(Ye>ve+Fe+l){const je=n+(Ye-ve)+u;ue+=je+z.slice(Ye,ze),oe+=Ye-(ve+je.length)}else ue+=z.slice(ve,ze);Me.push(new s(0,Oe.startColumn-oe,Oe.endColumn-oe)),ve=ze}this.preview={text:ue,matches:Array.isArray(this.ranges)?Me:Me[0]}}else{const ue=Array.isArray(Y)?Y[0].startLineNumber:Y.startLineNumber;this.preview={text:z,matches:(0,d.mapArrayOrNot)(Y,oe=>new r(oe.startLineNumber-ue,oe.startColumn,oe.endLineNumber-ue,oe.endColumn))}}}}e.TextSearchMatch=i;function v(U){const z=U[0].startLineNumber;for(const Y of U)if(Y.startLineNumber!==z||Y.endLineNumber!==z)return!1;return!0}class r{constructor(z,Y,re,j){this.startLineNumber=z,this.startColumn=Y,this.endLineNumber=re,this.endColumn=j}}e.SearchRange=r;class s extends r{constructor(z,Y,re){super(z,Y,z,re)}}e.OneLineRange=s;var c;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(c=e.SearchSortOrder||(e.SearchSortOrder={}));function h(U,z=!0){const Y=U&&U.files&&U.files.exclude,re=z&&U&&U.search&&U.search.exclude;if(!Y&&!re)return;if(!Y||!re)return Y||re;let j=Object.create(null);return j=b.mixin(j,b.deepClone(Y)),j=b.mixin(j,b.deepClone(re),!0),j}e.getExcludes=h;function g(U,z){return U.excludePattern&&M.match(U.excludePattern,z)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&M.match(U.includePattern,z)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(Y=>{const re=Y.folder.fsPath;if(R.isEqualOrParent(z,re)){const j=_.relative(re,z);return!Y.includePattern||!!M.match(Y.includePattern,j)}else return!1}):!1:!0}e.pathIncludedInQuery=g;var k;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(k=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(z,Y){super(z);this.code=Y}}e.SearchError=P;function p(U){const z=U.message;if((0,T.isPromiseCanceledError)(U))return new P(z,k.canceled);try{const Y=JSON.parse(z);return new P(Y.message,Y.code)}catch(Y){return new P(z,k.other)}}e.deserializeSearchError=p;function D(U){const z={message:U.message,code:U.code};return new Error(JSON.stringify(z))}e.serializeSearchError=D;function f(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=f;function A(U){return U.type==="success"}e.isSerializedSearchSuccess=A;function L(U){return!!U.path}e.isSerializedFileMatch=L;function V(U,z){const Y=U.searchPath?U.searchPath:U.relativePath;return(0,F.fuzzyContains)(Y,z)}e.isFilePatternMatch=V;class G{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=G;function $(U,z){const Y={...U||{},...z||{}};return Object.keys(Y).filter(re=>{const j=Y[re];return typeof j=="boolean"&&j})}e.resolvePatternsForProvider=$;class K{constructor(z,Y){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...Y.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let re=z.includePattern;Y.includePattern&&(re?re={...re,...Y.includePattern}:re=Y.includePattern),re&&(this._parsedIncludeExpression=M.parse(re))}includedInQuerySync(z,Y,re){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,Y,re)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,Y,re))}includedInQuery(z,Y,re){const j=this._parsedExcludeExpression(z,Y,re),ue=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(z,Y,re):!0;return(0,E.isPromise)(j)?j.then(oe=>oe?!1:ue()):ue()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=K;function W(U){for(const z in U)if(typeof U[z]!="boolean")return!0;return!1}}),define(we[31],be([0,1,13,14,21,3,20,11,75,24,9,10,2,130,4,15,145,47,37,29,12,7,41,5]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w,I,S,o,m,y,i,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(D,f,A){return new T.ExtUri(L=>g(L,A)).isEqual(D,f)}function s(D,f,A){return r(D.uri,f.uri,A)?0:(0,t.compare)(D.uri.toString(),f.uri.toString())}function c(D,f,A){return D.index!==f.index?D.index<f.index?-1:1:r(D.uri,f.uri,A)?(0,t.compare)(D.name,f.name):(0,t.compare)(D.uri.toString(),f.uri.toString())}function h(D,f,A,L){const V=D.slice(0).sort(($,K)=>A($,K,L)),G=f.slice(0).sort(($,K)=>A($,K,L));return(0,d.delta)(V,G,($,K)=>A($,K,L))}function g(D,f){const A=f.getCapabilities(D.scheme);return!(A&&A&1024)}class k extends I.Workspace{constructor(f,A,L,V,G,$){super(f,L.map(K=>new I.WorkspaceFolder(K)),V,$);this._name=A,this._isUntitled=G,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris($),L.forEach(K=>{this._workspaceFolders.push(K),this._structure.set(K.uri,K)})}static toExtHostWorkspace(f,A,L,V){if(!f)return{workspace:null,added:[],removed:[]};const{id:G,name:$,folders:K,configuration:W,isUntitled:U}=f,z=[],Y=A;A?K.forEach((oe,ve)=>{const Fe=n.URI.revive(oe.uri),Me=k._findFolder(L||A,Fe,V);Me?(Me.name=oe.name,Me.index=oe.index,z.push(Me)):z.push({uri:Fe,name:oe.name,index:ve})}):z.push(...K.map(({uri:oe,name:ve,index:Fe})=>({uri:n.URI.revive(oe),name:ve,index:Fe}))),z.sort((oe,ve)=>oe.index<ve.index?-1:1);const re=new k(G,$,z,W?n.URI.revive(W):null,!!U,oe=>g(oe,V)),{added:j,removed:ue}=h(Y?Y.workspaceFolders:[],re.workspaceFolders,s,V);return{workspace:re,added:j,removed:ue}}static _findFolder(f,A,L){for(let V=0;V<f.folders.length;V++){const G=f.workspaceFolders[V];if(r(G.uri,A,L))return G}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(f,A){return A&&this._structure.get(f)&&(f=(0,T.dirname)(f)),this._structure.findSubstr(f)}resolveWorkspaceFolder(f){return this._structure.get(f)}}let P=class{constructor(f,A,L,V){this._onDidChangeWorkspace=new R.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new R.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=V,this._extHostFileSystemInfo=L,this._requestIdProvider=new _.Counter,this._barrier=new M.Barrier,this._proxy=f.getProxy(v.MainContext.MainThreadWorkspace),this._messageService=f.getProxy(v.MainContext.MainThreadMessageService);const G=A.workspace;this._confirmedWorkspace=G?new k(G.id,G.name,[],G.configuration?n.URI.revive(G.configuration):null,!!G.isUntitled,$=>g($,L)):void 0}$initializeWorkspace(f,A){this._trusted=A,this.$acceptWorkspaceData(f),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:C.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(f,A,L,...V){const G=[];if(Array.isArray(V)&&V.forEach(z=>{n.URI.isUri(z.uri)&&!G.some(Y=>r(Y.uri,z.uri,this._extHostFileSystemInfo))&&G.push({uri:z.uri,name:z.name||(0,T.basenameOrAuthority)(z.uri)})}),this._unconfirmedWorkspace||[A,L].some(z=>typeof z!="number"||z<0)||L===0&&G.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(A+L>$.length)return!1;const K=$.slice(0);K.splice(A,L,...G.map(z=>({uri:z.uri,name:z.name||(0,T.basenameOrAuthority)(z.uri),index:void 0})));for(let z=0;z<K.length;z++){const Y=K[z];if(K.some((re,j)=>j!==z&&r(Y.uri,re.uri,this._extHostFileSystemInfo)))return!1}K.forEach((z,Y)=>z.index=Y);const{added:W,removed:U}=h($,K,c,this._extHostFileSystemInfo);if(W.length===0&&U.length===0)return!1;if(this._proxy){const z=f.displayName||f.name;this._proxy.$updateWorkspaceFolders(z,A,L,G).then(void 0,Y=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,(0,u.localize)(0,null,z,Y.toString()),{extension:f},[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(f,A){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(f,A)}async getWorkspaceFolder2(f,A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(f,A)}async resolveWorkspaceFolder(f){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(f)}getPath(){if(!this._actualWorkspace)return;const{folders:f}=this._actualWorkspace;if(f.length!==0)return f[0].uri.fsPath}getRelativePath(f,A){let L,V="";if(typeof f=="string"?(L=n.URI.file(f),V=f):typeof f!="undefined"&&(L=f,V=f.fsPath),!L)return V;const G=this.getWorkspaceFolder(L,!0);if(!G)return V;typeof A=="undefined"&&this._actualWorkspace&&(A=this._actualWorkspace.folders.length>1);let $=(0,T.relativePath)(G.uri,L);return A&&G.name&&($=`${G.name}/${$}`),$}trySetWorkspaceFolders(f){this._actualWorkspace&&(this._unconfirmedWorkspace=k.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:f,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(f){const{workspace:A,added:L,removed:V}=k.toExtHostWorkspace(f,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=A||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:V}))}findFiles(f,A,L,V,G=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let $;if(A===null?$=!1:A&&(typeof A=="string"?$=A:$=A.pattern),G&&G.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:W}=p(f);return this._proxy.$startFileSearch((0,E.withUndefinedAsNull)(K),(0,E.withUndefinedAsNull)(W),(0,E.withUndefinedAsNull)($),(0,E.withUndefinedAsNull)(L),G).then(U=>Array.isArray(U)?U.map(z=>n.URI.revive(z)):[])}async findTextInFiles(f,A,L,V,G=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),K=typeof A.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:A.previewOptions,{includePattern:W,folder:U}=p(A.include),z=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,Y={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!0,fileEncoding:A.encoding,maxResults:A.maxResults,previewOptions:K,afterContext:A.afterContext,beforeContext:A.beforeContext,includePattern:W,excludePattern:z},re=!1;if(this._activeSearchCallbacks[$]=j=>{if(re)return;const ue=n.URI.revive(j.resource);j.results.forEach(oe=>{(0,i.resultIsMatch)(oe)?L({uri:ue,preview:{text:oe.preview.text,matches:(0,d.mapArrayOrNot)(oe.preview.matches,ve=>new y.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,d.mapArrayOrNot)(oe.ranges,ve=>new y.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):L({uri:ue,text:oe.text,lineNumber:oe.lineNumber})})},G.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(f,(0,E.withUndefinedAsNull)(U),Y,$,G);return delete this._activeSearchCallbacks[$],j||{}}catch(j){throw delete this._activeSearchCallbacks[$],j}}$handleTextSearchResult(f,A){this._activeSearchCallbacks[A]&&this._activeSearchCallbacks[A](f)}saveAll(f){return this._proxy.$saveAll(f)}resolveProxy(f){return this._proxy.$resolveProxy(f)}get trusted(){return this._trusted}requestWorkspaceTrust(f){return this._proxy.$requestWorkspaceTrust(f)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};P=Ue([He(0,m.IExtHostRpcService),He(1,o.IExtHostInitDataService),He(2,S.IExtHostFileSystemInfo),He(3,a.ILogService)],P),e.ExtHostWorkspace=P,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function p(D){let f,A;return D&&(typeof D=="string"?f=D:(f=D.pattern,A=D.baseFolder||n.URI.file(D.base))),{includePattern:f,folder:A}}}),define(we[32],be([0,1,23,3,31,5,7,148,62,10,14,4,12,15,2]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(v,r){if(r){const s=r.split(".");let c=v;for(let h=0;c&&h<s.length;h++)c=c[s[h]];return c}}function w(v){return v instanceof l.URI}function I(v){return v&&v.uri instanceof l.URI&&v.languageId&&typeof v.languageId=="string"}function S(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function o(v){return v&&v.uri instanceof l.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function m(v){if(w(v))return{resource:v};if(I(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(S(v))return{overrideIdentifier:v.languageId};if(o(v))return{resource:v.uri};if(v===null)return{resource:null}}let y=class{constructor(r,s,c){this._proxy=r.getProxy(R.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=c,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(r,s))}};y=Ue([He(0,n.IExtHostRpcService),He(1,b.IExtHostWorkspace),He(2,u.ILogService)],y),e.ExtHostConfiguration=y;class i{constructor(r,s,c,h){this._onDidChangeConfiguration=new M.Emitter,this._proxy=r,this._logService=h,this._extHostWorkspace=s,this._configuration=C.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,c))}getConfiguration(r,s,c){const h=m(s)||{},g=this._toReadonlyValue(r?a(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,h,c?.identifier);function k(p){if(p==null)return null;if(typeof p=="boolean")return p?1:4;switch(p){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const P={has(p){return typeof a(g,p)!="undefined"},get:(p,D)=>{this._validateConfigurationAccess(r?`${r}.${p}`:p,h,c?.identifier);let f=a(g,p);if(typeof f=="undefined")f=D;else{let A;const L=(V,G)=>{let $;const K=()=>{A=A||(0,d.deepClone)(g),$=$||a(A,G)};return(0,T.isObject)(V)?new Proxy(V,{get:(W,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return K(),()=>$;if(A)return $=$||a(A,G),$[U];const z=W[U];return typeof U=="string"?L(z,`${G}.${U}`):z},set:(W,U,z)=>(K(),$&&($[U]=z),!0),deleteProperty:(W,U)=>(K(),$&&delete $[U],!0),defineProperty:(W,U,z)=>(K(),$&&Object.defineProperty($,U,z),!0)}):V};f=L(f,p)}return f},update:(p,D,f,A)=>{p=r?`${r}.${p}`:p;const L=k(f);return D!==void 0?this._proxy.$updateConfigurationOption(L,p,D,h,A):this._proxy.$removeConfigurationOption(L,p,h,A)},inspect:p=>{p=r?`${r}.${p}`:p;const D=(0,d.deepClone)(this._configuration.inspect(p,h,this._extHostWorkspace.workspace));if(D)return{key:p,defaultValue:D.default?.value,globalValue:D.user?.value,workspaceValue:D.workspace?.value,workspaceFolderValue:D.workspaceFolder?.value,defaultLanguageValue:D.default?.override,globalLanguageValue:D.user?.override,workspaceLanguageValue:D.workspace?.override,workspaceFolderLanguageValue:D.workspaceFolder?.override,languageIds:D.overrideIdentifiers}}};return typeof g=="object"&&(0,d.mixin)(P,g,!1),Object.freeze(P)}_toReadonlyValue(r){const s=c=>(0,T.isObject)(c)?new Proxy(c,{get:(h,g)=>s(h[g]),set:(h,g,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(h,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(h,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return s(r)}_validateConfigurationAccess(r,s,c){const h=_.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),g=c?`[${c.value}] `:"";if(h===4){typeof s?.resource=="undefined"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){s?.resource&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const c=new C.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,g)=>c.affectsConfiguration(h,m(g))})}_toMap(r){return r.reduce((s,c)=>(s.set(c[0],c[1]),s),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,E.createDecorator)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,d):b?b.value=d:e.set(ne,d),d},Ae=this&&this.__classPrivateFieldGet||function(ne,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[99],be([0,1,2,14,3,5,7,31,49,32,21,40,12,29,4,11,26,15,70,165,16]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w,I,S,o,m){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(G){function $(W){if(W!=null)return W}G.from=$;function K(W){if(W!=null)return W}G.to=K})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var v;(function(G){function $(W){if(W!=null)return W}G.from=$;function K(W){if(W!=null)return W}G.to=K})(v=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(G){function $(W){if(W!=null)return W}G.from=$;function K(W){if(W!=null)return W}G.to=K})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(G){function $(U){if(U){const z=U;return z&&!!z.process}else return!1}G.is=$;function K(U){if(U==null)return;const z={process:U.process,args:U.args};return U.options&&(z.options=r.from(U.options)),z}G.from=K;function W(U){if(U!=null)return new F.ProcessExecution(U.process,U.args,U.options)}G.to=W})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function(G){function $(W){if(W!=null)return W}G.from=$;function K(W){if(W!=null)return W}G.to=K})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(G){function $(U){if(U){const z=U;return z&&(!!z.commandLine||!!z.command)}else return!1}G.is=$;function K(U){if(U==null)return;const z={};return U.commandLine!==void 0?z.commandLine=U.commandLine:(z.command=U.command,z.args=U.args),U.options&&(z.options=c.from(U.options)),z}G.from=K;function W(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new F.ShellExecution(U.commandLine,U.options):new F.ShellExecution(U.command,U.args?U.args:[],U.options)}G.to=W})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var g;(function(G){function $(U){if(U){let z=U;return z&&z.customExecution==="customExecution"}else return!1}G.is=$;function K(U){return{customExecution:"customExecution"}}G.from=K;function W(U,z){return z.get(U)}G.to=W})(g=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var k;(function(G){function $(K,W){let U;return K.scope!==void 0&&typeof K.scope!="number"?U=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===F.TaskScope.Workspace&&W&&W.workspaceFile?U=W.workspaceFile:U=o.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:U}}G.from=$})(k=e.TaskHandleDTO||(e.TaskHandleDTO={}));var P;(function(G){function $(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}G.from=$})(P=e.TaskGroupDTO||(e.TaskGroupDTO={}));var p;(function(G){function $(U,z){if(U==null)return[];const Y=[];for(let re of U){const j=K(re,z);j&&Y.push(j)}return Y}G.fromMany=$;function K(U,z){if(U==null)return;let Y;U.execution instanceof F.ProcessExecution?Y=s.from(U.execution):U.execution instanceof F.ShellExecution?Y=h.from(U.execution):U.execution&&U.execution instanceof F.CustomExecution&&(Y=g.from(U.execution));const re=i.from(U.definition);let j;return U.scope?typeof U.scope=="number"?j=U.scope:j=U.scope.uri:j=F.TaskScope.Workspace,!re||!j?void 0:{_id:U._id,definition:re,name:U.name,source:{extensionId:z.identifier.value,label:U.source,scope:j},execution:Y,isBackground:U.isBackground,group:P.from(U.group),presentationOptions:v.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}G.from=K;async function W(U,z,Y){if(U==null)return;let re;s.is(U.execution)?re=s.to(U.execution):h.is(U.execution)?re=h.to(U.execution):g.is(U.execution)&&(re=g.to(U._id,Y));const j=i.to(U.definition);let ue;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?ue=U.source.scope:ue=await z.resolveWorkspaceFolder(d.URI.revive(U.source.scope)):ue=F.TaskScope.Workspace),!j||!ue)return;const oe=new F.Task(j,ue,U.name,U.source.label,re,U.problemMatchers);return U.isBackground!==void 0&&(oe.isBackground=U.isBackground),U.group!==void 0&&(oe.group=F.TaskGroup.from(U.group._id),oe.group&&(oe.group=new F.TaskGroup(oe.group.id,oe.group.label),U.group.isDefault&&(oe.group.isDefault=U.group.isDefault))),U.presentationOptions&&(oe.presentationOptions=v.to(U.presentationOptions)),U._id&&(oe._id=U._id),U.detail&&(oe.detail=U.detail),oe}G.to=W})(p=e.TaskDTO||(e.TaskDTO={}));var D;(function(G){function $(W){return W}G.from=$;function K(W){if(!!W)return Object.assign(Object.create(null),W)}G.to=K})(D=e.TaskFilterDTO||(e.TaskFilterDTO={}));class f{constructor($,K,W){this._id=K,this._task=W,y.set(this,void 0),Xe(this,y,$,"f")}get task(){return this._task}terminate(){Ae(this,y,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}y=new WeakMap;var A;(function(G){function $(K){return{id:K._id,task:void 0}}G.from=$})(A=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let L=class{constructor($,K,W,U,z,Y,re,j){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=$.getProxy(R.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=U,this._configurationService=z,this._terminalService=Y,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=re,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider($,K,W){if(!W)return new F.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:K,provider:W,extension:$}),this._proxy.$registerTaskProvider(U,K),new F.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem($,K){this._proxy.$registerTaskSystem($,K)}fetchTasks($){return this._proxy.$fetchTasks(D.from($)).then(async K=>{const W=[];for(let U of K){const z=await p.to(U,this._workspaceProvider,this._providedCustomExecutions2);z&&W.push(z)}return W})}get taskExecutions(){const $=[];return this._taskExecutions.forEach(K=>$.push(K)),$}terminateTask($){if(!($ instanceof f))throw new Error("No valid task execution provided");return this._proxy.$terminateTask($._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask($,K,W){const U=this._providedCustomExecutions2.get($.id);if(U){if(this._activeCustomExecutions2.get($.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set($.id,U),this._terminalService.attachPtyToTerminal(K,await U.callback(W))}this._lastStartedTask=$.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution($)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask($){const K=await this.getTaskExecution($);this._taskExecutionPromises.delete($.id),this._taskExecutions.delete($.id),this.customExecutionComplete($),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess($){const K=await this.getTaskExecution($.id);this._onDidTaskProcessStarted.fire({execution:K,processId:$.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess($){const K=await this.getTaskExecution($.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:$.exitCode})}$provideTasks($,K){const W=this._handlers.get($);if(!W)return Promise.reject(new Error("no handler found"));const U=[],z=(0,M.asPromise)(()=>W.provider.provideTasks(t.CancellationToken.None)).then(Y=>this.provideTasksInternal(K,U,W,Y));return new Promise(Y=>{z.then(re=>{Promise.all(U).then(()=>{Y(re)})})})}async $resolveTask($,K){const W=this._handlers.get($);if(!W)return Promise.reject(new Error("no handler found"));if(K.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${W.type}].`);const U=await p.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const z=await W.provider.resolveTask(U,t.CancellationToken.None);if(!z)return;this.checkDeprecation(z,W);const Y=p.from(z,W.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(Y.execution)&&await this.addCustomExecution(Y,z,!0),await this.resolveTaskInternal(Y)}nextHandle(){return this._handleCounter++}async addCustomExecution($,K,W){const U=await this._proxy.$createTaskId($);!W&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,K.execution)}async getTaskExecution($,K){if(typeof $=="string"){const z=this._taskExecutionPromises.get($);if(!z)throw new Error("Unexpected: The specified task is missing an execution");return z}let W=this._taskExecutionPromises.get($.id);if(W)return W;const U=new Promise(async(z,Y)=>{const re=K||await p.to($.task,this._workspaceProvider,this._providedCustomExecutions2);re?z(new f(this,$.id,re)):Y("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set($.id,U),U.then(z=>(this._taskExecutions.set($.id,z),z),z=>Promise.reject(z))}checkDeprecation($,K){$._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete($){this._activeCustomExecutions2.get($.id)&&this._activeCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.has($.id)&&this._lastStartedTask!==$.id&&(this._providedCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.delete($.id));let W=this._notProvidedCustomExecutions.values(),U=W.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=W.next()}};L=Ue([He(0,n.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,_.IExtHostDocumentsAndEditors),He(4,T.IExtHostConfiguration),He(5,E.IExtHostTerminalService),He(6,I.ILogService),He(7,S.IExtHostApiDeprecationService)],L),e.ExtHostTaskBase=L;let V=class extends L{constructor($,K,W,U,z,Y,re,j){super($,K,W,U,z,Y,re,j);this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask($,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const W=p.from(K,$);if(W===void 0)throw new Error("Task is not valid");if(g.is(W.execution))await this.addCustomExecution(W,K,!1);else throw new m.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),K);return this._proxy.$executeTask(W).catch(z=>{throw new Error(z)}),U}provideTasksInternal($,K,W,U){const z=[];if(U)for(let Y of U){this.checkDeprecation(Y,W),(!Y.definition||!$[Y.definition.type])&&this._logService.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const re=p.from(Y,W.extension);re&&g.is(re.execution)?(z.push(re),K.push(this.addCustomExecution(re,Y,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:W.extension}}async resolveTaskInternal($){if(g.is($.execution))return $;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables($,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,K,W){}};V=Ue([He(0,n.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,_.IExtHostDocumentsAndEditors),He(4,T.IExtHostConfiguration),He(5,E.IExtHostTerminalService),He(6,I.ILogService),He(7,S.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(we[216],be([0,1,13,51,27,77,20,11,17,24,9,10,2,111,134,84,47,92,215,41]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w,I,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(k,P,p,D){this.configurationService=k,this.workspaceContextService=P,this.editorGroupsService=p,this.pathService=D}text(k,P,p={}){k=this.getContentPattern(k,p);const D=this.configurationService.getValue(),f=P&&P.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(P?.map(w.toWorkspaceFolder),p),type:2,contentPattern:k,previewOptions:p.previewOptions,maxFileSize:p.maxFileSize,usePCRE2:D.search.usePCRE2||f||!1,beforeContext:p.beforeContext,afterContext:p.afterContext,userDisabledExcludesAndIgnoreFiles:p.disregardExcludeSettings&&p.disregardIgnoreFiles}}getContentPattern(k,P){const p=this.configurationService.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const D={...k,wordSeparators:p.editor.wordSeparators};return this.isCaseSensitive(k,P)&&(D.isCaseSensitive=!0),this.isMultiline(k)&&(D.isMultiline=!0),D}file(k,P={}){return{...this.commonQuery(k,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}handleIncludeExclude(k,P){return k?(k=Array.isArray(k)?k.map(s):s(k),P?this.parseSearchPaths(k):{pattern:i(...Array.isArray(k)?k:[k])}):{}}commonQuery(k=[],P={}){const p=this.handleIncludeExclude(P.includePattern,P.expandPatterns),D=this.handleIncludeExclude(P.excludePattern,P.expandPatterns),f=k.length>1,A=(p.searchPaths&&p.searchPaths.length?p.searchPaths.map(G=>this.getFolderQueryForSearchPath(G,P,D)):k.map(G=>this.getFolderQueryForRoot(G,P,D,f))).filter(G=>!!G),L={_reason:P._reason,folderQueries:A,usingSearchPaths:!!(p.searchPaths&&p.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:D.pattern,includePattern:p.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const $=d.coalesce(d.flatten(this.editorGroupsService.groups.map(W=>W.editors.map(U=>U.resource)))).filter(W=>(0,o.pathIncludedInQuery)(L,W.fsPath)),K=this.commonQueryFromFileList($);return{...L,...K}}const V=P.extraFileResources&&P.extraFileResources.filter(G=>(0,o.pathIncludedInQuery)(L,G.fsPath));return L.extraFileResources=V&&V.length?V:void 0,L}commonQueryFromFileList(k){const P=[],p=new F.ResourceMap,D={};let f=!1;return k.forEach(A=>{if(A.scheme===C.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(A)){const V=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:_.dirname(A.fsPath)});let G=p.get(V);G||(f=!0,G={folder:V,includePattern:{}},P.push(G),p.set(V,G));const $=_.relative(V.fsPath,A.fsPath);(0,E.assertIsDefined)(G.includePattern)[$.replace(/\\/g,"/")]=!0}else A.fsPath&&(f=!0,D[A.fsPath]=!0)}),{folderQueries:P,includePattern:D,usingSearchPaths:!0,excludePattern:f?void 0:{"**/*":!0}}}isCaseSensitive(k,P){if(P.isSmartCase){if(k.isRegExp){if(t.containsUppercaseCharacter(k.pattern,!0))return!0}else if(t.containsUppercaseCharacter(k.pattern))return!0}return!!k.isCaseSensitive}isMultiline(k){return k.isMultiline||k.isRegExp&&(0,u.isMultilineRegexSource)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const P=K=>_.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),D=(Array.isArray(k)?k:v(k)).map(K=>{const W=this.pathService.resolvedUserHome;return W?(0,R.untildify)(K,W.scheme===C.Schemas.file?W.fsPath:W.path):K}),f=M.groupBy(D,K=>P(K)?"searchPaths":"exprSegments"),A=(f.exprSegments||[]).map(K=>t.rtrim(K,"/")).map(K=>t.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),r(K))),L={},V=this.expandSearchPathPatterns(f.searchPaths||[]);V&&V.length&&(L.searchPaths=V);const G=d.flatten(A),$=i(...G);return $&&(L.pattern=$),L}getExcludesForFolder(k,P){return P.disregardExcludeSettings?void 0:(0,o.getExcludes)(k,!P.disregardSearchExcludeSettings)}expandSearchPathPatterns(k){if(!k||!k.length)return[];const P=d.flatten(k.map(D=>{let{pathPortion:f,globPortion:A}=y(D);A&&(A=c(A));const L=this.expandOneSearchPath(f);return d.flatten(L.map(V=>this.resolveOneSearchPathPattern(V,A)))})),p=new Map;return P.forEach(D=>{const f=D.searchPath.toString(),A=p.get(f);A?D.pattern&&(A.pattern=A.pattern||{},A.pattern[D.pattern]=!0):p.set(f,{searchPath:D.searchPath,pattern:D.pattern?i(D.pattern):void 0})}),Array.from(p.values())}expandOneSearchPath(k){if(_.isAbsolute(k)){const P=this.workspaceContextService.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==C.Schemas.file?[{searchPath:P[0].uri.with({path:k})}]:[{searchPath:n.URI.file(_.normalize(k))}]}if(this.workspaceContextService.getWorkbenchState()===2){const P=this.workspaceContextService.getWorkspace().folders[0].uri;if(k=s(k),k.startsWith("../")||k===".."){const D=_.posix.resolve(P.path,k);return[{searchPath:P.with({path:D})}]}const p=c(k);return[{searchPath:P,pattern:p}]}else{if(k==="./"||k===".\\")return[];{const P=k.replace(/^\.[\/\\]/,""),D=this.workspaceContextService.getWorkspace().folders.map(f=>{const A=P.match(new RegExp(`^${t.escapeRegExpCharacters(f.name)}(?:/(.*)|$)`));return A?{match:A,folder:f}:null}).filter(E.isDefined);if(D.length)return D.map(f=>{const A=f.match[1];return{searchPath:f.folder.uri,pattern:A&&c(A)}});{const f=k.match(/\.[\/\\](.+)[\/\\]?/),A=f?f[1]:k,L=l.localize(0,null,A);throw new Error(L)}}}}resolveOneSearchPathPattern(k,P){const p=k.pattern&&P?`${k.pattern}/${P}`:k.pattern||P,D=[{searchPath:k.searchPath,pattern:p}];return p&&!p.endsWith("**")&&D.push({searchPath:k.searchPath,pattern:p+"/**"}),D}getFolderQueryForSearchPath(k,P,p){const D=this.getFolderQueryForRoot((0,w.toWorkspaceFolder)(k.searchPath),P,p,!1);return D?{...D,includePattern:k.pattern}:null}getFolderQueryForRoot(k,P,p,D){let f;const A=n.URI.isUri(k)?k:k.uri;if(p.searchPaths){const K=p.searchPaths.filter(W=>(0,T.isEqual)(W.searchPath,A))[0];if(K&&!K.pattern)return null;K&&(f=K.pattern)}const L=this.configurationService.getValue({resource:A}),G={...this.getExcludesForFolder(L,P)||{},...f||{}},$=n.URI.isUri(k)?(0,T.basename)(k):k.name;return{folder:A,folderName:D?$:void 0,excludePattern:Object.keys(G).length>0?G:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!L.search.followSymlinks}}};m=Ue([He(0,a.IConfigurationService),He(1,w.IWorkspaceContextService),He(2,I.IEditorGroupsService),He(3,S.IPathService)],m),e.QueryBuilder=m;function y(g){const k=g.match(/[\*\{\}\(\)\[\]\?]/);if(k){const P=k.index,p=g.substr(0,P).match(/[/|\\][^/\\]*$/);if(p){let D=g.substr(0,p.index);return D.match(/[/\\]/)||(D+="/"),{pathPortion:D,globPortion:g.substr((p.index||0)+1)}}}return{pathPortion:g}}function i(...g){return g.length?g.reduce((k,P)=>(k[P]=!0,k),Object.create(null)):void 0}function v(g){return b.splitGlobAware(g,",").map(k=>k.trim()).filter(k=>!!k.length)}function r(g){return[`**/${g}/**`,`**/${g}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function s(g){return g.replace(/\\/g,"/")}function c(g){return s(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(g,k){g=d.distinct(g,D=>D.toString());const P=[],p=k.getWorkspace();return g&&g.forEach(D=>{let f;if(k.getWorkbenchState()===2)f=(0,T.relativePath)(p.folders[0].uri,D),f&&f!=="."&&(f="./"+f);else{const A=k.getWorkspaceFolder(D);if(A){const L=A.name;if(p.folders.filter(G=>G.name===L).length===1){const G=(0,T.relativePath)(A.uri,D);G===""?f=`./${A.name}`:f=`./${A.name}/${G}`}else f=D.fsPath}}f&&P.push(f)}),P}e.resolveResourcesForSearchIncludes=h}),define(we[217],be([0,1,24,2,21,16,4,216,41,47]),function(ne,e,d,M,b,R,F,C,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function E(a,w){const I=w.activationEvents;if(!I)return Promise.resolve(void 0);const S=[],o=[];for(const s of I)if(/^workspaceContains:/.test(s)){const c=s.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||a.forceUsingSearch?o.push(c):S.push(c)}if(S.length===0&&o.length===0)return Promise.resolve(void 0);let m;const y=new Promise((s,c)=>{m=s}),i=s=>m({activationEvent:s}),v=Promise.all(S.map(s=>n(a,s,i))).then(()=>{}),r=u(a,w.identifier,o,i);return Promise.all([v,r]).then(()=>{m(void 0)}),y}e.checkActivateWorkspaceContainsExtension=E;async function n(a,w,I){for(const S of a.folders)if(await a.exists(d.joinPath(M.URI.revive(S),w))){I(`workspaceContains:${w}`);return}}async function u(a,w,I,S){if(I.length===0)return Promise.resolve(void 0);const o=new b.CancellationTokenSource,m=a.checkExists(a.folders,I,o.token),y=setTimeout(async()=>{o.cancel(),S(`workspaceContainsTimeout:${I.join(",")}`)},t);let i=!1;try{i=await m}catch(v){R.isPromiseCanceledError(v)||R.onUnexpectedError(v)}o.dispose(),clearTimeout(y),i&&S(`workspaceContains:${I.join(",")}`)}function l(a,w,I,S){const o=a.get(F.IInstantiationService),m=a.get(_.ISearchService),i=o.createInstance(C.QueryBuilder).file(w.map(v=>(0,T.toWorkspaceFolder)(M.URI.revive(v))),{_reason:"checkExists",includePattern:I,exists:!0});return m.fileSearch(i,S).then(v=>!!v.limitHit,v=>R.isPromiseCanceledError(v)?!1:Promise.reject(v))}e.checkGlobFileExists=l});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,d,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,d):b?b.value=d:e.set(ne,d),d},Ae=this&&this.__classPrivateFieldGet||function(ne,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[33],be([0,1,125,17,74,24,14,6,20,2,15,5,32,178,72,31,30,176,16,25,22,152,7,85,4,29,73,12,61,64,40,3,217,69,154]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w,I,S,o,m,y,i,v,r,s,c,h,g,k,P,p,D,f,A){"use strict";var L,V,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let $=class Wi extends C.Disposable{constructor(z,Y,re,j,ue,oe,ve,Fe,Me,Oe){super();this._onDidChangeRemoteConnectionData=this._register(new p.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Y,this._extHostContext=re,this._initData=ve,this._extHostWorkspace=j,this._extHostConfiguration=ue,this._logService=oe,this._extHostTunnelService=Me,this._extHostTerminalService=Oe,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(E.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(E.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(E.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new I.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new f.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=z.createChild(new g.ServiceCollection([l.IExtHostStorage,this._storage],[f.IExtHostSecretState,this._secretState]));const Ye=new Set;this._initData.hostExtensions.forEach(ze=>Ye.add(o.ExtensionIdentifier.toKey(ze))),this._activator=new u.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,je,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,S.transformErrorForSerialization(je),x)},actualActivateExtension:async(ze,je)=>{if(Ye.has(o.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,je),new u.HostExtension;const x=this._registry.getExtensionDescription(ze);return this._activateExtension(x,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(z){S.onUnexpectedError(z)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let z=[];try{z=this._registry.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this._deactivate(ue))}catch(Y){}await Promise.all(z)}isActivated(z){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(z):!1}_activateByEvent(z,Y){return this._activator.activateByEvent(z,Y)}_activateById(z,Y){return this._activator.activateById(z,Y)}activateByIdWithErrors(z,Y){return this._activateById(z,Y).then(()=>{const re=this._activator.getActivatedExtension(z);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(z=>this._registry)}getExtensionExports(z){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(z).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const z=_.TernarySearchTree.forPaths(),Y=this._registry.getAllExtensionDescriptions().map(re=>{if(!!this._getEntryPoint(re))return this._hostUtils.realpath(re.extensionLocation.fsPath).then(j=>z.set(T.URI.file(j).fsPath,re))});this._extensionPathIndex=Promise.all(Y).then(()=>z)}return this._extensionPathIndex}_deactivate(z){let Y=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(z))return Y;const re=this._activator.getActivatedExtension(z);if(!re)return Y;try{typeof re.module.deactivate=="function"&&(Y=Promise.resolve(re.module.deactivate()).then(void 0,j=>(this._logService.error(j),Promise.resolve(void 0))))}catch(j){this._logService.error(j)}try{(0,C.dispose)(re.subscriptions)}catch(j){this._logService.error(j)}return Y}async _activateExtension(z,Y){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(z.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(z.identifier),this._doActivateExtension(z,Y).then(re=>{const j=re.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(z.identifier,j.codeLoadingTime,j.activateCallTime,j.activateResolvedTime,Y),this._logExtensionActivationTimes(z,Y,"success",j),re},re=>{throw this._logExtensionActivationTimes(z,Y,"failure"),re})}_logExtensionActivationTimes(z,Y,re,j){const ue=K(z,Y);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ue,...j||{},outcome:re})}_doActivateExtension(z,Y){const re=K(z,Y);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",re);const j=this._getEntryPoint(z);if(!j)return Promise.resolve(new u.EmptyExtension(u.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${z.identifier.value} ${JSON.stringify(Y)}`),this._logService.flush();const ue=new u.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this._loadCommonJSModule(z.identifier,(0,R.joinPath)(z.extensionLocation,j),ue),this._loadExtensionContext(z)]).then(oe=>(b.mark(`code/extHost/willActivateExtension/${z.identifier.value}`),Wi._callActivate(this._logService,z.identifier,oe[0],oe[1],ue))).then(oe=>(b.mark(`code/extHost/didActivateExtension/${z.identifier.value}`),oe))}_loadExtensionContext(z){const Y=new y.ExtensionGlobalMemento(z,this._storage),re=new y.ExtensionMemento(z.identifier.value,!1,this._storage),j=new A.ExtensionSecrets(z,this._secretState),ue=z.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,oe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${z.identifier.value}`),Promise.all([Y.whenReady,re.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Fe;return Object.freeze({globalState:Y,workspaceState:re,secrets:j,subscriptions:[],get extensionUri(){return z.extensionLocation},get extensionPath(){return z.extensionLocation.fsPath},asAbsolutePath(Me){return M.join(z.extensionLocation.fsPath,Me)},get storagePath(){return ve._storagePath.workspaceValue(z)?.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(z).fsPath},get logPath(){return M.join(ve._initData.logsLocation.fsPath,z.identifier.value)},get logUri(){return T.URI.joinPath(ve._initData.logsLocation,z.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(z)},get globalStorageUri(){return ve._storagePath.globalValue(z)},get extensionMode(){return ue},get extension(){return Fe===void 0&&(Fe=new W(ve,z.identifier,z,oe)),Fe},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(z),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(z)}})})}static _callActivate(z,Y,re,j,ue){return re=re||{activate:void 0,deactivate:void 0},this._callActivateOptional(z,Y,re,j,ue).then(oe=>new u.ActivatedExtension(!1,null,ue.build(),re,oe,j.subscriptions))}static _callActivateOptional(z,Y,re,j,ue){if(typeof re.activate=="function")try{ue.activateCallStart(),z.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const oe=typeof global=="object"?global:self,ve=re.activate.apply(oe,[j]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(ve).then(Fe=>(ue.activateResolveStop(),Fe))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(re)}_activateOneStartupFinished(z,Y){this._activateById(z.identifier,{startup:!1,extensionId:z.identifier,activationEvent:Y}).then(void 0,re=>{this._logService.error(re)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const z of this._registry.getAllExtensionDescriptions())if(z.activationEvents)for(const Y of z.activationEvents)Y==="onStartupFinished"&&this._activateOneStartupFinished(z,Y)}_handleEagerExtensions(){const z=this._activateByEvent("*",!0).then(void 0,ue=>{this._logService.error(ue)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ue=>this._handleWorkspaceContainsEagerExtensions(ue.added)));const Y=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],re=this._handleWorkspaceContainsEagerExtensions(Y),j=Promise.all([z,re]).then(()=>{});return Promise.race([j,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),j}_handleWorkspaceContainsEagerExtensions(z){return z.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Y=>this._handleWorkspaceContainsEagerExtension(z,Y))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(z,Y){if(this.isActivated(Y.identifier))return;const re=!this._initData.remote.isRemote&&!!this._initData.remote.authority,j={folders:z.map(oe=>oe.uri),forceUsingSearch:re,exists:oe=>this._hostUtils.exists(oe.fsPath),checkExists:(oe,ve,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(oe,ve,Fe)},ue=await(0,D.checkActivateWorkspaceContainsExtension)(j,Y);if(!!ue)return this._activateById(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:ue.activationEvent}).then(void 0,oe=>this._logService.error(oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(z){throw console.error(z),z}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:z,extensionTestsLocationURI:Y}=this._initData.environment;if(!z||!Y)throw new Error(d.localize(0,null));const re=await this._loadCommonJSModule(null,Y,new u.ExtensionActivationTimesBuilder(!1));if(!re||typeof re.run!="function")throw new Error(d.localize(1,null,Y.toString()));return new Promise((j,ue)=>{const oe=(Me,Oe)=>{Me?ue(Me):j(typeof Oe=="number"&&Oe>0?1:0)},ve=(0,R.originalFSPath)(Y),Fe=re.run(ve,oe);Fe&&Fe.then&&Fe.then(()=>{j(0)}).catch(Me=>{ue(Me.toString())})})}async $extensionTestsExit(z){this._logService.info(`extension host terminating: test runner requested exit with code ${z}`),this._logService.info(`exiting with code ${z}`),this._logService.flush(),this._hostUtils.exit(z)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(z,Y){return this._resolvers[z]=Y,(0,C.toDisposable)(()=>{delete this._resolvers[z]})}async _activateAndGetResolver(z){const Y=z.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const re=z.substr(0,Y);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this._resolvers[re]}}async $resolveAuthority(z,Y){const{authorityPrefix:re,resolver:j}=await this._activateAndGetResolver(z);if(!j)return{type:"error",error:{code:v.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${re}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(j)),b.mark(`code/extHost/willResolveAuthority/${re}`);const ue=await j.resolve(z,{resolveAttempt:Y});b.mark(`code/extHost/didResolveAuthorityOK/${re}`);const oe={authority:z,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},ve={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted};return{type:"ok",value:{authority:oe,options:ve,tunnelInformation:{environmentTunnels:ue.environmentTunnels}}}}catch(ue){if(b.mark(`code/extHost/didResolveAuthorityError/${re}`),ue instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(z,Y){const{authorityPrefix:re,resolver:j}=await this._activateAndGetResolver(z);if(!j)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${re}`);const ue=T.URI.revive(Y);if(typeof j.getCanonicalURI=="undefined")return ue;const oe=await(0,F.asPromise)(()=>j.getCanonicalURI(ue));return oe||ue}$startExtensionHost(z){return this._registry.keepOnly(z),this._startExtensionHost()}$activateByEvent(z,Y){return Y===1?this._activateByEvent(z,!1):this._readyToRunExtensions.wait().then(re=>this._activateByEvent(z,!1))}async $activate(z,Y){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(z)?(await this._activateById(z,Y),!0):!1}async $deltaExtensions(z,Y){z.forEach(j=>j.extensionLocation=T.URI.revive(j.extensionLocation));const re=await this.getExtensionPathIndex();return await Promise.all(Y.map(async j=>{const ue=this._registry.getExtensionDescription(j);if(!ue)return;const oe=await this._hostUtils.realpath(ue.extensionLocation.fsPath);re.delete(T.URI.file(oe).fsPath)})),await Promise.all(z.map(async j=>{const ue=await this._hostUtils.realpath(j.extensionLocation.fsPath);re.set(T.URI.file(ue).fsPath,j)})),this._registry.deltaExtensions(z,Y),Promise.resolve(void 0)}async $test_latency(z){return z}async $test_up(z){return z.byteLength}async $test_down(z){let Y=m.VSBuffer.alloc(z),re=Math.random()%256;for(let j=0;j<z;j++)Y.writeUInt8(re,j);return Y}async $updateRemoteConnectionData(z){this._remoteConnectionData=z,this._onDidChangeRemoteConnectionData.fire()}};$=Ue([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,h.IExtHostRpcService),He(3,a.IExtHostWorkspace),He(4,n.IExtHostConfiguration),He(5,t.ILogService),He(6,s.IExtHostInitDataService),He(7,c.IExtensionStoragePaths),He(8,k.IExtHostTunnelService),He(9,P.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function K(U,z){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:z.activationEvent,reasonId:z.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class W{constructor(z,Y,re,j){L.set(this,void 0),V.set(this,void 0),G.set(this,void 0),Xe(this,L,z,"f"),Xe(this,V,Y,"f"),Xe(this,G,re.identifier,"f"),this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=M.normalize((0,R.originalFSPath)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=j}get isActive(){return Ae(this,L,"f").isActivated(Ae(this,G,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ae(this,L,"f").getExtensionExports(Ae(this,G,"f"))}activate(){return Ae(this,L,"f").activateByIdWithErrors(Ae(this,G,"f"),{startup:!1,extensionId:Ae(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,L=new WeakMap,V=new WeakMap,G=new WeakMap}),define(we[100],be([0,1,17,2,3,14,5,7,162,31,33,49,167,32,163,12,4,10,91,68]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w,I,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let m=class{constructor(g,k,P,p,D,f){this._workspaceService=k,this._extensionService=P,this._editorsService=p,this._configurationService=D,this._editorTabs=f,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new b.Emitter,this._onDidTerminateDebugSession=new b.Emitter,this._onDidChangeActiveDebugSession=new b.Emitter,this._onDidReceiveDebugSessionCustomEvent=new b.Emitter,this._debugServiceProxy=g.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new b.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(A=>{A.onDidChange(L=>{this.registerAllDebugTypes(A)}),this.registerAllDebugTypes(A)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(g,k){const P=g;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let p=`debug:${encodeURIComponent(P.path||"")}`,D="?";return k&&(p+=`${D}session=${encodeURIComponent(k.id)}`,D="&"),p+=`${D}ref=${P.sourceReference}`,M.URI.parse(p)}else{if(P.path)return M.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(g){const k=[];for(const P of g.getAllExtensionDescriptions())if(P.contributes){const p=P.contributes.debuggers;if(p&&p.length>0)for(const D of p)(0,l.isDebuggerMainContribution)(D)&&k.push(D.type)}this._debugServiceProxy.$registerDebugTypes(k)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const g=[];return this._breakpoints.forEach(k=>g.push(k)),g}addBreakpoints(g){this.startBreakpoints();const k=g.filter(D=>{const f=D.id;return this._breakpoints.has(f)?!1:(this._breakpoints.set(f,D),!0)});this.fireBreakpointChanges(k,[],[]);const P=[],p=new Map;for(const D of k)if(D instanceof C.SourceBreakpoint){let f=p.get(D.location.uri.toString());f||(f={type:"sourceMulti",uri:D.location.uri,lines:[]},p.set(D.location.uri.toString(),f),P.push(f)),f.lines.push({id:D.id,enabled:D.enabled,condition:D.condition,hitCondition:D.hitCondition,logMessage:D.logMessage,line:D.location.range.start.line,character:D.location.range.start.character})}else D instanceof C.FunctionBreakpoint&&P.push({type:"function",id:D.id,enabled:D.enabled,hitCondition:D.hitCondition,logMessage:D.logMessage,condition:D.condition,functionName:D.functionName});return this._debugServiceProxy.$registerBreakpoints(P)}removeBreakpoints(g){this.startBreakpoints();const k=g.filter(f=>this._breakpoints.delete(f.id));this.fireBreakpointChanges([],k,[]);const P=k.filter(f=>f instanceof C.SourceBreakpoint).map(f=>f.id),p=k.filter(f=>f instanceof C.FunctionBreakpoint).map(f=>f.id),D=k.filter(f=>f instanceof C.DataBreakpoint).map(f=>f.id);return this._debugServiceProxy.$unregisterBreakpoints(P,p,D)}startDebugging(g,k,P){return this._debugServiceProxy.$startDebugging(g?g.uri:void 0,k,{parentSessionID:P.parentSession?P.parentSession.id:void 0,lifecycleManagedByParent:P.lifecycleManagedByParent,repl:P.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact,debugUI:P.debugUI,suppressSaveBeforeStart:P.suppressSaveBeforeStart})}stopDebugging(g){return this._debugServiceProxy.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,k,P){if(!k)return new C.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:g,handle:p,provider:k}),this._debugServiceProxy.$registerDebugConfigurationProvider(g,P,!!k.provideDebugConfigurations,!!k.resolveDebugConfiguration,!!k.resolveDebugConfigurationWithSubstitutedVariables,p),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(D=>D.provider!==k),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(g,k,P){if(!P)return new C.Disposable(()=>{});if(!this.definesDebugType(g,k))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${k}' debugger.`);if(this.getAdapterDescriptorFactoryByType(k))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:k,handle:p,factory:P}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(k,p),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(D=>D.factory!==P),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(g,k){if(!k)return new C.Disposable(()=>{});const P=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:g,handle:P,factory:k}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==k)})}async $runInTerminal(g,k){return Promise.resolve(void 0)}async $substituteVariables(g,k){if(!this._variableResolver){const[D,f]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(D||[],this._editorsService,f)}let P;const p=await this.getFolder(g);return p&&(P={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(P,k)}createDebugAdapter(g,k){if(g.type==="implementation")return new s(g.implementation)}createSignService(){}async $startDASession(g,k){const P=this,p=await this.getSession(k);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const f=this.convertToDto(D),A=this.createDebugAdapter(f,p);if(!A)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const L=A;return this._debugAdapters.set(g,L),this.getDebugAdapterTrackers(p).then(V=>(V&&this._debugAdaptersTrackers.set(g,V),L.onMessage(async G=>{if(G.type==="request"&&G.command==="handshake"){const $=G,K={type:"response",seq:0,command:$.command,request_seq:$.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const W=await this._signService.sign($.arguments.value);K.body={signature:W},L.sendResponse(K)}else throw new Error("no signer")}catch(W){K.success=!1,K.message=W.message,L.sendResponse(K)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(G),G=(0,l.convertToVSCPaths)(G,!0),P._debugServiceProxy.$acceptDAMessage(g,G)}),L.onError(G=>{V&&V.onError&&V.onError(G),this._debugServiceProxy.$acceptDAError(g,G.name,G.message,G.stack)}),L.onExit(G=>{V&&V.onExit&&V.onExit((0,I.withNullAsUndefined)(G),void 0),this._debugServiceProxy.$acceptDAExit(g,(0,I.withNullAsUndefined)(G),void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),L.startSession()))})}$sendDAMessage(g,k){k=(0,l.convertToDAPaths)(k,!1);const P=this._debugAdaptersTrackers.get(g);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(k);const p=this._debugAdapters.get(g);p&&p.sendMessage(k)}$stopDASession(g){const k=this._debugAdaptersTrackers.get(g);this._debugAdaptersTrackers.delete(g),k&&k.onWillStopSession&&k.onWillStopSession();const P=this._debugAdapters.get(g);return this._debugAdapters.delete(g),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const k=[],P=[],p=[];if(g.added)for(const D of g.added){const f=D.id;if(f&&!this._breakpoints.has(f)){let A;if(D.type==="function")A=new C.FunctionBreakpoint(D.functionName,D.enabled,D.condition,D.hitCondition,D.logMessage);else if(D.type==="data")A=new C.DataBreakpoint(D.label,D.dataId,D.canPersist,D.enabled,D.hitCondition,D.condition,D.logMessage);else{const L=M.URI.revive(D.uri);A=new C.SourceBreakpoint(new C.Location(L,new C.Position(D.line,D.character)),D.enabled,D.condition,D.hitCondition,D.logMessage)}A._id=f,this._breakpoints.set(f,A),k.push(A)}}if(g.removed)for(const D of g.removed){const f=this._breakpoints.get(D);f&&(this._breakpoints.delete(D),P.push(f))}if(g.changed){for(const D of g.changed)if(D.id){const f=this._breakpoints.get(D.id);if(f){if(f instanceof C.FunctionBreakpoint&&D.type==="function"){const A=f;A.enabled=D.enabled,A.condition=D.condition,A.hitCondition=D.hitCondition,A.logMessage=D.logMessage,A.functionName=D.functionName}else if(f instanceof C.SourceBreakpoint&&D.type==="source"){const A=f;A.enabled=D.enabled,A.condition=D.condition,A.hitCondition=D.hitCondition,A.logMessage=D.logMessage,A.location=new C.Location(M.URI.revive(D.uri),new C.Position(D.line,D.character))}p.push(f)}}}this.fireBreakpointChanges(k,P,p)}$provideDebugConfigurations(g,k,P){return(0,R.asPromise)(async()=>{const p=this.getConfigProviderByHandle(g);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const D=await this.getFolder(k);return p.provideDebugConfigurations(D,P)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(g,k,P,p){return(0,R.asPromise)(async()=>{const D=this.getConfigProviderByHandle(g);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const f=await this.getFolder(k);return D.resolveDebugConfiguration(f,P,p)})}$resolveDebugConfigurationWithSubstitutedVariables(g,k,P,p){return(0,R.asPromise)(async()=>{const D=this.getConfigProviderByHandle(g);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const f=await this.getFolder(k);return D.resolveDebugConfigurationWithSubstitutedVariables(f,P,p)})}async $provideDebugAdapter(g,k){const P=this.getAdapterDescriptorFactoryByHandle(g);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(k);return this.getAdapterDescriptor(P,p).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(D)})}async $acceptDebugSessionStarted(g){const k=await this.getSession(g);this._onDidStartDebugSession.fire(k)}async $acceptDebugSessionTerminated(g){const k=await this.getSession(g);k&&(this._onDidTerminateDebugSession.fire(k),this._debugSessions.delete(k.id))}async $acceptDebugSessionActiveChanged(g){this._activeDebugSession=g?await this.getSession(g):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(g,k){const P=await this.getSession(g);P&&P._acceptNameChanged(k)}async $acceptDebugSessionCustomEvent(g,k){const p={session:await this.getSession(g),event:k.event,body:k.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(g){if(g instanceof C.DebugAdapterExecutable)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof C.DebugAdapterServer)return{type:"server",port:g.port,host:g.host};if(g instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:g.path};if(g instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(g){const k=this._adapterFactories.filter(P=>P.type===g);if(k.length>0)return k[0].factory}getAdapterDescriptorFactoryByHandle(g){const k=this._adapterFactories.filter(P=>P.handle===g);if(k.length>0)return k[0].factory}getConfigProviderByHandle(g){const k=this._configProviders.filter(P=>P.handle===g);if(k.length>0)return k[0].provider}definesDebugType(g,k){if(g.contributes){const P=g.contributes.debuggers;if(P&&P.length>0){for(const p of P)if(p.label&&p.type&&p.type===k)return!0}}return!1}getDebugAdapterTrackers(g){const P=g.configuration.type,p=this._trackerFactories.filter(D=>D.type===P||D.type==="*").map(D=>(0,R.asPromise)(()=>D.factory.createDebugAdapterTracker(g)).then(f=>f,f=>null));return Promise.race([Promise.all(p).then(D=>{const f=D.filter(A=>!!A);if(f.length>0)return new r(f)}),new Promise((D,f)=>{const A=setTimeout(()=>{clearTimeout(A),f(new Error("timeout"))},1e3)})]).catch(D=>{})}async getAdapterDescriptor(g,k){const P=k.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new C.DebugAdapterServer(P));if(g){const D=await this._extensionService.getExtensionRegistry();return(0,R.asPromise)(()=>g.createDebugAdapterDescriptor(k,this.daExecutableFromPackage(k,D))).then(f=>{if(f)return f})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(k,p))}daExecutableFromPackage(g,k){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(g,k,P){(g.length>0||k.length>0||P.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:g,removed:k,changed:P}))}async getSession(g){if(g)if(typeof g=="string"){const k=this._debugSessions.get(g);if(k)return k}else{let k=this._debugSessions.get(g.id);if(!k){const P=await this.getFolder(g.folderUri),p=g.parent?this._debugSessions.get(g.parent):void 0;k=new y(this._debugServiceProxy,g.id,g.type,g.name,P,g.configuration,p),this._debugSessions.set(k.id,k),this._debugServiceProxy.$sessionCached(k.id)}return k}throw new Error("cannot find session")}getFolder(g){if(g){const k=M.URI.revive(g);return this._workspaceService.resolveWorkspaceFolder(k)}return Promise.resolve(void 0)}};m=Ue([He(0,a.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,t.IExtHostExtensionService),He(3,E.IExtHostDocumentsAndEditors),He(4,u.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],m),e.ExtHostDebugServiceBase=m;class y{constructor(g,k,P,p,D,f,A){this._debugServiceProxy=g,this._id=k,this._type=P,this._name=p,this._workspaceFolder=D,this._configuration=f,this._parentSession=A}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(g){this._name=g,this._debugServiceProxy.$setDebugSessionName(this._id,g)}get parentSession(){return this._parentSession}_acceptNameChanged(g){this._name=g}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(g,k){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,g,k)}getDebugProtocolBreakpoint(g){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,g.id)}}e.ExtHostDebugSession=y;class i{constructor(g){this.value=Object.freeze({append(k){g.$appendDebugConsole(k)},appendLine(k){this.append(k+`
`)}})}}e.ExtHostDebugConsole=i;class v extends n.AbstractVariableResolverService{constructor(g,k,P,p,D){function f(){if(k){const A=k.activeEditor();if(A)return A.document.uri;const L=p.tabs.filter(V=>V.isActive);if(L.length>0){const V=L[0].resource;return V&&(V.primary||V.secondary)?V.primary??V.secondary:L[0].resource}}}super({getFolderUri:A=>{const L=g.filter(V=>V.name===A);if(L&&L.length>0)return L[0].uri},getWorkspaceFolderCount:()=>g.length,getConfigurationValue:(A,L)=>P.getConfiguration(void 0,A).get(L),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{const A=f();if(A)return d.normalize(A.fsPath)},getWorkspaceFolderPathForFile:()=>{if(D){const A=f();if(A){const L=D.getWorkspaceFolder(A);if(L)return d.normalize(L.uri.fsPath)}}},getSelectedText:()=>{if(k){const A=k.activeEditor();if(A&&!A.selection.isEmpty)return A.document.getText(A.selection)}},getLineNumber:()=>{if(k){const A=k.activeEditor();if(A)return String(A.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=v;class r{constructor(g){this.trackers=g}onWillStartSession(){this.trackers.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.trackers.forEach(k=>k.onWillReceiveMessage?k.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.trackers.forEach(k=>k.onDidSendMessage?k.onDidSendMessage(g):void 0)}onWillStopSession(){this.trackers.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.trackers.forEach(k=>k.onError?k.onError(g):void 0)}onExit(g,k){this.trackers.forEach(P=>P.onExit?P.onExit(g,k):void 0)}}class s extends _.AbstractDebugAdapter{constructor(g){super();this.implementation=g,g.onDidSendMessage(k=>{this.acceptMessage(k)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.implementation.handleMessage(g)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends m{constructor(g,k,P,p,D,f){super(g,k,P,p,D,f)}createVariableResolver(g,k,P){return new v(g,k,P,this._editorTabs)}};c=Ue([He(0,a.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,t.IExtHostExtensionService),He(3,E.IExtHostDocumentsAndEditors),He(4,u.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(we[218],be([0,1,74,2,5,32,30,25,12,29,4,33,91,15]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(o,m,y,i,v,r,s){this._apiFactory=o,this._extensionRegistry=m,this._instaService=y,this._extHostConfiguration=i,this._extHostExtensionService=v,this._initData=r,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const m=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,m,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,m,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let m of o.nodeModuleName)this._factories.set(m,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(m=>o.alternativeModuleName(m))}};l=Ue([He(2,t.IInstantiationService),He(3,R.IExtHostConfiguration),He(4,E.IExtHostExtensionService),He(5,T.IExtHostInitDataService),He(6,u.ILogService)],l),e.RequireInterceptor=l;class a{constructor(o,m,y,i,v){this._apiFactory=o,this._extensionPaths=m,this._extensionRegistry=y,this._configProvider=i,this._logService=v,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,m){const y=this._extensionPaths.findSubstr(m.fsPath);if(y){let i=this._extApiImpl.get(C.ExtensionIdentifier.toKey(y.identifier));return i||(i=this._apiFactory(y,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(y.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((v,r)=>i+=`	${r} -> ${v.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${m.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(o,m){this.nodeModuleName="keytar";const{environment:y}=m,i=o.getProxy(b.MainContext.MainThreadKeytar);if(y.appRoot){let v=y.appRoot.fsPath;n.platform==="win32"&&(v=v.replace(/\\/g,"/")),v[v.length-1]==="/"&&(v=v.substr(0,v.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${v}/node_modules.asar/keytar`),this.alternativeNames.add(`${v}/node_modules/keytar`)}this._impl={getPassword:(v,r)=>i.$getPassword(v,r),setPassword:(v,r,s)=>i.$setPassword(v,r,s),deletePassword:(v,r)=>i.$deletePassword(v,r),findPassword:v=>i.$findPassword(v),findCredentials(v){return i.$findCredentials(v)}}}load(o,m){return this._impl}alternativeModuleName(o){const m=o.length;if(m<=7||!this.alternativeNames)return;const y=m-7;if((o.charAt(y)==="/"||o.charAt(y)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};w=Ue([He(0,_.IExtHostRpcService),He(1,T.IExtHostInitDataService)],w);let I=class{constructor(o,m,y){this._extensionPaths=o,this._appUriScheme=m,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=y.getProxy(b.MainContext.MainThreadTelemetry);const i=y.getProxy(b.MainContext.MainThreadWindow);this._impl=(v,r)=>{const s=M.URI.parse(v);return r?this.callOriginal(v,r):s.scheme==="http"||s.scheme==="https"?i.$openUri(s,v,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?i.$openUri(s,v,{}):this.callOriginal(v,r)}}load(o,m,y){const i=this._extensionPaths.findSubstr(m.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=y(o),this._impl}callOriginal(o,m){return this.sendNoForwardTelemetry(),this._original(o,m)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=Ue([He(2,_.IExtHostRpcService)],I)}),define(we[219],be([0,1,14,16,74,6,2,5,212,15,57,61,29,144,12,65,33,40]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(m,y,i,v){this._disposables=new R.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new _.RPCProtocol(m,null,v),y=S._transform(y,this._rpcProtocol);const r=new E.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...y}),r.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),r.set(a.IURITransformerService,new a.URITransformerService(v)),r.set(w.IHostUtils,i);const s=new u.InstantiationService(r,!0),c=s.invokeFunction(P=>P.get(I.IExtHostTerminalService));this._disposables.add(c),this._logService=s.invokeFunction(P=>P.get(T.ILogService)),b.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",y),this._extensionService=s.invokeFunction(P=>P.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(P=>{Error.prepareStackTrace=(p,D)=>{let f="",A,L;for(const V of D)f+=`
	at ${V.toString()}`,L=V.getFileName(),!A&&L&&(A=P.findSubstr(L));return h.set(p,A),`${p.name||"Error"}: ${p.message||""}${f}`}});const g=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),k=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(P=>{const p=M.transformErrorForSerialization(P),D=h.get(P);D?g.$onExtensionRuntimeError(D.identifier,p):k.$onUnexpectedError(p)})}terminate(m){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${m}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const y=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,d.timeout)(4e3),y]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(m,y){m.extensions.forEach(v=>v.extensionLocation=F.URI.revive(y.transformIncomingURIs(v.extensionLocation))),m.environment.appRoot=F.URI.revive(y.transformIncomingURIs(m.environment.appRoot));const i=m.environment.extensionDevelopmentLocationURI;return i&&(m.environment.extensionDevelopmentLocationURI=i.map(v=>F.URI.revive(y.transformIncomingURIs(v)))),m.environment.extensionTestsLocationURI=F.URI.revive(y.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=F.URI.revive(y.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=F.URI.revive(y.transformIncomingURIs(m.environment.workspaceStorageHome)),m.logsLocation=F.URI.revive(y.transformIncomingURIs(m.logsLocation)),m.logFile=F.URI.revive(y.transformIncomingURIs(m.logFile)),m.workspace=y.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=S}),define(we[220],be([0,1,17,21,56,27,24,193,41]),function(ne,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(n,u,l){this.config=n,this.provider=u,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&R.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&R.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const u=this.config.folderQueries||[];return new Promise((l,a)=>{const w=I=>{this.resultCount++,n(I)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(I=>{const S=I.toString(),o=d.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,o)||this.matchFile(w,{base:I,basename:o})}),Promise.all(u.map(I=>this.searchInFolder(I,w))).then(I=>{l({limitHit:this.isLimitHit,stats:I[0]||void 0})},I=>{a(new Error((0,b.toErrorMessage)(I)))})})}async searchInFolder(n,u){const l=new M.CancellationTokenSource,a=this.getSearchOptionsForFolder(n),w=this.initDirectoryTree(),I=new _.QueryGlobTester(this.config,n),S=!I.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(l),o=C.StopWatch.create();const m=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,l.token),y=o.elapsed(),i=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(m&&m.forEach(v=>{const r=d.posix.relative(n.folder.path,v.path);if(S){const s=d.basename(v.path);this.matchFile(u,{base:n.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(w,n.folder,r,u)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,I,u),{providerTime:y,postProcessTime:i.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(n){const u=(0,_.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),l=(0,_.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:l,includes:u,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},u,l,a){if(l===this.filePattern){const I=d.basename(this.filePattern);this.matchFile(a,{base:u,relativePath:this.filePattern,basename:I})}function w(I){const S=d.basename(I),o=d.dirname(I);let m=n[o];m||(m=n[o]=[],w(o)),m.push({base:u,relativePath:I,basename:S})}w(l)}matchDirectoryTree({rootEntries:n,pathToEntries:u},l,a){const w=this,I=this.filePattern;function S(o){const m=R.hasSiblingFn(()=>o.map(y=>y.basename));for(let y=0,i=o.length;y<i;y++){const v=o[y],{relativePath:r,basename:s}=v;if(!l.includedInQuerySync(r,s,I!==s?m:void 0))continue;const c=u[r];if(c)S(c);else{if(r===I)continue;w.matchFile(a,v)}if(w.isLimitHit)break}}S(n)}matchFile(n,u){(!this.includePattern||u.relativePath&&this.includePattern(u.relativePath,u.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(u))}}class t{constructor(){this.sessions=new Map}fileSearch(n,u,l,a){const w=this.getSessionTokenSource(n.cacheKey),I=new T(n,u,w&&w.token);let S=0;const o=m=>{S+=m.length,l(m.map(y=>this.rawMatchToSearchItem(y)))};return this.doSearch(I,t.BATCH_SIZE,o,a).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:m.stats}}))}clearCache(n){const u=this.getSessionTokenSource(n);u&&u.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:F.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,u,l,a){a.onCancellationRequested(()=>{n.cancel()});const w=S=>{S&&(I.push(S),u>0&&I.length>=u&&(l(I),I=[]))};let I=[];return n.search(w).then(S=>(I.length&&l(I),S),S=>(I.length&&l(I),Promise.reject(S)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(we[221],be([0,1,13,21,56,27,11,17,24,10,2,41]),function(ne,e,d,M,b,R,F,C,_,T,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(o,m,y,i){this.query=o,this.provider=m,this.fileUtils=y,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,m){const y=this.query.folderQueries||[],i=new M.CancellationTokenSource;return m.onCancellationRequested(()=>i.cancel()),new Promise((v,r)=>{this.collector=new l(o);let s=!1;const c=(h,g)=>{if(!s&&!this.isLimitHit){const k=this.resultSize(h);w(h)&&typeof this.query.maxResults=="number"&&this.resultCount+k>this.query.maxResults&&(this.isLimitHit=!0,s=!0,i.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const P=this.resultSize(h);this.resultCount+=P,(P>0||!w(h))&&this.collector.add(h,g)}};Promise.all(y.map((h,g)=>this.searchInFolder(h,k=>c(k,g),i.token))).then(h=>{i.dispose(),this.collector.flush();const g=h.some(k=>!!k&&!!k.limitHit);v({limitHit:this.isLimitHit||g,messages:(0,d.flatten)(h.map(k=>k?.message?(0,T.isArray)(k.message)?k.message:[k.message]:[])),stats:{type:this.processType}})},h=>{i.dispose();const g=(0,b.toErrorMessage)(h);r(new Error(g))})})}resultSize(o){return w(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,m){const y=Array.isArray(o.ranges)?o.ranges:[o.ranges],i=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:y.slice(0,m),preview:{matches:i.slice(0,m),text:o.preview.text},uri:o.uri}}async searchInFolder(o,m,y){const i=new E.QueryGlobTester(this.query,o),v=[],r={report:h=>{if(!this.validateProviderResult(h))return;const g=o.folder.scheme===F.Schemas.file?R.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(h.uri))):void 0,k=_.relativePath(o.folder,h.uri);if(k){const P=i.includedInQuery(k,C.basename(k),g);(0,T.isPromise)(P)?v.push(P.then(p=>{p&&m(h)})):P&&m(h)}}},s=this.getSearchOptionsForFolder(o),c=await this.provider.provideTextSearchResults(u(this.query.contentPattern),s,r,y);return v.length&&await Promise.all(v),c}validateProviderResult(o){if(w(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const m=(0,E.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),y=(0,E.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),i={folder:t.URI.from(o.folder),excludes:y,includes:m,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function u(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class l{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new I(512,m=>this.sendItems(m))}add(o,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!_.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(a(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=l;function a(S){return w(S)?{preview:{matches:(0,d.mapArrayOrNot)(S.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:S.preview.text},ranges:(0,d.mapArrayOrNot)(S.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function w(S){return!!S.preview}e.extensionResultIsMatch=w;class I{constructor(o,m){this.maxBatchSize=o,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,m){!o||this.addItemToBatch(o,m)}addItems(o,m){!o||this.addItemsToBatch(o,m)}addItemToBatch(o,m){this.batch.push(o),this.batchSize+=m,this.onUpdate()}addItemsToBatch(o,m){this.batch=this.batch.concat(o),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<I.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},I.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=I,I.TIMEOUT=4e3,I.START_BATCH_AFTER_COUNT=50}),define(we[101],be([0,1,6,5,4,220,12,65,15,2,221]),function(ne,e,d,M,b,R,F,C,_,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let E=class{constructor(a,w,I){this.extHostRpc=a,this._uriTransformer=w,this._logService=I,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new R.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,w){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const I=this._handlePool++;return this._textSearchProvider.set(I,w),this._proxy.$registerTextSearchProvider(I,this._transformScheme(a)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}registerFileSearchProvider(a,w){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const I=this._handlePool++;return this._fileSearchProvider.set(I,w),this._proxy.$registerFileSearchProvider(I,this._transformScheme(a)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}$provideFileSearchResults(a,w,I,S){const o=n(I),m=this._fileSearchProvider.get(a);if(m)return this._fileSearchManager.fileSearch(o,m,y=>{this._proxy.$handleFileMatch(a,w,y.map(i=>i.resource))},S);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,w,I,S){const o=this._textSearchProvider.get(a);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const m=n(I);return this.createTextSearchManager(m,o).search(i=>this._proxy.$handleTextMatch(a,w,i),S)}$enableExtensionHostSearch(){}createTextSearchManager(a,w){return new t.TextSearchManager(a,w,{readdir:I=>Promise.resolve([]),toCanonicalName:I=>I},"textSearchProvider")}};E=Ue([He(0,F.IExtHostRpcService),He(1,C.IURITransformerService),He(2,_.ILogService)],E),e.ExtHostSearch=E;function n(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(u),extraFileResources:l.extraFileResources&&l.extraFileResources.map(a=>T.URI.revive(a))}}e.reviveQuery=n;function u(l){return{...l,folder:T.URI.revive(l.folder)}}}),define(we[222],be([0,1,21,16,3,35,2,117,79,113,55,60,5,183,182,39,184,32,185,186,187,169,188,49,33,189,170,192,194,195,96,172,200,201,202,72,40,204,173,8,7,207,50,97,31,30,51,159,191,86,95,99,100,101,15,65,12,29,196,156,64,70,180,205,155,73,71,210,208,209,181,37,203,206,69,68,87,198,98,199,11,146,197,153,190]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w,I,S,o,m,y,i,v,r,s,c,h,g,k,P,p,D,f,A,L,V,G,$,K,W,U,z,Y,re,j,ue,oe,ve,Fe,Me,Oe,Ye,ze,je,x,Q,ee,le,q,ae,he,Te,Be,$e,Qe,_e,rt,H,J,me,Ne,Ke,ot,at,vt,kt,ht,yt,It,ft,Je,Et,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(Z){const ce=Z.get(ee.IExtHostInitDataService),ge=Z.get(Ne.IExtHostFileSystemInfo),fe=Z.get(_e.IExtHostConsumerFileSystem),Ie=Z.get(r.IExtHostExtensionService),xe=Z.get(re.IExtHostWorkspace),Le=Z.get(kt.IExtHostTelemetry),Ve=Z.get(I.IExtHostConfiguration),Ze=Z.get(x.IURITransformerService),ie=Z.get(Q.IExtHostRpcService),pe=Z.get(L.IExtHostStorage),se=Z.get(Qe.IExtensionStoragePaths),B=Z.get(je.ILogService),De=Z.get(ae.IExtHostTunnelService),Se=Z.get(he.IExtHostApiDeprecationService),qe=Z.get(Y.IExtHostWindow),We=Z.get(at.IExtHostSecretState),tt=Z.get(vt.IExtHostEditorTabs);ie.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),ie.set(n.ExtHostContext.ExtHostLogService,B),ie.set(n.ExtHostContext.ExtHostWorkspace,xe),ie.set(n.ExtHostContext.ExtHostConfiguration,Ve),ie.set(n.ExtHostContext.ExtHostExtensionService,Ie),ie.set(n.ExtHostContext.ExtHostStorage,pe),ie.set(n.ExtHostContext.ExtHostTunnelService,De),ie.set(n.ExtHostContext.ExtHostWindow,qe),ie.set(n.ExtHostContext.ExtHostSecretState,We),ie.set(n.ExtHostContext.ExtHostTelemetry,Le),ie.set(n.ExtHostContext.ExtHostEditorTabs,tt);const mt=ie.set(n.ExtHostContext.ExtHostDecorations,Z.get(Me.IExtHostDecorations)),wt=ie.set(n.ExtHostContext.ExtHostDocumentsAndEditors,Z.get(v.IExtHostDocumentsAndEditors)),nt=ie.set(n.ExtHostContext.ExtHostCommands,Z.get(a.IExtHostCommands)),ct=ie.set(n.ExtHostContext.ExtHostTerminalService,Z.get(V.IExtHostTerminalService)),lt=ie.set(n.ExtHostContext.ExtHostDebugService,Z.get(Ye.IExtHostDebugService)),Tt=ie.set(n.ExtHostContext.ExtHostSearch,Z.get(ze.IExtHostSearch)),_t=ie.set(n.ExtHostContext.ExtHostTask,Z.get(Oe.IExtHostTask)),Ut=ie.set(n.ExtHostContext.ExtHostOutputService,Z.get(P.IExtHostOutputService)),$t=ie.set(n.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(ie)),Ct=ie.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ie,wt)),Wt=ie.set(n.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(ie,wt,B)),ei=ie.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new y.ExtHostDocumentSaveParticipant(B,Ct,ie.getProxy(n.MainContext.MainThreadBulkEdits))),gt=ie.set(n.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(ie,nt,wt,Ct,se)),Qt=ie.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(B,gt)),jt=ie.set(n.ExtHostContext.ExtHostNotebookEditors,new Et.ExtHostNotebookEditors(B,ie,gt)),ti=ie.set(n.ExtHostContext.ExtHostNotebookKernels,new ht.ExtHostNotebookKernels(ie,ce,gt,nt,B)),ii=ie.set(n.ExtHostContext.ExtHostNotebookRenderers,new It.ExtHostNotebookRenderers(ie,gt)),Pt=ie.set(n.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(ie,wt)),Yt=ie.set(n.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(ie.getProxy(n.MainContext.MainThreadTreeViews),nt,B)),wi=ie.set(n.ExtHostContext.ExtHostEditorInsets,new oe.ExtHostEditorInsets(ie.getProxy(n.MainContext.MainThreadEditorInsets),Pt,ce)),Ht=ie.set(n.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(ie,B,ge)),zt=ie.set(n.ExtHostContext.ExtHostLanguages,new g.ExtHostLanguages(ie,Ct,nt.converter)),dt=ie.set(n.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(ie,Ze,Ct,nt,Ht,B,Se)),ni=ie.set(n.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(ie,dt)),Ot=ie.set(n.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(ie,B,wt)),Nt=ie.set(n.ExtHostContext.ExtHostQuickOpen,(0,D.createExtHostQuickOpen)(ie,xe,nt)),Jt=ie.set(n.ExtHostContext.ExtHostSCM,new f.ExtHostSCM(ie,nt,B)),bi=ie.set(n.ExtHostContext.ExtHostComments,(0,w.createExtHostComments)(ie,nt,Ct)),hi=ie.set(n.ExtHostContext.ExtHostProgress,new p.ExtHostProgress(ie.getProxy(n.MainContext.MainThreadProgress))),Ei=ie.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(ie)),fi=ie.set(n.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(ie)),ri=ie.set(n.ExtHostContext.ExtHostAuthentication,new Te.ExtHostAuthentication(ie)),si=ie.set(n.ExtHostContext.ExtHostTimeline,new Be.ExtHostTimeline(ie,nt)),qt=ie.set(n.ExtHostContext.ExtHostWebviews,new z.ExtHostWebviews(ie,{remote:ce.remote},xe,B,Se)),oi=ie.set(n.ExtHostContext.ExtHostWebviewPanels,new J.ExtHostWebviewPanels(ie,qt,xe)),_i=ie.set(n.ExtHostContext.ExtHostCustomEditors,new H.ExtHostCustomEditors(ie,Ct,se,qt,oi)),yi=ie.set(n.ExtHostContext.ExtHostWebviewViews,new rt.ExtHostWebviewViews(ie,qt)),Gt=ie.set(n.ExtHostContext.ExtHostTesting,new Ke.ExtHostTesting(ie,nt)),Xt=ie.set(n.ExtHostContext.ExtHostUriOpeners,new ot.ExtHostUriOpeners(ie));ie.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(ie,gt,wt,nt));const Si=(0,ue.values)(n.ExtHostContext);ie.assertRegistered(Si);const Di=new me.ExtHostBulkEdits(ie,wt),ai=new l.ExtHostClipboard(ie),li=new k.ExtHostMessageService(ie,B),Vt=new o.ExtHostDialogs(ie),Mt=new A.ExtHostStatusBar(ie,nt.converter);return u.ExtHostApiCommands.register(nt),function(Re,Rt,Kt){const pt=function(){let X=!Re.isUnderDevelopment;function de(ke){X||(B.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(it){if(Array.isArray(it))it.forEach(ke);else if(typeof it=="string")de(it);else{const bt=it;typeof bt.scheme=="undefined"&&de(it),!Re.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,j.throwProposedApiError)(Re)}return it}}(),Ci={getSession(X,de,ke){return ke?.forceNewSession&&(0,j.checkProposedApiEnabled)(Re),ri.getSession(Re,X,de,ke)},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(X,de,ke,it){return ri.registerAuthenticationProvider(X,de,ke,it)}},ki={registerCommand(X,de,ke){return nt.registerCommand(!0,X,de,ke)},registerTextEditorCommand(X,de,ke){return nt.registerCommand(!0,X,(...it)=>{const bt=Pt.getActiveTextEditor();if(!bt){B.warn("Cannot execute "+X+" because there is no active text editor.");return}return bt.edit(Dt=>{de.apply(ke,[bt,Dt,...it])}).then(Dt=>{Dt||B.warn("Edits from command "+X+" were not applied.")},Dt=>{B.warn("An error occurred while running command "+X,Dt)})})},registerDiffInformationCommand:(X,de,ke)=>((0,j.checkProposedApiEnabled)(Re),nt.registerCommand(!0,X,async(...it)=>{const bt=wt.activeEditor(!0);if(!bt){B.warn("Cannot execute "+X+" because there is no active text editor.");return}const Dt=await Pt.getDiffInformation(bt.id);de.apply(ke,[Dt,...it])})),executeCommand(X,...de){return nt.executeCommand(X,...de)},getCommands(X=!1){return nt.getCommands(X)}},mi={get machineId(){return ce.telemetryInfo.machineId},get sessionId(){return ce.telemetryInfo.sessionId},get language(){return ce.environment.appLanguage},get appName(){return ce.environment.appName},get appRoot(){return ce.environment.appRoot?.fsPath??""},get appHost(){return ce.environment.appHost},get uriScheme(){return ce.environment.appUriScheme},get clipboard(){return ai.value},get shell(){return ct.getDefaultShell(!1)},get isTelemetryEnabled(){return Le.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Le.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(ce.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,de){return qe.openUri(X,{allowTunneling:!!ce.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===ce.environment.appUriScheme)return $t.createAppUri(X);try{return await qe.asExternalUri(X,{allowTunneling:!!ce.remote.authority})}catch(de){if((0,Je.matchesScheme)(X,ft.Schemas.http)||(0,Je.matchesScheme)(X,ft.Schemas.https))return X;throw de}},get remoteName(){return(0,Fe.getRemoteName)(ce.remote.authority)},get remoteAuthority(){return(0,j.checkProposedApiEnabled)(Re),ce.remote.authority},get uiKind(){return ce.uiKind}};ce.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ce.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Ii={createTestController(X,de){return Gt.createTestController(X,de)},createTestObserver(){return(0,j.checkProposedApiEnabled)(Re),Gt.createTestObserver()},runTests(X){return(0,j.checkProposedApiEnabled)(Re),Gt.runTests(X)},get onDidChangeTestResults(){return(0,j.checkProposedApiEnabled)(Re),Gt.onResultsChanged},get testResults(){return(0,j.checkProposedApiEnabled)(Re),Gt.results}},Pi={getExtension(X){const de=Rt.getExtensionDescription(X);if(de)return new r.Extension(Ie,Re.identifier,de,gi)},get all(){return Rt.getAllExtensionDescriptions().map(X=>new r.Extension(Ie,Re.identifier,X,gi))},get onDidChange(){return Rt.onDidChange}},ui={createDiagnosticCollection(X){return Ht.createDiagnosticCollection(Re.identifier,X)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:X=>Ht.getDiagnostics(X),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(X,de){return zt.changeLanguage(X.uri,de)},match(X,de){return(0,t.score)(K.LanguageSelector.from(X),de.uri,de.languageId,!0)},registerCodeActionsProvider(X,de,ke){return dt.registerCodeActionProvider(Re,pt(X),de,ke)},registerCodeLensProvider(X,de){return dt.registerCodeLensProvider(Re,pt(X),de)},registerDefinitionProvider(X,de){return dt.registerDefinitionProvider(Re,pt(X),de)},registerDeclarationProvider(X,de){return dt.registerDeclarationProvider(Re,pt(X),de)},registerImplementationProvider(X,de){return dt.registerImplementationProvider(Re,pt(X),de)},registerTypeDefinitionProvider(X,de){return dt.registerTypeDefinitionProvider(Re,pt(X),de)},registerHoverProvider(X,de){return dt.registerHoverProvider(Re,pt(X),de,Re.identifier)},registerEvaluatableExpressionProvider(X,de){return dt.registerEvaluatableExpressionProvider(Re,pt(X),de,Re.identifier)},registerInlineValuesProvider(X,de){return dt.registerInlineValuesProvider(Re,pt(X),de,Re.identifier)},registerDocumentHighlightProvider(X,de){return dt.registerDocumentHighlightProvider(Re,pt(X),de)},registerLinkedEditingRangeProvider(X,de){return dt.registerLinkedEditingRangeProvider(Re,pt(X),de)},registerReferenceProvider(X,de){return dt.registerReferenceProvider(Re,pt(X),de)},registerRenameProvider(X,de){return dt.registerRenameProvider(Re,pt(X),de)},registerDocumentSymbolProvider(X,de,ke){return dt.registerDocumentSymbolProvider(Re,pt(X),de,ke)},registerWorkspaceSymbolProvider(X){return dt.registerWorkspaceSymbolProvider(Re,X)},registerDocumentFormattingEditProvider(X,de){return dt.registerDocumentFormattingEditProvider(Re,pt(X),de)},registerDocumentRangeFormattingEditProvider(X,de){return dt.registerDocumentRangeFormattingEditProvider(Re,pt(X),de)},registerOnTypeFormattingEditProvider(X,de,ke,...it){return dt.registerOnTypeFormattingEditProvider(Re,pt(X),de,[ke].concat(it))},registerDocumentSemanticTokensProvider(X,de,ke){return dt.registerDocumentSemanticTokensProvider(Re,pt(X),de,ke)},registerDocumentRangeSemanticTokensProvider(X,de,ke){return dt.registerDocumentRangeSemanticTokensProvider(Re,pt(X),de,ke)},registerSignatureHelpProvider(X,de,ke,...it){return typeof ke=="object"?dt.registerSignatureHelpProvider(Re,pt(X),de,ke):dt.registerSignatureHelpProvider(Re,pt(X),de,typeof ke=="undefined"?[]:[ke,...it])},registerCompletionItemProvider(X,de,...ke){return dt.registerCompletionItemProvider(Re,pt(X),de,ke)},registerInlineCompletionItemProvider(X,de){return(0,j.checkProposedApiEnabled)(Re),dt.registerInlineCompletionsProvider(Re,pt(X),de)},registerDocumentLinkProvider(X,de){return dt.registerDocumentLinkProvider(Re,pt(X),de)},registerColorProvider(X,de){return dt.registerColorProvider(Re,pt(X),de)},registerFoldingRangeProvider(X,de){return dt.registerFoldingRangeProvider(Re,pt(X),de)},registerSelectionRangeProvider(X,de){return dt.registerSelectionRangeProvider(Re,X,de)},registerCallHierarchyProvider(X,de){return dt.registerCallHierarchyProvider(Re,X,de)},registerTypeHierarchyProvider(X,de){return dt.registerTypeHierarchyProvider(Re,X,de)},setLanguageConfiguration:(X,de)=>dt.setLanguageConfiguration(Re,X,de),getTokenInformationAtPosition(X,de){return(0,j.checkProposedApiEnabled)(Re),zt.tokenAtPosition(X,de)},registerInlayHintsProvider(X,de){return(0,j.checkProposedApiEnabled)(Re),dt.registerInlayHintsProvider(Re,X,de)},createLanguageStatusItem(X,de){return(0,j.checkProposedApiEnabled)(Re),zt.createLanguageStatusItem(Re,X,de)}},Ti={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(X,de,ke){const it=await(F.URI.isUri(X)?Promise.resolve(pi.openTextDocument(X)):Promise.resolve(X));return Pt.showTextDocument(it,de,ke)},createTextEditorDecorationType(X){return Pt.createTextEditorDecorationType(Re,X)},onDidChangeActiveTextEditor(X,de,ke){return Pt.onDidChangeActiveTextEditor(X,de,ke)},onDidChangeVisibleTextEditors(X,de,ke){return Pt.onDidChangeVisibleTextEditors(X,de,ke)},onDidChangeTextEditorSelection(X,de,ke){return Pt.onDidChangeTextEditorSelection(X,de,ke)},onDidChangeTextEditorOptions(X,de,ke){return Pt.onDidChangeTextEditorOptions(X,de,ke)},onDidChangeTextEditorVisibleRanges(X,de,ke){return Pt.onDidChangeTextEditorVisibleRanges(X,de,ke)},onDidChangeTextEditorViewColumn(X,de,ke){return Pt.onDidChangeTextEditorViewColumn(X,de,ke)},onDidCloseTerminal(X,de,ke){return ct.onDidCloseTerminal(X,de,ke)},onDidOpenTerminal(X,de,ke){return ct.onDidOpenTerminal(X,de,ke)},onDidChangeActiveTerminal(X,de,ke){return ct.onDidChangeActiveTerminal(X,de,ke)},onDidChangeTerminalDimensions(X,de,ke){return(0,j.checkProposedApiEnabled)(Re),ct.onDidChangeTerminalDimensions(X,de,ke)},onDidChangeTerminalState(X,de,ke){return(0,j.checkProposedApiEnabled)(Re),ct.onDidChangeTerminalState(X,de,ke)},onDidWriteTerminalData(X,de,ke){return(0,j.checkProposedApiEnabled)(Re),ct.onDidWriteTerminalData(X,de,ke)},get state(){return qe.state},onDidChangeWindowState(X,de,ke){return qe.onDidChangeWindowState(X,de,ke)},showInformationMessage(X,...de){return li.showMessage(Re,R.default.Info,X,de[0],de.slice(1))},showWarningMessage(X,...de){return li.showMessage(Re,R.default.Warning,X,de[0],de.slice(1))},showErrorMessage(X,...de){return li.showMessage(Re,R.default.Error,X,de[0],de.slice(1))},showQuickPick(X,de,ke){return Nt.showQuickPick(X,!!Re.enableProposedApi,de,ke)},showWorkspaceFolderPick(X){return Nt.showWorkspaceFolderPick(X)},showInputBox(X,de){return Nt.showInput(X,de)},showOpenDialog(X){return Vt.showOpenDialog(X)},showSaveDialog(X){return Vt.showSaveDialog(X)},createStatusBarItem(X,de,ke){let it,bt,Dt;return typeof X=="string"?(it=X,bt=de,Dt=ke):(bt=X,Dt=de),Mt.createStatusBarEntry(Re,it,bt,Dt)},setStatusBarMessage(X,de){return Mt.setStatusBarMessage(X,de)},withScmProgress(X){return Se.report("window.withScmProgress",Re,"Use 'withProgress' instead."),hi.withProgress(Re,{location:W.ProgressLocation.SourceControl},(de,ke)=>X({report(it){}}))},withProgress(X,de){return hi.withProgress(Re,X,de)},createOutputChannel(X){return Ut.createOutputChannel(X,Re)},createWebviewPanel(X,de,ke,it){return oi.createWebviewPanel(Re,X,de,ke,it)},createWebviewTextEditorInset(X,de,ke,it){return(0,j.checkProposedApiEnabled)(Re),wi.createWebviewEditorInset(X,de,ke,it,Re)},createTerminal(X,de,ke){return typeof X=="object"?("location"in X&&(0,j.checkProposedApiEnabled)(Re),"pty"in X?ct.createExtensionTerminal(X):ct.createTerminalFromOptions(X)):ct.createTerminal(X,de,ke)},registerTerminalLinkProvider(X){return ct.registerLinkProvider(X)},registerTerminalProfileProvider(X,de){return ct.registerProfileProvider(Re,X,de)},registerTreeDataProvider(X,de){return Yt.registerTreeDataProvider(X,de,Re)},createTreeView(X,de){return Yt.createTreeView(X,de,Re)},registerWebviewPanelSerializer:(X,de)=>oi.registerWebviewPanelSerializer(Re,X,de),registerCustomEditorProvider:(X,de,ke={})=>_i.registerCustomEditorProvider(Re,X,de,ke),registerFileDecorationProvider(X){return mt.registerFileDecorationProvider(X,Re.identifier)},registerUriHandler(X){return $t.registerUriHandler(Re.identifier,X)},createQuickPick(){return Nt.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Nt.createInputBox(Re.identifier)},get activeColorTheme(){return fi.activeColorTheme},onDidChangeActiveColorTheme(X,de,ke){return fi.onDidChangeActiveColorTheme(X,de,ke)},registerWebviewViewProvider(X,de,ke){return yi.registerWebviewViewProvider(Re,X,de,ke?.webviewOptions)},get activeNotebookEditor(){return(0,j.checkProposedApiEnabled)(Re),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,de,ke){return(0,j.checkProposedApiEnabled)(Re),gt.onDidChangeActiveNotebookEditor(X,de,ke)},get visibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Re),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Re),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,de,ke){return(0,j.checkProposedApiEnabled)(Re),jt.onDidChangeNotebookEditorSelection(X,de,ke)},onDidChangeNotebookEditorVisibleRanges(X,de,ke){return(0,j.checkProposedApiEnabled)(Re),jt.onDidChangeNotebookEditorVisibleRanges(X,de,ke)},showNotebookDocument(X,de){return(0,j.checkProposedApiEnabled)(Re),gt.showNotebookDocument(X,de)},registerExternalUriOpener(X,de,ke){return(0,j.checkProposedApiEnabled)(Re),Xt.registerExternalUriOpener(Re.identifier,X,de,ke)},get tabs(){return(0,j.checkProposedApiEnabled)(Re),tt.tabs},get activeTab(){return(0,j.checkProposedApiEnabled)(Re),tt.activeTab},get onDidChangeTabs(){return(0,j.checkProposedApiEnabled)(Re),tt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,j.checkProposedApiEnabled)(Re),tt.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,j.checkProposedApiEnabled)(Re),h.InlineCompletionController.get(X)}},pi={get rootPath(){return Se.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),xe.getPath()},set rootPath(X){throw M.readonly()},getWorkspaceFolder(X){return xe.getWorkspaceFolder(X)},get workspaceFolders(){return xe.getWorkspaceFolders()},get name(){return xe.name},set name(X){throw M.readonly()},get workspaceFile(){return xe.workspaceFile},set workspaceFile(X){throw M.readonly()},updateWorkspaceFolders:(X,de,...ke)=>xe.updateWorkspaceFolders(Re,X,de||0,...ke),onDidChangeWorkspaceFolders:function(X,de,ke){return xe.onDidChangeWorkspace(X,de,ke)},asRelativePath:(X,de)=>xe.getRelativePath(X,de),findFiles:(X,de,ke,it)=>xe.findFiles(K.GlobPattern.from(X),K.GlobPattern.from(de),ke,Re.identifier,it),findTextInFiles:(X,de,ke,it)=>{let bt,Dt;return typeof de=="object"?(bt=de,Dt=ke):(bt={},Dt=de,it=ke),xe.findTextInFiles(X,bt||{},Dt,Re.identifier,it)},saveAll:X=>xe.saveAll(X),applyEdit(X){return Di.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,de,ke,it)=>Ot.createFileSystemWatcher(K.GlobPattern.from(X),de,ke,it),get textDocuments(){return Ct.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw M.readonly()},openTextDocument(X){let de;const ke=X;if(typeof X=="string")de=Promise.resolve(F.URI.file(X));else if(F.URI.isUri(X))de=Promise.resolve(X);else if(!ke||typeof ke=="object")de=Ct.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(it=>Ct.ensureDocumentData(it).then(bt=>bt.document))},onDidOpenTextDocument:(X,de,ke)=>Ct.onDidAddDocument(X,de,ke),onDidCloseTextDocument:(X,de,ke)=>Ct.onDidRemoveDocument(X,de,ke),onDidChangeTextDocument:(X,de,ke)=>Ct.onDidChangeDocument(X,de,ke),onDidSaveTextDocument:(X,de,ke)=>Ct.onDidSaveDocument(X,de,ke),onWillSaveTextDocument:(X,de,ke)=>ei.getOnWillSaveTextDocumentEvent(Re)(X,de,ke),get notebookDocuments(){return gt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,de){let ke;if(F.URI.isUri(X))ke=X,await gt.openNotebookDocument(X);else if(typeof X=="string")ke=F.URI.revive(await gt.createNotebookDocument({viewType:X,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(X,de,ke,it){return gt.registerNotebookSerializer(Re,X,de,ke,Re.enableProposedApi?it:void 0)},registerNotebookContentProvider:(X,de,ke,it)=>((0,j.checkProposedApiEnabled)(Re),gt.registerNotebookContentProvider(Re,X,de,ke,Re.enableProposedApi?it:void 0)),onDidChangeConfiguration:(X,de,ke)=>Kt.onDidChangeConfiguration(X,de,ke),getConfiguration(X,de){return de=arguments.length===1?void 0:de,Kt.getConfiguration(X,de,Re)},registerTextDocumentContentProvider(X,de){return Wt.registerTextDocumentContentProvider(X,de)},registerTaskProvider:(X,de)=>(Se.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Re,X,de)),registerFileSystemProvider(X,de,ke){return ni.registerFileSystemProvider(Re.identifier,X,de,ke)},get fs(){return fe.value},registerFileSearchProvider:(X,de)=>((0,j.checkProposedApiEnabled)(Re),Tt.registerFileSearchProvider(X,de)),registerTextSearchProvider:(X,de)=>((0,j.checkProposedApiEnabled)(Re),Tt.registerTextSearchProvider(X,de)),registerRemoteAuthorityResolver:(X,de)=>((0,j.checkProposedApiEnabled)(Re),Ie.registerRemoteAuthorityResolver(X,de)),registerResourceLabelFormatter:X=>((0,j.checkProposedApiEnabled)(Re),Ei.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,de,ke)=>Ot.onDidCreateFile(X,de,ke),onDidDeleteFiles:(X,de,ke)=>Ot.onDidDeleteFile(X,de,ke),onDidRenameFiles:(X,de,ke)=>Ot.onDidRenameFile(X,de,ke),onWillCreateFiles:(X,de,ke)=>Ot.getOnWillCreateFileEvent(Re)(X,de,ke),onWillDeleteFiles:(X,de,ke)=>Ot.getOnWillDeleteFileEvent(Re)(X,de,ke),onWillRenameFiles:(X,de,ke)=>Ot.getOnWillRenameFileEvent(Re)(X,de,ke),openTunnel:X=>((0,j.checkProposedApiEnabled)(Re),De.openTunnel(Re,X).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,j.checkProposedApiEnabled)(Re),De.getTunnels()},onDidChangeTunnels:(X,de,ke)=>((0,j.checkProposedApiEnabled)(Re),De.onDidChangeTunnels(X,de,ke)),registerPortAttributesProvider:(X,de)=>((0,j.checkProposedApiEnabled)(Re),De.registerPortsAttributesProvider(X,de)),registerTimelineProvider:(X,de)=>((0,j.checkProposedApiEnabled)(Re),si.registerTimelineProvider(X,de,Re.identifier,nt.converter)),get isTrusted(){return xe.trusted},requestWorkspaceTrust:X=>((0,j.checkProposedApiEnabled)(Re),xe.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,de,ke)=>xe.onDidGrantWorkspaceTrust(X,de,ke)},Ai={get inputBox(){return Se.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Re)},createSourceControl(X,de,ke){return Jt.createSourceControl(Re,X,de,ke)}},Ri={createCommentController(X,de){return bi.createCommentController(Re,X,de)}},Fi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(X,de,ke){return lt.onDidStartDebugSession(X,de,ke)},onDidTerminateDebugSession(X,de,ke){return lt.onDidTerminateDebugSession(X,de,ke)},onDidChangeActiveDebugSession(X,de,ke){return lt.onDidChangeActiveDebugSession(X,de,ke)},onDidReceiveDebugSessionCustomEvent(X,de,ke){return lt.onDidReceiveDebugSessionCustomEvent(X,de,ke)},onDidChangeBreakpoints(X,de,ke){return lt.onDidChangeBreakpoints(X,de,ke)},registerDebugConfigurationProvider(X,de,ke){return lt.registerDebugConfigurationProvider(X,de,ke||W.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,de){return lt.registerDebugAdapterDescriptorFactory(Re,X,de)},registerDebugAdapterTrackerFactory(X,de){return lt.registerDebugAdapterTrackerFactory(X,de)},startDebugging(X,de,ke){return!ke||typeof ke=="object"&&"configuration"in ke?lt.startDebugging(X,de,{parentSession:ke}):lt.startDebugging(X,de,ke||{})},stopDebugging(X){return lt.stopDebugging(X)},addBreakpoints(X){return lt.addBreakpoints(X)},removeBreakpoints(X){return lt.removeBreakpoints(X)},asDebugSourceUri(X,de){return lt.asDebugSourceUri(X,de)}},Mi={registerTaskProvider:(X,de)=>_t.registerTaskProvider(Re,X,de),fetchTasks:X=>_t.fetchTasks(X),executeTask:X=>_t.executeTask(Re,X),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(X,de,ke)=>_t.onDidStartTask(X,de,ke),onDidEndTask:(X,de,ke)=>_t.onDidEndTask(X,de,ke),onDidStartTaskProcess:(X,de,ke)=>_t.onDidStartTaskProcess(X,de,ke),onDidEndTaskProcess:(X,de,ke)=>_t.onDidEndTaskProcess(X,de,ke)},Li={createNotebookController(X,de,ke,it,bt){return ti.createNotebookController(Re,X,de,ke,it,Re.enableProposedApi?bt:void 0)},registerNotebookCellStatusBarItemProvider:(X,de)=>gt.registerNotebookCellStatusBarItemProvider(Re,X,de),get onDidSaveNotebookDocument(){return(0,j.checkProposedApiEnabled)(Re),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,j.checkProposedApiEnabled)(Re),jt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return ii.createRendererMessaging(Re,X)},onDidChangeNotebookDocumentMetadata(X,de,ke){return(0,j.checkProposedApiEnabled)(Re),Qt.onDidChangeNotebookDocumentMetadata(X,de,ke)},onDidChangeNotebookCells(X,de,ke){return(0,j.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCells(X,de,ke)},onDidChangeNotebookCellExecutionState(X,de,ke){return(0,j.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCellExecutionState(X,de,ke)},onDidChangeCellOutputs(X,de,ke){return(0,j.checkProposedApiEnabled)(Re),gt.onDidChangeCellOutputs(X,de,ke)},onDidChangeCellMetadata(X,de,ke){return(0,j.checkProposedApiEnabled)(Re),gt.onDidChangeCellMetadata(X,de,ke)},createConcatTextDocument(X,de){return(0,j.checkProposedApiEnabled)(Re),new $e.ExtHostNotebookConcatDocument(gt,Ct,X,de)}};return{version:ce.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:ui,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:Ti,workspace:pi,Breakpoint:W.Breakpoint,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:W.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:b.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestions,Hover:W.Hover,IndentAction:T.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:n.UIKind,Uri:F.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,InlayHint:W.InlayHint,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestMessage:W.TestMessage,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:yt.TextSearchCompleteMessageType,CoveredCount:W.CoveredCount,FileCoverage:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,FunctionCoverage:W.FunctionCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(we[223],be([0,1,57,96,31,95,32,39,49,40,99,100,101,72,64,70,97,71,37,69,87,68]),function(ne,e,d,M,b,R,F,C,_,T,t,E,n,u,l,a,w,I,S,o,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService),(0,d.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,d.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,d.registerSingleton)(I.IExtHostConsumerFileSystem,I.ExtHostConsumerFileSystem),(0,d.registerSingleton)(E.IExtHostDebugService,E.WorkerExtHostDebugService),(0,d.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations),(0,d.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(S.IExtHostFileSystemInfo,S.ExtHostFileSystemInfo),(0,d.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,d.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,d.registerSingleton)(u.IExtHostStorage,u.ExtHostStorage),(0,d.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,d.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,d.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,d.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,d.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace),(0,d.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,d.registerSingleton)(m.IExtHostTelemetry,m.ExtHostTelemetry),(0,d.registerSingleton)(y.IExtHostEditorTabs,y.ExtHostEditorTabs)}),define(we[224],be([0,1,222,33,218,7,14,5,11]),function(ne,e,d,M,b,R,F,C,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var T;(function(l){const a=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(I,...S)=>{S.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const o=S.slice(0,-1).join(","),m=S.pop().toString();return`(function anonymous(${o}) {
${m}
})`}});function w(...I){return a?self.eval(a.createScript("",...I)):new Function(...I)}l.create=w})(T||(T={}));class t extends b.RequireInterceptor{_installInterceptor(){}getModule(a,w){for(let I of this._alternatives){let S=I(a);if(S){a=S;break}}if(this._factories.has(a))return this._factories.get(a).load(a,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class E extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=R.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const a=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);u(a,this._initData.environment.isExtensionDevelopmentDebug);const w=this._instaService.invokeFunction(d.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,w,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(a){return a.browser}async _loadCommonJSModule(a,w,I){w=w.with({path:n(w.path,".js")}),a&&performance.mark(`code/extHost/willFetchExtensionCode/${a.value}`);const S=await fetch(_.FileAccess.asBrowserUri(w).toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a.value}`),S.status!==200)throw new Error(S.statusText);const o=await S.text(),m=`${w.toString(!0)}#vscode-extension`,y=`${o}
//# sourceURL=${m}`;let i;try{i=T.create(E._ttpExtensionScripts?.createScript("module")??"module",E._ttpExtensionScripts?.createScript("exports")??"exports",E._ttpExtensionScripts?.createScript("require")??"require",E._ttpExtensionScripts?.createScript(y)??y)}catch(c){throw console.error(a?`Loading code for extension ${a.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${w.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const v={},r={exports:v},s=c=>{const h=this._fakeModules.getModule(c,w);if(h===void 0)throw new Error(`Cannot load module '${c}'`);return h};try{return I.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a.value}`),i(r,v,s),r.exports!==v?r.exports:v}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a.value}`),I.codeLoadingStop()}}async $setRemoteEnvironment(a){}async _waitForDebuggerAttachment(a=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+a;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=E,E._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:l=>l});function n(l,a){return l.endsWith(a)?l:l+a}function u(l,a){w("info","log"),w("log","log"),w("warn","warn"),w("error","error");function w(o,m){const y=console[o];console[o]=function(){l.$logExtensionHostMessage({type:"__$console",severity:m,arguments:S(arguments)}),a&&y.apply(console,arguments)}}const I=1e5;function S(o){const m=[],y=[];if(o.length)for(let i=0;i<o.length;i++){if(typeof o[i]=="undefined")o[i]="undefined";else if(o[i]instanceof Error){const v=o[i];v.stack?o[i]=v.stack:o[i]=v.toString()}y.push(o[i])}try{const i=JSON.stringify(y,function(v,r){if(r&&typeof r=="object"){if(m.indexOf(r)!==-1)return"[Circular]";m.push(r)}return r});return i.length>I?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(we[225],be([0,1,57,15,33,73,224,211]),function(ne,e,d,M,b,R,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(b.IExtHostExtensionService,F.ExtHostExtensionService),(0,d.registerSingleton)(M.ILogService,C.ExtHostLogService),(0,d.registerSingleton)(R.IExtensionStoragePaths,R.ExtensionStoragePaths)}),define(we[235],be([0,1,22,3,177,219,213,17,74,11,2,223,225]),function(ne,e,d,M,b,R,F,C,_,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const u=fetch.bind(self);if(self.fetch=function(o,m){return o instanceof Request||/^file:/i.test(String(o))&&(o=T.FileAccess.asBrowserUri(t.URI.parse(String(o))).toString(!0)),u(o,m)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,m,y,i,v){return/^file:/i.test(m.toString())&&(m=T.FileAccess.asBrowserUri(t.URI.parse(m.toString())).toString(!0)),super.open(o,m,y??!0,i,v)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:y=>y}),m=self.Worker;Worker=function(y,i){/^file:/i.test(y.toString())&&(y=T.FileAccess.asBrowserUri(t.URI.parse(y.toString())).toString(!0));const r=`(${function(g){function k(f){return typeof f=="string"||f instanceof URL?String(f).replace(/^file:\/\//i,"vscode-file://vscode-app"):f}const P=fetch.bind(self);self.fetch=function(f,A){return f instanceof Request?P(f,A):P(k(f),A)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,A,L,V,G){return super.open(f,k(A),L??!0,V,G)}};const p=importScripts.bind(self);self.importScripts=(...f)=>{p(...f.map(k))};const D=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:f=>f}):void 0;p(D?D.createScriptURL(g):g)}.toString()}('${y}'))`;i=i||{},i.name=i.name||C.basename(y.toString());const s=new Blob([r],{type:"application/javascript"}),c=URL.createObjectURL(s);return new m(o?o.createScriptURL(c):c,i)}}else self.Worker=class extends F.NestedWorker{constructor(o,m){super(n,o,{name:C.basename(o.toString()),...m})}};const l=new class{exit(o){E()}async exists(o){return!0}async realpath(o){return o}};class a{constructor(){const m=new MessageChannel,y=new M.Emitter;let i=!1;n(m.port2,[m.port2]),m.port1.onmessage=v=>{const{data:r}=v;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const s=d.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,b.isMessageOfType)(s,2)){i=!0,I("received terminate message from renderer");return}y.fire(s)},this.protocol={onMessage:y.event,send:v=>{if(!i){const r=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);m.port1.postMessage(r,[r])}}}}}function w(o){return new Promise(m=>{const y=o.onMessage(i=>{y.dispose();const v=JSON.parse(i.toString());o.send((0,b.createMessageOfType)(0)),m({protocol:o,initData:v})});o.send((0,b.createMessageOfType)(1))})}let I=o=>E();function S(){const o=new a;_.mark("code/extHost/willConnectToRenderer"),w(o.protocol).then(m=>{_.mark("code/extHost/didWaitForInitData");const y=new R.ExtensionHostMain(m.protocol,m.initData,l,null);I=i=>y.terminate(i)})}e.create=S})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a0af58197e4a1d3e82fbe3048e0549e622d19f4f/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
